
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRES SQL YACC rules/actions
 *
 * Portions Copyright (c) 1996-2008, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  $PostgreSQL: pgsql/src/backend/parser/gram.y,v 2.606 2008/02/07 21:07:55 tgl Exp $
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "parser/gramparse.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

extern List *parsetree;			/* final parse result is delivered here */

static bool QueryIsRule = FALSE;

/*
 * If you need access to certain yacc-generated variables and find that
 * they're static by default, uncomment the next line.  (this is not a
 * problem, yet.)
 */
/*#define __YYSCLASS*/

static Node *makeColumnRef(char *relname, List *indirection, int location);
static Node *makeTypeCast(Node *arg, TypeName *typename);
static Node *makeStringConst(char *str, TypeName *typename);
static Node *makeIntConst(int val);
static Node *makeFloatConst(char *str);
static Node *makeAConst(Value *v);
static A_Const *makeBoolAConst(bool state);
static FuncCall *makeOverlaps(List *largs, List *rargs, int location);
static void check_qualified_name(List *names);
static List *check_func_name(List *names);
static List *extractArgTypes(List *parameters);
static SelectStmt *findLeftmostSelect(SelectStmt *node);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args);



/* Line 189 of yacc.c  */
#line 195 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ABORT_P = 258,
     ABSOLUTE_P = 259,
     ACCESS = 260,
     ACTION = 261,
     ADD_P = 262,
     ADMIN = 263,
     AFTER = 264,
     AGGREGATE = 265,
     ALL = 266,
     ALSO = 267,
     ALTER = 268,
     ALWAYS = 269,
     ANALYSE = 270,
     ANALYZE = 271,
     AND = 272,
     ANY = 273,
     ARRAY = 274,
     AS = 275,
     ASC = 276,
     ASSERTION = 277,
     ASSIGNMENT = 278,
     ASYMMETRIC = 279,
     AT = 280,
     AUTHORIZATION = 281,
     BACKWARD = 282,
     BEFORE = 283,
     BEGIN_P = 284,
     BETWEEN = 285,
     BIGINT = 286,
     BINARY = 287,
     BIT = 288,
     BOOLEAN_P = 289,
     BOTH = 290,
     BY = 291,
     CACHE = 292,
     CALLED = 293,
     CASCADE = 294,
     CASCADED = 295,
     CASE = 296,
     CAST = 297,
     CHAIN = 298,
     CHAR_P = 299,
     CHARACTER = 300,
     CHARACTERISTICS = 301,
     CHECK = 302,
     CHECKPOINT = 303,
     CLASS = 304,
     CLOSE = 305,
     CLUSTER = 306,
     COALESCE = 307,
     COLLATE = 308,
     COLUMN = 309,
     COMMENT = 310,
     COMMIT = 311,
     COMMITTED = 312,
     CONCURRENTLY = 313,
     CONFIGURATION = 314,
     CONNECTION = 315,
     CONSTRAINT = 316,
     CONSTRAINTS = 317,
     CONTENT_P = 318,
     CONVERSION_P = 319,
     COPY = 320,
     COST = 321,
     CREATE = 322,
     CREATEDB = 323,
     CREATEROLE = 324,
     CREATEUSER = 325,
     CROSS = 326,
     CSV = 327,
     CURRENT_P = 328,
     CURRENT_DATE = 329,
     CURRENT_ROLE = 330,
     CURRENT_TIME = 331,
     CURRENT_TIMESTAMP = 332,
     CURRENT_USER = 333,
     CURSOR = 334,
     CYCLE = 335,
     DATABASE = 336,
     DAY_P = 337,
     DEALLOCATE = 338,
     DEC = 339,
     DECIMAL_P = 340,
     DECLARE = 341,
     DEFAULT = 342,
     DEFAULTS = 343,
     DEFERRABLE = 344,
     DEFERRED = 345,
     DEFINER = 346,
     DELETE_P = 347,
     DELIMITER = 348,
     DELIMITERS = 349,
     DESC = 350,
     DICTIONARY = 351,
     DISABLE_P = 352,
     DISCARD = 353,
     DISTINCT = 354,
     DO = 355,
     DOCUMENT_P = 356,
     DOMAIN_P = 357,
     DOUBLE_P = 358,
     DROP = 359,
     EACH = 360,
     ELSE = 361,
     ENABLE_P = 362,
     ENCODING = 363,
     ENCRYPTED = 364,
     END_P = 365,
     ENUM_P = 366,
     ESCAPE = 367,
     EXCEPT = 368,
     EXCLUDING = 369,
     EXCLUSIVE = 370,
     EXECUTE = 371,
     EXISTS = 372,
     EXPLAIN = 373,
     EXTERNAL = 374,
     EXTRACT = 375,
     FALSE_P = 376,
     FAMILY = 377,
     FETCH = 378,
     FIRST_P = 379,
     FLOAT_P = 380,
     FOR = 381,
     FORCE = 382,
     FOREIGN = 383,
     FORWARD = 384,
     FREEZE = 385,
     FROM = 386,
     FULL = 387,
     FUNCTION = 388,
     GLOBAL = 389,
     GRANT = 390,
     GRANTED = 391,
     GREATEST = 392,
     GROUP_P = 393,
     HANDLER = 394,
     HAVING = 395,
     HEADER_P = 396,
     HOLD = 397,
     HOUR_P = 398,
     IF_P = 399,
     ILIKE = 400,
     IMMEDIATE = 401,
     IMMUTABLE = 402,
     IMPLICIT_P = 403,
     IN_P = 404,
     INCLUDING = 405,
     INCREMENT = 406,
     INDEX = 407,
     INDEXES = 408,
     INHERIT = 409,
     INHERITS = 410,
     INITIALLY = 411,
     INNER_P = 412,
     INOUT = 413,
     INPUT_P = 414,
     INSENSITIVE = 415,
     INSERT = 416,
     INSTEAD = 417,
     INT_P = 418,
     INTEGER = 419,
     INTERSECT = 420,
     INTERVAL = 421,
     INTO = 422,
     INVOKER = 423,
     IS = 424,
     ISNULL = 425,
     ISOLATION = 426,
     JOIN = 427,
     KEY = 428,
     LANCOMPILER = 429,
     LANGUAGE = 430,
     LARGE_P = 431,
     LAST_P = 432,
     LEADING = 433,
     LEAST = 434,
     LEFT = 435,
     LEVEL = 436,
     LIKE = 437,
     LIMIT = 438,
     LISTEN = 439,
     LOAD = 440,
     LOCAL = 441,
     LOCALTIME = 442,
     LOCALTIMESTAMP = 443,
     LOCATION = 444,
     LOCK_P = 445,
     LOGIN_P = 446,
     MAPPING = 447,
     MATCH = 448,
     MAXVALUE = 449,
     MINUTE_P = 450,
     MINVALUE = 451,
     MODE = 452,
     MONTH_P = 453,
     MOVE = 454,
     NAME_P = 455,
     NAMES = 456,
     NATIONAL = 457,
     NATURAL = 458,
     NCHAR = 459,
     NEW = 460,
     NEXT = 461,
     NO = 462,
     NOCREATEDB = 463,
     NOCREATEROLE = 464,
     NOCREATEUSER = 465,
     NOINHERIT = 466,
     NOLOGIN_P = 467,
     NONE = 468,
     NOSUPERUSER = 469,
     NOT = 470,
     NOTHING = 471,
     NOTIFY = 472,
     NOTNULL = 473,
     NOWAIT = 474,
     NULL_P = 475,
     NULLIF = 476,
     NULLS_P = 477,
     NUMERIC = 478,
     OBJECT_P = 479,
     OF = 480,
     OFF = 481,
     OFFSET = 482,
     OIDS = 483,
     OLD = 484,
     ON = 485,
     ONLY = 486,
     OPERATOR = 487,
     OPTION = 488,
     OR = 489,
     ORDER = 490,
     OUT_P = 491,
     OUTER_P = 492,
     OVERLAPS = 493,
     OVERLAY = 494,
     OWNED = 495,
     OWNER = 496,
     PARSER = 497,
     PARTIAL = 498,
     PASSWORD = 499,
     PLACING = 500,
     PLANS = 501,
     POSITION = 502,
     PRECISION = 503,
     PRESERVE = 504,
     PREPARE = 505,
     PREPARED = 506,
     PRIMARY = 507,
     PRIOR = 508,
     PRIVILEGES = 509,
     PROCEDURAL = 510,
     PROCEDURE = 511,
     QUOTE = 512,
     READ = 513,
     REAL = 514,
     REASSIGN = 515,
     RECHECK = 516,
     REFERENCES = 517,
     REINDEX = 518,
     RELATIVE_P = 519,
     RELEASE = 520,
     RENAME = 521,
     REPEATABLE = 522,
     REPLACE = 523,
     REPLICA = 524,
     RESET = 525,
     RESTART = 526,
     RESTRICT = 527,
     RETURNING = 528,
     RETURNS = 529,
     REVOKE = 530,
     RIGHT = 531,
     ROLE = 532,
     ROLLBACK = 533,
     ROW = 534,
     ROWS = 535,
     RULE = 536,
     SAVEPOINT = 537,
     SCHEMA = 538,
     SCROLL = 539,
     SEARCH = 540,
     SECOND_P = 541,
     SECURITY = 542,
     SELECT = 543,
     SEQUENCE = 544,
     SERIALIZABLE = 545,
     SESSION = 546,
     SESSION_USER = 547,
     SET = 548,
     SETOF = 549,
     SHARE = 550,
     SHOW = 551,
     SIMILAR = 552,
     SIMPLE = 553,
     SMALLINT = 554,
     SOME = 555,
     STABLE = 556,
     STANDALONE_P = 557,
     START = 558,
     STATEMENT = 559,
     STATISTICS = 560,
     STDIN = 561,
     STDOUT = 562,
     STORAGE = 563,
     STRICT_P = 564,
     STRIP_P = 565,
     SUBSTRING = 566,
     SUPERUSER_P = 567,
     SYMMETRIC = 568,
     SYSID = 569,
     SYSTEM_P = 570,
     TABLE = 571,
     TABLESPACE = 572,
     TEMP = 573,
     TEMPLATE = 574,
     TEMPORARY = 575,
     TEXT_P = 576,
     THEN = 577,
     TIME = 578,
     TIMESTAMP = 579,
     TO = 580,
     TRAILING = 581,
     TRANSACTION = 582,
     TREAT = 583,
     TRIGGER = 584,
     TRIM = 585,
     TRUE_P = 586,
     TRUNCATE = 587,
     TRUSTED = 588,
     TYPE_P = 589,
     UNCOMMITTED = 590,
     UNENCRYPTED = 591,
     UNION = 592,
     UNIQUE = 593,
     UNKNOWN = 594,
     UNLISTEN = 595,
     UNTIL = 596,
     UPDATE = 597,
     USER = 598,
     USING = 599,
     VACUUM = 600,
     VALID = 601,
     VALIDATOR = 602,
     VALUE_P = 603,
     VALUES = 604,
     VARCHAR = 605,
     VARYING = 606,
     VERBOSE = 607,
     VERSION_P = 608,
     VIEW = 609,
     VOLATILE = 610,
     WHEN = 611,
     WHERE = 612,
     WHITESPACE_P = 613,
     WITH = 614,
     WITHOUT = 615,
     WORK = 616,
     WRITE = 617,
     XML_P = 618,
     XMLATTRIBUTES = 619,
     XMLCONCAT = 620,
     XMLELEMENT = 621,
     XMLFOREST = 622,
     XMLPARSE = 623,
     XMLPI = 624,
     XMLROOT = 625,
     XMLSERIALIZE = 626,
     YEAR_P = 627,
     YES_P = 628,
     ZONE = 629,
     NULLS_FIRST = 630,
     NULLS_LAST = 631,
     WITH_CASCADED = 632,
     WITH_LOCAL = 633,
     WITH_CHECK = 634,
     IDENT = 635,
     FCONST = 636,
     SCONST = 637,
     BCONST = 638,
     XCONST = 639,
     Op = 640,
     ICONST = 641,
     PARAM = 642,
     POSTFIXOP = 643,
     UMINUS = 644,
     TYPECAST = 645
   };
#endif
/* Tokens.  */
#define ABORT_P 258
#define ABSOLUTE_P 259
#define ACCESS 260
#define ACTION 261
#define ADD_P 262
#define ADMIN 263
#define AFTER 264
#define AGGREGATE 265
#define ALL 266
#define ALSO 267
#define ALTER 268
#define ALWAYS 269
#define ANALYSE 270
#define ANALYZE 271
#define AND 272
#define ANY 273
#define ARRAY 274
#define AS 275
#define ASC 276
#define ASSERTION 277
#define ASSIGNMENT 278
#define ASYMMETRIC 279
#define AT 280
#define AUTHORIZATION 281
#define BACKWARD 282
#define BEFORE 283
#define BEGIN_P 284
#define BETWEEN 285
#define BIGINT 286
#define BINARY 287
#define BIT 288
#define BOOLEAN_P 289
#define BOTH 290
#define BY 291
#define CACHE 292
#define CALLED 293
#define CASCADE 294
#define CASCADED 295
#define CASE 296
#define CAST 297
#define CHAIN 298
#define CHAR_P 299
#define CHARACTER 300
#define CHARACTERISTICS 301
#define CHECK 302
#define CHECKPOINT 303
#define CLASS 304
#define CLOSE 305
#define CLUSTER 306
#define COALESCE 307
#define COLLATE 308
#define COLUMN 309
#define COMMENT 310
#define COMMIT 311
#define COMMITTED 312
#define CONCURRENTLY 313
#define CONFIGURATION 314
#define CONNECTION 315
#define CONSTRAINT 316
#define CONSTRAINTS 317
#define CONTENT_P 318
#define CONVERSION_P 319
#define COPY 320
#define COST 321
#define CREATE 322
#define CREATEDB 323
#define CREATEROLE 324
#define CREATEUSER 325
#define CROSS 326
#define CSV 327
#define CURRENT_P 328
#define CURRENT_DATE 329
#define CURRENT_ROLE 330
#define CURRENT_TIME 331
#define CURRENT_TIMESTAMP 332
#define CURRENT_USER 333
#define CURSOR 334
#define CYCLE 335
#define DATABASE 336
#define DAY_P 337
#define DEALLOCATE 338
#define DEC 339
#define DECIMAL_P 340
#define DECLARE 341
#define DEFAULT 342
#define DEFAULTS 343
#define DEFERRABLE 344
#define DEFERRED 345
#define DEFINER 346
#define DELETE_P 347
#define DELIMITER 348
#define DELIMITERS 349
#define DESC 350
#define DICTIONARY 351
#define DISABLE_P 352
#define DISCARD 353
#define DISTINCT 354
#define DO 355
#define DOCUMENT_P 356
#define DOMAIN_P 357
#define DOUBLE_P 358
#define DROP 359
#define EACH 360
#define ELSE 361
#define ENABLE_P 362
#define ENCODING 363
#define ENCRYPTED 364
#define END_P 365
#define ENUM_P 366
#define ESCAPE 367
#define EXCEPT 368
#define EXCLUDING 369
#define EXCLUSIVE 370
#define EXECUTE 371
#define EXISTS 372
#define EXPLAIN 373
#define EXTERNAL 374
#define EXTRACT 375
#define FALSE_P 376
#define FAMILY 377
#define FETCH 378
#define FIRST_P 379
#define FLOAT_P 380
#define FOR 381
#define FORCE 382
#define FOREIGN 383
#define FORWARD 384
#define FREEZE 385
#define FROM 386
#define FULL 387
#define FUNCTION 388
#define GLOBAL 389
#define GRANT 390
#define GRANTED 391
#define GREATEST 392
#define GROUP_P 393
#define HANDLER 394
#define HAVING 395
#define HEADER_P 396
#define HOLD 397
#define HOUR_P 398
#define IF_P 399
#define ILIKE 400
#define IMMEDIATE 401
#define IMMUTABLE 402
#define IMPLICIT_P 403
#define IN_P 404
#define INCLUDING 405
#define INCREMENT 406
#define INDEX 407
#define INDEXES 408
#define INHERIT 409
#define INHERITS 410
#define INITIALLY 411
#define INNER_P 412
#define INOUT 413
#define INPUT_P 414
#define INSENSITIVE 415
#define INSERT 416
#define INSTEAD 417
#define INT_P 418
#define INTEGER 419
#define INTERSECT 420
#define INTERVAL 421
#define INTO 422
#define INVOKER 423
#define IS 424
#define ISNULL 425
#define ISOLATION 426
#define JOIN 427
#define KEY 428
#define LANCOMPILER 429
#define LANGUAGE 430
#define LARGE_P 431
#define LAST_P 432
#define LEADING 433
#define LEAST 434
#define LEFT 435
#define LEVEL 436
#define LIKE 437
#define LIMIT 438
#define LISTEN 439
#define LOAD 440
#define LOCAL 441
#define LOCALTIME 442
#define LOCALTIMESTAMP 443
#define LOCATION 444
#define LOCK_P 445
#define LOGIN_P 446
#define MAPPING 447
#define MATCH 448
#define MAXVALUE 449
#define MINUTE_P 450
#define MINVALUE 451
#define MODE 452
#define MONTH_P 453
#define MOVE 454
#define NAME_P 455
#define NAMES 456
#define NATIONAL 457
#define NATURAL 458
#define NCHAR 459
#define NEW 460
#define NEXT 461
#define NO 462
#define NOCREATEDB 463
#define NOCREATEROLE 464
#define NOCREATEUSER 465
#define NOINHERIT 466
#define NOLOGIN_P 467
#define NONE 468
#define NOSUPERUSER 469
#define NOT 470
#define NOTHING 471
#define NOTIFY 472
#define NOTNULL 473
#define NOWAIT 474
#define NULL_P 475
#define NULLIF 476
#define NULLS_P 477
#define NUMERIC 478
#define OBJECT_P 479
#define OF 480
#define OFF 481
#define OFFSET 482
#define OIDS 483
#define OLD 484
#define ON 485
#define ONLY 486
#define OPERATOR 487
#define OPTION 488
#define OR 489
#define ORDER 490
#define OUT_P 491
#define OUTER_P 492
#define OVERLAPS 493
#define OVERLAY 494
#define OWNED 495
#define OWNER 496
#define PARSER 497
#define PARTIAL 498
#define PASSWORD 499
#define PLACING 500
#define PLANS 501
#define POSITION 502
#define PRECISION 503
#define PRESERVE 504
#define PREPARE 505
#define PREPARED 506
#define PRIMARY 507
#define PRIOR 508
#define PRIVILEGES 509
#define PROCEDURAL 510
#define PROCEDURE 511
#define QUOTE 512
#define READ 513
#define REAL 514
#define REASSIGN 515
#define RECHECK 516
#define REFERENCES 517
#define REINDEX 518
#define RELATIVE_P 519
#define RELEASE 520
#define RENAME 521
#define REPEATABLE 522
#define REPLACE 523
#define REPLICA 524
#define RESET 525
#define RESTART 526
#define RESTRICT 527
#define RETURNING 528
#define RETURNS 529
#define REVOKE 530
#define RIGHT 531
#define ROLE 532
#define ROLLBACK 533
#define ROW 534
#define ROWS 535
#define RULE 536
#define SAVEPOINT 537
#define SCHEMA 538
#define SCROLL 539
#define SEARCH 540
#define SECOND_P 541
#define SECURITY 542
#define SELECT 543
#define SEQUENCE 544
#define SERIALIZABLE 545
#define SESSION 546
#define SESSION_USER 547
#define SET 548
#define SETOF 549
#define SHARE 550
#define SHOW 551
#define SIMILAR 552
#define SIMPLE 553
#define SMALLINT 554
#define SOME 555
#define STABLE 556
#define STANDALONE_P 557
#define START 558
#define STATEMENT 559
#define STATISTICS 560
#define STDIN 561
#define STDOUT 562
#define STORAGE 563
#define STRICT_P 564
#define STRIP_P 565
#define SUBSTRING 566
#define SUPERUSER_P 567
#define SYMMETRIC 568
#define SYSID 569
#define SYSTEM_P 570
#define TABLE 571
#define TABLESPACE 572
#define TEMP 573
#define TEMPLATE 574
#define TEMPORARY 575
#define TEXT_P 576
#define THEN 577
#define TIME 578
#define TIMESTAMP 579
#define TO 580
#define TRAILING 581
#define TRANSACTION 582
#define TREAT 583
#define TRIGGER 584
#define TRIM 585
#define TRUE_P 586
#define TRUNCATE 587
#define TRUSTED 588
#define TYPE_P 589
#define UNCOMMITTED 590
#define UNENCRYPTED 591
#define UNION 592
#define UNIQUE 593
#define UNKNOWN 594
#define UNLISTEN 595
#define UNTIL 596
#define UPDATE 597
#define USER 598
#define USING 599
#define VACUUM 600
#define VALID 601
#define VALIDATOR 602
#define VALUE_P 603
#define VALUES 604
#define VARCHAR 605
#define VARYING 606
#define VERBOSE 607
#define VERSION_P 608
#define VIEW 609
#define VOLATILE 610
#define WHEN 611
#define WHERE 612
#define WHITESPACE_P 613
#define WITH 614
#define WITHOUT 615
#define WORK 616
#define WRITE 617
#define XML_P 618
#define XMLATTRIBUTES 619
#define XMLCONCAT 620
#define XMLELEMENT 621
#define XMLFOREST 622
#define XMLPARSE 623
#define XMLPI 624
#define XMLROOT 625
#define XMLSERIALIZE 626
#define YEAR_P 627
#define YES_P 628
#define ZONE 629
#define NULLS_FIRST 630
#define NULLS_LAST 631
#define WITH_CASCADED 632
#define WITH_LOCAL 633
#define WITH_CHECK 634
#define IDENT 635
#define FCONST 636
#define SCONST 637
#define BCONST 638
#define XCONST 639
#define Op 640
#define ICONST 641
#define PARAM 642
#define POSTFIXOP 643
#define UMINUS 644
#define TYPECAST 645




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 118 "gram.y"

	int					ival;
	char				chr;
	char				*str;
	const char			*keyword;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;

	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	A_Indices			*aind;
	ResTarget			*target;
	PrivTarget			*privtarget;

	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;



/* Line 214 of yacc.c  */
#line 1046 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 1071 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  621
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   47947

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  408
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  427
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1813
/* YYNRULES -- Number of states.  */
#define YYNSTATES  3288

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   645

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   396,     2,     2,
     401,   402,   394,   392,   406,   393,   404,   395,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   407,   405,
     389,   388,   390,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   399,     2,   400,   397,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   391,   398,   403
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   194,   200,   202,
     203,   206,   207,   210,   213,   217,   221,   223,   225,   227,
     229,   231,   233,   235,   237,   239,   241,   243,   245,   249,
     253,   256,   259,   262,   265,   269,   273,   279,   285,   290,
     296,   301,   305,   311,   315,   321,   327,   334,   336,   338,
     342,   348,   355,   360,   362,   363,   366,   367,   369,   371,
     373,   375,   377,   379,   382,   386,   390,   394,   398,   402,
     406,   410,   414,   417,   423,   426,   429,   433,   437,   441,
     443,   447,   449,   453,   455,   457,   459,   462,   465,   468,
     470,   472,   474,   476,   478,   480,   482,   486,   493,   495,
     497,   499,   501,   503,   504,   506,   508,   511,   515,   520,
     524,   527,   530,   532,   535,   539,   544,   548,   551,   556,
     558,   560,   562,   564,   566,   569,   572,   575,   578,   583,
     588,   590,   594,   598,   603,   610,   617,   624,   631,   636,
     643,   646,   651,   655,   659,   663,   667,   672,   677,   681,
     685,   689,   693,   697,   701,   706,   711,   715,   718,   722,
     724,   726,   730,   734,   738,   741,   744,   748,   751,   753,
     755,   756,   759,   760,   763,   766,   777,   784,   786,   788,
     790,   792,   794,   797,   798,   800,   802,   806,   810,   812,
     814,   818,   822,   826,   831,   833,   834,   837,   838,   842,
     843,   845,   846,   858,   871,   873,   875,   878,   881,   884,
     887,   888,   890,   891,   893,   897,   899,   901,   903,   907,
     910,   911,   915,   917,   919,   922,   924,   928,   933,   938,
     941,   947,   949,   952,   955,   958,   962,   965,   966,   969,
     972,   975,   978,   981,   984,   988,   990,   995,  1002,  1010,
    1022,  1026,  1027,  1029,  1033,  1035,  1038,  1041,  1044,  1045,
    1047,  1049,  1052,  1055,  1056,  1060,  1064,  1067,  1069,  1071,
    1074,  1077,  1082,  1083,  1086,  1089,  1092,  1093,  1097,  1102,
    1107,  1108,  1111,  1112,  1117,  1118,  1125,  1131,  1135,  1136,
    1138,  1142,  1144,  1150,  1155,  1158,  1159,  1162,  1164,  1167,
    1171,  1174,  1177,  1180,  1183,  1187,  1191,  1195,  1197,  1198,
    1200,  1202,  1204,  1207,  1209,  1215,  1225,  1227,  1228,  1230,
    1233,  1236,  1237,  1240,  1241,  1247,  1255,  1257,  1258,  1265,
    1268,  1269,  1273,  1279,  1294,  1314,  1316,  1318,  1320,  1324,
    1330,  1332,  1334,  1336,  1340,  1341,  1343,  1344,  1346,  1348,
    1350,  1354,  1355,  1357,  1359,  1361,  1363,  1365,  1367,  1370,
    1371,  1373,  1376,  1378,  1381,  1382,  1385,  1387,  1390,  1393,
    1400,  1409,  1418,  1423,  1429,  1434,  1439,  1444,  1448,  1456,
    1465,  1472,  1479,  1486,  1493,  1497,  1499,  1503,  1507,  1509,
    1511,  1513,  1515,  1517,  1519,  1523,  1527,  1531,  1533,  1537,
    1541,  1543,  1547,  1561,  1563,  1567,  1572,  1580,  1585,  1593,
    1596,  1598,  1599,  1602,  1603,  1605,  1606,  1613,  1622,  1631,
    1633,  1637,  1643,  1649,  1657,  1667,  1675,  1685,  1691,  1698,
    1705,  1710,  1712,  1714,  1716,  1718,  1720,  1722,  1724,  1726,
    1730,  1734,  1738,  1742,  1744,  1748,  1750,  1753,  1756,  1760,
    1765,  1772,  1780,  1788,  1798,  1807,  1816,  1823,  1832,  1842,
    1852,  1860,  1871,  1879,  1888,  1897,  1906,  1915,  1917,  1919,
    1921,  1923,  1925,  1927,  1929,  1931,  1933,  1935,  1937,  1939,
    1941,  1943,  1948,  1951,  1956,  1959,  1960,  1962,  1964,  1966,
    1968,  1971,  1974,  1976,  1978,  1980,  1983,  1986,  1988,  1991,
    1994,  1996,  1998,  2006,  2014,  2025,  2027,  2029,  2032,  2034,
    2038,  2040,  2042,  2044,  2046,  2048,  2051,  2054,  2057,  2060,
    2063,  2066,  2069,  2071,  2075,  2077,  2080,  2084,  2085,  2087,
    2091,  2094,  2101,  2108,  2118,  2122,  2123,  2127,  2128,  2142,
    2157,  2159,  2160,  2163,  2164,  2166,  2170,  2175,  2180,  2187,
    2189,  2192,  2193,  2195,  2197,  2198,  2200,  2202,  2203,  2213,
    2221,  2224,  2225,  2229,  2232,  2234,  2238,  2242,  2246,  2249,
    2252,  2254,  2256,  2258,  2260,  2263,  2265,  2267,  2269,  2274,
    2280,  2282,  2285,  2290,  2296,  2298,  2300,  2302,  2304,  2308,
    2312,  2315,  2318,  2321,  2324,  2326,  2329,  2332,  2334,  2336,
    2340,  2343,  2344,  2350,  2352,  2355,  2357,  2358,  2364,  2372,
    2378,  2386,  2394,  2404,  2406,  2410,  2414,  2418,  2420,  2424,
    2436,  2447,  2450,  2453,  2454,  2464,  2467,  2468,  2473,  2478,
    2483,  2485,  2487,  2489,  2490,  2498,  2505,  2512,  2519,  2526,
    2534,  2544,  2554,  2561,  2568,  2575,  2582,  2589,  2598,  2607,
    2614,  2621,  2628,  2637,  2646,  2655,  2664,  2666,  2667,  2675,
    2682,  2689,  2696,  2703,  2710,  2718,  2725,  2732,  2739,  2746,
    2754,  2764,  2774,  2784,  2791,  2798,  2805,  2814,  2823,  2824,
    2839,  2841,  2843,  2847,  2851,  2853,  2855,  2857,  2859,  2861,
    2863,  2865,  2866,  2868,  2870,  2872,  2874,  2876,  2878,  2879,
    2886,  2895,  2898,  2901,  2904,  2907,  2910,  2914,  2918,  2921,
    2924,  2927,  2930,  2934,  2937,  2943,  2948,  2952,  2956,  2960,
    2962,  2964,  2965,  2969,  2972,  2975,  2977,  2981,  2984,  2986,
    2987,  2996,  3007,  3010,  3014,  3018,  3019,  3022,  3028,  3031,
    3032,  3036,  3040,  3044,  3048,  3052,  3056,  3060,  3064,  3068,
    3073,  3077,  3081,  3083,  3084,  3090,  3095,  3098,  3099,  3104,
    3108,  3114,  3121,  3126,  3133,  3140,  3146,  3154,  3156,  3157,
    3164,  3176,  3188,  3200,  3214,  3224,  3236,  3247,  3251,  3253,
    3258,  3261,  3262,  3267,  3273,  3279,  3282,  3287,  3289,  3291,
    3293,  3294,  3296,  3297,  3299,  3300,  3304,  3305,  3310,  3312,
    3314,  3316,  3318,  3320,  3322,  3324,  3325,  3331,  3335,  3336,
    3338,  3340,  3342,  3344,  3348,  3357,  3361,  3362,  3365,  3369,
    3372,  3376,  3382,  3384,  3389,  3392,  3394,  3398,  3401,  3404,
    3405,  3412,  3415,  3416,  3422,  3426,  3427,  3430,  3433,  3436,
    3440,  3442,  3446,  3448,  3451,  3453,  3454,  3462,  3464,  3468,
    3470,  3472,  3476,  3482,  3485,  3487,  3491,  3499,  3500,  3504,
    3507,  3510,  3513,  3514,  3517,  3520,  3522,  3524,  3528,  3532,
    3534,  3537,  3542,  3547,  3549,  3551,  3560,  3562,  3567,  3572,
    3577,  3580,  3581,  3585,  3589,  3594,  3599,  3604,  3609,  3612,
    3614,  3616,  3617,  3619,  3621,  3622,  3624,  3630,  3632,  3633,
    3635,  3636,  3640,  3642,  3646,  3651,  3655,  3660,  3665,  3668,
    3671,  3676,  3678,  3679,  3681,  3683,  3685,  3689,  3690,  3693,
    3694,  3696,  3700,  3702,  3703,  3705,  3708,  3713,  3718,  3721,
    3722,  3725,  3729,  3732,  3733,  3735,  3739,  3741,  3744,  3746,
    3749,  3755,  3762,  3768,  3770,  3773,  3775,  3780,  3784,  3789,
    3795,  3800,  3806,  3811,  3817,  3820,  3825,  3827,  3830,  3833,
    3836,  3838,  3840,  3841,  3846,  3849,  3851,  3854,  3857,  3862,
    3864,  3867,  3871,  3873,  3876,  3877,  3880,  3885,  3890,  3891,
    3893,  3897,  3900,  3903,  3907,  3913,  3920,  3924,  3929,  3930,
    3932,  3934,  3936,  3938,  3940,  3943,  3949,  3951,  3953,  3955,
    3957,  3960,  3964,  3968,  3969,  3971,  3973,  3975,  3977,  3979,
    3982,  3985,  3988,  3991,  3994,  3996,  4000,  4001,  4003,  4005,
    4007,  4009,  4015,  4018,  4020,  4022,  4024,  4026,  4032,  4035,
    4038,  4041,  4043,  4047,  4051,  4054,  4056,  4057,  4061,  4062,
    4068,  4071,  4077,  4080,  4082,  4086,  4090,  4091,  4093,  4095,
    4097,  4099,  4101,  4103,  4107,  4111,  4115,  4119,  4123,  4127,
    4131,  4132,  4134,  4138,  4144,  4147,  4150,  4154,  4158,  4162,
    4166,  4170,  4174,  4178,  4182,  4186,  4190,  4193,  4196,  4200,
    4204,  4207,  4211,  4217,  4222,  4229,  4233,  4239,  4244,  4251,
    4256,  4263,  4269,  4277,  4281,  4284,  4289,  4292,  4296,  4300,
    4305,  4309,  4314,  4318,  4323,  4329,  4336,  4343,  4351,  4358,
    4366,  4373,  4381,  4385,  4390,  4395,  4402,  4405,  4409,  4414,
    4416,  4420,  4423,  4426,  4430,  4434,  4438,  4442,  4446,  4450,
    4454,  4458,  4462,  4466,  4469,  4472,  4478,  4485,  4492,  4500,
    4504,  4509,  4511,  4513,  4516,  4521,  4523,  4525,  4527,  4530,
    4533,  4536,  4539,  4541,  4545,  4550,  4556,  4562,  4567,  4569,
    4571,  4576,  4578,  4583,  4585,  4590,  4592,  4597,  4599,  4601,
    4603,  4605,  4612,  4617,  4622,  4627,  4632,  4639,  4645,  4651,
    4657,  4662,  4669,  4674,  4679,  4684,  4689,  4695,  4703,  4711,
    4721,  4726,  4733,  4739,  4747,  4755,  4763,  4766,  4770,  4774,
    4778,  4783,  4784,  4789,  4791,  4795,  4799,  4801,  4803,  4805,
    4808,  4811,  4812,  4817,  4821,  4827,  4829,  4831,  4833,  4835,
    4837,  4839,  4841,  4843,  4845,  4847,  4849,  4851,  4853,  4855,
    4857,  4862,  4864,  4869,  4871,  4876,  4878,  4881,  4883,  4886,
    4888,  4892,  4896,  4897,  4899,  4903,  4905,  4909,  4913,  4917,
    4919,  4921,  4923,  4925,  4927,  4929,  4931,  4933,  4938,  4942,
    4945,  4949,  4950,  4954,  4958,  4961,  4964,  4966,  4967,  4970,
    4973,  4977,  4980,  4982,  4984,  4988,  4994,  4996,  4999,  5004,
    5007,  5008,  5010,  5011,  5013,  5016,  5019,  5022,  5026,  5032,
    5034,  5037,  5038,  5041,  5043,  5044,  5046,  5048,  5050,  5054,
    5058,  5060,  5064,  5068,  5070,  5072,  5074,  5076,  5078,  5082,
    5084,  5087,  5089,  5093,  5095,  5097,  5099,  5101,  5103,  5105,
    5107,  5110,  5112,  5114,  5116,  5118,  5120,  5123,  5129,  5132,
    5136,  5143,  5145,  5147,  5149,  5151,  5153,  5155,  5157,  5160,
    5162,  5164,  5166,  5168,  5170,  5172,  5174,  5176,  5178,  5180,
    5182,  5184,  5186,  5188,  5190,  5192,  5194,  5196,  5198,  5200,
    5202,  5204,  5206,  5208,  5210,  5212,  5214,  5216,  5218,  5220,
    5222,  5224,  5226,  5228,  5230,  5232,  5234,  5236,  5238,  5240,
    5242,  5244,  5246,  5248,  5250,  5252,  5254,  5256,  5258,  5260,
    5262,  5264,  5266,  5268,  5270,  5272,  5274,  5276,  5278,  5280,
    5282,  5284,  5286,  5288,  5290,  5292,  5294,  5296,  5298,  5300,
    5302,  5304,  5306,  5308,  5310,  5312,  5314,  5316,  5318,  5320,
    5322,  5324,  5326,  5328,  5330,  5332,  5334,  5336,  5338,  5340,
    5342,  5344,  5346,  5348,  5350,  5352,  5354,  5356,  5358,  5360,
    5362,  5364,  5366,  5368,  5370,  5372,  5374,  5376,  5378,  5380,
    5382,  5384,  5386,  5388,  5390,  5392,  5394,  5396,  5398,  5400,
    5402,  5404,  5406,  5408,  5410,  5412,  5414,  5416,  5418,  5420,
    5422,  5424,  5426,  5428,  5430,  5432,  5434,  5436,  5438,  5440,
    5442,  5444,  5446,  5448,  5450,  5452,  5454,  5456,  5458,  5460,
    5462,  5464,  5466,  5468,  5470,  5472,  5474,  5476,  5478,  5480,
    5482,  5484,  5486,  5488,  5490,  5492,  5494,  5496,  5498,  5500,
    5502,  5504,  5506,  5508,  5510,  5512,  5514,  5516,  5518,  5520,
    5522,  5524,  5526,  5528,  5530,  5532,  5534,  5536,  5538,  5540,
    5542,  5544,  5546,  5548,  5550,  5552,  5554,  5556,  5558,  5560,
    5562,  5564,  5566,  5568,  5570,  5572,  5574,  5576,  5578,  5580,
    5582,  5584,  5586,  5588,  5590,  5592,  5594,  5596,  5598,  5600,
    5602,  5604,  5606,  5608,  5610,  5612,  5614,  5616,  5618,  5620,
    5622,  5624,  5626,  5628,  5630,  5632,  5634,  5636,  5638,  5640,
    5642,  5644,  5646,  5648,  5650,  5652,  5654,  5656,  5658,  5660,
    5662,  5664,  5666,  5668,  5670,  5672,  5674,  5676,  5678,  5680,
    5682,  5684,  5686,  5688,  5690,  5692,  5694,  5696,  5698,  5700,
    5702,  5704,  5706,  5708,  5710,  5712,  5714,  5716,  5718,  5720,
    5722,  5724,  5726,  5728,  5730,  5732,  5734,  5736,  5738,  5740,
    5742,  5744,  5746,  5748,  5750,  5752,  5754,  5756,  5758,  5760,
    5762,  5764,  5766,  5768,  5770,  5772,  5774,  5776,  5778,  5780,
    5782,  5784,  5786,  5788,  5790,  5792,  5794,  5796,  5798,  5800,
    5802,  5804,  5806,  5808,  5810,  5812,  5814,  5816,  5818,  5820,
    5822,  5824,  5826,  5828,  5830,  5832,  5834,  5836,  5838,  5840,
    5842,  5844,  5846,  5848,  5850,  5852,  5854,  5856,  5858,  5860,
    5862,  5864,  5866,  5868,  5870,  5872,  5874,  5876,  5878,  5880,
    5882,  5884,  5886,  5888,  5890,  5892,  5894,  5896,  5898,  5900,
    5902,  5904,  5906,  5908,  5910,  5912,  5914,  5916,  5918,  5920,
    5922,  5924,  5926,  5928
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     409,     0,    -1,   410,    -1,   410,   405,   411,    -1,   411,
      -1,   650,    -1,   651,    -1,   656,    -1,   607,    -1,   424,
      -1,   624,    -1,   625,    -1,   501,    -1,   449,    -1,   418,
      -1,   417,    -1,   659,    -1,   658,    -1,   420,    -1,   419,
      -1,   664,    -1,   447,    -1,   457,    -1,   661,    -1,   564,
      -1,   444,    -1,   458,    -1,   495,    -1,   532,    -1,   615,
      -1,   660,    -1,   655,    -1,   593,    -1,   423,    -1,   544,
      -1,   550,    -1,   551,    -1,   508,    -1,   427,    -1,   500,
      -1,   467,    -1,   515,    -1,   518,    -1,   412,    -1,   416,
      -1,   646,    -1,   678,    -1,   697,    -1,   534,    -1,   684,
      -1,   448,    -1,   533,    -1,   617,    -1,   426,    -1,   554,
      -1,   555,    -1,   556,    -1,   513,    -1,   634,    -1,   558,
      -1,   517,    -1,   531,    -1,   421,    -1,   422,    -1,   654,
      -1,   676,    -1,   670,    -1,   567,    -1,   570,    -1,   581,
      -1,   585,    -1,   679,    -1,   636,    -1,   645,    -1,   686,
      -1,   635,    -1,   673,    -1,   557,    -1,   619,    -1,   611,
      -1,   610,    -1,   612,    -1,   622,    -1,   571,    -1,   582,
      -1,   626,    -1,   700,    -1,   638,    -1,   563,    -1,   637,
      -1,   690,    -1,   663,    -1,   441,    -1,   431,    -1,   443,
      -1,   643,    -1,    -1,    67,   277,   825,   413,   414,    -1,
     359,    -1,    -1,   414,   415,    -1,    -1,   244,   824,    -1,
     244,   220,    -1,   109,   244,   824,    -1,   336,   244,   824,
      -1,   312,    -1,   214,    -1,   154,    -1,   211,    -1,    68,
      -1,   208,    -1,    69,    -1,   209,    -1,    70,    -1,   210,
      -1,   191,    -1,   212,    -1,    60,   183,   826,    -1,   346,
     341,   824,    -1,   343,   814,    -1,   314,   823,    -1,     8,
     814,    -1,   277,   814,    -1,   149,   277,   814,    -1,   149,
     138,   814,    -1,    67,   343,   825,   413,   414,    -1,    13,
     277,   825,   413,   414,    -1,    13,   277,   825,   442,    -1,
      13,   343,   825,   413,   414,    -1,    13,   343,   825,   442,
      -1,   104,   277,   814,    -1,   104,   277,   144,   117,   814,
      -1,   104,   343,   814,    -1,   104,   343,   144,   117,   814,
      -1,    67,   138,   825,   413,   414,    -1,    13,   138,   825,
     425,   343,   814,    -1,     7,    -1,   104,    -1,   104,   138,
     814,    -1,   104,   138,   144,   117,   814,    -1,    67,   283,
     428,    26,   825,   429,    -1,    67,   283,   827,   429,    -1,
     827,    -1,    -1,   429,   430,    -1,    -1,   467,    -1,   585,
      -1,   500,    -1,   518,    -1,   570,    -1,   643,    -1,   293,
     432,    -1,   293,   186,   432,    -1,   293,   291,   432,    -1,
     433,   325,   434,    -1,   433,   388,   434,    -1,   433,   325,
      87,    -1,   433,   388,    87,    -1,   433,   131,    73,    -1,
     323,   374,   438,    -1,   327,   641,    -1,   291,    46,    20,
     327,   641,    -1,   201,   439,    -1,   277,   440,    -1,   291,
      26,   440,    -1,   291,    26,    87,    -1,   363,   233,   773,
      -1,   827,    -1,   433,   404,   827,    -1,   435,    -1,   434,
     406,   435,    -1,   437,    -1,   440,    -1,   505,    -1,   258,
     335,    -1,   258,    57,    -1,   267,   258,    -1,   290,    -1,
     331,    -1,   121,    -1,   230,    -1,   226,    -1,   824,    -1,
     380,    -1,   761,   824,   763,    -1,   761,   401,   823,   402,
     824,   763,    -1,   505,    -1,    87,    -1,   186,    -1,   824,
      -1,    87,    -1,    -1,   827,    -1,   382,    -1,   270,   433,
      -1,   270,   323,   374,    -1,   270,   327,   171,   181,    -1,
     270,   291,    26,    -1,   270,    11,    -1,   293,   432,    -1,
     441,    -1,   296,   433,    -1,   296,   323,   374,    -1,   296,
     327,   171,   181,    -1,   296,   291,    26,    -1,   296,    11,
      -1,   293,    62,   445,   446,    -1,    11,    -1,   812,    -1,
      90,    -1,   146,    -1,    48,    -1,    98,    11,    -1,    98,
     318,    -1,    98,   320,    -1,    98,   246,    -1,    13,   316,
     734,   450,    -1,    13,   152,   734,   452,    -1,   451,    -1,
     450,   406,   451,    -1,     7,   623,   472,    -1,    13,   623,
     827,   454,    -1,    13,   623,   827,   104,   215,   220,    -1,
      13,   623,   827,   293,   215,   220,    -1,    13,   623,   827,
     293,   305,   507,    -1,    13,   623,   827,   293,   308,   827,
      -1,   104,   623,   827,   455,    -1,    13,   623,   827,   334,
     741,   456,    -1,     7,   480,    -1,   104,    61,   815,   455,
      -1,   293,   360,   228,    -1,    51,   230,   815,    -1,   293,
     360,    51,    -1,   107,   329,   815,    -1,   107,    14,   329,
     815,    -1,   107,   269,   329,   815,    -1,   107,   329,    11,
      -1,   107,   329,   343,    -1,    97,   329,   815,    -1,    97,
     329,    11,    -1,    97,   329,   343,    -1,   107,   281,   815,
      -1,   107,    14,   281,   815,    -1,   107,   269,   281,   815,
      -1,    97,   281,   815,    -1,   154,   813,    -1,   207,   154,
     813,    -1,   453,    -1,   453,    -1,   452,   406,   453,    -1,
     241,   325,   825,    -1,   293,   317,   815,    -1,   293,   535,
      -1,   270,   535,    -1,   293,    87,   764,    -1,   104,    87,
      -1,    39,    -1,   272,    -1,    -1,   344,   764,    -1,    -1,
      50,   815,    -1,    50,    11,    -1,    65,   463,   813,   482,
     464,   459,   460,   465,   413,   461,    -1,    65,   701,   325,
     460,   413,   461,    -1,   131,    -1,   325,    -1,   824,    -1,
     306,    -1,   307,    -1,   461,   462,    -1,    -1,    32,    -1,
     228,    -1,    93,   657,   824,    -1,   220,   657,   824,    -1,
      72,    -1,   141,    -1,   257,   657,   824,    -1,   112,   657,
     824,    -1,   127,   257,   483,    -1,   127,   215,   220,   483,
      -1,    32,    -1,    -1,   359,   228,    -1,    -1,   466,    94,
     824,    -1,    -1,   344,    -1,    -1,    67,   468,   316,   813,
     401,   469,   402,   490,   491,   492,   493,    -1,    67,   468,
     316,   813,   225,   813,   401,   469,   402,   491,   492,   493,
      -1,   320,    -1,   318,    -1,   186,   320,    -1,   186,   318,
      -1,   134,   320,    -1,   134,   318,    -1,    -1,   470,    -1,
      -1,   471,    -1,   470,   406,   471,    -1,   472,    -1,   477,
      -1,   480,    -1,   827,   741,   473,    -1,   473,   474,    -1,
      -1,    61,   815,   475,    -1,   475,    -1,   476,    -1,   215,
     220,    -1,   220,    -1,   338,   606,   494,    -1,   252,   173,
     606,   494,    -1,    47,   401,   764,   402,    -1,    87,   765,
      -1,   262,   813,   482,   485,   486,    -1,    89,    -1,   215,
      89,    -1,   156,    90,    -1,   156,   146,    -1,   182,   813,
     478,    -1,   478,   479,    -1,    -1,   150,    88,    -1,   114,
      88,    -1,   150,    62,    -1,   114,    62,    -1,   150,   153,
      -1,   114,   153,    -1,    61,   815,   481,    -1,   481,    -1,
      47,   401,   764,   402,    -1,   338,   401,   483,   402,   606,
     494,    -1,   252,   173,   401,   483,   402,   606,   494,    -1,
     128,   173,   401,   483,   402,   262,   813,   482,   485,   486,
     528,    -1,   401,   483,   402,    -1,    -1,   484,    -1,   483,
     406,   484,    -1,   827,    -1,   193,   132,    -1,   193,   243,
      -1,   193,   298,    -1,    -1,   487,    -1,   488,    -1,   487,
     488,    -1,   488,   487,    -1,    -1,   230,   342,   489,    -1,
     230,    92,   489,    -1,   207,     6,    -1,   272,    -1,    39,
      -1,   293,   220,    -1,   293,    87,    -1,   155,   401,   812,
     402,    -1,    -1,   359,   535,    -1,   359,   228,    -1,   360,
     228,    -1,    -1,   230,    56,   104,    -1,   230,    56,    92,
     280,    -1,   230,    56,   249,   280,    -1,    -1,   317,   815,
      -1,    -1,   344,   152,   317,   815,    -1,    -1,    67,   468,
     316,   496,    20,   700,    -1,   813,   497,   491,   492,   493,
      -1,   401,   498,   402,    -1,    -1,   499,    -1,   498,   406,
     499,    -1,   827,    -1,    67,   468,   289,   813,   502,    -1,
      13,   289,   813,   502,    -1,   502,   503,    -1,    -1,    37,
     505,    -1,    80,    -1,   207,    80,    -1,   151,   504,   505,
      -1,   194,   505,    -1,   196,   505,    -1,   207,   194,    -1,
     207,   196,    -1,   240,    36,   561,    -1,   303,   413,   505,
      -1,   271,   413,   505,    -1,    36,    -1,    -1,   506,    -1,
     507,    -1,   381,    -1,   393,   381,    -1,   826,    -1,    67,
     509,   514,   175,   440,    -1,    67,   509,   514,   175,   440,
     139,   510,   511,   512,    -1,   333,    -1,    -1,   815,    -1,
     815,   562,    -1,   347,   510,    -1,    -1,   174,   824,    -1,
      -1,   104,   514,   175,   440,   455,    -1,   104,   514,   175,
     144,   117,   440,   455,    -1,   255,    -1,    -1,    67,   317,
     815,   516,   189,   824,    -1,   241,   815,    -1,    -1,   104,
     317,   815,    -1,   104,   317,   144,   117,   815,    -1,    67,
     329,   815,   519,   520,   230,   813,   522,   116,   256,   821,
     401,   525,   402,    -1,    67,    61,   329,   815,     9,   520,
     230,   813,   527,   528,   126,   105,   279,   116,   256,   821,
     401,   525,   402,    -1,    28,    -1,     9,    -1,   521,    -1,
     521,   234,   521,    -1,   521,   234,   521,   234,   521,    -1,
     161,    -1,    92,    -1,   342,    -1,   126,   523,   524,    -1,
      -1,   105,    -1,    -1,   279,    -1,   304,    -1,   526,    -1,
     525,   406,   526,    -1,    -1,   386,    -1,   381,    -1,   824,
      -1,   383,    -1,   384,    -1,   827,    -1,   131,   813,    -1,
      -1,   529,    -1,   529,   530,    -1,   530,    -1,   530,   529,
      -1,    -1,   215,    89,    -1,    89,    -1,   156,   146,    -1,
     156,    90,    -1,   104,   329,   815,   230,   813,   455,    -1,
     104,   329,   144,   117,   815,   230,   813,   455,    -1,    67,
      22,   815,    47,   401,   764,   402,   528,    -1,   104,    22,
     815,   455,    -1,    67,    10,   821,   539,   535,    -1,    67,
      10,   821,   540,    -1,    67,   232,   614,   535,    -1,    67,
     334,   561,   535,    -1,    67,   334,   561,    -1,    67,   334,
     561,    20,   401,   739,   402,    -1,    67,   334,   561,    20,
     111,   401,   543,   402,    -1,    67,   321,   285,   242,   561,
     535,    -1,    67,   321,   285,    96,   561,   535,    -1,    67,
     321,   285,   319,   561,   535,    -1,    67,   321,   285,    59,
     561,   535,    -1,   401,   536,   402,    -1,   537,    -1,   536,
     406,   537,    -1,   829,   388,   538,    -1,   829,    -1,   601,
      -1,   833,    -1,   780,    -1,   505,    -1,   824,    -1,   401,
     784,   402,    -1,   401,   394,   402,    -1,   401,   541,   402,
      -1,   542,    -1,   541,   406,   542,    -1,   380,   388,   538,
      -1,   824,    -1,   543,   406,   824,    -1,    67,   232,    49,
     561,   547,   126,   334,   741,   344,   817,   548,    20,   545,
      -1,   546,    -1,   545,   406,   546,    -1,   232,   823,   614,
     549,    -1,   232,   823,   614,   401,   613,   402,   549,    -1,
     133,   823,   821,   595,    -1,   133,   823,   401,   784,   402,
     821,   595,    -1,   308,   741,    -1,    87,    -1,    -1,   122,
     561,    -1,    -1,   261,    -1,    -1,    67,   232,   122,   561,
     344,   817,    -1,    13,   232,   122,   561,   344,   817,     7,
     545,    -1,    13,   232,   122,   561,   344,   817,   104,   552,
      -1,   553,    -1,   552,   406,   553,    -1,   232,   823,   401,
     784,   402,    -1,   133,   823,   401,   784,   402,    -1,   104,
     232,    49,   561,   344,   817,   455,    -1,   104,   232,    49,
     144,   117,   561,   344,   817,   455,    -1,   104,   232,   122,
     561,   344,   817,   455,    -1,   104,   232,   122,   144,   117,
     561,   344,   817,   455,    -1,   104,   240,    36,   814,   455,
      -1,   260,   240,    36,   814,   325,   815,    -1,   104,   559,
     144,   117,   560,   455,    -1,   104,   559,   560,   455,    -1,
     316,    -1,   289,    -1,   354,    -1,   152,    -1,   334,    -1,
     102,    -1,    64,    -1,   283,    -1,   321,   285,   242,    -1,
     321,   285,    96,    -1,   321,   285,   319,    -1,   321,   285,
      59,    -1,   561,    -1,   560,   406,   561,    -1,   827,    -1,
     827,   562,    -1,   404,   818,    -1,   562,   404,   818,    -1,
     332,   707,   812,   455,    -1,    55,   230,   565,   561,   169,
     566,    -1,    55,   230,    10,   821,   539,   169,   566,    -1,
      55,   230,   133,   821,   595,   169,   566,    -1,    55,   230,
     232,   614,   401,   613,   402,   169,   566,    -1,    55,   230,
      61,   815,   230,   561,   169,   566,    -1,    55,   230,   281,
     815,   230,   561,   169,   566,    -1,    55,   230,   281,   815,
     169,   566,    -1,    55,   230,   329,   815,   230,   561,   169,
     566,    -1,    55,   230,   232,    49,   561,   344,   817,   169,
     566,    -1,    55,   230,   232,   122,   561,   344,   817,   169,
     566,    -1,    55,   230,   176,   224,   505,   169,   566,    -1,
      55,   230,    42,   401,   741,    20,   741,   402,   169,   566,
      -1,    55,   230,   514,   175,   561,   169,   566,    -1,    55,
     230,   321,   285,   242,   561,   169,   566,    -1,    55,   230,
     321,   285,    96,   561,   169,   566,    -1,    55,   230,   321,
     285,   319,   561,   169,   566,    -1,    55,   230,   321,   285,
      59,   561,   169,   566,    -1,    54,    -1,    81,    -1,   283,
      -1,   152,    -1,   289,    -1,   316,    -1,   102,    -1,   334,
      -1,   354,    -1,    64,    -1,   317,    -1,   277,    -1,   824,
      -1,   220,    -1,   123,   568,   569,   815,    -1,   123,   815,
      -1,   199,   568,   569,   815,    -1,   199,   815,    -1,    -1,
     206,    -1,   253,    -1,   124,    -1,   177,    -1,     4,   826,
      -1,   264,   826,    -1,   826,    -1,    11,    -1,   129,    -1,
     129,   826,    -1,   129,    11,    -1,    27,    -1,    27,   826,
      -1,    27,    11,    -1,   131,    -1,   149,    -1,   135,   572,
     230,   575,   325,   576,   578,    -1,   275,   572,   230,   575,
     131,   576,   455,    -1,   275,   135,   233,   126,   572,   230,
     575,   131,   576,   455,    -1,   573,    -1,    11,    -1,    11,
     254,    -1,   574,    -1,   573,   406,   574,    -1,   288,    -1,
     262,    -1,    67,    -1,   827,    -1,   812,    -1,   316,   812,
      -1,   289,   812,    -1,   133,   579,    -1,    81,   814,    -1,
     175,   814,    -1,   283,   814,    -1,   317,   814,    -1,   577,
      -1,   576,   406,   577,    -1,   825,    -1,   138,   825,    -1,
     359,   135,   233,    -1,    -1,   580,    -1,   579,   406,   580,
      -1,   821,   595,    -1,   135,   573,   325,   814,   583,   584,
      -1,   275,   573,   131,   814,   584,   455,    -1,   275,     8,
     233,   126,   573,   131,   814,   584,   455,    -1,   359,     8,
     233,    -1,    -1,   136,    36,   825,    -1,    -1,    67,   586,
     152,   819,   230,   813,   587,   401,   588,   402,   606,   493,
     737,    -1,    67,   586,   152,    58,   819,   230,   813,   587,
     401,   588,   402,   606,   493,   737,    -1,   338,    -1,    -1,
     344,   817,    -1,    -1,   589,    -1,   588,   406,   589,    -1,
     827,   590,   591,   592,    -1,   767,   590,   591,   592,    -1,
     401,   764,   402,   590,   591,   592,    -1,   561,    -1,   344,
     561,    -1,    -1,    21,    -1,    95,    -1,    -1,   375,    -1,
     376,    -1,    -1,    67,   594,   133,   821,   595,   274,   600,
     602,   606,    -1,    67,   594,   133,   821,   595,   602,   606,
      -1,   234,   268,    -1,    -1,   401,   596,   402,    -1,   401,
     402,    -1,   597,    -1,   596,   406,   597,    -1,   598,   599,
     601,    -1,   599,   598,   601,    -1,   599,   601,    -1,   598,
     601,    -1,   601,    -1,   149,    -1,   236,    -1,   158,    -1,
     149,   236,    -1,   828,    -1,   601,    -1,   741,    -1,   828,
     562,   396,   334,    -1,   294,   828,   562,   396,   334,    -1,
     604,    -1,   602,   604,    -1,    38,   230,   220,   159,    -1,
     274,   220,   230,   220,   159,    -1,   309,    -1,   147,    -1,
     301,    -1,   355,    -1,   119,   287,    91,    -1,   119,   287,
     168,    -1,   287,    91,    -1,   287,   168,    -1,    66,   505,
      -1,   280,   505,    -1,   442,    -1,    20,   605,    -1,   175,
     440,    -1,   603,    -1,   824,    -1,   824,   406,   824,    -1,
     359,   535,    -1,    -1,    13,   133,   580,   608,   609,    -1,
     603,    -1,   608,   603,    -1,   272,    -1,    -1,   104,   133,
     821,   595,   455,    -1,   104,   133,   144,   117,   821,   595,
     455,    -1,   104,    10,   821,   539,   455,    -1,   104,    10,
     144,   117,   821,   539,   455,    -1,   104,   232,   614,   401,
     613,   402,   455,    -1,   104,   232,   144,   117,   614,   401,
     613,   402,   455,    -1,   741,    -1,   741,   406,   741,    -1,
     213,   406,   741,    -1,   741,   406,   213,    -1,   777,    -1,
     827,   404,   614,    -1,    67,    42,   401,   741,    20,   741,
     402,   359,   133,   580,   616,    -1,    67,    42,   401,   741,
      20,   741,   402,   360,   133,   616,    -1,    20,   148,    -1,
      20,    23,    -1,    -1,   104,    42,   618,   401,   741,    20,
     741,   402,   455,    -1,   144,   117,    -1,    -1,   263,   620,
     813,   621,    -1,   263,   315,   815,   621,    -1,   263,    81,
     815,   621,    -1,   152,    -1,   316,    -1,   127,    -1,    -1,
      13,    10,   821,   539,   266,   325,   815,    -1,    13,    64,
     561,   266,   325,   815,    -1,    13,    81,   816,   266,   325,
     816,    -1,    13,   133,   580,   266,   325,   815,    -1,    13,
     138,   825,   266,   325,   825,    -1,    13,   514,   175,   815,
     266,   325,   815,    -1,    13,   232,    49,   561,   344,   817,
     266,   325,   815,    -1,    13,   232,   122,   561,   344,   817,
     266,   325,   815,    -1,    13,   283,   815,   266,   325,   815,
      -1,    13,   316,   734,   266,   325,   815,    -1,    13,   289,
     734,   266,   325,   815,    -1,    13,   354,   734,   266,   325,
     815,    -1,    13,   152,   734,   266,   325,   815,    -1,    13,
     316,   734,   266,   623,   815,   325,   815,    -1,    13,   329,
     815,   230,   734,   266,   325,   815,    -1,    13,   277,   825,
     266,   325,   825,    -1,    13,   343,   825,   266,   325,   825,
      -1,    13,   317,   815,   266,   325,   815,    -1,    13,   321,
     285,   242,   561,   266,   325,   815,    -1,    13,   321,   285,
      96,   561,   266,   325,   815,    -1,    13,   321,   285,   319,
     561,   266,   325,   815,    -1,    13,   321,   285,    59,   561,
     266,   325,   815,    -1,    54,    -1,    -1,    13,    10,   821,
     539,   293,   283,   815,    -1,    13,   102,   561,   293,   283,
     815,    -1,    13,   133,   580,   293,   283,   815,    -1,    13,
     289,   734,   293,   283,   815,    -1,    13,   316,   734,   293,
     283,   815,    -1,    13,   334,   561,   293,   283,   815,    -1,
      13,    10,   821,   539,   241,   325,   825,    -1,    13,    64,
     561,   241,   325,   825,    -1,    13,    81,   816,   241,   325,
     825,    -1,    13,   102,   561,   241,   325,   825,    -1,    13,
     133,   580,   241,   325,   825,    -1,    13,   514,   175,   815,
     241,   325,   825,    -1,    13,   232,   614,   401,   613,   402,
     241,   325,   825,    -1,    13,   232,    49,   561,   344,   817,
     241,   325,   825,    -1,    13,   232,   122,   561,   344,   817,
     241,   325,   825,    -1,    13,   283,   815,   241,   325,   825,
      -1,    13,   334,   561,   241,   325,   825,    -1,    13,   317,
     815,   241,   325,   825,    -1,    13,   321,   285,    96,   561,
     241,   325,   825,    -1,    13,   321,   285,    59,   561,   241,
     325,   825,    -1,    -1,    67,   594,   281,   815,    20,   627,
     230,   632,   325,   813,   737,   100,   633,   628,    -1,   216,
      -1,   630,    -1,   401,   629,   402,    -1,   629,   405,   631,
      -1,   631,    -1,   700,    -1,   679,    -1,   690,    -1,   684,
      -1,   635,    -1,   630,    -1,    -1,   288,    -1,   342,    -1,
      92,    -1,   161,    -1,   162,    -1,    12,    -1,    -1,   104,
     281,   815,   230,   813,   455,    -1,   104,   281,   144,   117,
     815,   230,   813,   455,    -1,   217,   827,    -1,   184,   827,
      -1,   340,   827,    -1,   340,   394,    -1,     3,   639,    -1,
      29,   639,   642,    -1,   303,   327,   642,    -1,    56,   639,
      -1,   110,   639,    -1,   278,   639,    -1,   282,   827,    -1,
     265,   282,   827,    -1,   265,   827,    -1,   278,   639,   325,
     282,   827,    -1,   278,   639,   325,   827,    -1,   250,   327,
     824,    -1,    56,   251,   824,    -1,   278,   251,   824,    -1,
     361,    -1,   327,    -1,    -1,   171,   181,   436,    -1,   258,
     231,    -1,   258,   362,    -1,   640,    -1,   641,   406,   640,
      -1,   641,   640,    -1,   641,    -1,    -1,    67,   468,   354,
     813,   482,    20,   700,   644,    -1,    67,   234,   268,   468,
     354,   813,   482,    20,   700,   644,    -1,   379,   233,    -1,
     377,    47,   233,    -1,   378,    47,   233,    -1,    -1,   185,
     820,    -1,    67,    81,   816,   413,   647,    -1,   647,   648,
      -1,    -1,   317,   649,   815,    -1,   317,   649,    87,    -1,
     189,   649,   824,    -1,   189,   649,    87,    -1,   319,   649,
     815,    -1,   319,   649,    87,    -1,   108,   649,   824,    -1,
     108,   649,   823,    -1,   108,   649,    87,    -1,    60,   183,
     649,   826,    -1,   241,   649,   815,    -1,   241,   649,    87,
      -1,   388,    -1,    -1,    13,    81,   816,   413,   652,    -1,
      13,    81,   816,   442,    -1,   652,   653,    -1,    -1,    60,
     183,   649,   826,    -1,   104,    81,   816,    -1,   104,    81,
     144,   117,   816,    -1,    67,   102,   561,   657,   741,   473,
      -1,    13,   102,   561,   454,    -1,    13,   102,   561,   104,
     215,   220,    -1,    13,   102,   561,   293,   215,   220,    -1,
      13,   102,   561,     7,   480,    -1,    13,   102,   561,   104,
      61,   815,   455,    -1,    20,    -1,    -1,    13,   321,   285,
      96,   561,   535,    -1,    13,   321,   285,    59,   561,     7,
     192,   126,   814,   359,   560,    -1,    13,   321,   285,    59,
     561,    13,   192,   126,   814,   359,   560,    -1,    13,   321,
     285,    59,   561,    13,   192,   268,   561,   359,   561,    -1,
      13,   321,   285,    59,   561,    13,   192,   126,   814,   268,
     561,   359,   561,    -1,    13,   321,   285,    59,   561,   104,
     192,   126,   814,    -1,    13,   321,   285,    59,   561,   104,
     192,   144,   117,   126,   814,    -1,    67,   547,    64,   561,
     126,   824,   325,   824,   131,   561,    -1,    51,   813,   662,
      -1,    51,    -1,    51,   819,   230,   813,    -1,   344,   819,
      -1,    -1,   345,   667,   668,   666,    -1,   345,   667,   668,
     666,   813,    -1,   345,   667,   668,   666,   664,    -1,   665,
     666,    -1,   665,   666,   813,   669,    -1,    16,    -1,    15,
      -1,   352,    -1,    -1,   132,    -1,    -1,   130,    -1,    -1,
     401,   814,   402,    -1,    -1,   118,   672,   666,   671,    -1,
     700,    -1,   679,    -1,   690,    -1,   684,    -1,   697,    -1,
     676,    -1,   665,    -1,    -1,   250,   815,   674,    20,   675,
      -1,   401,   784,   402,    -1,    -1,   700,    -1,   679,    -1,
     690,    -1,   684,    -1,   116,   815,   677,    -1,    67,   468,
     316,   496,    20,   116,   815,   677,    -1,   401,   782,   402,
      -1,    -1,    83,   815,    -1,    83,   250,   815,    -1,    83,
      11,    -1,    83,   250,    11,    -1,   161,   167,   813,   680,
     683,    -1,   700,    -1,   401,   681,   402,   700,    -1,    87,
     349,    -1,   682,    -1,   681,   406,   682,    -1,   827,   804,
      -1,   273,   809,    -1,    -1,    92,   131,   735,   685,   738,
     683,    -1,   344,   727,    -1,    -1,   190,   707,   812,   687,
     689,    -1,   149,   688,   197,    -1,    -1,     5,   295,    -1,
     279,   295,    -1,   279,   115,    -1,   295,   342,   115,    -1,
     295,    -1,   295,   279,   115,    -1,   115,    -1,     5,   115,
      -1,   219,    -1,    -1,   342,   735,   293,   691,   726,   738,
     683,    -1,   692,    -1,   691,   406,   692,    -1,   693,    -1,
     694,    -1,   695,   388,   806,    -1,   401,   696,   402,   388,
     808,    -1,   827,   804,    -1,   695,    -1,   696,   406,   695,
      -1,    86,   815,   698,    79,   699,   126,   700,    -1,    -1,
     698,   207,   284,    -1,   698,   284,    -1,   698,    32,    -1,
     698,   160,    -1,    -1,   359,   142,    -1,   360,   142,    -1,
     702,    -1,   701,    -1,   401,   702,   402,    -1,   401,   701,
     402,    -1,   704,    -1,   703,   711,    -1,   703,   710,   720,
     715,    -1,   703,   710,   714,   721,    -1,   704,    -1,   701,
      -1,   288,   709,   809,   705,   726,   737,   718,   719,    -1,
     725,    -1,   703,   337,   708,   703,    -1,   703,   165,   708,
     703,    -1,   703,   113,   708,   703,    -1,   167,   706,    -1,
      -1,   320,   707,   813,    -1,   318,   707,   813,    -1,   186,
     320,   707,   813,    -1,   186,   318,   707,   813,    -1,   134,
     320,   707,   813,    -1,   134,   318,   707,   813,    -1,   316,
     813,    -1,   813,    -1,   316,    -1,    -1,    11,    -1,    99,
      -1,    -1,    99,    -1,    99,   230,   401,   782,   402,    -1,
      11,    -1,    -1,   711,    -1,    -1,   235,    36,   712,    -1,
     713,    -1,   712,   406,   713,    -1,   764,   344,   780,   592,
      -1,   764,   591,   592,    -1,   183,   716,   227,   717,    -1,
     227,   717,   183,   716,    -1,   183,   716,    -1,   227,   717,
      -1,   183,   716,   406,   717,    -1,   714,    -1,    -1,   764,
      -1,    11,    -1,   764,    -1,   138,    36,   782,    -1,    -1,
     140,   764,    -1,    -1,   722,    -1,   126,   258,   231,    -1,
     720,    -1,    -1,   723,    -1,   722,   723,    -1,   126,   342,
     724,   689,    -1,   126,   295,   724,   689,    -1,   225,   814,
      -1,    -1,   349,   808,    -1,   725,   406,   808,    -1,   131,
     727,    -1,    -1,   728,    -1,   727,   406,   728,    -1,   734,
      -1,   734,   730,    -1,   736,    -1,   736,   730,    -1,   736,
      20,   401,   739,   402,    -1,   736,    20,   827,   401,   739,
     402,    -1,   736,   827,   401,   739,   402,    -1,   701,    -1,
     701,   730,    -1,   729,    -1,   401,   729,   402,   730,    -1,
     401,   729,   402,    -1,   728,    71,   172,   728,    -1,   728,
     731,   172,   728,   733,    -1,   728,   172,   728,   733,    -1,
     728,   203,   731,   172,   728,    -1,   728,   203,   172,   728,
      -1,    20,   827,   401,   814,   402,    -1,    20,   827,    -1,
     827,   401,   814,   402,    -1,   827,    -1,   132,   732,    -1,
     180,   732,    -1,   276,   732,    -1,   157,    -1,   237,    -1,
      -1,   344,   401,   814,   402,    -1,   230,   764,    -1,   813,
      -1,   813,   394,    -1,   231,   813,    -1,   231,   401,   813,
     402,    -1,   734,    -1,   734,   827,    -1,   734,    20,   827,
      -1,   767,    -1,   357,   764,    -1,    -1,   357,   764,    -1,
     357,    73,   225,   815,    -1,   357,    73,   225,   387,    -1,
      -1,   740,    -1,   739,   406,   740,    -1,   827,   741,    -1,
     743,   742,    -1,   294,   743,   742,    -1,   743,    19,   399,
     823,   400,    -1,   294,   743,    19,   399,   823,   400,    -1,
     742,   399,   400,    -1,   742,   399,   823,   400,    -1,    -1,
     745,    -1,   747,    -1,   749,    -1,   753,    -1,   760,    -1,
     761,   763,    -1,   761,   401,   823,   402,   763,    -1,   747,
      -1,   750,    -1,   754,    -1,   760,    -1,   828,   746,    -1,
     828,   562,   746,    -1,   401,   782,   402,    -1,    -1,   163,
      -1,   164,    -1,   299,    -1,    31,    -1,   259,    -1,   125,
     748,    -1,   103,   248,    -1,    85,   746,    -1,    84,   746,
      -1,   223,   746,    -1,    34,    -1,   401,   823,   402,    -1,
      -1,   751,    -1,   752,    -1,   751,    -1,   752,    -1,    33,
     758,   401,   782,   402,    -1,    33,   758,    -1,   755,    -1,
     756,    -1,   755,    -1,   756,    -1,   757,   401,   823,   402,
     759,    -1,   757,   759,    -1,    45,   758,    -1,    44,   758,
      -1,   350,    -1,   202,    45,   758,    -1,   202,    44,   758,
      -1,   204,   758,    -1,   351,    -1,    -1,    45,   293,   827,
      -1,    -1,   324,   401,   823,   402,   762,    -1,   324,   762,
      -1,   323,   401,   823,   402,   762,    -1,   323,   762,    -1,
     166,    -1,   359,   323,   374,    -1,   360,   323,   374,    -1,
      -1,   372,    -1,   198,    -1,    82,    -1,   143,    -1,   195,
      -1,   286,    -1,   372,   325,   198,    -1,    82,   325,   143,
      -1,    82,   325,   195,    -1,    82,   325,   286,    -1,   143,
     325,   195,    -1,   143,   325,   286,    -1,   195,   325,   286,
      -1,    -1,   766,    -1,   764,   403,   741,    -1,   764,    25,
     323,   374,   764,    -1,   392,   764,    -1,   393,   764,    -1,
     764,   392,   764,    -1,   764,   393,   764,    -1,   764,   394,
     764,    -1,   764,   395,   764,    -1,   764,   396,   764,    -1,
     764,   397,   764,    -1,   764,   389,   764,    -1,   764,   390,
     764,    -1,   764,   388,   764,    -1,   764,   779,   764,    -1,
     779,   764,    -1,   764,   779,    -1,   764,    17,   764,    -1,
     764,   234,   764,    -1,   215,   764,    -1,   764,   182,   764,
      -1,   764,   182,   764,   112,   764,    -1,   764,   215,   182,
     764,    -1,   764,   215,   182,   764,   112,   764,    -1,   764,
     145,   764,    -1,   764,   145,   764,   112,   764,    -1,   764,
     215,   145,   764,    -1,   764,   215,   145,   764,   112,   764,
      -1,   764,   297,   325,   764,    -1,   764,   297,   325,   764,
     112,   764,    -1,   764,   215,   297,   325,   764,    -1,   764,
     215,   297,   325,   764,   112,   764,    -1,   764,   169,   220,
      -1,   764,   170,    -1,   764,   169,   215,   220,    -1,   764,
     218,    -1,   775,   238,   775,    -1,   764,   169,   331,    -1,
     764,   169,   215,   331,    -1,   764,   169,   121,    -1,   764,
     169,   215,   121,    -1,   764,   169,   339,    -1,   764,   169,
     215,   339,    -1,   764,   169,    99,   131,   764,    -1,   764,
     169,   215,    99,   131,   764,    -1,   764,   169,   225,   401,
     784,   402,    -1,   764,   169,   215,   225,   401,   784,   402,
      -1,   764,    30,   805,   765,    17,   765,    -1,   764,   215,
      30,   805,   765,    17,   765,    -1,   764,    30,   313,   765,
      17,   765,    -1,   764,   215,    30,   313,   765,    17,   765,
      -1,   764,   149,   795,    -1,   764,   215,   149,   795,    -1,
     764,   781,   776,   701,    -1,   764,   781,   776,   401,   764,
     402,    -1,   338,   701,    -1,   764,   169,   101,    -1,   764,
     169,   215,   101,    -1,   766,    -1,   765,   403,   741,    -1,
     392,   765,    -1,   393,   765,    -1,   765,   392,   765,    -1,
     765,   393,   765,    -1,   765,   394,   765,    -1,   765,   395,
     765,    -1,   765,   396,   765,    -1,   765,   397,   765,    -1,
     765,   389,   765,    -1,   765,   390,   765,    -1,   765,   388,
     765,    -1,   765,   779,   765,    -1,   779,   765,    -1,   765,
     779,    -1,   765,   169,    99,   131,   765,    -1,   765,   169,
     215,    99,   131,   765,    -1,   765,   169,   225,   401,   784,
     402,    -1,   765,   169,   215,   225,   401,   784,   402,    -1,
     765,   169,   101,    -1,   765,   169,   215,   101,    -1,   801,
      -1,   822,    -1,   387,   804,    -1,   401,   764,   402,   804,
      -1,   796,    -1,   767,    -1,   701,    -1,   701,   803,    -1,
     117,   701,    -1,    19,   701,    -1,    19,   786,    -1,   775,
      -1,   821,   401,   402,    -1,   821,   401,   782,   402,    -1,
     821,   401,    11,   782,   402,    -1,   821,   401,    99,   782,
     402,    -1,   821,   401,   394,   402,    -1,    74,    -1,    76,
      -1,    76,   401,   823,   402,    -1,    77,    -1,    77,   401,
     823,   402,    -1,   187,    -1,   187,   401,   823,   402,    -1,
     188,    -1,   188,   401,   823,   402,    -1,    75,    -1,    78,
      -1,   292,    -1,   343,    -1,    42,   401,   764,    20,   741,
     402,    -1,   120,   401,   783,   402,    -1,   239,   401,   788,
     402,    -1,   247,   401,   790,   402,    -1,   311,   401,   791,
     402,    -1,   328,   401,   764,    20,   741,   402,    -1,   330,
     401,    35,   794,   402,    -1,   330,   401,   178,   794,   402,
      -1,   330,   401,   326,   794,   402,    -1,   330,   401,   794,
     402,    -1,   221,   401,   764,   406,   764,   402,    -1,    52,
     401,   782,   402,    -1,   137,   401,   782,   402,    -1,   179,
     401,   782,   402,    -1,   365,   401,   782,   402,    -1,   366,
     401,   200,   829,   402,    -1,   366,   401,   200,   829,   406,
     770,   402,    -1,   366,   401,   200,   829,   406,   782,   402,
      -1,   366,   401,   200,   829,   406,   770,   406,   782,   402,
      -1,   367,   401,   771,   402,    -1,   368,   401,   773,   764,
     774,   402,    -1,   369,   401,   200,   829,   402,    -1,   369,
     401,   200,   829,   406,   764,   402,    -1,   370,   401,   764,
     406,   768,   769,   402,    -1,   371,   401,   773,   764,    20,
     743,   402,    -1,   353,   764,    -1,   353,   207,   348,    -1,
     406,   302,   373,    -1,   406,   302,   207,    -1,   406,   302,
     207,   348,    -1,    -1,   364,   401,   771,   402,    -1,   772,
      -1,   771,   406,   772,    -1,   764,    20,   829,    -1,   764,
      -1,   101,    -1,    63,    -1,   249,   358,    -1,   310,   358,
      -1,    -1,   279,   401,   782,   402,    -1,   279,   401,   402,
      -1,   401,   782,   406,   764,   402,    -1,    18,    -1,   300,
      -1,    11,    -1,   385,    -1,   778,    -1,   392,    -1,   393,
      -1,   394,    -1,   395,    -1,   396,    -1,   397,    -1,   389,
      -1,   390,    -1,   388,    -1,   385,    -1,   232,   401,   614,
     402,    -1,   777,    -1,   232,   401,   614,   402,    -1,   777,
      -1,   232,   401,   614,   402,    -1,   182,    -1,   215,   182,
      -1,   145,    -1,   215,   145,    -1,   764,    -1,   782,   406,
     764,    -1,   787,   131,   764,    -1,    -1,   741,    -1,   784,
     406,   741,    -1,   786,    -1,   785,   406,   786,    -1,   399,
     782,   400,    -1,   399,   785,   400,    -1,   380,    -1,   372,
      -1,   198,    -1,    82,    -1,   143,    -1,   195,    -1,   286,
      -1,   382,    -1,   764,   789,   792,   793,    -1,   764,   789,
     792,    -1,   245,   764,    -1,   765,   149,   765,    -1,    -1,
     764,   792,   793,    -1,   764,   793,   792,    -1,   764,   792,
      -1,   764,   793,    -1,   782,    -1,    -1,   131,   764,    -1,
     126,   764,    -1,   764,   131,   782,    -1,   131,   782,    -1,
     782,    -1,   701,    -1,   401,   782,   402,    -1,    41,   800,
     797,   799,   110,    -1,   798,    -1,   797,   798,    -1,   356,
     764,   322,   764,    -1,   106,   764,    -1,    -1,   764,    -1,
      -1,   811,    -1,   811,   803,    -1,   404,   818,    -1,   404,
     394,    -1,   399,   764,   400,    -1,   399,   764,   407,   764,
     400,    -1,   802,    -1,   803,   802,    -1,    -1,   804,   802,
      -1,    24,    -1,    -1,   764,    -1,    87,    -1,   806,    -1,
     807,   406,   806,    -1,   401,   807,   402,    -1,   810,    -1,
     809,   406,   810,    -1,   764,    20,   829,    -1,   764,    -1,
     394,    -1,   834,    -1,   827,    -1,   813,    -1,   812,   406,
     813,    -1,   811,    -1,   811,   803,    -1,   815,    -1,   814,
     406,   815,    -1,   827,    -1,   827,    -1,   827,    -1,   829,
      -1,   827,    -1,   824,    -1,   828,    -1,   811,   803,    -1,
     823,    -1,   381,    -1,   824,    -1,   383,    -1,   384,    -1,
     821,   824,    -1,   821,   401,   782,   402,   824,    -1,   744,
     824,    -1,   761,   824,   763,    -1,   761,   401,   823,   402,
     824,   763,    -1,   331,    -1,   121,    -1,   220,    -1,   386,
      -1,   382,    -1,   827,    -1,   386,    -1,   393,   386,    -1,
     380,    -1,   830,    -1,   831,    -1,   380,    -1,   830,    -1,
     832,    -1,   380,    -1,   830,    -1,   831,    -1,   832,    -1,
     833,    -1,     3,    -1,     4,    -1,     5,    -1,     6,    -1,
       7,    -1,     8,    -1,     9,    -1,    10,    -1,    12,    -1,
      13,    -1,    14,    -1,    22,    -1,    23,    -1,    25,    -1,
      27,    -1,    28,    -1,    29,    -1,    36,    -1,    37,    -1,
      38,    -1,    39,    -1,    40,    -1,    43,    -1,    46,    -1,
      48,    -1,    49,    -1,    50,    -1,    51,    -1,    55,    -1,
      56,    -1,    57,    -1,    58,    -1,    59,    -1,    60,    -1,
      62,    -1,    63,    -1,    64,    -1,    65,    -1,    66,    -1,
      68,    -1,    69,    -1,    70,    -1,    72,    -1,    73,    -1,
      79,    -1,    80,    -1,    81,    -1,    82,    -1,    83,    -1,
      86,    -1,    88,    -1,    90,    -1,    91,    -1,    92,    -1,
      93,    -1,    94,    -1,    96,    -1,    97,    -1,    98,    -1,
     101,    -1,   102,    -1,   103,    -1,   104,    -1,   105,    -1,
     107,    -1,   108,    -1,   109,    -1,   111,    -1,   112,    -1,
     114,    -1,   115,    -1,   116,    -1,   118,    -1,   119,    -1,
     122,    -1,   123,    -1,   124,    -1,   127,    -1,   129,    -1,
     133,    -1,   134,    -1,   136,    -1,   139,    -1,   141,    -1,
     142,    -1,   143,    -1,   144,    -1,   146,    -1,   147,    -1,
     148,    -1,   150,    -1,   151,    -1,   152,    -1,   153,    -1,
     154,    -1,   155,    -1,   159,    -1,   160,    -1,   161,    -1,
     162,    -1,   168,    -1,   171,    -1,   173,    -1,   174,    -1,
     175,    -1,   176,    -1,   177,    -1,   181,    -1,   184,    -1,
     185,    -1,   186,    -1,   189,    -1,   190,    -1,   191,    -1,
     192,    -1,   193,    -1,   194,    -1,   195,    -1,   196,    -1,
     197,    -1,   198,    -1,   199,    -1,   200,    -1,   201,    -1,
     206,    -1,   207,    -1,   208,    -1,   209,    -1,   210,    -1,
     211,    -1,   212,    -1,   214,    -1,   216,    -1,   217,    -1,
     219,    -1,   222,    -1,   224,    -1,   225,    -1,   228,    -1,
     232,    -1,   233,    -1,   240,    -1,   241,    -1,   242,    -1,
     243,    -1,   244,    -1,   246,    -1,   250,    -1,   251,    -1,
     249,    -1,   253,    -1,   254,    -1,   255,    -1,   256,    -1,
     257,    -1,   258,    -1,   260,    -1,   261,    -1,   263,    -1,
     264,    -1,   265,    -1,   266,    -1,   267,    -1,   268,    -1,
     269,    -1,   270,    -1,   271,    -1,   272,    -1,   274,    -1,
     275,    -1,   277,    -1,   278,    -1,   280,    -1,   281,    -1,
     282,    -1,   283,    -1,   284,    -1,   285,    -1,   286,    -1,
     287,    -1,   289,    -1,   290,    -1,   291,    -1,   293,    -1,
     295,    -1,   296,    -1,   298,    -1,   301,    -1,   302,    -1,
     303,    -1,   304,    -1,   305,    -1,   306,    -1,   307,    -1,
     308,    -1,   309,    -1,   310,    -1,   312,    -1,   314,    -1,
     315,    -1,   317,    -1,   318,    -1,   319,    -1,   320,    -1,
     321,    -1,   327,    -1,   329,    -1,   332,    -1,   333,    -1,
     334,    -1,   335,    -1,   336,    -1,   339,    -1,   340,    -1,
     341,    -1,   342,    -1,   345,    -1,   346,    -1,   347,    -1,
     348,    -1,   351,    -1,   353,    -1,   354,    -1,   355,    -1,
     358,    -1,   359,    -1,   360,    -1,   361,    -1,   362,    -1,
     363,    -1,   372,    -1,   373,    -1,   374,    -1,    31,    -1,
      33,    -1,    34,    -1,    44,    -1,    45,    -1,    52,    -1,
      84,    -1,    85,    -1,   117,    -1,   120,    -1,   125,    -1,
     137,    -1,   158,    -1,   163,    -1,   164,    -1,   166,    -1,
     179,    -1,   202,    -1,   204,    -1,   213,    -1,   221,    -1,
     223,    -1,   236,    -1,   239,    -1,   247,    -1,   248,    -1,
     259,    -1,   279,    -1,   294,    -1,   299,    -1,   311,    -1,
     323,    -1,   324,    -1,   328,    -1,   330,    -1,   349,    -1,
     350,    -1,   364,    -1,   365,    -1,   366,    -1,   367,    -1,
     368,    -1,   369,    -1,   370,    -1,   371,    -1,    26,    -1,
      30,    -1,    32,    -1,    71,    -1,   130,    -1,   132,    -1,
     145,    -1,   157,    -1,   169,    -1,   170,    -1,   172,    -1,
     180,    -1,   182,    -1,   203,    -1,   218,    -1,   237,    -1,
     238,    -1,   276,    -1,   297,    -1,   352,    -1,    11,    -1,
      15,    -1,    16,    -1,    17,    -1,    18,    -1,    19,    -1,
      20,    -1,    21,    -1,    24,    -1,    35,    -1,    41,    -1,
      42,    -1,    47,    -1,    53,    -1,    54,    -1,    61,    -1,
      67,    -1,    74,    -1,    75,    -1,    76,    -1,    77,    -1,
      78,    -1,    87,    -1,    89,    -1,    95,    -1,    99,    -1,
     100,    -1,   106,    -1,   110,    -1,   113,    -1,   121,    -1,
     126,    -1,   128,    -1,   131,    -1,   135,    -1,   138,    -1,
     140,    -1,   149,    -1,   156,    -1,   165,    -1,   167,    -1,
     178,    -1,   183,    -1,   187,    -1,   188,    -1,   205,    -1,
     215,    -1,   220,    -1,   226,    -1,   227,    -1,   229,    -1,
     230,    -1,   231,    -1,   234,    -1,   235,    -1,   245,    -1,
     252,    -1,   262,    -1,   273,    -1,   288,    -1,   292,    -1,
     300,    -1,   313,    -1,   316,    -1,   322,    -1,   325,    -1,
     326,    -1,   331,    -1,   337,    -1,   338,    -1,   343,    -1,
     344,    -1,   356,    -1,   357,    -1,   229,    -1,   205,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   511,   511,   515,   521,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   622,   632,   643,   644,
     653,   654,   658,   663,   667,   672,   677,   681,   685,   689,
     693,   697,   701,   705,   709,   714,   718,   722,   726,   730,
     735,   740,   744,   748,   752,   756,   770,   788,   799,   816,
     828,   848,   855,   874,   881,   898,   916,   927,   928,   940,
     947,   964,   976,   988,   989,   993,   994,  1002,  1003,  1004,
    1005,  1006,  1007,  1021,  1027,  1033,  1042,  1050,  1058,  1065,
    1072,  1080,  1091,  1099,  1107,  1118,  1126,  1134,  1141,  1151,
    1152,  1159,  1160,  1163,  1165,  1167,  1171,  1172,  1173,  1174,
    1178,  1179,  1180,  1181,  1193,  1197,  1201,  1214,  1226,  1227,
    1228,  1232,  1233,  1234,  1238,  1239,  1243,  1250,  1257,  1264,
    1271,  1281,  1282,  1287,  1293,  1299,  1305,  1311,  1321,  1331,
    1332,  1336,  1337,  1345,  1360,  1366,  1372,  1378,  1394,  1402,
    1413,  1414,  1420,  1428,  1437,  1445,  1453,  1462,  1471,  1483,
    1493,  1501,  1510,  1517,  1525,  1533,  1541,  1549,  1557,  1564,
    1571,  1579,  1586,  1593,  1601,  1609,  1617,  1625,  1633,  1640,
    1647,  1648,  1654,  1662,  1670,  1678,  1688,  1689,  1693,  1694,
    1695,  1699,  1700,  1713,  1719,  1742,  1764,  1779,  1780,  1789,
    1790,  1791,  1797,  1798,  1803,  1807,  1811,  1815,  1819,  1823,
    1827,  1831,  1835,  1839,  1848,  1852,  1856,  1860,  1865,  1869,
    1873,  1874,  1885,  1899,  1925,  1926,  1927,  1928,  1929,  1930,
    1931,  1935,  1936,  1940,  1944,  1951,  1952,  1953,  1956,  1968,
    1969,  1973,  1994,  1995,  2014,  2025,  2036,  2048,  2060,  2071,
    2082,  2111,  2117,  2123,  2129,  2147,  2157,  2158,  2162,  2163,
    2164,  2165,  2166,  2167,  2176,  2197,  2201,  2211,  2223,  2235,
    2253,  2254,  2258,  2259,  2262,  2268,  2272,  2279,  2284,  2296,
    2298,  2300,  2302,  2305,  2308,  2311,  2315,  2316,  2317,  2318,
    2319,  2322,  2323,  2328,  2329,  2330,  2331,  2334,  2335,  2336,
    2337,  2340,  2341,  2344,  2345,  2355,  2376,  2388,  2389,  2393,
    2394,  2398,  2423,  2434,  2443,  2444,  2447,  2451,  2455,  2459,
    2463,  2467,  2471,  2475,  2479,  2483,  2487,  2493,  2494,  2498,
    2499,  2502,  2503,  2510,  2522,  2532,  2546,  2547,  2555,  2556,
    2560,  2561,  2565,  2566,  2570,  2578,  2589,  2590,  2600,  2610,
    2611,  2624,  2631,  2649,  2667,  2691,  2692,  2696,  2702,  2708,
    2717,  2718,  2719,  2723,  2728,  2738,  2739,  2743,  2744,  2748,
    2749,  2750,  2754,  2760,  2761,  2762,  2763,  2764,  2768,  2769,
    2773,  2775,  2783,  2790,  2799,  2803,  2804,  2808,  2809,  2814,
    2824,  2846,  2865,  2888,  2898,  2909,  2919,  2929,  2940,  2974,
    2981,  2990,  2999,  3008,  3019,  3022,  3023,  3026,  3030,  3037,
    3038,  3039,  3040,  3041,  3044,  3045,  3048,  3051,  3052,  3055,
    3061,  3063,  3080,  3095,  3096,  3100,  3110,  3120,  3129,  3139,
    3148,  3149,  3152,  3153,  3156,  3157,  3162,  3172,  3181,  3193,
    3194,  3198,  3206,  3218,  3227,  3239,  3248,  3269,  3279,  3297,
    3306,  3318,  3319,  3320,  3321,  3322,  3323,  3324,  3325,  3326,
    3327,  3328,  3329,  3333,  3334,  3337,  3338,  3341,  3343,  3356,
    3387,  3396,  3405,  3414,  3424,  3433,  3442,  3452,  3461,  3470,
    3479,  3488,  3497,  3506,  3514,  3522,  3530,  3541,  3542,  3543,
    3544,  3545,  3546,  3547,  3548,  3549,  3550,  3551,  3552,  3556,
    3557,  3567,  3574,  3583,  3590,  3603,  3609,  3616,  3623,  3630,
    3637,  3644,  3651,  3658,  3665,  3672,  3679,  3686,  3693,  3700,
    3709,  3710,  3720,  3735,  3748,  3774,  3776,  3778,  3782,  3784,
    3788,  3789,  3790,  3791,  3799,  3806,  3813,  3820,  3827,  3834,
    3841,  3848,  3859,  3860,  3863,  3873,  3887,  3888,  3892,  3893,
    3898,  3914,  3927,  3937,  3949,  3950,  3953,  3954,  3969,  3985,
    4004,  4005,  4009,  4010,  4013,  4014,  4022,  4031,  4040,  4051,
    4052,  4053,  4056,  4057,  4058,  4061,  4062,  4063,  4079,  4091,
    4106,  4107,  4110,  4111,  4115,  4116,  4130,  4138,  4146,  4154,
    4162,  4173,  4174,  4175,  4176,  4182,  4186,  4201,  4202,  4208,
    4220,  4221,  4228,  4232,  4236,  4240,  4244,  4248,  4252,  4256,
    4260,  4264,  4268,  4272,  4276,  4284,  4288,  4292,  4298,  4299,
    4306,  4307,  4319,  4330,  4331,  4336,  4337,  4352,  4362,  4375,
    4385,  4398,  4408,  4421,  4428,  4430,  4432,  4437,  4439,  4450,
    4460,  4472,  4473,  4474,  4478,  4489,  4490,  4504,  4512,  4522,
    4535,  4536,  4539,  4540,  4550,  4559,  4567,  4575,  4584,  4592,
    4600,  4609,  4618,  4626,  4635,  4644,  4653,  4662,  4671,  4680,
    4688,  4696,  4704,  4712,  4720,  4728,  4738,  4739,  4749,  4758,
    4766,  4775,  4783,  4791,  4807,  4816,  4824,  4832,  4840,  4849,
    4857,  4866,  4875,  4884,  4892,  4900,  4908,  4916,  4934,  4933,
    4952,  4953,  4954,  4959,  4965,  4974,  4975,  4976,  4977,  4978,
    4982,  4983,  4986,  4987,  4988,  4989,  4993,  4994,  4995,  5000,
    5010,  5031,  5041,  5052,  5060,  5081,  5088,  5095,  5102,  5109,
    5116,  5123,  5131,  5139,  5147,  5155,  5163,  5170,  5177,  5186,
    5187,  5188,  5192,  5195,  5198,  5205,  5207,  5209,  5214,  5216,
    5228,  5239,  5257,  5263,  5269,  5275,  5285,  5301,  5311,  5312,
    5316,  5320,  5324,  5328,  5332,  5336,  5340,  5344,  5348,  5352,
    5356,  5360,  5370,  5371,  5382,  5392,  5403,  5404,  5408,  5422,
    5429,  5446,  5458,  5467,  5475,  5483,  5492,  5503,  5504,  5515,
    5525,  5535,  5545,  5555,  5565,  5573,  5594,  5617,  5624,  5632,
    5642,  5643,  5655,  5667,  5679,  5691,  5703,  5718,  5719,  5723,
    5724,  5727,  5728,  5731,  5732,  5736,  5737,  5748,  5759,  5760,
    5761,  5762,  5763,  5764,  5768,  5769,  5779,  5789,  5790,  5794,
    5795,  5796,  5797,  5807,  5815,  5832,  5833,  5843,  5849,  5855,
    5861,  5877,  5886,  5892,  5898,  5907,  5909,  5914,  5925,  5926,
    5937,  5950,  5951,  5954,  5965,  5966,  5969,  5970,  5971,  5972,
    5973,  5974,  5975,  5976,  5979,  5980,  5991,  6008,  6009,  6013,
    6014,  6018,  6026,  6053,  6064,  6065,  6075,  6086,  6087,  6088,
    6089,  6090,  6093,  6094,  6095,  6143,  6144,  6148,  6149,  6159,
    6160,  6166,  6172,  6181,  6182,  6209,  6223,  6224,  6228,  6232,
    6239,  6249,  6257,  6262,  6267,  6272,  6277,  6282,  6287,  6292,
    6299,  6300,  6303,  6304,  6305,  6312,  6313,  6314,  6315,  6319,
    6320,  6324,  6328,  6329,  6332,  6340,  6352,  6354,  6356,  6358,
    6360,  6371,  6373,  6377,  6378,  6388,  6392,  6393,  6397,  6398,
    6402,  6403,  6407,  6408,  6412,  6413,  6417,  6425,  6436,  6437,
    6442,  6448,  6466,  6467,  6471,  6472,  6482,  6486,  6491,  6498,
    6506,  6513,  6523,  6533,  6559,  6566,  6570,  6596,  6600,  6612,
    6625,  6639,  6650,  6665,  6671,  6676,  6682,  6689,  6690,  6691,
    6692,  6696,  6697,  6709,  6710,  6715,  6722,  6729,  6736,  6755,
    6759,  6766,  6776,  6781,  6782,  6787,  6788,  6796,  6804,  6809,
    6813,  6819,  6840,  6845,  6851,  6857,  6867,  6869,  6872,  6876,
    6877,  6878,  6879,  6880,  6881,  6887,  6907,  6908,  6909,  6910,
    6921,  6927,  6935,  6936,  6942,  6947,  6952,  6957,  6962,  6967,
    6972,  6977,  6983,  6989,  6995,  7002,  7022,  7031,  7035,  7043,
    7047,  7055,  7067,  7088,  7092,  7098,  7102,  7115,  7134,  7157,
    7159,  7161,  7163,  7165,  7167,  7172,  7173,  7177,  7178,  7185,
    7198,  7210,  7219,  7230,  7238,  7239,  7240,  7244,  7245,  7246,
    7247,  7248,  7249,  7250,  7252,  7254,  7257,  7260,  7262,  7265,
    7267,  7293,  7294,  7296,  7315,  7317,  7319,  7321,  7323,  7325,
    7327,  7329,  7331,  7333,  7335,  7338,  7340,  7342,  7345,  7347,
    7349,  7352,  7354,  7364,  7366,  7376,  7378,  7388,  7390,  7401,
    7413,  7423,  7435,  7455,  7462,  7469,  7476,  7483,  7487,  7494,
    7501,  7508,  7515,  7522,  7529,  7533,  7541,  7545,  7549,  7556,
    7563,  7576,  7589,  7607,  7627,  7636,  7643,  7658,  7662,  7679,
    7681,  7683,  7685,  7687,  7689,  7691,  7693,  7695,  7697,  7699,
    7701,  7703,  7705,  7707,  7709,  7711,  7715,  7720,  7724,  7728,
    7732,  7748,  7749,  7750,  7764,  7776,  7778,  7780,  7789,  7811,
    7820,  7829,  7831,  7848,  7858,  7868,  7882,  7892,  7912,  7940,
    7957,  7974,  7988,  8006,  8023,  8040,  8057,  8075,  8085,  8095,
    8105,  8115,  8117,  8127,  8142,  8153,  8166,  8185,  8198,  8208,
    8218,  8228,  8232,  8238,  8245,  8252,  8256,  8260,  8264,  8268,
    8272,  8276,  8284,  8288,  8292,  8297,  8310,  8312,  8320,  8322,
    8324,  8327,  8330,  8333,  8334,  8337,  8345,  8355,  8356,  8359,
    8360,  8361,  8374,  8375,  8376,  8379,  8380,  8381,  8384,  8385,
    8388,  8389,  8390,  8391,  8392,  8393,  8394,  8395,  8396,  8399,
    8401,  8406,  8408,  8413,  8415,  8417,  8419,  8421,  8423,  8435,
    8439,  8446,  8453,  8456,  8457,  8460,  8462,  8466,  8472,  8485,
    8486,  8487,  8488,  8489,  8490,  8491,  8492,  8501,  8505,  8512,
    8519,  8520,  8536,  8540,  8545,  8549,  8566,  8571,  8575,  8578,
    8581,  8582,  8583,  8586,  8593,  8603,  8616,  8617,  8621,  8631,
    8632,  8635,  8636,  8644,  8648,  8655,  8659,  8663,  8670,  8680,
    8681,  8685,  8686,  8689,  8690,  8701,  8702,  8706,  8707,  8715,
    8726,  8727,  8731,  8739,  8747,  8769,  8770,  8774,  8775,  8786,
    8793,  8819,  8821,  8826,  8829,  8832,  8834,  8836,  8838,  8848,
    8850,  8858,  8865,  8872,  8879,  8886,  8898,  8908,  8919,  8927,
    8938,  8948,  8952,  8956,  8964,  8965,  8966,  8968,  8969,  8985,
    8986,  8987,  8992,  8993,  8994,  9000,  9001,  9002,  9003,  9004,
    9024,  9025,  9026,  9027,  9028,  9029,  9030,  9031,  9032,  9033,
    9034,  9035,  9036,  9037,  9038,  9039,  9040,  9041,  9042,  9043,
    9044,  9045,  9046,  9047,  9048,  9049,  9050,  9051,  9052,  9053,
    9054,  9055,  9056,  9057,  9058,  9059,  9060,  9061,  9062,  9063,
    9064,  9065,  9066,  9067,  9068,  9069,  9070,  9071,  9072,  9073,
    9074,  9075,  9076,  9077,  9078,  9079,  9080,  9081,  9082,  9083,
    9084,  9085,  9086,  9087,  9088,  9089,  9090,  9091,  9092,  9093,
    9094,  9095,  9096,  9097,  9098,  9099,  9100,  9101,  9102,  9103,
    9104,  9105,  9106,  9107,  9108,  9109,  9110,  9111,  9112,  9113,
    9114,  9115,  9116,  9117,  9118,  9119,  9120,  9121,  9122,  9123,
    9124,  9125,  9126,  9127,  9128,  9129,  9130,  9131,  9132,  9133,
    9134,  9135,  9136,  9137,  9138,  9139,  9140,  9141,  9142,  9143,
    9144,  9145,  9146,  9147,  9148,  9149,  9150,  9151,  9152,  9153,
    9154,  9155,  9156,  9157,  9158,  9159,  9160,  9161,  9162,  9163,
    9164,  9165,  9166,  9167,  9168,  9169,  9170,  9171,  9172,  9173,
    9174,  9175,  9176,  9177,  9178,  9179,  9180,  9181,  9182,  9183,
    9184,  9185,  9186,  9187,  9188,  9189,  9190,  9191,  9192,  9193,
    9194,  9195,  9196,  9197,  9198,  9199,  9200,  9201,  9202,  9203,
    9204,  9205,  9206,  9207,  9208,  9209,  9210,  9211,  9212,  9213,
    9214,  9215,  9216,  9217,  9218,  9219,  9220,  9221,  9222,  9223,
    9224,  9225,  9226,  9227,  9228,  9229,  9230,  9231,  9232,  9233,
    9234,  9235,  9236,  9237,  9238,  9239,  9240,  9241,  9242,  9243,
    9244,  9245,  9246,  9247,  9248,  9249,  9250,  9251,  9252,  9253,
    9254,  9255,  9256,  9270,  9271,  9272,  9273,  9274,  9275,  9276,
    9277,  9278,  9279,  9280,  9281,  9282,  9283,  9284,  9285,  9286,
    9287,  9288,  9289,  9290,  9291,  9292,  9293,  9294,  9295,  9296,
    9297,  9298,  9299,  9300,  9301,  9302,  9303,  9304,  9305,  9306,
    9307,  9308,  9309,  9310,  9311,  9312,  9313,  9314,  9328,  9329,
    9330,  9331,  9332,  9333,  9334,  9335,  9336,  9337,  9338,  9339,
    9340,  9341,  9342,  9343,  9344,  9345,  9346,  9347,  9357,  9358,
    9359,  9360,  9361,  9362,  9363,  9364,  9365,  9366,  9367,  9368,
    9369,  9370,  9371,  9372,  9373,  9374,  9375,  9376,  9377,  9378,
    9379,  9380,  9381,  9382,  9383,  9384,  9385,  9386,  9387,  9388,
    9389,  9390,  9391,  9392,  9393,  9394,  9395,  9396,  9397,  9398,
    9399,  9400,  9401,  9402,  9403,  9404,  9405,  9406,  9407,  9408,
    9409,  9410,  9411,  9412,  9413,  9414,  9415,  9416,  9417,  9418,
    9419,  9420,  9421,  9422,  9423,  9424,  9425,  9426,  9427,  9428,
    9429,  9430,  9435,  9444
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "AT", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS",
  "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE",
  "COLLATE", "COLUMN", "COMMENT", "COMMIT", "COMMITTED", "CONCURRENTLY",
  "CONFIGURATION", "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CREATEDB", "CREATEROLE",
  "CREATEUSER", "CROSS", "CSV", "CURRENT_P", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER",
  "CURSOR", "CYCLE", "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P",
  "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER",
  "DELETE_P", "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EXCEPT", "EXCLUDING", "EXCLUSIVE", "EXECUTE",
  "EXISTS", "EXPLAIN", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH",
  "FIRST_P", "FLOAT_P", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE",
  "FROM", "FULL", "FUNCTION", "GLOBAL", "GRANT", "GRANTED", "GREATEST",
  "GROUP_P", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IF_P",
  "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING",
  "INCREMENT", "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "KEY", "LANCOMPILER", "LANGUAGE",
  "LARGE_P", "LAST_P", "LEADING", "LEAST", "LEFT", "LEVEL", "LIKE",
  "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP",
  "LOCATION", "LOCK_P", "LOGIN_P", "MAPPING", "MATCH", "MAXVALUE",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NO", "NOCREATEDB",
  "NOCREATEROLE", "NOCREATEUSER", "NOINHERIT", "NOLOGIN_P", "NONE",
  "NOSUPERUSER", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "OLD", "ON", "ONLY", "OPERATOR", "OPTION", "OR", "ORDER",
  "OUT_P", "OUTER_P", "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER",
  "PARTIAL", "PASSWORD", "PLACING", "PLANS", "POSITION", "PRECISION",
  "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES",
  "PROCEDURAL", "PROCEDURE", "QUOTE", "READ", "REAL", "REASSIGN",
  "RECHECK", "REFERENCES", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME",
  "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW",
  "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P",
  "SECURITY", "SELECT", "SEQUENCE", "SERIALIZABLE", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "STANDALONE_P", "START", "STATEMENT",
  "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P", "STRIP_P",
  "SUBSTRING", "SUPERUSER_P", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIME",
  "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT", "TRIGGER", "TRIM",
  "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "UNCOMMITTED", "UNENCRYPTED",
  "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNTIL", "UPDATE", "USER",
  "USING", "VACUUM", "VALID", "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR",
  "VARYING", "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WITH", "WITHOUT", "WORK", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLFOREST", "XMLPARSE",
  "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P", "ZONE",
  "NULLS_FIRST", "NULLS_LAST", "WITH_CASCADED", "WITH_LOCAL", "WITH_CHECK",
  "IDENT", "FCONST", "SCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM",
  "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "TYPECAST", "'.'", "';'",
  "','", "':'", "$accept", "stmtblock", "stmtmulti", "stmt",
  "CreateRoleStmt", "opt_with", "OptRoleList", "OptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "var_name", "var_list", "var_value", "iso_level",
  "opt_boolean", "zone_value", "opt_encoding", "ColId_or_Sconst",
  "VariableResetStmt", "SetResetClause", "VariableShowStmt",
  "ConstraintsSetStmt", "constraints_set_list", "constraints_set_mode",
  "CheckPointStmt", "DiscardStmt", "AlterTableStmt", "alter_table_cmds",
  "alter_table_cmd", "alter_rel_cmds", "alter_rel_cmd",
  "alter_column_default", "opt_drop_behavior", "alter_using",
  "ClosePortalStmt", "CopyStmt", "copy_from", "copy_file_name",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "CreateStmt", "OptTemp",
  "OptTableElementList", "TableElementList", "TableElement", "columnDef",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptWith", "OnCommitOption", "OptTableSpace",
  "OptConsTableSpace", "CreateAsStmt", "create_as_target", "OptCreateAs",
  "CreateAsList", "CreateAsElement", "CreateSeqStmt", "AlterSeqStmt",
  "OptSeqList", "OptSeqElem", "opt_by", "NumericOnly", "FloatOnly",
  "IntegerOnly", "CreatePLangStmt", "opt_trusted", "handler_name",
  "opt_validator", "opt_lancompiler", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerForSpec", "TriggerForOpt", "TriggerForType",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintDeferrabilitySpec",
  "ConstraintTimeSpec", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "enum_val_list", "CreateOpClassStmt",
  "opclass_item_list", "opclass_item", "opt_default", "opt_opfamily",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "CommentStmt", "comment_type", "comment_text", "FetchStmt",
  "fetch_direction", "from_in", "GrantStmt", "RevokeStmt", "privileges",
  "privilege_list", "privilege", "privilege_target", "grantee_list",
  "grantee", "opt_grant_grant_option", "function_with_argtypes_list",
  "function_with_argtypes", "GrantRoleStmt", "RevokeRoleStmt",
  "opt_grant_admin_option", "opt_granted_by", "IndexStmt",
  "index_opt_unique", "access_method_clause", "index_params", "index_elem",
  "opt_class", "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list", "func_arg", "arg_class",
  "param_name", "func_return", "func_type", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "opt_definition", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "CreateCastStmt", "cast_context",
  "DropCastStmt", "opt_if_exists", "ReindexStmt", "reindex_type",
  "opt_force", "RenameStmt", "opt_column", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "$@1", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "ListenStmt", "UnlistenStmt",
  "TransactionStmt", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_item", "opt_equal", "AlterDatabaseStmt",
  "AlterDatabaseSetStmt", "alterdb_opt_list", "alterdb_opt_item",
  "DropdbStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "opt_analyze", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_rest", "insert_column_list",
  "insert_column_item", "returning_clause", "DeleteStmt", "using_clause",
  "LockStmt", "opt_lock", "lock_type", "opt_nowait", "UpdateStmt",
  "set_clause_list", "set_clause", "single_set_clause",
  "multiple_set_clause", "set_target", "set_target_list",
  "DeclareCursorStmt", "cursor_options", "opt_hold", "SelectStmt",
  "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "into_clause", "OptTempTableName", "opt_table",
  "opt_all", "opt_distinct", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "select_limit_value", "select_offset_value", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "join_type", "join_outer", "join_qual", "relation_expr",
  "relation_expr_opt_alias", "func_table", "where_clause",
  "where_or_current_clause", "TableFuncElementList", "TableFuncElement",
  "Typename", "opt_array_bounds", "SimpleTypename", "ConstTypename",
  "GenericType", "opt_type_modifiers", "Numeric", "opt_float", "Bit",
  "ConstBit", "BitWithLength", "BitWithoutLength", "Character",
  "ConstCharacter", "CharacterWithLength", "CharacterWithoutLength",
  "character", "opt_varying", "opt_charset", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "a_expr", "b_expr",
  "c_expr", "func_expr", "xml_root_version", "opt_xml_root_standalone",
  "xml_attributes", "xml_attribute_list", "xml_attribute_el",
  "document_or_content", "xml_whitespace_option", "row", "sub_type",
  "all_Op", "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "extract_list", "type_list", "array_expr_list", "array_expr",
  "extract_arg", "overlay_list", "overlay_placing", "position_list",
  "substr_list", "substr_from", "substr_for", "trim_list", "in_expr",
  "case_expr", "when_clause_list", "when_clause", "case_default",
  "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "relation_name",
  "qualified_name_list", "qualified_name", "name_list", "name",
  "database_name", "access_method", "attr_name", "index_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "RoleId", "SignedIconst",
  "ColId", "type_function_name", "ColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "SpecialRuleRelation", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,    61,    60,
      62,   643,    43,    45,    42,    47,    37,    94,   644,    91,
      93,    40,    41,   645,    46,    59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   408,   409,   410,   410,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   411,   411,   412,   413,   413,
     414,   414,   415,   415,   415,   415,   415,   415,   415,   415,
     415,   415,   415,   415,   415,   415,   415,   415,   415,   415,
     415,   415,   415,   415,   415,   415,   416,   417,   418,   419,
     420,   421,   421,   422,   422,   423,   424,   425,   425,   426,
     426,   427,   427,   428,   428,   429,   429,   430,   430,   430,
     430,   430,   430,   431,   431,   431,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   433,
     433,   434,   434,   435,   435,   435,   436,   436,   436,   436,
     437,   437,   437,   437,   438,   438,   438,   438,   438,   438,
     438,   439,   439,   439,   440,   440,   441,   441,   441,   441,
     441,   442,   442,   443,   443,   443,   443,   443,   444,   445,
     445,   446,   446,   447,   448,   448,   448,   448,   449,   449,
     450,   450,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     452,   452,   453,   453,   453,   453,   454,   454,   455,   455,
     455,   456,   456,   457,   457,   458,   458,   459,   459,   460,
     460,   460,   461,   461,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   463,   463,   464,   464,   465,   465,
     466,   466,   467,   467,   468,   468,   468,   468,   468,   468,
     468,   469,   469,   470,   470,   471,   471,   471,   472,   473,
     473,   474,   474,   474,   475,   475,   475,   475,   475,   475,
     475,   476,   476,   476,   476,   477,   478,   478,   479,   479,
     479,   479,   479,   479,   480,   480,   481,   481,   481,   481,
     482,   482,   483,   483,   484,   485,   485,   485,   485,   486,
     486,   486,   486,   486,   487,   488,   489,   489,   489,   489,
     489,   490,   490,   491,   491,   491,   491,   492,   492,   492,
     492,   493,   493,   494,   494,   495,   496,   497,   497,   498,
     498,   499,   500,   501,   502,   502,   503,   503,   503,   503,
     503,   503,   503,   503,   503,   503,   503,   504,   504,   505,
     505,   506,   506,   507,   508,   508,   509,   509,   510,   510,
     511,   511,   512,   512,   513,   513,   514,   514,   515,   516,
     516,   517,   517,   518,   518,   519,   519,   520,   520,   520,
     521,   521,   521,   522,   522,   523,   523,   524,   524,   525,
     525,   525,   526,   526,   526,   526,   526,   526,   527,   527,
     528,   528,   528,   528,   528,   529,   529,   530,   530,   531,
     531,   532,   533,   534,   534,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   535,   536,   536,   537,   537,   538,
     538,   538,   538,   538,   539,   539,   540,   541,   541,   542,
     543,   543,   544,   545,   545,   546,   546,   546,   546,   546,
     547,   547,   548,   548,   549,   549,   550,   551,   551,   552,
     552,   553,   553,   554,   554,   555,   555,   556,   557,   558,
     558,   559,   559,   559,   559,   559,   559,   559,   559,   559,
     559,   559,   559,   560,   560,   561,   561,   562,   562,   563,
     564,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     564,   564,   564,   564,   564,   564,   564,   565,   565,   565,
     565,   565,   565,   565,   565,   565,   565,   565,   565,   566,
     566,   567,   567,   567,   567,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     569,   569,   570,   571,   571,   572,   572,   572,   573,   573,
     574,   574,   574,   574,   575,   575,   575,   575,   575,   575,
     575,   575,   576,   576,   577,   577,   578,   578,   579,   579,
     580,   581,   582,   582,   583,   583,   584,   584,   585,   585,
     586,   586,   587,   587,   588,   588,   589,   589,   589,   590,
     590,   590,   591,   591,   591,   592,   592,   592,   593,   593,
     594,   594,   595,   595,   596,   596,   597,   597,   597,   597,
     597,   598,   598,   598,   598,   599,   600,   601,   601,   601,
     602,   602,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   604,   604,   604,   605,   605,
     606,   606,   607,   608,   608,   609,   609,   610,   610,   611,
     611,   612,   612,   613,   613,   613,   613,   614,   614,   615,
     615,   616,   616,   616,   617,   618,   618,   619,   619,   619,
     620,   620,   621,   621,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   623,   623,   624,   624,
     624,   624,   624,   624,   625,   625,   625,   625,   625,   625,
     625,   625,   625,   625,   625,   625,   625,   625,   627,   626,
     628,   628,   628,   629,   629,   630,   630,   630,   630,   630,
     631,   631,   632,   632,   632,   632,   633,   633,   633,   634,
     634,   635,   636,   637,   637,   638,   638,   638,   638,   638,
     638,   638,   638,   638,   638,   638,   638,   638,   638,   639,
     639,   639,   640,   640,   640,   641,   641,   641,   642,   642,
     643,   643,   644,   644,   644,   644,   645,   646,   647,   647,
     648,   648,   648,   648,   648,   648,   648,   648,   648,   648,
     648,   648,   649,   649,   650,   651,   652,   652,   653,   654,
     654,   655,   656,   656,   656,   656,   656,   657,   657,   658,
     659,   659,   659,   659,   659,   659,   660,   661,   661,   661,
     662,   662,   663,   663,   663,   664,   664,   665,   665,   666,
     666,   667,   667,   668,   668,   669,   669,   670,   671,   671,
     671,   671,   671,   671,   672,   672,   673,   674,   674,   675,
     675,   675,   675,   676,   676,   677,   677,   678,   678,   678,
     678,   679,   680,   680,   680,   681,   681,   682,   683,   683,
     684,   685,   685,   686,   687,   687,   688,   688,   688,   688,
     688,   688,   688,   688,   689,   689,   690,   691,   691,   692,
     692,   693,   694,   695,   696,   696,   697,   698,   698,   698,
     698,   698,   699,   699,   699,   700,   700,   701,   701,   702,
     702,   702,   702,   703,   703,   704,   704,   704,   704,   704,
     705,   705,   706,   706,   706,   706,   706,   706,   706,   706,
     707,   707,   708,   708,   708,   709,   709,   709,   709,   710,
     710,   711,   712,   712,   713,   713,   714,   714,   714,   714,
     714,   715,   715,   716,   716,   717,   718,   718,   719,   719,
     720,   720,   721,   721,   722,   722,   723,   723,   724,   724,
     725,   725,   726,   726,   727,   727,   728,   728,   728,   728,
     728,   728,   728,   728,   728,   728,   728,   729,   729,   729,
     729,   729,   729,   730,   730,   730,   730,   731,   731,   731,
     731,   732,   732,   733,   733,   734,   734,   734,   734,   735,
     735,   735,   736,   737,   737,   738,   738,   738,   738,   739,
     739,   740,   741,   741,   741,   741,   742,   742,   742,   743,
     743,   743,   743,   743,   743,   743,   744,   744,   744,   744,
     745,   745,   746,   746,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   748,   748,   749,   749,   750,
     750,   751,   752,   753,   753,   754,   754,   755,   756,   757,
     757,   757,   757,   757,   757,   758,   758,   759,   759,   760,
     760,   760,   760,   761,   762,   762,   762,   763,   763,   763,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   764,   764,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   764,   764,   764,   765,
     765,   765,   765,   765,   765,   765,   765,   765,   765,   765,
     765,   765,   765,   765,   765,   765,   765,   765,   765,   765,
     765,   766,   766,   766,   766,   766,   766,   766,   766,   766,
     766,   766,   766,   767,   767,   767,   767,   767,   767,   767,
     767,   767,   767,   767,   767,   767,   767,   767,   767,   767,
     767,   767,   767,   767,   767,   767,   767,   767,   767,   767,
     767,   767,   767,   767,   767,   767,   767,   767,   767,   767,
     767,   767,   767,   767,   767,   767,   768,   768,   769,   769,
     769,   769,   770,   771,   771,   772,   772,   773,   773,   774,
     774,   774,   775,   775,   775,   776,   776,   776,   777,   777,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   779,
     779,   780,   780,   781,   781,   781,   781,   781,   781,   782,
     782,   783,   783,   784,   784,   785,   785,   786,   786,   787,
     787,   787,   787,   787,   787,   787,   787,   788,   788,   789,
     790,   790,   791,   791,   791,   791,   791,   791,   792,   793,
     794,   794,   794,   795,   795,   796,   797,   797,   798,   799,
     799,   800,   800,   801,   801,   802,   802,   802,   802,   803,
     803,   804,   804,   805,   805,   806,   806,   807,   807,   808,
     809,   809,   810,   810,   810,   811,   811,   812,   812,   813,
     813,   814,   814,   815,   816,   817,   818,   819,   820,   821,
     821,   822,   822,   822,   822,   822,   822,   822,   822,   822,
     822,   822,   822,   822,   823,   824,   825,   826,   826,   827,
     827,   827,   828,   828,   828,   829,   829,   829,   829,   829,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   832,   832,
     832,   832,   832,   832,   832,   832,   832,   832,   832,   832,
     832,   832,   832,   832,   832,   832,   832,   832,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   834,   834
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     5,     1,     0,
       2,     0,     2,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       2,     2,     2,     2,     3,     3,     5,     5,     4,     5,
       4,     3,     5,     3,     5,     5,     6,     1,     1,     3,
       5,     6,     4,     1,     0,     2,     0,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     5,     2,     2,     3,     3,     3,     1,
       3,     1,     3,     1,     1,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     3,     6,     1,     1,
       1,     1,     1,     0,     1,     1,     2,     3,     4,     3,
       2,     2,     1,     2,     3,     4,     3,     2,     4,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     4,     4,
       1,     3,     3,     4,     6,     6,     6,     6,     4,     6,
       2,     4,     3,     3,     3,     3,     4,     4,     3,     3,
       3,     3,     3,     3,     4,     4,     3,     2,     3,     1,
       1,     3,     3,     3,     2,     2,     3,     2,     1,     1,
       0,     2,     0,     2,     2,    10,     6,     1,     1,     1,
       1,     1,     2,     0,     1,     1,     3,     3,     1,     1,
       3,     3,     3,     4,     1,     0,     2,     0,     3,     0,
       1,     0,    11,    12,     1,     1,     2,     2,     2,     2,
       0,     1,     0,     1,     3,     1,     1,     1,     3,     2,
       0,     3,     1,     1,     2,     1,     3,     4,     4,     2,
       5,     1,     2,     2,     2,     3,     2,     0,     2,     2,
       2,     2,     2,     2,     3,     1,     4,     6,     7,    11,
       3,     0,     1,     3,     1,     2,     2,     2,     0,     1,
       1,     2,     2,     0,     3,     3,     2,     1,     1,     2,
       2,     4,     0,     2,     2,     2,     0,     3,     4,     4,
       0,     2,     0,     4,     0,     6,     5,     3,     0,     1,
       3,     1,     5,     4,     2,     0,     2,     1,     2,     3,
       2,     2,     2,     2,     3,     3,     3,     1,     0,     1,
       1,     1,     2,     1,     5,     9,     1,     0,     1,     2,
       2,     0,     2,     0,     5,     7,     1,     0,     6,     2,
       0,     3,     5,    14,    19,     1,     1,     1,     3,     5,
       1,     1,     1,     3,     0,     1,     0,     1,     1,     1,
       3,     0,     1,     1,     1,     1,     1,     1,     2,     0,
       1,     2,     1,     2,     0,     2,     1,     2,     2,     6,
       8,     8,     4,     5,     4,     4,     4,     3,     7,     8,
       6,     6,     6,     6,     3,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     1,     3,     3,
       1,     3,    13,     1,     3,     4,     7,     4,     7,     2,
       1,     0,     2,     0,     1,     0,     6,     8,     8,     1,
       3,     5,     5,     7,     9,     7,     9,     5,     6,     6,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     1,     3,     1,     2,     2,     3,     4,
       6,     7,     7,     9,     8,     8,     6,     8,     9,     9,
       7,    10,     7,     8,     8,     8,     8,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     2,     4,     2,     0,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     2,     2,     1,     2,     2,
       1,     1,     7,     7,    10,     1,     1,     2,     1,     3,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     1,     3,     1,     2,     3,     0,     1,     3,
       2,     6,     6,     9,     3,     0,     3,     0,    13,    14,
       1,     0,     2,     0,     1,     3,     4,     4,     6,     1,
       2,     0,     1,     1,     0,     1,     1,     0,     9,     7,
       2,     0,     3,     2,     1,     3,     3,     3,     2,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     4,     5,
       1,     2,     4,     5,     1,     1,     1,     1,     3,     3,
       2,     2,     2,     2,     1,     2,     2,     1,     1,     3,
       2,     0,     5,     1,     2,     1,     0,     5,     7,     5,
       7,     7,     9,     1,     3,     3,     3,     1,     3,    11,
      10,     2,     2,     0,     9,     2,     0,     4,     4,     4,
       1,     1,     1,     0,     7,     6,     6,     6,     6,     7,
       9,     9,     6,     6,     6,     6,     6,     8,     8,     6,
       6,     6,     8,     8,     8,     8,     1,     0,     7,     6,
       6,     6,     6,     6,     7,     6,     6,     6,     6,     7,
       9,     9,     9,     6,     6,     6,     8,     8,     0,    14,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     0,     6,
       8,     2,     2,     2,     2,     2,     3,     3,     2,     2,
       2,     2,     3,     2,     5,     4,     3,     3,     3,     1,
       1,     0,     3,     2,     2,     1,     3,     2,     1,     0,
       8,    10,     2,     3,     3,     0,     2,     5,     2,     0,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       3,     3,     1,     0,     5,     4,     2,     0,     4,     3,
       5,     6,     4,     6,     6,     5,     7,     1,     0,     6,
      11,    11,    11,    13,     9,    11,    10,     3,     1,     4,
       2,     0,     4,     5,     5,     2,     4,     1,     1,     1,
       0,     1,     0,     1,     0,     3,     0,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     3,     0,     1,
       1,     1,     1,     3,     8,     3,     0,     2,     3,     2,
       3,     5,     1,     4,     2,     1,     3,     2,     2,     0,
       6,     2,     0,     5,     3,     0,     2,     2,     2,     3,
       1,     3,     1,     2,     1,     0,     7,     1,     3,     1,
       1,     3,     5,     2,     1,     3,     7,     0,     3,     2,
       2,     2,     0,     2,     2,     1,     1,     3,     3,     1,
       2,     4,     4,     1,     1,     8,     1,     4,     4,     4,
       2,     0,     3,     3,     4,     4,     4,     4,     2,     1,
       1,     0,     1,     1,     0,     1,     5,     1,     0,     1,
       0,     3,     1,     3,     4,     3,     4,     4,     2,     2,
       4,     1,     0,     1,     1,     1,     3,     0,     2,     0,
       1,     3,     1,     0,     1,     2,     4,     4,     2,     0,
       2,     3,     2,     0,     1,     3,     1,     2,     1,     2,
       5,     6,     5,     1,     2,     1,     4,     3,     4,     5,
       4,     5,     4,     5,     2,     4,     1,     2,     2,     2,
       1,     1,     0,     4,     2,     1,     2,     2,     4,     1,
       2,     3,     1,     2,     0,     2,     4,     4,     0,     1,
       3,     2,     2,     3,     5,     6,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     5,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     5,     2,     2,
       2,     1,     3,     3,     2,     1,     0,     3,     0,     5,
       2,     5,     2,     1,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     3,     5,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     3,     3,
       2,     3,     5,     4,     6,     3,     5,     4,     6,     4,
       6,     5,     7,     3,     2,     4,     2,     3,     3,     4,
       3,     4,     3,     4,     5,     6,     6,     7,     6,     7,
       6,     7,     3,     4,     4,     6,     2,     3,     4,     1,
       3,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     5,     6,     6,     7,     3,
       4,     1,     1,     2,     4,     1,     1,     1,     2,     2,
       2,     2,     1,     3,     4,     5,     5,     4,     1,     1,
       4,     1,     4,     1,     4,     1,     4,     1,     1,     1,
       1,     6,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       4,     6,     5,     7,     7,     7,     2,     3,     3,     3,
       4,     0,     4,     1,     3,     3,     1,     1,     1,     2,
       2,     0,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     4,     1,     4,     1,     2,     1,     2,     1,
       3,     3,     0,     1,     3,     1,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     2,
       3,     0,     3,     3,     2,     2,     1,     0,     2,     2,
       3,     2,     1,     1,     3,     5,     1,     2,     4,     2,
       0,     1,     0,     1,     2,     2,     2,     3,     5,     1,
       2,     0,     2,     1,     0,     1,     1,     1,     3,     3,
       1,     3,     3,     1,     1,     1,     1,     1,     3,     1,
       2,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     5,     2,     3,
       6,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      96,   811,   417,   878,   877,   811,   213,     0,   868,     0,
     811,   285,   300,     0,     0,     0,     0,   417,   811,     0,
     895,   575,     0,     0,     0,     0,   981,   575,     0,     0,
       0,     0,     0,     0,     0,   811,     0,   988,     0,     0,
       0,   981,     0,     0,   882,     0,     0,     0,     2,     4,
      43,    44,    15,    14,    19,    18,    62,    63,    33,     9,
      53,    38,    93,    92,    94,    25,    21,    50,    13,    22,
      26,    40,    27,    39,    12,    37,    57,    41,    60,    42,
      61,    28,    51,    48,    34,    35,    36,    54,    55,    56,
      77,    59,    88,    24,    67,    68,    83,    69,    84,    70,
      32,     8,    80,    79,    81,    29,    52,    78,    82,    10,
      11,    85,    58,    75,    72,    89,    87,    95,    73,    45,
       5,     6,    64,    31,     7,    17,    16,    30,    23,    91,
      20,   880,    66,    76,    65,    46,    71,    49,    74,    90,
      47,    86,   956,   955,   990,   959,   966,   810,   809,   795,
       0,     0,     0,     0,     0,     0,     0,     0,   416,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     819,  1440,  1441,  1442,  1443,  1444,  1445,  1446,  1447,   264,
    1448,  1449,  1450,  1451,  1452,  1453,  1454,  1455,  1456,  1673,
    1674,  1675,  1457,  1458,  1459,  1460,  1461,  1462,  1676,  1677,
    1463,  1464,  1465,  1466,  1467,  1678,  1468,  1469,  1470,  1471,
    1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,  1481,
    1482,  1483,  1484,  1485,  1486,  1487,  1488,  1679,  1680,  1489,
    1490,  1491,  1492,  1493,  1494,  1495,  1496,  1497,  1498,  1499,
    1500,  1501,  1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,
    1510,  1511,  1681,  1512,  1513,  1682,  1514,  1515,  1516,  1683,
    1517,  1518,  1519,  1520,  1521,  1684,  1522,  1523,  1524,  1525,
    1526,  1527,  1528,  1529,  1530,  1531,  1532,  1533,  1534,  1535,
    1685,  1536,  1537,  1538,  1539,  1686,  1687,  1688,  1540,  1541,
    1542,  1543,  1544,  1545,  1546,  1689,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,  1560,
    1561,  1562,  1563,  1690,  1691,  1564,  1565,  1566,  1567,  1568,
    1569,  1570,  1692,  1571,  1572,  1573,  1574,  1693,  1575,  1694,
    1576,  1577,  1578,  1579,  1580,  1695,  1696,  1581,  1582,  1583,
    1584,  1585,  1586,  1697,  1698,  1589,  1587,  1588,  1590,  1591,
    1592,  1593,  1594,  1595,  1699,  1596,  1597,  1598,  1599,  1600,
    1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,
    1611,  1700,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1701,  1624,  1625,  1626,  1702,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1703,
    1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1704,  1705,
    1645,  1706,  1646,  1707,  1647,  1648,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,  1657,  1658,  1659,  1708,  1709,  1660,
    1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1710,
    1711,  1712,  1713,  1714,  1715,  1716,  1717,  1670,  1671,  1672,
    1429,   263,  1403,  1430,  1431,  1813,  1812,  1399,   871,     0,
    1396,  1395,   417,     0,   798,   284,     0,     0,     0,     0,
       0,     0,     0,   500,     0,     0,     0,     0,     0,     0,
       0,   144,     0,   295,   294,     0,     0,   406,     0,   630,
       0,     0,   417,     0,     0,     0,   909,  1587,   907,   947,
       0,   214,   217,   215,   216,     0,     0,   716,   527,     0,
     526,     0,     0,   524,     0,     0,     0,     0,   528,   522,
     521,     0,     0,     0,   525,     0,   523,     0,     0,   799,
     906,   894,   880,  1441,   583,   587,   578,   584,   579,   576,
     577,  1599,  1427,     0,     0,   572,   582,   596,   602,   601,
     600,     0,   595,   598,   603,     0,   792,  1425,   826,  1408,
     980,     0,     0,   574,   791,  1645,   898,     0,     0,   720,
       0,   721,     0,  1614,   803,   200,  1622,  1704,  1645,   196,
     169,  1445,     0,     0,   595,     0,   800,   801,   987,   985,
       0,  1474,  1550,   193,  1610,  1622,  1704,  1645,  1669,   153,
       0,   207,  1622,  1704,  1645,   203,   819,     0,   794,   793,
       0,  1059,     0,  1055,  1396,   881,   884,     0,  1020,   964,
       0,     1,    96,   879,   875,   984,   984,     0,   984,     0,
     960,     0,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1429,     0,     0,  1409,  1430,  1434,     0,   535,
      99,  1404,     0,     0,     0,     0,  1426,     0,  1465,  1514,
    1308,  1318,  1316,  1317,  1310,  1311,  1312,  1313,  1314,  1315,
       0,   707,  1309,     0,    99,     0,     0,   385,     0,     0,
       0,     0,     0,    99,     0,     0,     0,     0,   815,   818,
     796,     0,     0,  1379,  1400,     0,   867,     0,     0,     0,
     557,     0,   566,   558,   563,     0,   560,     0,     0,   568,
       0,   559,   561,   562,   567,     0,     0,   564,   565,     0,
       0,   807,   341,     0,     0,     0,     0,     0,    99,   858,
     299,   298,    99,   297,   296,  1465,  1514,     0,   650,    99,
       0,   146,   420,     0,     0,   467,    99,     0,     0,     0,
       0,     0,     0,     0,     0,   910,   908,     0,   922,  1526,
       0,   260,     0,     0,  1526,   849,  1526,     0,  1526,   139,
    1401,  1465,  1514,  1526,     0,     0,  1526,   131,  1526,     0,
    1526,   421,     0,  1526,     0,  1526,   133,     0,  1526,   260,
     533,     0,   903,     0,   580,   589,   588,   586,   585,   581,
    1428,   590,   591,     0,   597,     0,     0,     0,     0,   925,
    1397,     0,   806,     0,     0,     0,   723,   723,   723,   802,
     199,   197,     0,     0,     0,     0,     0,     0,   808,     0,
       0,     0,  1673,  1674,  1675,  1372,     0,  1676,  1677,  1678,
    1248,  1257,  1249,  1251,  1258,  1679,  1680,  1501,  1681,  1682,
    1422,  1683,  1684,  1686,  1687,  1688,  1689,  1253,  1255,  1690,
    1691,     0,  1423,  1693,  1694,  1579,  1696,  1697,  1699,  1700,
    1259,  1702,  1703,  1704,  1705,  1706,  1707,  1421,     0,  1260,
    1709,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1412,  1414,
    1415,  1319,  1424,  1381,     0,     0,  1394,     0,  1237,     0,
    1086,  1087,  1109,  1110,  1088,  1115,  1116,  1128,  1089,     0,
    1393,  1151,  1236,  1242,     0,  1235,  1231,   971,  1390,  1373,
       0,  1232,  1411,  1413,   209,     0,   210,  1622,   154,   192,
     164,   191,   195,   165,   194,     0,  1463,   155,     0,   162,
       0,     0,     0,     0,   206,   204,     0,   797,   260,     0,
    1057,     0,  1060,     0,  1056,   883,   880,  1386,  1385,  1387,
       0,   958,   957,     3,   886,   982,   983,     0,     0,     0,
       0,     0,     0,     0,  1013,  1002,  1010,  1014,  1021,  1410,
       0,     0,     0,     0,     0,   536,     0,     0,     0,    98,
     847,   202,   845,     0,     0,     0,     0,   852,     0,     0,
       0,   675,     0,     0,     0,     0,     0,     0,   676,   674,
     677,   684,   693,   696,     0,   620,   137,   138,     0,     0,
       0,     0,     0,     0,   219,   250,     0,     0,     0,     0,
       0,   101,   128,     0,     0,     0,     0,   383,   747,   747,
       0,     0,   747,     0,     0,     0,   747,     0,   218,   220,
     249,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   101,   130,     0,     0,     0,   813,   814,     0,   817,
       0,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,
    1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,
    1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,
    1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,
    1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,
    1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,
    1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,
    1807,  1808,  1809,  1810,  1811,  1435,  1376,  1375,  1406,  1436,
    1437,  1438,  1439,  1380,   870,  1407,   869,     0,     0,     0,
       0,     0,  1465,  1514,     0,     0,     0,     0,     0,     0,
       0,   287,   270,   271,    99,   269,     0,     0,   464,     0,
    1097,  1126,  1104,  1126,  1126,  1093,  1093,  1106,  1094,  1095,
    1133,     0,  1126,  1093,  1098,     0,  1096,  1136,  1136,  1121,
    1432,     0,  1078,  1079,  1080,  1081,  1107,  1108,  1082,  1113,
    1114,  1083,  1150,  1093,  1433,     0,   829,   857,     0,   101,
     501,     0,     0,   465,     0,   101,     0,   142,     0,     0,
       0,     0,     0,     0,   426,   425,     0,     0,   466,   101,
     385,     0,   378,   341,     0,     0,  1471,     0,     0,     0,
     950,   952,   951,     0,   949,     0,  1068,     0,   260,   258,
     259,   462,   715,     0,     0,     0,   260,     0,     0,  1526,
       0,  1526,     0,     0,     0,   260,     0,     0,     0,     0,
     532,   530,   529,   531,     0,     0,     0,  1526,   260,     0,
       0,   520,  1329,     0,   300,   887,   893,   889,   891,   890,
     892,   888,   571,  1486,  1519,  1544,  1615,  1620,     0,  1640,
       0,   604,   625,   599,     0,     0,   919,   912,     0,     0,
     935,   573,  1333,     0,     0,     0,   722,   719,   718,   717,
     198,   170,     0,     0,     0,   627,  1614,   805,     0,     0,
    1240,  1241,  1125,  1112,  1371,     0,     0,  1120,  1119,     0,
       0,     0,     0,  1102,  1101,  1100,  1239,  1332,     0,  1099,
       0,     0,     0,     0,  1126,  1126,  1124,  1170,     0,  1103,
       0,     0,  1351,     0,  1357,     0,     0,     0,  1132,     0,
    1130,     0,     0,  1206,     0,     0,     0,     0,     0,     0,
       0,  1233,  1154,  1155,  1708,  1237,  1329,     0,  1238,  1418,
       0,     0,  1118,     0,  1150,     0,     0,     0,  1384,  1327,
       0,     0,  1184,  1325,     0,  1186,     0,     0,     0,  1319,
    1318,  1316,  1317,  1310,  1311,  1312,  1313,  1314,  1315,     0,
    1323,  1167,     0,     0,  1166,     0,     0,  1023,  1374,     0,
    1416,   211,   212,   208,     0,   167,   166,     0,   189,   190,
     185,   401,     0,   161,   188,   399,   400,     0,   184,   403,
    1298,  1297,   168,   160,   158,   181,   183,   182,   180,   156,
     171,   173,   174,   175,   159,   157,   205,   539,     0,  1061,
       0,  1023,   937,   939,   940,     0,  1381,   872,  1389,     0,
       0,   876,   964,   969,   963,   968,   991,   992,   644,   967,
       0,  1019,  1019,  1004,   998,  1003,   999,  1005,  1012,   962,
    1001,   961,     0,  1015,     0,     0,     0,     0,     0,     0,
       0,   537,     0,     0,     0,   201,   844,     0,     0,     0,
       0,     0,   855,   335,     0,   257,     0,     0,     0,     0,
       0,     0,   682,     0,     0,     0,     0,   683,   680,   681,
    1615,   695,   694,   692,   661,   663,   662,     0,   653,     0,
     654,     0,     0,   660,   667,   665,     0,     0,     0,     0,
     255,     0,   254,     0,     0,     0,     0,     0,   703,   708,
       0,   127,     0,     0,     0,     0,     0,   387,   398,     0,
       0,     0,     0,    99,    99,   384,   746,   230,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   247,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   129,     0,     0,     0,
       0,     0,   179,   812,   816,  1377,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   342,   344,     0,     0,   273,
    1432,     0,   487,   463,     0,  1078,     0,     0,  1072,  1139,
    1140,  1141,  1138,  1142,  1137,     0,  1084,  1093,  1090,     0,
     827,   310,   135,     0,     0,     0,   475,   478,     0,    97,
     146,   300,     0,   145,   147,   149,   150,   151,   148,   152,
     419,     0,     0,     0,     0,     0,   431,   430,   432,     0,
     427,     0,     0,   126,   382,     0,     0,   302,   366,     0,
     404,     0,     0,     0,     0,   768,     0,     0,     0,   948,
       0,  1033,   921,  1024,  1035,  1026,  1028,  1062,  1399,     0,
       0,   919,     0,   699,     0,   850,     0,   697,   140,  1402,
       0,     0,     0,     0,     0,     0,   517,   132,     0,   260,
     422,     0,   260,   134,     0,   414,   260,   534,   905,     0,
       0,   608,   607,   618,   609,   610,   606,   605,   611,     0,
       0,   627,   914,     0,   915,  1381,     0,   911,     0,   932,
       0,   930,     0,  1398,   934,   923,   897,     0,   896,   900,
     902,   901,   899,     0,     0,     0,   595,     0,     0,   260,
     804,     0,     0,     0,  1335,     0,     0,  1370,  1366,     0,
       0,     0,     0,     0,  1342,  1343,  1344,  1341,  1345,  1340,
    1339,  1346,     0,     0,     0,     0,     0,     0,     0,  1123,
    1122,     0,     0,     0,     0,     0,     0,     0,  1209,  1242,
       0,     0,  1303,     0,  1329,  1356,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1329,  1362,     0,     0,
       0,  1296,     0,  1293,     0,     0,     0,     0,  1382,  1381,
       0,     0,     0,     0,  1419,  1168,  1392,     0,  1383,     0,
       0,  1175,     0,  1363,  1202,     0,  1207,  1190,     0,  1183,
       0,  1188,  1192,  1171,  1384,  1328,     0,  1326,     0,     0,
    1169,     0,  1164,  1162,  1163,  1156,  1157,  1158,  1159,  1160,
    1161,  1152,  1165,  1307,  1305,  1306,     0,     0,     0,  1187,
    1520,  1550,     0,   981,   981,   970,   979,  1391,     0,  1064,
       0,     0,     0,  1243,     0,     0,   402,     0,  1150,     0,
    1058,   944,     0,     0,  1068,     0,   943,   874,   873,  1388,
       0,     0,   642,   643,     0,   647,  1011,     0,   935,   935,
       0,     0,     0,   485,   484,     0,     0,     0,   755,   725,
     538,   756,   726,     0,   846,     0,     0,     0,     0,     0,
     260,   853,   757,   256,   854,   749,     0,   678,   679,   758,
     727,     0,   750,   664,  1093,   652,     0,     0,   659,     0,
     658,  1093,  1093,   728,   136,   252,   736,   253,   251,     0,
    1405,     0,     0,     0,     0,   739,     0,     0,   110,   112,
     114,     0,     0,   108,   116,   111,   113,   115,   109,   117,
     107,     0,     0,   106,     0,     0,     0,     0,   100,   763,
     732,   734,   751,   386,   397,     0,   390,   391,   388,   392,
     393,     0,     0,     0,   222,     0,     0,   233,   246,   241,
     242,   240,   260,   260,     0,     0,     0,     0,   243,   238,
     239,   235,   248,   733,     0,   752,   234,   232,     0,   221,
     765,   741,     0,     0,     0,     0,     0,     0,     0,   859,
       0,     0,     0,   764,   753,   740,   735,     0,     0,   177,
     176,   178,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   570,   546,   569,     0,     0,     0,     0,     0,     0,
       0,   540,   340,     0,   286,   267,   268,     0,   266,     0,
     486,     0,     0,     0,  1073,     0,     0,     0,     0,     0,
       0,     0,     0,  1091,     0,     0,   843,   843,   843,   843,
     843,   828,   851,     0,   506,   474,     0,     0,   341,   141,
       0,     0,   418,   473,   471,   470,   472,     0,     0,     0,
       0,  1069,     0,     0,   375,     0,     0,     0,   301,   303,
     305,   306,   307,     0,   379,   381,     0,     0,   370,     0,
       0,     0,     0,   633,     0,     0,     0,   691,   687,   670,
       0,   953,   954,     0,   964,     0,  1035,     0,  1034,  1046,
       0,     0,  1052,  1050,     0,  1052,     0,  1052,     0,  1027,
       0,  1029,  1046,  1400,     0,  1483,  1065,   920,   260,     0,
     260,     0,   260,     0,   260,     0,   260,     0,   789,     0,
     459,   260,   519,  1330,     0,     0,     0,   617,   612,   614,
       0,   621,     0,     0,   917,   918,   933,   926,   928,   927,
       0,     0,   924,  1334,   518,     0,     0,   260,     0,   622,
     986,  1337,  1338,     0,     0,     0,     0,  1367,     0,     0,
    1272,  1250,  1252,  1092,  1262,     0,  1105,  1273,  1274,  1254,
    1256,     0,  1320,     0,     0,  1263,  1211,  1212,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1224,  1223,  1264,  1302,     0,     0,  1354,  1355,  1265,
    1134,  1135,  1136,  1136,     0,     0,  1361,     0,     0,     0,
    1270,  1275,     0,     0,  1280,     0,  1301,     0,     0,     0,
    1234,  1330,  1127,  1128,     0,     0,     0,     0,     0,     0,
       0,     0,  1208,  1191,  1185,     0,  1189,  1193,     0,     0,
       0,     0,  1177,  1203,  1173,     0,     0,  1179,     0,  1204,
     981,   981,   981,   981,   978,     0,     0,  1022,     0,  1007,
       0,     0,  1247,  1244,   163,     0,   186,   172,     0,     0,
     938,   919,   941,   885,   993,     0,  1321,   647,   645,   646,
     995,  1018,  1017,  1016,   996,  1000,   997,   754,   724,   748,
     843,     0,   334,     0,     0,     0,   856,   672,     0,  1093,
     655,   656,   657,     0,     0,     0,     0,     0,     0,     0,
     705,     0,   706,   704,   122,     0,     0,     0,     0,   103,
     102,   123,   121,     0,   120,     0,   389,   394,   396,   395,
     310,     0,     0,     0,   223,   231,   228,   244,   236,   245,
     237,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   759,   729,  1378,   541,     0,     0,   542,   550,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   552,
     343,   289,   274,   278,   858,   858,     0,   279,   858,   275,
     858,   272,  1579,  1311,   482,   489,   479,   481,   483,   480,
       0,   488,   454,     0,     0,     0,  1076,     0,  1144,  1145,
    1146,  1147,  1148,  1149,  1143,  1150,     0,   843,   842,     0,
       0,     0,     0,     0,     0,     0,     0,   321,     0,     0,
     315,     0,     0,   691,   309,   312,   313,     0,   476,   477,
       0,   300,     0,   434,   428,     0,   490,   468,     0,  1071,
     906,   302,   327,   362,     0,   377,     0,   364,   363,   365,
       0,   372,   825,   411,   408,     0,   633,     0,     0,   685,
     688,   686,     0,   666,     0,   671,   649,     0,   946,  1037,
    1044,     0,  1025,     0,  1051,  1047,     0,  1048,     0,     0,
    1049,     0,     0,  1044,     0,     0,     0,   700,     0,   698,
       0,   513,     0,   515,     0,   701,   260,   260,   415,     0,
     378,   619,   615,     0,     0,   592,   624,   913,   916,   931,
     929,   627,     0,   593,   626,  1336,  1111,     0,  1369,  1365,
       0,  1331,     0,  1349,  1348,  1350,     0,  1229,     0,     0,
    1221,  1219,  1220,  1213,  1214,  1215,  1216,  1217,  1218,  1210,
    1222,  1359,  1358,  1352,  1353,  1131,  1129,     0,  1267,  1268,
    1269,  1360,  1276,     0,  1295,  1294,     0,     0,     0,  1282,
       0,     0,  1291,     0,  1304,  1117,  1150,  1153,     0,     0,
    1176,  1364,  1194,     0,     0,     0,  1172,     0,     0,     0,
       0,  1181,  1320,     0,     0,     0,     0,     0,     0,   973,
     972,  1063,     0,  1009,  1245,  1246,  1417,     0,     0,   945,
     936,     0,   994,     0,   336,     0,     0,   691,   673,     0,
     668,     0,     0,     0,     0,     0,   507,   493,     0,     0,
     508,   509,     0,     0,     0,   118,   104,   125,   124,   105,
     119,   308,     0,     0,     0,     0,   262,   737,     0,     0,
       0,     0,     0,   767,   745,   766,   743,   742,   744,   738,
       0,   544,     0,     0,     0,   545,   556,   554,   553,   555,
     547,   290,    99,     0,     0,     0,     0,     0,     0,     0,
     456,     0,     0,   461,   450,   452,     0,     0,     0,  1074,
    1077,  1085,   449,     0,   838,   837,   836,   833,   832,   841,
     840,   831,   830,   835,   834,     0,     0,   319,   323,   324,
     322,   314,   691,   341,   374,     0,     0,     0,   436,     0,
       0,   469,     0,  1070,   904,     0,   325,     0,   366,   304,
     380,   381,     0,     0,   376,     0,     0,     0,   820,     0,
     413,   409,     0,     0,   632,     0,     0,   691,   690,   784,
     785,   782,   783,     0,  1036,     0,     0,  1038,     0,     0,
    1040,  1042,     0,     0,     0,     0,     0,  1403,  1244,  1067,
    1066,   260,   260,   260,   260,   790,   460,     0,     0,     0,
     613,   260,     0,  1368,  1261,  1271,  1347,     0,     0,  1230,
       0,     0,  1266,  1710,     0,     0,  1299,  1300,  1281,     0,
    1565,  1286,     0,     0,     0,  1420,  1200,  1198,  1195,     0,
    1196,     0,     0,  1178,  1174,     0,  1180,  1205,   977,   976,
     975,   974,     0,     0,   965,  1150,   942,     0,   848,     0,
     691,   374,   669,   761,   730,     0,     0,   499,     0,     0,
       0,     0,   762,   731,   760,   224,   225,   226,   227,     0,
     229,     0,     0,     0,   864,     0,     0,   548,   549,   543,
     273,     0,   276,   281,     0,   282,   277,   280,   458,   457,
     455,   451,   453,  1075,     0,   713,     0,   454,   839,     0,
       0,   311,   374,   348,     0,   316,     0,   825,   302,   435,
       0,     0,   429,   491,   366,     0,     0,   326,     0,   370,
       0,   367,     0,   371,     0,     0,   822,   410,     0,   405,
       0,     0,     0,     0,   634,   641,   641,   689,   648,     0,
       0,  1045,  1054,     0,  1041,  1039,  1030,     0,  1032,   714,
     514,   516,   702,   616,   623,   260,  1225,     0,     0,     0,
       0,  1277,     0,  1278,  1283,  1287,     0,  1284,  1285,  1197,
    1201,  1199,  1182,  1006,  1008,   187,  1322,     0,   374,   337,
       0,     0,   505,   494,     0,     0,   510,   261,     0,     0,
       0,     0,     0,   551,   265,   288,   283,   713,     0,   710,
     448,     0,   318,   317,     0,   353,     0,   503,   821,   437,
     438,   433,     0,   370,   331,   329,   333,   330,   328,   332,
       0,   372,   368,   369,   823,   824,   412,   866,     0,     0,
     691,     0,     0,   639,   644,   644,  1064,  1043,     0,  1031,
     594,  1226,     0,  1227,     0,     0,  1289,  1288,   341,   338,
       0,   497,   504,     0,   495,     0,     0,   860,     0,   861,
     862,   865,   709,   712,   711,     0,   345,   346,   347,     0,
     320,   349,   350,     0,     0,     0,     0,   372,   361,   292,
     691,   641,   372,   635,   640,   647,   647,     0,  1053,  1228,
    1292,  1279,  1290,   348,     0,     0,   512,   511,     0,     0,
       0,     0,     0,   351,     0,   352,   373,   502,     0,   441,
     293,   372,   644,  1064,   637,   636,   788,   353,     0,   505,
     863,     0,   358,     0,   357,     0,   355,   354,   492,   443,
     445,   446,   442,     0,   439,   444,   447,  1064,   647,   628,
     787,   786,     0,   454,   498,   496,     0,   356,   360,   359,
     423,     0,   629,   638,   770,   781,   769,   771,   779,   776,
     778,   777,   775,   339,     0,   440,     0,   780,   774,   964,
     955,     0,   772,   781,   441,   773,     0,   424
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    47,    48,    49,    50,  1000,  1591,  2058,    51,    52,
      53,    54,    55,    56,    57,    58,    59,  1029,    60,    61,
     750,  1237,  1703,    62,  1535,   600,  1479,  1480,  1643,  1481,
    1463,   940,  1482,  1001,  1021,    64,    65,   935,  1453,    66,
      67,    68,  1058,  1059,  1034,  1060,  1007,  1271,  2980,    69,
      70,  2147,  1184,  2148,  2521,   466,  1668,  2802,  2803,    71,
    1234,  2197,  2198,  2199,  2200,  2172,  2564,  2565,  2566,  2201,
    2856,  3027,  2202,  1543,  1181,  1664,  1665,  3115,  3180,  3181,
    3182,  3236,  2858,  2208,  2591,  2864,  3015,    72,  1251,  1728,
    2203,  2204,    73,    74,  1047,  1605,  2065,  1483,  1465,  1466,
      75,   492,  2593,  2870,  3039,    76,   169,    77,  1239,    78,
      79,  1246,  1719,  1720,  2849,  3020,  3121,  3243,  3244,  3007,
    2813,  2814,  2815,    80,    81,    82,    83,  1582,  1695,  1696,
    2525,   991,  1188,  1671,  1672,  2575,    84,  2756,  2757,   493,
    3185,  3164,    85,    86,  2760,  2761,    87,    88,    89,    90,
      91,   528,   799,   800,  2022,    92,    93,   730,  2132,    94,
     544,   813,    95,    96,   551,  1816,   553,  1320,  2267,  2268,
    2645,  1782,   663,    97,    98,  1791,  1819,    99,   494,  2598,
    3043,  3044,  3144,  1975,  2420,   100,   495,  1025,  1569,  1570,
    1571,  1572,  2602,  1573,  2217,  2218,  2219,  2599,  2606,   101,
    1023,  1563,   102,   103,   104,  1587,   680,   105,  3109,   106,
     773,   107,   572,  1337,   108,  1608,   109,   110,   111,  2220,
    3266,  3276,  3277,  3278,  2883,  3252,   112,  3268,   114,   115,
     116,   149,   698,   699,   700,   117,  2868,   118,   119,  1690,
    2171,  2549,   120,   121,  1536,  1994,   122,   123,   124,  1228,
     125,   126,   127,   128,   706,   129,   130,   131,   624,   616,
     966,  1501,   132,  1305,   532,   133,   824,  1808,   134,   802,
     135,  3269,  1326,  1793,  1794,  1797,  3270,  1266,   138,  1330,
    1802,  1805,  3271,  1491,  1492,  1493,  1494,  1495,  1962,   140,
     767,  1738,  3272,   908,   143,   144,   145,  1447,  1945,   561,
     977,   590,   629,   630,  1506,  1507,   984,  1521,  1514,  1516,
    2733,  2954,   985,  1519,   986,   987,  1978,   146,  1949,  1742,
    1743,  1744,  2228,  2238,  2615,  2890,  1745,   612,  1746,  2399,
    1751,  2190,  2191,  1332,  1678,  1212,   909,  1213,  1688,   910,
    1369,  1215,   911,   912,   913,  1218,   914,   915,   916,   917,
    1353,  1412,   918,   919,  1388,  1686,  1302,  1857,   921,   922,
    2702,  2933,  2924,  1882,  1883,  1472,  2698,   923,  1936,  1440,
     682,   924,  2527,  1442,  1877,  1842,  1525,  1823,  1351,  1843,
    1854,  2314,  1861,  1866,  2337,  2338,  1878,  1904,   925,  1827,
    1828,  2298,  1355,   926,   703,  1408,  1401,  1900,   969,   970,
     618,   927,   928,   929,  1321,   613,  2886,   780,   660,  2029,
    1157,   459,   558,   930,   931,   932,   933,  2269,  1469,   614,
     655,  1158,   453,   454,   657,  1162,   461
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -2817
static const int yypact[] =
{
    7531,   -27,  3455, -2817, -2817,   -27, -2817, 33203, 32069,    79,
       5,    98,  5841, 33581, 38117,   387,   155,  3823,   -27, 38117,
    1283, 24855, 29423,   444, 38117,   237,   363, 24855, 38117, 38495,
     462,   597, 38873, 33959, 29045,   629, 38117,   617, 39251, 34337,
     395,   363, 22548, 30179,   582,   342,   673,   826,   389, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817,   486, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817,  2126, -2817,    82,  2286,   464, -2817, -2817, -2817,
   27533, 38117, 38117, 38117, 27533, 38117, 30179, 20195, -2817, 38117,
   38117, 30179, 30179, 38117,   594, 38117, 38117, 38117, 30179,   715,
     539, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817,   863,   613,   735,
     758, -2817,  7249,   237, -2817, -2817, 32069,   591, 27533, 38117,
     596,   685, 38117, -2817, 38117,  1001, 38117,  1082, 20590,   778,
   38117, 38117, 38117, -2817, -2817,   839, 38117, -2817, 38117, -2817,
   38117,   780,   830,  1078,  1005,   126, -2817, 34715, -2817, -2817,
   30179, -2817, -2817, -2817, -2817, 27911, 38117,  1036, -2817, 39629,
   -2817, 28289, 40007, -2817, 20985,  1156, 40385, 40763, -2817, -2817,
   -2817, 41141,   918, 41519, -2817, 41897, -2817,  1070, 42275, -2817,
     816, -2817,   486,   903, -2817,   118,   132,   149,   138,   139,
     141,   903, -2817,   921,   176, -2817, -2817,  1033, -2817, -2817,
   -2817,  1118,   -56, -2817, -2817, 32069, -2817, -2817, -2817, -2817,
   -2817, 32069,   176, -2817, -2817,   237,   971,  1375, 38117, -2817,
   38117, -2817, 32069, 38117, -2817, -2817,  1364,  1027,  1256,  1029,
   -2817,  1228,  1236,  1289,    25,   237,  1246, -2817, -2817,  1355,
   11554, 30557, 42653,    57, 26395, 35093,  1218,   539,  1382, -2817,
     227, -2817,  1598,  1262,  1459,  1029,   539, 32069, -2817, -2817,
   18261, 43031,  1377,  1271, -2817, -2817,  1552, 11953, -2817,  1286,
    1301, -2817,  7531, -2817, 32069,   835,   835,  1655,   835,   708,
     772,   342, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817,   693,   863,  1341, -2817,   711, -2817,    62,  1349,
     777, -2817,   161,  4022,  1387,   211, -2817,   886, 38117, 38117,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
    1392, -2817, -2817,  1390,   784,    63,   355,   500,  1169,   730,
     183,  1526,   575,   814,  1513, 38117,  1618,    23, -2817,   459,
   -2817, 13948, 22170, -2817,   863, 38117, -2817, 32069, 27533,  1400,
   -2817, 38117, -2817, -2817, -2817, 27533, -2817,  1579, 21380, -2817,
   38117, -2817, -2817, -2817, -2817,  1519, 38117, -2817, -2817,  1631,
   38117, -2817,  1406,   -33,  1414,  1770, 46811, 38117,  1461,  1801,
   -2817, -2817,  1461, -2817, -2817, 38117, 38117,  1422,   671,  1461,
    1802,  1803,  1586,   393,  1136,    99,  1461, 32069, 32069, 32069,
    1656, 38117, 43409, 27533, 38117, -2817, -2817,   592,  1486,  1717,
    1341,   154,  1718,  1435,  1721, -2817,  1723,  1387,  1726,  1438,
   -2817, 43787, 44165,  1731,  1448, 38117,  1734,  1438,  1736,  1624,
    1739, -2817,   608,  1742,  1630,  1744,  1438, 26775,  1745,    88,
   -2817, 13948, -2817,   120, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, 38117, -2817, 30935, 38117, 31313,    66,    76,
   -2817, 38117, -2817, 46811,  1844, 38117,  1741,  1741,  1741, -2817,
   -2817, -2817,  1694, 38117,  1753,  1761, 30935, 38117, -2817, 44543,
    1489,   961,  1510,   -71,  1511, 13948,  1493,   206,   206,  1494,
   -2817, -2817,  1495,  1496, -2817,   818,   818,  1651,  1499,  1500,
   -2817,   823,  1502,  1524,  1529,   881,  1512,  1514,  1516,  1401,
     206, 13948, -2817,  1517,   818,  1521,  1523,  1528,  1543,  1531,
   -2817,  1545,  1532,   867,   919,  1534,  1536, -2817,  1499, -2817,
     208,  1537,  1541,  1542,  1544,  1549,  1550,  1553, -2817, -2817,
   -2817, -2817, -2817, -2817, 13948, 13948, -2817, 12352,   863,   237,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817,    83, -2817,   901,
    4888, -2817, -2817,  1692, 13948, -2817, -2817,    22, -2817,   863,
     902, -2817, -2817, -2817, -2817,   202,  1538,   280, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, 26015,  1933, -2817,   975,   459,
     232,  1882, 23682, 24073, -2817, -2817,  1776, -2817,    92, 32069,
   -2817, 38117, -2817, 19021, -2817, -2817,   486, -2817,  8634, -2817,
     800, -2817, -2817, -2817,  1557, -2817, -2817,   673,   673, 13948,
     673,   808, 12751, 13948,  1833,   116,  1834, -2817, -2817,   863,
   22926,   631,  1636,  1637, 27155,  1559,  1640,  1641, 42653, -2817,
   -2817, -2817, -2817,   147,   593,  1642,   168, -2817,  1738,   996,
    1683, -2817,  1646,  1648,  1755,   996,   179, 44921, -2817, -2817,
   -2817, -2817, -2817,   762, 10777, -2817, -2817, -2817,  1653,  1638,
    1658,  1659,  1422,   -50,  1574, -2817,  1643,  1644, 45677, 21775,
    1660, -2817, -2817,  1665,  1666,  1667,  1710,  1192,   122,  1942,
    1768,     2,  1268,   137, 32069,  1846,   128,   532,  1595, -2817,
   -2817,  1677,  1678, 38117, 38117, 38117, 38117, 30179,  1681,  1724,
    1685, -2817, -2817,  1686,   812,   980, -2817, -2817,   539, -2817,
    2734, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817,  1341, 46811,  1793,
    1387,   996, 38117, 38117,  1627,   443,   610,  1794, 38117,  1861,
   38117,  1672, -2817, -2817,  1461, -2817, 23304,  1422, -2817,  1632,
   -2817,  1687, -2817,  1687,  1687,  1633,  1633,  1639, -2817, -2817,
   -2817,  1401,  1687,  1633, -2817, 47567, -2817,   766,   773, -2817,
   -2817,  2012,  2022, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817,    91,   707, -2817,  2033, -2817, -2817, 46811, -2817,
    1957,  1701, 27155, -2817,  1697, -2817, 38117,   209, 38117,  1857,
   38117, 38117, 38117, 38117, -2817, -2817,   136,    35, -2817, -2817,
   -2817,  2028,    10,  1406, 26395,  1924, 38117,  1822,  1387,  2039,
   -2817,  1295, -2817,  1769, -2817, 17121,  1707, 27533,   154, -2817,
   -2817, -2817, -2817, 46811, 38117, 27533,   154, 38117, 38117,  1954,
    1729,  1958,  1730, 21775, 45677,    95, 38117, 38117, 32069, 38117,
   -2817, -2817, -2817, -2817, 38117, 32069, 38117,  1960,   154, 38117,
   38117, -2817,  8634,   869,    85, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, 38117, 27533, 38117, 38117, 32069, 32069, 38117,
    1754,  1538,   -68, -2817,  1733, 18641,  1805, -2817,   145, 32069,
    1864, -2817, -2817,   939,   656,   -37, -2817, -2817, -2817, -2817,
   -2817, -2817, 31313, 29423,  1949,    75, 38117, -2817, 13948, 13150,
   -2817, -2817, -2817,  1684,  8634,  1740, 13948, -2817, -2817, 13948,
    1708,  1708, 13948, -2817, -2817, -2817, -2817,  1023,  1708, -2817,
   13948, 13948,  1708,  1708,  1687,  1687, -2817,  3025, 13948, -2817,
   21775, 13948, 15544,  9999, 13948,  1774,  1778,  1708, -2817,  1708,
   -2817, 13948, 11155, -2817, 13948,  1903, 13948,   232,  1905, 13948,
     232,   863,  1711,  1711,   342,   810,  5157,  1709,   863, -2817,
    1820,  1708, -2817,  1708,   144, 13948, 27155,  1797,   131, 13948,
    1716,   554, -2817, 13948,   580, -2817,  1725, 13948,  1799,   146,
   13948, 13948, 13948, 13948, 13948, 13948, 13948, 13948, 13948, 46811,
   -2817, 15943,   156,   271,   295, 31691, 11554,  1997,   931,  9599,
   -2817, -2817, -2817, -2817,  1933, -2817, -2817,  1812, -2817, -2817,
   -2817, -2817,   978, -2817, -2817, -2817, -2817,   913, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,  1735,
   -2817, -2817, -2817, -2817, -2817,  1735, -2817, -2817,  1747, -2817,
   38117,    44, -2817, -2817, -2817,  1752, -2817, 29801, -2817, 11953,
   38117, -2817, -2817,  1967, -2817, -2817,  1737, -2817,  4051,  1967,
    1911,  1919,  1919, -2817,   200,  8634,  1963,  8634, -2817, -2817,
   -2817, -2817,   388, -2817,  1748,  1022,  1829,  1831,  1878, 38117,
   38117, -2817, 27155, 38117, 38117, -2817,  2102,  1762, 38117,  1991,
    1993,  1773, -2817, -2817, 38117, -2817,  1950, 38117, 13948,  1951,
   38117,  1955, -2817,   620, 38117, 38117,  1947, -2817, -2817, -2817,
   38117, -2817, -2817, -2817,  1944, -2817, -2817, 47567, -2817,  1032,
   -2817, 47189, 45299, -2817, -2817,   185, 38117, 38117, 38117, 38117,
   -2817, 38117, -2817,   751, 38117, 38117,  1775,  1782,  1780, -2817,
   38117,  8764, 38117, 38117, 38117, 38117,   996, -2817,  2151,   996,
     996,   747,  2153,  1461,  1461, -2817, -2817, -2817, 38117, 38117,
   38117, 38117, 32447, 38117, 38117,    17,   752, 38117, 32825, -2817,
   32069, 38117, 38117, 38117,   163,  1679, 38117, 38117,   214,    -4,
    1928,  1929,  1939, 38117, 38117, 38117,  8764, 38117,  1881,  1883,
     133,  1956, -2817, -2817, -2817, -2817, 13948,  2038,  2192, 38117,
    2046,  2049,  1875,  1876, 45677,    52, 38117, 38117, 38117, 38117,
   38117, 38117,  2052,    52,  1042, -2817, -2817,  1998,    69, -2817,
    1837,  1048, -2817, -2817, 13948,  2209, 46811,  1832,  1836,  1907,
    1926,  1932, -2817, -2817,  1936,  1708, -2817,  1141, -2817,   136,
     655, -2817,  8764,  2127, 38117,  1050, -2817,  1866, 32069,  8764,
   -2817,  1480, 29423, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817,   237,  1422,  1422,  1422,  1422, -2817, -2817, -2817,  2032,
    2024,  1863, 38117,  8764,  1192,    47, 32069, 28667,  1357,  2247,
    2129,   237,  2040, 32069,  2691, -2817,  2138,  2140,  2143, -2817,
   16741, 35471,  1867,  1128, -2817, 35471, 35849, -2817,   863,  1888,
   14347,  1805,  1341, -2817,  2263, -2817,  1387, -2817,  1438, -2817,
   38117, 38117, 38117, 38117,  1894,  1895, -2817,  1438,  2066,   154,
   -2817,  2071,   154,  1438, 26395, -2817,    88, -2817, -2817, 13948,
    1986,  1438,  1897, -2817,  1438,  1438,  1538,  1538,  1438, 36227,
    2296,  2171, -2817,  1058, -2817, -2817, 11554, -2817,    81, -2817,
     198,    -2,  2111, -2817, -2817, -2817, -2817, 46811, -2817, -2817,
   -2817, -2817, -2817, 38117,    53,  2080,  1908, 36227,  2275,   154,
   -2817,  1065,   -92,   788, -2817, 13948, 13948,   135, -2817,  6096,
    1072,  1913,  1918,  1073, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817,  1920,  2182,  1922,  1087,  1088,  1934,  1935, -2817,
   -2817,  3656,  1937,  5010,  1938, 15544, 15544,  1673, -2817, -2817,
   15544,  1940, -2817,  1106,  2690,  1925,  1945,  1943,  1952,  1961,
    1964,  6500, 13549, 13948, 13549, 13549,  6574,  1925,  1966,  1109,
   27155,  6761,  1114, -2817, 13948, 27155,  3730, 13948, -2817, -2817,
   13948, 38117,  1968,  1970, -2817,  3025, -2817,  1972, -2817, 15544,
   15544,  1354, 12352, -2817, -2817,  2197, -2817, -2817,   600, -2817,
    1948, -2817, -2817,  1807,   134, 13948,  1716, 13948,  2005, 21775,
    2130, 13948,  4184,  3086,  3086,   111,   111,   197,   197,   197,
     117, -2817,   295, -2817, -2817, -2817,  1953,  1531, 13948, -2817,
    1210,  1305, 32069,  2098,  3161, -2817, -2817, -2817, 17121,  1984,
   13948, 13948,  1971, -2817,  1120,   539, -2817,  1708,   144, 24464,
   -2817, -2817,  1123, 19021,  1707, 11953,   863, -2817, -2817, -2817,
    1129, 13948, -2817, -2817,  2181,  1107, -2817, 38117,  1864,  1864,
   13948, 13948, 12751, -2817, -2817, 38117, 38117, 38117, -2817, -2817,
   -2817, -2817, -2817,  2176, -2817, 13948,   105,  1959,  1973, 38117,
     154, -2817, -2817,  8634, -2817, -2817,  2206, -2817, -2817, -2817,
   -2817,  2149, -2817, -2817,   707, -2817, 45299, 47189, -2817, 47189,
   -2817,   707,   977, -2817,  1438, -2817, -2817, -2817, -2817,   899,
   -2817,   217, 46811,  2135, 46055, -2817, 38117,  2194, -2817, -2817,
   -2817,  2134,   152, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817,   190, 38117, -2817,  1708,  2136, 38117,  2041, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817,   996, -2817, -2817, -2817, -2817,
   -2817, 38117,   996,   996, -2817, 46811,   489, -2817, -2817, -2817,
   -2817, -2817,   154,   154, 38117, 38117, 38117, 38117, -2817, -2817,
   -2817, -2817, -2817, -2817,  2054, -2817, -2817, -2817,   659, -2817,
   -2817, -2817,  2189,  2191,  2193,  2061,  2062,  2064,  2067, -2817,
    2068,  2075,  2077, -2817, -2817, -2817, -2817, 38117, 38117, -2817,
   -2817, -2817,  7072,    52, 46811,  2227,    52,    52, 38117, 38117,
    2001, -2817, -2817, -2817,  2235,  2237,  2238,  2240,  2241,  2250,
      52, -2817, -2817, 38117, -2817, -2817, -2817,   -33,  1902, 19800,
   -2817,  2036,  7463,  2021,  1836,  2019,  1708,   334,   614,   382,
    2137,  2224,  2023, -2817,  2196,  2245,  2042,  2042,  2042,  2042,
    2042, -2817,  1265,  2097, -2817, -2817, 27155, 19800,  1406,   209,
    2165,   794, -2817, -2817, -2817, -2817, -2817, 32069,   136,   237,
    1131, -2817, 46811, 38117, -2817,  2035, 32069,  2037,  2031, -2817,
   -2817, -2817, -2817,  1132, -2817, 46811,   -30,  2213,  2204,   673,
   38117,  2117, 32069,  2099,   237, 26395, 46433,  2131, -2817, -2817,
    2214, -2817, -2817,   673, 10399,  1128,  2044, 38117, -2817,  2047,
   17121,  2277,  2215, -2817, 17121,  2215,   626,  2215,  2281, -2817,
   19401, -2817,  2053,  1069,  9599,  2231,  8634, -2817,   154, 46811,
     154,  2116,   154,  2118,   154, 45677,   154, 32069, -2817, 32069,
   -2817,   154, -2817,  8634, 32069, 27533, 38117,   -54, -2817, -2817,
    2228, -2817,   673, 38117,   863,  2058, -2817, -2817, -2817, -2817,
    2351,  2352, -2817, -2817, -2817, 38117, 30935,   109, 38117, -2817,
   -2817, -2817, -2817,  2069,  1137,  7770, 13948, -2817,  2361, 46811,
   -2817, -2817, -2817, -2817, -2817, 13948, -2817, -2817, -2817, -2817,
   -2817, 13948, -2817, 13948,  2341, -2817,  2070,  2070, 15544,   960,
    1521, 15544, 15544, 15544, 15544, 15544, 15544, 15544, 15544, 15544,
   46811, 16342,   525, -2817, -2817, 13948, 13948,  2348,  2341, -2817,
   -2817, -2817,  1363,  1363, 46811,  2076,  1925,  2078,  2079, 13948,
   -2817, -2817,  1142, 27155, -2817, 13948,  4307,  1145,  2132,  7692,
     863,  7956, -2817,  2434,   237, 13948,   244,   557, 13948,  1159,
   13948,  2357, -2817, -2817, -2817,  2088, -2817, -2817, 46811, 13948,
   15544, 15544,  3282, -2817,  4560, 13948,  2091,  4651, 12352, -2817,
     363,   363,   363,   363, -2817, 32069, 32069,  1867, 13948,  2356,
    1161,  1162, -2817,   237,   459,  2093, -2817, -2817,  2110, 38117,
   -2817,  1805, -2817, -2817, -2817,  2100, -2817,  1107, -2817, -2817,
   -2817,  1438, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
    2042,  7999, -2817, 38117, 38117,  1164, -2817, -2817,  2340,  1021,
   -2817, -2817, -2817,  2170,  2180,  2184,    64,   191,  2185,  2187,
   -2817,  2203, -2817, -2817,  1438,   903,   237, 38117, 38117, -2817,
   -2817,  1438, -2817,   237,  1438,   237, -2817, -2817, -2817, -2817,
   -2817,   492,   112, 46811, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, 38117,  2390,   435,   868, 38117, 38117, 38117, 38117, 38117,
   38117, 38117, -2817, -2817, -2817, -2817,  2115,    52, -2817, -2817,
    2360,  2363,  2365,    52,    52,    52,    52,    52,    52, -2817,
   -2817,   207, -2817, -2817,  1801,  1801,   825, -2817,  1801, -2817,
    1801, -2817,  2100,   978, -2817, -2817, -2817, -2817, -2817, -2817,
    1837, -2817,   160,  1708,  1372,  2142, -2817,  2144, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817,   144, 32069,  2042, -2817,    56,
      67, 36605, 36983, 37361,  2145, 38117, 15544, -2817,   691,   189,
   -2817,  2372, 32069,  2190, -2817, -2817, -2817, 46811, -2817, -2817,
    2510,    85, 32069,  2430,  2323,  1167, -2817, -2817, 38117, -2817,
     816, 28667, -2817,  2403, 28667, -2817, 38117, -2817, -2817, -2817,
    2503,  2246,  1230,  2218,  1349,   237,  2099, 38117,  2166, -2817,
    2162, -2817,  3703, -2817,  1422, -2817, -2817,   513, -2817, 35471,
    2178, 38117,  1128, 17121, -2817, -2817,  1915, -2817, 17121,  2408,
   -2817, 17121, 38117,  2183, 38117,  1175, 25246, -2817,  2179, -2817,
   38117, -2817, 38117, -2817,  2186, -2817,   154,   154, -2817,  2562,
    2188, -2817, -2817,  2448, 36227, -2817, -2817, -2817, -2817, -2817,
   -2817,    75,  2456, -2817, -2817, -2817, -2817, 13948,  8634, -2817,
    2195,  8634,  8194,  8634,  2348,  1852,  2459, -2817,   585,  2198,
    1852,  2158,  2158,  1012,  1012,   756,   756,   756,  2070, -2817,
     525,  8634,  8634, -2817, -2817, -2817, -2817,  2202, -2817, -2817,
   -2817,  1925, -2817, 14746, -2817, -2817,  2233,  2236,  2205, -2817,
   13948, 15145,  2200, 47567, -2817, -2817,   144,  1711, 15544, 15544,
    1696, -2817,   343, 13948, 46811,  1185,  1696,   847,  1488, 13948,
   13948,  5452,   174, 13948,  8234, 32069, 32069, 32069, 32069, -2817,
   -2817,  8634,  2557,  2455, -2817, -2817, -2817,   237,   342, -2817,
   -2817, 21775, -2817,   903, -2817,  1214,  1215,  2190, -2817,  2262,
   -2817, 38117, 38117,  1708,  1708, 46811,  2211, -2817,  1708,  1708,
    2216, -2817, 38117, 38117, 38117, -2817, -2817,  1438,  1438, -2817,
   -2817,  1265,  2378,  2380,   903, 38117,  2264, -2817, 38117, 38117,
   38117, 38117,  2492, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
    2441, -2817,    52,    52,    52, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817,  1461,  2518,   237,   237,  2399, 38117,   237,   237,
   -2817,   769,  2531, -2817,  2468,   576,  2225,  2497,  2500, -2817,
   -2817, -2817,  2504,   903, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, 13948,   686,  1852, -2817, -2817,
   -2817, -2817,  2190,  1406,  2293,  2295,   673,    21,  2535,  2525,
     136, -2817,   237, -2817, -2817,  2242,   954,  2244,  1357, -2817,
   -2817, -2817,   572, 38117, -2817,  2595,  2596,  2413, -2817, 38117,
    2474,  1559,  2519,  2248, -2817, 17501,   237,  2131, -2817, -2817,
   -2817, -2817, -2817,  2327, -2817, 38117,  1216, -2817, 13948,  2252,
   -2817, -2817, 17121,  1915,  1235, 38117,  1247, 46811, -2817, -2817,
   -2817,   154,   154,   154,   154, -2817, -2817,  2538, 38117,  2423,
   -2817,   154, 36227,  8634, -2817, -2817, -2817, 15544,  2526, -2817,
    2257, 46811, -2817,  2259,  1272,  1273, -2817, -2817, -2817,  8312,
    2314,  8634,  2362,  2261,  2265, -2817,  1623,  1623,   343,  1287,
   -2817, 15544, 15544,  1696,  1696, 13948,  1696, -2817, -2817, -2817,
   -2817, -2817, 13948, 13948, -2817,   144, -2817,  2266, -2817,  2407,
    2190,  2293, -2817, -2817, -2817, 17881, 21775, -2817,    64,  2269,
    2272,   191, -2817, -2817, -2817, -2817, -2817, -2817, -2817, 13948,
   -2817,   445,   497,  2306,  1438,  2551,    52, -2817, -2817, -2817,
   -2817,   237, -2817, -2817, 38117,  2273, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, 27533,  2658, 32069,   160, -2817,  8343,
    2461, -2817,  2293,  2490,  2532, -2817, 38117,  1230, 28667, -2817,
      15,  2429, -2817, -2817,  1357,   820,  1002, -2817, 32069,  2204,
    2409, -2817,  2411, -2817,  2454,  2462, -2817, -2817,   237, -2817,
   38117, 17501, 13948,  1288, -2817, 37739,  9216, -2817, -2817, 32069,
    1296, -2817,  8634, 38117, -2817, -2817, -2817,  1298, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817,   109,   726, 15544, 46811,  1299,
   13948, -2817, 13948, -2817, -2817, -2817,    59, -2817, -2817, -2817,
    1623,  1623,  1696,  1925,  8634, -2817, -2817, 32069,  2293, -2817,
   46811,  1387,    -9, -2817, 46811, 46811, -2817,  8634, 38117, 38117,
   38117, 38117, 38117, -2817,  1902, -2817,  2273,  2658,   240, -2817,
   -2817,  2570, -2817, -2817,   466,  2458,  2381,  2575, -2817, -2817,
   -2817, -2817, 27533,  2204, -2817, -2817, -2817, -2817, -2817, -2817,
    1322,  2246, -2817, -2817, -2817, -2817, -2817, -2817,  1331,  8509,
    2190, 17501, 38117, -2817,   261,   261,  1984, -2817,  1332, -2817,
   -2817,   726,  1352, -2817,  1353,  1360,  2358, -2817,  1406, -2817,
    1365, -2817, -2817, 45677, -2817,  1367,  1376,  2302,  2350,  2302,
   -2817,  1438, -2817, -2817, -2817,  2594, -2817, -2817, -2817,   148,
   -2817,  2480,  2482, 38117, 38117,  2693,  2313,  2246, -2817, -2817,
    2190, 37739,  2246, -2817, -2817,  1107,  1107,  2616, -2817, -2817,
   -2817, -2817, -2817,  2490, 27533,  2315, -2817, -2817, 38117,  2439,
     478,   478,  2627, -2817,  2379, -2817, -2817, -2817,    64, 25631,
   -2817,  2246,   261,  1984, -2817, -2817,   233,  2458,  1387,  2464,
   -2817,  2606, -2817,  2717, -2817,   170, -2817, -2817,  2211, -2817,
   -2817, -2817, -2817,  1378, -2817, -2817, -2817,  1984,  1107, -2817,
   -2817, -2817,   750,   160, -2817, -2817,  2470, -2817, -2817, -2817,
   -2817, 25631, -2817, -2817, -2817,   753, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, 27533, -2817,  1108, -2817, -2817,  1173,
    1301,  2326, -2817,   753, 25631, -2817,  1379, -2817
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -2817, -2817, -2817,  2106, -2817,  -645,  -457, -2817, -2817, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,
   -2817,  1030, -2817, -2817,    65,  1358,  1779,   775, -2817, -2817,
   -2817, -2817,  -559,   101,   479, -2817, -2817, -2817, -2817, -2817,
   -2817, -2817, -2817,  1111, -2817,  -576,   662,  1099, -2817, -2817,
   -2817, -2817,   601,  -250, -2817, -2817, -2817, -2817, -2817, -1171,
      14,   162, -2817,   157,  1139,   274, -2817,   -87, -2817, -2817,
   -2817, -2817,    49,   757, -1248, -1938,   609,  -449,  -472,  -426,
    -423,  -451, -2817, -2635, -2786, -2043, -2676, -2817,   498, -2817,
   -2817,   175, -1170, -2817,  1520, -2817, -2817,  -903, -2817,   -11,
   -2817, -2817,  -103, -2817, -2817, -2817,    93, -2817, -2817, -2817,
   -1169, -2817,  1080, -2103, -2817, -2817, -2817,  -517,  -484, -2817,
   -2816,   -36,   -34, -2817, -2817, -2817, -2817,  -730, -2817,   602,
     604,  -680, -2817, -2817,   632, -2817, -2817,  -436,  -184,  1556,
   -2817,  -442, -2817, -2817, -2817,  -183, -2817, -2817, -2817, -2817,
   -2817, -2817, -1284,  1044,  -647, -2817, -2817, -2817, -1477, -2817,
    2765,  2234, -1164, -2817,     8,    16,  1976,  -805, -1766,   151,
   -2817, -2817, -1286, -2817, -2817, -2817, -1726, -1162, -2817,   201,
    -243,  -342, -2807, -2403, -2322, -2817, -2817,  -770, -2817,   787,
    1233,  1229, -2817, -1449,   205,  -537, -2123, -2817, -2463, -2817,
   -2817, -2817, -2817, -2817, -2817, -1274,  -470, -2817,  -299, -2817,
   -2817, -2817, -2817,   669, -2817,   331, -2817, -2817, -2817, -2817,
   -2817, -2817,  -443,  -464, -2817, -2817, -2817,   102, -2817, -2817,
   -2817,  1259,  -685,  -570,  2217, -1156,  -197, -2817, -2817, -2817,
   -2817, -1989, -2817, -2817, -2817, -2817, -2817, -2817, -2817, -1078,
   -2817, -2817, -2817, -2817, -2817, -2817,  1325,  2804,  -425, -2817,
   -2817, -2817, -2817, -2817, -2817, -2817, -2817, -2817,  2029,   246,
   -2817,    36, -2817, -2817,   560, -1655,    37, -2817, -2817, -2817,
   -2817,  -331,    40, -2817,   864, -2817, -2817, -1403, -2817,  2034,
   -2817, -2817,     4,     0,   -45,   213,   621, -2817, -2817,   -35,
    1117, -2817, -2817, -2817, -2817,   865,  1849, -2817,   858,  -220,
   -2817, -2817,  1858, -2817, -2817,  1855,  1333, -2817,  1356,   895,
   -1681,  1104, -1647,   612,  -467,   -44,     9,  2353, -2817, -2260,
     887, -2392,   276,  2589,  1177, -1189, -2817, -2817,  -833,  -603,
   -2817, -2817, -2817,  4028,  4093, -2817, -2817,  4481,  4804, -2817,
    -723,   493,  5199,  3937,  -855, -1359,  4341,   890,  -769, -1195,
   -2817, -2817, -2817,  -215,   506,   193, -2817, -1070, -2817,  -155,
   -2817,  6119,   888, -2817,  -767, -2817,  -802, -2817, -1293, -2817,
   -2817, -2817, -2817, -2817, -1563, -2192,  -641,   949, -2817, -2817,
    1040, -2817, -2817, -2817,  -624,  -395, -1379,   955, -1385, -2817,
    -622,  1074,  1427,  1297,  -558,  2913,  1613,  2169,  -396, -1532,
    -889,  -590, -2817,  -107, -2817, -1252,   268,  -135,    -8,    50,
    5415, -1172,  3113,  -684,  -672, -1040, -2817
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1644
static const yytype_int16 yytable[] =
{
     142,   620,   681,   819,   141,  1729,   607,  1276,   747,   988,
    1765,   467,   995,   546,  1079,  1776,  1675,  1233,  1160,   546,
     665,  1333,  1363,  1364,   684,  1248,   491,   949,  1783,  1390,
    1161,  1344,   693,   936,  1303,   943,   136,   137,   552,  1041,
     139,  1379,   583,   654,   784,  1464,   619,   664,  1071,   958,
     584,  2287,   611,  2031,  1187,  1894,  1824,   452,   460,  2225,
    1697,  2435,   704,   452,   452,  2271,  1704,  1705,  1706,   452,
    1747,   452,   554,  1707,   556,  1708,   738,   452,   564,   452,
    1163,  1709,   574,   580,   554,  2574,   587,  1961,   580,   580,
    1268,  1035,   609,  1226,  2605,  2742,  2247,  1229,  2239,  2241,
    2844,    63,   113,   599,  1235,  1531,  1552,   803,  1831,  1832,
     527,  1249,  1557,   775,  1969,  1164,  1844,  1966, -1454,  1247,
    1847,  1848,  2018,  2020,  1357,  1358,  1022,  1269,  1410,   805,
     465,  1269, -1516,  1214,  1269,  1869,  1417,  1870, -1546, -1564,
    1407, -1590,  1417,  2824,   939,  2683,  1721,  1376,  1269, -1518,
    1798,  1615,  1537,  1324,  2827,  1898,   837, -1308,  1898,  1892,
     807,  1893,  2174,  2193, -1308,   667,   501,  1933,  1003,  1537,
     686,   688,  1257,  1679,  1934,  1948,  1606,   694,  2550,  2551,
    2552,  2553,  1606,  1538,  2285, -1324,  2141,  1304, -1563,  1445,
    2119,  3111, -1324,  1269,  1537,   625,  2276,  2753,  2587,  1548,
    2145,   659,   661,   659, -1093,   666,    14,   683,  1538,   666,
     452,  1818,    15,   452,  2096,   452,   659,   666,  1026,   475,
    1214,  2102,  1417,  3029,  2446,  1328,  1679,  2103,  1716,  2252,
    2894,  2254,  2896,  1539,  1680,  1726,    19,  2107,  1298,  3145,
    3210,  2296,  1063,  3131,  1896,  3250,  1726,   626,  1174,  2810,
    1539, -1126,  3162, -1121,  1076,  1548,   463,  3258,   989,   763,
    1799,  2708,  2108,  3173,  1079,  1004,  3156,  1581,  1651,   816,
    1558,   477,  2131,  1182,  1183,  1539,  1701,  2280,  2840,  1064,
    1352,    23,  1972,  1611,  2961,  3089,  1681,  1680,  1813,  1682,
    2457,  1790,  1451,   559,  3119,  1470,  2754,  1717,  2084,   982,
     147,  -291,  1580,   992,  1043,  2643,   945,   811,  2291,   462,
    1160, -1126,  1859,  2278,  1779,  1027,  2811,   627,  2104,  3120,
    1417,  2447,  1161,   681,  2758,   812,  1454,  2773,   993,  1044,
   -1126,  1612,   147,  1471,   148,    37,  3113,  3187,  1278,  1681,
    2281,   742,  1682,   983,  1702,   749,  2085,  1559,  1452,   557,
     817,  1232,  2644,  1390,    37,   756,  1973,  1540,   951,   681,
    1270,   734,  1363,  1364,  1270,  1163,   148,  1270,  1417,  1278,
    1379,  1232,  2755,  1939,  1540,  2812,  2277,  1683,  1675,  3012,
    2130,  1270, -1563,  1549,  3222,  1077,  1456,  1214,  3174,  3123,
    3259,  2097,  3163,  1644,  2146,  3251,    45,  1232,   770,  1540,
    1650,   502,  1005,   483,   777,   484,  1616,   764,    37,  2841,
    2459,  1727,  3159,  2319,  3048,    45,  2274,  2774,  1617,   628,
    2775,  1214,  3018,  2759,  1800,  1065,  1270,  1980,  1446,  2458,
    1683,   817,  3157,  2162,   557,  1214,  1722,  3273,   557,   557,
    1801,  2743,   902,  1541,  1899, -1563, -1308,  2380,    46,   557,
    1963,  1550,  1240,  1621,  1006,  2105,  1935,  1673,  2448,   817,
    1541, -1563,    43,  1684,  1421,  1422,  1618,  1325,  2120,    45,
    1357,  1358,  2916,   503, -1324,   504,  2320,  1028,  1718,  1376,
    2106,  1278,  1329,  2449,  1411,  1541,  1562,  1647,  1734,  1241,
    3211,  1826,  1685,  2279,  1300,  2745,  2746,  3088,  1329,    46,
    1232,  1278,  1066,  3057,   542,  1435,  1436,  1437,  1438,   611,
    2360,   543, -1644,  1425,  1439,  2644,  1684,  3232,   500,   452,
    1439,    46,   661, -1454,   659,   804,   666,   806,   683,   808,
     666,   751,   452,   809,  1448,   542,   452, -1516,   659,  1669,
     666,  1497,   543, -1546, -1564,  1747, -1590,   452,  1160,  2612,
    1937,  2801,   952,  2616, -1518,   729,   452,  1352,  2823,   661,
    1161,  2779,   452,   681,   683,  1214,   452,   452,  2441,  1589,
    2442,   452,   557,   452,  2709,   452,  1687,  2541,   659,  1545,
    2412,  1821,  1822,  1214, -1093,   760,  1362, -1093, -1126,   994,
   -1121, -1093,  1830,  2471,  1438,  1833,  2500,  2501,  3176,  2406,
    1439,  1167,  1214,  1845,  1846,  2879,  1981, -1126,  1170, -1121,
    1914,   555,  1655,  1858,  1636,   953,  1863,  1865,   452,   557,
     452,  1045,   142,   829,  1260,  1214,   141,  1879,   588,   901,
     696,   833,  2321,  2322,  2323,  1242,  2324,  2325,  2326,  2327,
    2328,  2329,   580,  1990,   944,   580,  2495,  2330,  1046,  2498,
    2499,  1849,  1850,  1905,  1544,  1906,  1258,   938,   136,   137,
     947,   962,   139,  2509,  3030,  2810,  1732,  1290,  2542,  1657,
    1214,  1261,  1938,  1656,  2880,  1907,  3031,  3192,   568,   560,
    1545,  1214,  1954,  1511,  2918,  3233,  2919,  1433,  1434,  1435,
    1436,  1437,  1438,  2063,  2319,  1730,  2066,  2067,  1439,  2371,
    2526,  2372,   567,  2780,  1291,  2405,  1658,  2772,  2352,  3177,
     696,  2007,  1243,  2357,   615,  2165,   589,   697,   659,   659,
     902,  2373,   606,    63,   113,  1915,  2319,  3221,  2526,  1916,
    1512,   731,  1160,  2554,  2536,  1433,  1434,  1435,  1436,  1437,
    1438,  3195,  3196,   617,  1161,   452,  1439,  3022,    15,   569,
    3234,  2664,  1262,  1747,  2605,  1165,  2740,  2538,  2232,  1786,
    1787,   452,  1917,  2166,  3178,  3099, -1055,  2603,   683,  1908,
     452,  3235,  1692,  2556,  1909,  2684,   452,  1888,  1699,  1910,
     659,  2838,  2472,  2233,  1163,  1859,  1859,   452,  2008,  2320,
    1859,  2812,  1723, -1055,   622,   659,   659,   697,  2618,  1263,
    1008,  2881,  2462,   142,  3098,   475,  2235,  1311,  1546,  2539,
    2920,   659,  1165,  1764,   452,  1623,  1068,    23,   142,  3248,
    2374,  3032,  1327,  2473,  1163,  2375,   621,  2068,  1009,  1859,
    1859,   659,   659,   822,   981,   452,  1214,  2839,   623,  1307,
    1308,  1350,    15,  1309,  2167,    15,   975,   944,  1160,  1581,
    1292,  1278,  1659,   838,  2163,  2882,  3100,   477,  1366,  2998,
    1161,   941,   620,   452,  2941,  1078,   452,   554,  1069,  2995,
     631,   452,  1526,  3224,  3225,   452,  1264,  1918,  1755,   690,
     585,  1010,  3124,  1341,   681,  1911,  3197,   452,  1393,  1347,
     695,   982,  1624,  1912,   964, -1644,  2168,  1527,  -989,  2109,
    2540,  3010,  2237,  1278,  2535,  2537,  2560,  1405,  3125,  1011,
    1852,    23,   570,   571,    23,  2999,   733,  2324,  2325,  2326,
    2327,  2328,  2329,  -964,  1528,  2911,  3263,  1293,  2330,  1660,
    2570,  2376,  2887,  1232,   976,   983,  -964,  2891,  2561,  2377,
    2893,  2069,   901,  2070,    37,  2321,  2322,  2323,  2562,  2324,
    2325,  2326,  2327,  2328,  2329,  -989,   147,   705,  2072,  2073,
    2330,    37,  2884,  3249,  1214,   707,  3264,    28,  1214,  1214,
      28,  1061,  2169,  3126,  2170,  -964,  1581,  1502,  1502,  2641,
    1502,  2634,  2183,  2184,  2185,  2186,  2250,  3262, -1407,   483,
     148,   484,  1030,  -964,  2781,   944,  1062,   736,    43,  -989,
    2655,  1185,   944,   944,  1697,    45,  2739,  2028,  1704,  1705,
    1706,  1489,  2782,  1496,   737,  1707,  2319,  1708,   996,  1624,
    2791,  1032,    45,  1709,  2563,  -300,  2795,  2796,  2797,  2798,
    2799,  2800,    33,  2086,  1561,  1747,  1014,  -964,    37,  1747,
    2806,    37,  1015,   997,  1033,  -964,   748,    33,   580,  1016,
    1040,  1214,  1542,  1638,    33,   998,  3106,    46,  2294,  2666,
    1232,  2667,  1458,  1018,  3127,  2874,  1510,   580,  3025,   757,
     998,  1019,  2248,  1214,    46, -1432,  1632,   998,  1639,  2320,
    1070,  2087,  2807,   757,    33,   158,  1858,  1858,  3189,   683,
    3128,  1858,    43, -1433, -1432,    43,   758,  1607,  2902,    45,
    2903,  1700,    45,  1511,  3026,  1834,  2346,   998,  1362,  2529,
    2572,   994, -1433,   659,   659,   659,   659,  1020,  2324,  2325,
    2326,  2327,  2328,  2329,   753,  1385,  1386,  1030,   681,  2330,
    1858,  1858,  1385,  1386,   759,  2369,   999,  2529,  1992,  1002,
    2444,  1200,   761,   999,  3220,  1244,  3065,  -964,   759,  3223,
    1512,  3265,  1031,  2329,    46,  3129,  1032,   762,  1749,  2330,
    1752,  1459,  2466,  1042,  1245,  2445,  1835,  1387,  1756,  2468,
    2469,  1407,  1072,   999,  1389,  2668,  1048,  1409,  3247,  1033,
     772,  2694,  1049,  2400,  2401,  2669,  2821,  1414,  2292,  2163,
    1503,  1505,   785,  1509,  2293,   658,  1160,   662,  1450,  2231,
   -1093,  1160,  1498,   792,  1214, -1106,  1499,   664,  1161,   701,
     692,  3054,   971,  1161,   702,  2261,  1468,   801,  1836,  1362,
    1050,  1837,   659,   659,  1368,   681,  1385,  1386,   659,  1596,
    1666,  2345,   901,  2347,  2348,  2321,  2322,  2323,  1640,  2324,
    2325,  2326,  2327,  2328,  2329,   797,  2524,  1641,  1859, -1136,
    2330,  1859,  1859,  1859,  1859,  1859,  1859,  1859,  1859,  1859,
    2232,  1859,   701, -1133,   170,  1741,  1051,   702,  1387,   464,
    1642,  1778,  1597,  1052,  2524,  1779,  1053,   529,  1385,  1386,
     620,  2816, -1133,   557,   557,  2233,   666,   814,   452,   542,
     659,   659,   659,   659,   586,   557,   543,  2825,     3,     4,
    2234, -1136,  1413,  1449,   944,   457,  1165,   810,  2235,  1838,
    1859,  1859,  2554, -1410,  1957,  2987,  2988,  2989,  1780,   740,
    1389,   741,  1606,  1054,   661,   619,  2555,   452,   452,  1613,
     701,  2236, -1410,   683,   142,   702,   452,   452,  1812,   452,
     457,  1806,  1888,  1598,   452,  1807,   452,  2935,   815,   659,
     659,  1815,  2556,  2243,  2557,  1460,  1461,   557,  1814,  1956,
    1349,   542,    46,   452,   810,   452,   452,  2439,  1462,   452,
    1809,  1810,   823,  2443,  1811,  1795,  1055,  1461,  1362,  1417,
    1609,  1532,   542,  1614,  1418,  2404,  1599,  1622,  1600,  1462,
     830,   579,   554,   554,  1988,  1839,  1820,   605,  1991,  1601,
     743,   831,   744,  1840,  2237,  1841,  2326,  2327,  2328,  2329,
    1030,   825,  2002,  1214,  1214,  2330,  1214,  2749,  1747,  2009,
    1903,  2558,  1362,  1747,  1984,  1532,  1747,   832,  1807,  1214,
     683,  1214,  1602,   833,  2015,  1056,  2804,  2805,  2016,  1032,
    2808,  2023,  2809,  2025,  2142,  1374,  1375,   653,  2143,  2386,
    2150,   653,  2175,   457,  2151,  2035,  2176,  2059,   457,   457,
    2272,   834,  1057,  1603,  2273,   457,  2368,  2290,   701,   835,
   -1410,  1779,  1214,   702,  2300,  2303,  2588,  2625,  1779,  1779,
    2559,  2652,  2418,  2419,  3117,  2560,  1859,  2685,  2686,  2307,
    2308,  2100,  1160,  1779,  1779,  1604,  1338,  1339,  2113, -1644,
    2115,  2965,  2966,  1420,  1161,  2942,  2969,  2970,  2334,  3103,
    3282,  2351,  1779,  3283,  2934,  1779,  2354,  2561,   739,   836,
    2355,  1214,  2403,  1421,  1422,  2408,  1779,  2562,  2390,  2409,
    2391,  2413,   755,  2577,  2585,  1278, -1644,  2578,  2586,  2656,
    1496,   471,  1362,  1779,  2692,  1532,  1214,  2699,  2693,  1858,
     452,  2700,  1858,  1858,  1858,  1858,  1858,  1858,  1858,  1858,
    1858,  2711,  1858,  2734,  2735,  1779,  2747,  1779,  1779,  2851,
    2143,   839,  1425,  2852,  1214,   971,  2715,  2898,  -956,   666,
     452,  1779,  2691,   666,   661,   840,  1426,  2940,   452,  1214,
    1884,  1807,   948,  1887,   452,  3013,  3085,   666,  1504,  1504,
     452,  1504,  1214,  2563,   666,   452,  2163,  2865,  2866,  2867,
     452,  1858,  1858,  1214,   475,   950,  2959,  2960,  3051,  1163,
    2143,  2143,  1278,  2392,   954,  2393,   666,   452,   666,   452,
     956,   452,  -631,  1749,  2030,  2030,   955,  3056,  1859,  1859,
     666,  2578,   666,   452,   452,   452,  1214,  2422,  2423,  3058,
    1888, -1644,  1214,  2578,  1736,  1737,  2601,  2319,  2075,  2076,
     452,   452,   452,   452,  2083,   964,   477,   452,   452,  1160,
     963,   452,   452,   452,  3071,  3073,   666,   452,  3072,  1779,
    3045,  1161,   965,   666,   452,   666,  1048,   452,   971,  3079,
    3140,   979,  1049,  1807,  3141,   620,  1214,  1747,  3147,   659,
    3149,  3153,  1278,   972,  2578,  1807,   659,   659,   659,   659,
     659,   659,  1036,  1037,  2180,  2181,  2206,  2207,  3107,  1079,
    2320,  1417,  1385,  1386,  3188,   142,  1418,  1214,  1329,  2194,
    1050,  2817,  2818,  3190,  3198,  1958,  1888,  3141,  1278,  1429,
    2224,  1214,   990,   978,  2030,   980,  1433,  1434,  1435,  1436,
    1437,  1438,   554,   994,  3199,  3200,  1067,  1439,  1807,  2355,
    2424,  2425,  3201,   457,   681,   653,  1779,  3204,  2617,  3206,
    2620,  1807,  2192,  1807,  1179,  1214,  1051,  2205,  3207,  1073,
    3260,  3287,  1807,  1052,  3261,  3261,  1053,  1858,  1024,  1230,
    1231,  2229,  2319,  1038,  1039,  2229,  2242,   457,   483,  1075,
     484,  1168,   653,  1171,  1176,  1255,  1178,  1180,   653,   486,
     659,  2030,   659,  2030,  3167,  1186,  3169,  1189,   489,  2416,
     999,  1227,  2318,  1232,   944,  1280,  1282,  1238,  1236,  -143,
    1265,  1254,  1417,  1054,  1267,  1272,  1273,  1418,  1274,   666,
    1275,  1749,  2319,  1277,  1278,  1420,  3045,  1859,  1283,  1284,
    2427,  1286,   457,  1287,  1288,  2320,  1289,   620,   457,  1294,
    1295,  1296,  1299,   452,  1334,  1421,  1422,   666,  1336,   457,
    1214,  1859,  1859,   901,  2878,  1340,  2321,  2322,  2323,  1342,
    2324,  2325,  2326,  2327,  2328,  2329,  1055,  1343,   457,  3205,
    1348,  2330, -1097, -1104,  1356,  1359,  1360,  1361,  1301,  1365,
      46,  1367,  1405,  1370,   457,  2320, -1094,   457,  2395,  2396,
    3203, -1095,  2939,  1371,  1425,  1372,  1903,  1373,  1378,  2379,
    1030,   457,  1380,  2133,  1381, -1098,  2925, -1096,  1426,  1382,
    1443,  2133,  1383,  1384,  2512,  1391,  2389,  1392,  1394,  1858,
    1858,  2362,  1395,  1396,  1329,  1397,  3045,  2871,  1741,  1032,
    1398,  1399, -1644,  1457,  1400,  1473,  1420,  1486,  1500,   981,
    1522,  1529,  1530,  1532,  1214,  1533,  1534,  1547,  1551,   683,
    1553,  1554,  2098,  1555,  2513,  1556,  1421,  1422,  1576,  2182,
    1583,  1577,  2492,  1578,  1579,  1590,  2231,  1584,  1585, -1644,
    1592,  1593,  1594,  1595,  2416,  2514,  1606,  1859,  1610,  2211,
    1620,  1625,  1626,  1627,   457,   653,  1633,  1634,   901,   944,
    1635,  1637,   653,  1496,  2515,  2324,  2325,  2326,  2327,  2328,
    2329,  2319,  2416,  1649,  1661,  1425,  2330,   452,  1654,  2516,
    1663,  1667,  1676,  1674,  1362,   666,   452,   452,  1352,  1426,
    1368,  1677,  1689,  2517,   473,  1694,  1711,  2232,  1725,  1666,
    1731,  1698,  1733,  1739,   457,   457,   457,  1487,   901,  1735,
     653,  2321,  2322,  2323,  1750,  2324,  2325,  2326,  2327,  2328,
    2329,  1760,  2233,  1761,  1763,  1762,  2330,  1774,  1796,  1789,
    1817,  1429,  1792,  1804,  2320,  1825,   452,  2234,  1433,  1434,
    1435,  1436,  1437,  1438,   902,  2235,  1826,  1867, -1641,  1439,
    1214,  1868,   452,  1880, -1644,  1885,   452,  1628,  1629,  1630,
    1631,  1214,   457,  1891,  1439,  1890,  2956,  1902,  2236,  3069,
    1897,   659,  2518,  1749,  1921,   779,  1919,  1749,  1948,   787,
    2519,  2642,   626,   457,   452,   452,   452,   452,   796,  1955,
    1965,  1959,  1976,  1971,  1977,  2888,  1982,  1415,  1858,  1960,
    1983,  2214,  1214,  2654,  1985,  1417,  1986,  2990,   664,  2520,
    1418,  1987,  1993,  1995,  1997, -1641,  1998,   666,   452,  1008,
    2001,  2004,  1858,  1858,  1999,  2006,   451,  2011,  2030,  2030,
    2013,  2032,   498,   499,  2033,  3083,  2034,  2064,   530,  2071,
     545,  2237,  1429,  1666,  2110,  2111,   563,  1009,   566,  1433,
    1434,  1435,  1436,  1437,  1438,  2112,  2117,  2123,  2118,   142,
    1439, -1641,  2124,  2592,  2121,  2126,  1652,  1653,  2127,  2128,
    2129,  2140,  1662,   142, -1641,  2149,  2144,  2608,  2153, -1641,
    1741,  2156,  2158, -1641,  1741,  2157, -1641,   901, -1641,  -964,
    2321,  2322,  2323,   452,  2324,  2325,  2326,  2327,  2328,  2329,
    1010,  2159,  -964,  2173,  2177,  2330,   457,  2160,  2188,  2889,
     452,  2161,  2187, -1641,  2189,   944,  3152,  2209,  2210,  2223,
    2212,  2957,   142,  2230,  2229,  1419,  2647,  2610,  1011,  1420,
    2221, -1641,  2222,  2249,  1712,  1713,  1714,  1715,  3160,  2244,
    2623,  -964,  3165,  3166,  1214,  2255,  2257,  2256,  1858,  1421,
    1422,  2259,  2264,  2265,  2270,  3155,  2215,  1818,  2282,  -964,
    2286,  2288,  1423,  2305,   817,  2301,   666,  2340,  1214,  2460,
    2302,  3161,  2304,  1795,  2306, -1641,  2341,  2319,  2370,   685,
    2385,  1779,   689, -1641,   691,   452,  2309,  2310,   666,  2312,
    2315,  2398,  2333,   620,  1777,  1424,  2365,  2339,  1425,  2378,
    2783,   457,  2785,  -964,  2388,  2725,  2726,  2727,  2728,  2430,
    2433,  -964,  1426,  2342,   457,  2437,  2343,  1753,  2350,  2438,
    2363, -1641,  2364,  2402,  2434,  1757,  2451,  2455,  2456,  2481,
    2463,  2482,  2465,  2483,  1766,  2484,  2485,  2486,  1405,  2487,
    2320,  2133,  2488,  2489,  2133,  2133,  2497,  1775,  1285,  -963,
    2490,    33,  2491,  2502,  2503,  1014,  2504,  2505,  2133,  2506,
    2507,  1015,  -963,  2415,   560,  1185,  2530,  2528,  1016,  2508,
    2533,  2534,  2544,  2543,   998,  2545,  2546,  1428,  2547,  1322,
    2548,  2567,  1018,  2571,  2590, -1641,  2581,  2584,  1335,  2583,
    1019,  2589,  2595,  2597,  2607,  2528,  2609,  2765,  2611,  2613,
    1345,  -963,  2614,  2621,  2624, -1641,  2626,  2576,  3254,  1496,
    2630,  2646,  2632,  -964,  1446,  1214,  2649,  2650,  1349,  -963,
    3130,  2659,  2336,  2330,  2335, -1641, -1641, -1641,  2688,  1410,
    2689,  2690,  2600,  1666,  1666,  2701,  1020,  1214,  2713,  2714,
    2604,  1214,  1214,  2722,  2732,  2737,  3092, -1641,  2738,  2748,
   -1641,  2741, -1641, -1641,  2750,  2751,  1749,   452,   452,  2752,
    2762,  1749,  2763,  -963,  1749,  1429,  2778,  2790,  1430,  1431,
    1432,  -963,  1433,  1434,  1435,  1436,  1437,  1438,  2764,  2792,
    2846,   452,  2793,  1439,  2794,   666,   452,   666,   452,   452,
     452,   452,  2819,   901,  2820,  2842,  2835, -1644, -1644,  2604,
    2324,  2325,  2326,  2327,  2328,  2329,  2848,  2850,  2857,  2862,
    1214,  2330,  1748,  2863,   653,  2869,   670,  2875,  2876,   671,
     672,   673,   653,   674,   675,   676,   677,   678,   679,  2885,
    2892,  2901,  2907,  2909,  2895,   457,   681,  2912,  2904,  2908,
    2917,  2926,   457,  2952,  2927,  2953,  2962,  2914,  2975,  2921,
    2976,   452,   452,   452,  2922,   452,  2932,  2928,  2979,  2985,
    2986,   653,  2991,  1741,   457,   457,  2963,  2968,  1741,  2994,
    3000,  1741,  2971,  -963,  2811,  3003,   457,  2972,  2192,  2974,
    3004,  2075,  2706,  3005,  2075,  3006,  2861,  3014,   735,  3016,
    3019,  3021,  3034,  3035,  3024,  3028,  3036,  2030,  3038,  3041,
    3040,   752,  3049,  3053,  2193,   754,  3063,  3067,  3068,  2229,
    3070,   452,  3075,  3077,  3076,  3101,   766,  3078,  3086,  3087,
    3094,  2736,  2192,  3095,  2897,   771,   452,  3102,  3108,  2143,
    2030,  2841,  2030,  3114,  3116,  3122,   789,  3134,  3179,  3132,
     791,  3133,   794,  2125,   666,  3135,  3175,  3184,  3183,  3209,
    2134,  2135,  2136,  2137,  2138,  2139,  3202,  1415,  1300,  3208,
    3212,  2214,  3214,  3218,  3219,  1417,  3226,  3229,  3231,  3210,
    1418,  3211,  3256,  3257,  2766,  3162,  3274,  3284,   973,  1008,
    2179,  2769,  1485,  2770,  2407,  2958,  2099,   826,  2474,   827,
    3104,  2859,   457,  2855,  2771,  2316,  2317,  2074,  2511,  3011,
    2332,  1415,  2510,  2432,  3227,  3253,  3215,  1009,  3213,  1417,
    3237,  2860,  2639,  2977,  1418,  2133,  3037,  3286,  1749,  2164,
    1724,  2133,  2133,  2133,  2133,  2133,  2133,  3275,  2568,  3002,
    3001,  2569,  3238,  2531,  3093,  1749,  1693,  3255,  3096,  2366,
    2367,   683,   562,  1323,   457,  2910,   821,  2873,  3138,  3193,
    2017,   666,   452,  2440,  2251,  2019,  2253,  2877,  3172,  3267,
    1010,   681,   666,   452,   666,  3008,  2335,  2826,  2828,  3285,
    3118,  2336,  1967,   957,   531,  2978,  2854,  2410,   452,   452,
     659,   452,  1306,  2648,  1520,  1419,  2414,  1310,  1011,  1420,
    2426,  1523,  1518,  2397,  2226,  1979,   142,  1964,  2619,  3055,
    3017,  2411,  2154,   768,  2853,  3154,  2705,  1666,  3091,  1421,
    1422,  2695,  2417,  2872,  1074,  2383,  2215,  2297,  2258,  2381,
    2275,  2260,  1423,  1947,     0,  2262,     0,     0,     0,  1419,
    1169,     0,     0,  1420,     0,     0,     0,     0,     0,  1175,
    1758,     0,  1741,     0,     0,  1177,     0,   664,     0,  1767,
       0,     0,     0,  1421,  1422,  1424,  1225,     0,  1425,  1773,
       0,     0,     0,   452,     0,     0,  1423,   457,  2289,   452,
       0,   458,  1426,     0,  1427,  3046,  1781,     0,  1784,  1785,
       0,     0,  1788,  1259,  1749,   452,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2897,     0,     0,     0,  1424,
       0,     0,  1425,     0,     0,     0,     0,     0,  2861,     0,
       0,    33,   666,     0,     0,  2216,  1426,     0,  1427,     0,
       0,  1015,     0,     0,     0,     0,     0,     0,  1016,     0,
       0,     0,  1312,     0,   998,     0,     0,  1428,     0,     0,
    1331,     0,  1018,     0,     0,   457,     0,     0,     0,     0,
    1019,     0,     0,     0,     0,  2955,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3186,   683,     0,     0,     0,
       0,     0,     0,   457,     0,     0,     0,     0,     0,     0,
     457,  1428,     0,     0,  1749,     0,     0,  1748,     0,     0,
       0,     0,     0,     0,  1666,     0,  1020,     0,     0,     0,
    1417,     0,     0,     0,     0,  1418,     0,     0,     0,     0,
    2133,  2133,  2133,     0,     0,     0,  2030,     0,  2075,     0,
       0,     0,  2992,  2993,   687,  1429,  2996,  2997,  1430,  1431,
    1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,     0,     0,
     659,  3046,     0,  1439,     0,   659,   659,  3228,     0,  2436,
       0,     0,     0,   452,     0,     0,     0,     0,     0,     0,
       0,  1417,     0,  1970,     0,  2467,  1418,     0,     0,  1429,
    3023,     0,  1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,
    1437,  1438,     0,     0,  1645,     0,     0,  1439,     0,     0,
       0,  1646,     0,     0,  3047,     0,     0,     0,   659,   659,
     659,   659,   452,     0,     0,     0,     0,     0,     0,     0,
       0, -1643,     0,     0,     0,     0,     0,  3281,     0,     0,
    1419,     0,     0,     0,  1420,     0,     0,     0,     0,     0,
       0,  2475,  2476,     0,     0,     0,     0,     0,     0,     0,
    2024,  3046,   659,     0,  1421,  1422,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1423,  2665,     0,
       0,  2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,  2678,
    3280,  2680,     0,     0,     0,     0,     0,     0, -1643,     0,
       0,  1419,     0,   452,   659,  1420,     0,     0,     0,   457,
    1424,   659,     0,  1425,     0,  1748,     0,     0,     0,     0,
       0,     0,   142,     0,  2133,  1421,  1422,  1426,   659,  3105,
       0,     0,     0,   656,     0,  3279,     0,   656,  1423,  3246,
    2717,  2718,     0,     0, -1643,     0,     0,     0,     0,     0,
       0,     0,     0,   142,     0,     0,     0, -1643,     0,     0,
       0,     0, -1643,     0,     0,     0, -1643,     0,     0, -1643,
       0, -1643,     0,     0,  1425,     0,  3136,  1417,     0,     0,
       0,  3246,  1418,     0,     0,     0,     0,     0,  1426,     0,
       0,     0,  1428,     0,     0,  1211, -1643,     0,     0,     0,
       0,     0,     0,     0,  3246,     0,     0,     0,     0,     0,
       0,     0,     0,     0, -1643,     0,     0,  2627,     0,  2629,
       0,  2631,     0,  2633,     0,  2635,     0,     0,     0,     0,
    2638,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   732,
       0,     0,     0,  1428,     0,     0,  2653,     0, -1643,     0,
       0,     0,     0,     0,  2719,     0, -1643,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1710,     0,     0,
    1429,     0,     0,  1430,  1431,  1432,     0,  1433,  1434,  1435,
    1436,  1437,  1438,     0,     0,     0,     0, -1644,  1439,     0,
       0,  1420,     0,     0, -1643,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2837,  1759,     0,     0,
       0,  1421,  1422,     0,     0,     0,  1768,     0,  1770,     0,
       0,     0,     0,  1771, -1644,   150,     0,     0,   818,     0,
       0,  1429,     0,     0,   820, -1644, -1644,   560,  1433,  1434,
    1435,  1436,  1437,  1438,   457,   828,     0,  3245,     0,  1439,
       0,     0,     0,   457,     0,     0,     0,     0, -1643,     0,
    1425,     0,     0,     0,   820,     0,     0,     0,     0,   457,
       0,     0,     0,     0,  1426,     0,     0,     0, -1643,   151,
     820,     0,     0,   960,     0,     0,     0,  1748,     0,  3245,
       0,  1748,     0,     0,     0,     0,   152,   974, -1643, -1643,
   -1643,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3245,     0,   457,     0,   457,   153,     0,     0,
   -1643,   457,   653, -1643,     0, -1643, -1643,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1644,
       0,   656,     0,   457,     0,     0,     0,     0,   154,     0,
    2421,     0,     0,   155,     0,     0,     0,     0,  2936,  2937,
       0,     0,     0,     0,     0,     0,     0,   156,     0,     0,
       0,     0,     0,  1574,     0,     0,     0,     0,   656,     0,
    1166,     0,     0,     0,   656,     0,     0,  1588,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2454,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2461,     0,  1429,     0,  2464,
    1250,  1252,  1253,  1415,  1433,  1434,  1435,  1436,  1437,  1438,
       0,  1417,     0,     0,     0,  1439,  1418,   157,     0,     0,
       0,     0,   457,   457,     0,     0,     0,     0,     0,  1989,
       0,     0,     0,   656,     0,     0,     0,  1996,     0,     0,
     158,     0,     0,  2000,     0,     0,     0,     0,     0,  2005,
       0,     0,     0,  2214,  2010,     0,     0,     0,   820,  2012,
     656,     0,   159,     0,     0,  2905,  2906,     0,   160,     0,
       0,  1008,     0,     0,   161,     0,     0,  1415,  2026,   820,
    2027,     0,     0,     0,     0,  1417,     0,  1648,     0,     0,
    1418,     0,  2060,  2061,  2062,     0,     0,     0,     0,  1009,
       0,   162,   163,     0,     0,     0,   164,     0,     0,  2077,
    2078,  2081,  2082,     0,   165,     0,  2088,  2091,     0,   166,
    2093,  2094,  2095,     0,     0,     0,  2101,     0,   167,     0,
       0,  1419,     0,  2114,     0,  1420,  2116,  3066,     0,   168,
       0,     0,     0,     0,   656,  1159,     0,  1691,     0,     0,
       0,   656,  1010,     0,  2983,  1421,  1422,     0,   656,     0,
       0,  3080,  3081,   505,     0,     0,     0,     0,  1423,     0,
       0,     0,     0,   457,     0,   506,     0,     0,     0,  1224,
    1011,     0,     0,     0,     0,     0,     0,     0,     0,   457,
       0,     0,  1754,     0,     0,   507,     0,     0,     0,   457,
       0,  1424,  1488,  1588,  1425,  1419,   656,     0,  2215,  1420,
       0,     0,     0,     0,     0,     0,     0,   508,  1426,     0,
    1427,     0,     0,     0,     0,     0,     0,     0,  2651,  1421,
    1422,     0,     0,     0,   509,     0,     0,     0,     0,     0,
    1748,     0,  1423,     0,   656,  1748,     0,     0,  1748,     0,
       0,     0,     0,     0,     0,   510,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1224,     0,     0,     0,
       0,     0,     0,     0,     0,  1424,     0,     0,  1425,     0,
       0,     0,     0,  1428,     0,     0,   511,  3151,   656,     0,
       0,   512,  1426,     0,  1427,     0,     0,  1619,     0,     0,
       0,     0,     0,    33,     0,   513,     0,  1014,     0,     0,
       0,     0,  2284,  1015,   656,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,     0,     0,   998,     0,     0,     0,
    3059,  3060,  3061,  3062,  1018,     0,     0,     0,     0,     0,
    3064,     0,  1019,     0,     0,     0,     0,   656,   656,     0,
     656,     0,   457,   457,   457,   457,     0,  1428,  1931,     0,
       0,     0,     0,     0,     0,     0,     0,   656,     0,     0,
       0,  1429,     0,     0,  1430,  1431,  1432,     0,  1433,  1434,
    1435,  1436,  1437,  1438,     0,   514,     0,     0,  1020,  1439,
    1008,     0,  2311,   515,     0,     0,     0,     0,  1415,     0,
    2767,  2768,  1972,     0,     0,     0,  1417,     0,   158,     0,
       0,  1418,     0,     0,  3137,     0,     0,     0,  1009,  3143,
    3143,     0,   656,     0,     0,   656,   656,     0,     0,     0,
     516,     0,     0,  1224,   517,     0,   518,  1159,     0,     0,
       0,     0,   519,     0,     0,  1429,     0,     0,  1430,  1431,
    1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,     0,     0,
       0,     0,     0,  1439,     0,     0,  2358,  1224,     0,   520,
     521,  1010,     0,  3168,   522,  3170,  1973,     0,     0,     0,
       0,  1224,   523,     0,     0,  2428,  2429,   524,     0,     0,
    1574,  1574,     0,     0,  3150,     0,   525,     0,     0,  1011,
       0,     0,   653,     0,     0,     0,     0,   526,     0,     0,
       0,     0,     0,     0,     0,     0,  3194,     0,     0,  1748,
       0,     0,     0,     0,     0,     0,  1419,     0,     0,     0,
    1420,  1769,     0,     0,     0,     0,     0,     0,  1772,  1417,
       0,     0,     0,     0,  1418,     0,     0,     0,     0,     0,
    1421,  1422,     0,     0,     0,     0,     0,     0,  3217,     0,
     820,   820,     0,  1423,     0,  3143,     0,     0,     0,     0,
       0,     0,  1803,  1588,     0,     0,     0,     0,     0,     0,
       0,     0,  3230,  2477,  2478,  2479,  2480,     0,     0,     0,
       0,     0,   653,  1012,     0,  2155,  1424,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1224,     0,  1426,     0,  1427,     0,  2493,  1013,     0,
       0,     0,    33,     0,     0,     0,  1014,     0,     0,  1224,
       0,   653,  1015,   457,     0,     0,     0,     0,     0,  1016,
       0,     0,     0,     0,     0,  1017,     0,     0,  1224,     0,
       0,     0,     0,  1018,  1415,   457,     0,     0,     0,  1419,
       0,  1019,  1417,  1420,     0,     0,     0,  1418,   653,     0,
       0,  1224,     0,     0,     0,  1159,   457,     0,  1428,     0,
       0,     0,     0,  1421,  1422,     0,     0,     0,  1946,     0,
       0,     0,  2580,     0,     0,     0,  1423,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,   656,  2594,
     656,     0,     0,     0,   457,     0,  1224,     0,   656,     0,
       0,  2981,  2982,     0,  2984,  1974,  2283,  1224,     0,     0,
       0,     0,  1425,     0,     0,     0,     0,     0,     0,     0,
    1968,     0,     0,     0,     0,     0,  1426,     0,     0,   653,
       0,     0,     0,     0,     0,     0,     0,   656,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,   653,  1430,
    1431,  1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,     0,
       0,     0,  1419,     0,  1439,     0,  1420,     0,     0,     0,
       0,   656,   656,     0,     0,     0,     0,     0,     0,   656,
       0,     0,   656,     0,     0,   656,  1421,  1422,     0,     0,
       0,  1428,     0,   656,   656,     0,     0,     0,     0,  1423,
       0,   656,     0,     0,   656,   656,   656,   656,  3050,     0,
       0,   653,     0,     0,   656,   656,     0,   656,  3050,   656,
       0,     0,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1424,     0,     0,  1425,     0,     0,   656,  1159,
       0,     0,   656,  2092,     0,     0,   656,     0,     0,  1426,
     656,  1427,     0,   656,   656,   656,   656,   656,   656,   656,
     656,   656,  1224,     0,   656,     0,  2696,     0,     0,   656,
       0,     0,   656,     0,     0,     0,     0,     0,     0,  1429,
       0,   653,  1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,
    1437,  1438,     0,     0,     0,  1417,     0,  1439,     0,     0,
    1418,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,  1574,  1574,     0,  1574,     0,
       0,  2178,   656,     0,     0,     0,     0,  2697,     0,     0,
       0,  2450,     0,  2453,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2195,
       0,     0,     0,     0,     0,  1159,  2213,     0,     0,     0,
    2777,     0,     0,     0,     0,  2784,     0,  2786,  2787,  2788,
    2789,   656,     0,     0,  2470,     0,  3148,     0,     0,     0,
       0,     0,  2720,  1222,     0,     0,  1417,     0,     0,     0,
    1224,  1418,     0,     0,  1224,  1224,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,  1430,  1431,  1432,     0,  1433,
    1434,  1435,  1436,  1437,  1438, -1644,     0,     0,     0,  1420,
    1439,     0,     0,  2496,     0,  3171,     0,     0,     0,     0,
    2830,  2832,  2834,     0,  2836,     0,     0,     0,     0,  1421,
    1422,     0,     0,     0,     0,     0,     0,     0,  1574,     0,
       0,     0, -1644,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   656,
    1222,     0,     0,  2723,  1216,     0,  1574,  1224,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1425,     0,
       0,  2579,     0,     0,     0,     0,     0,   656,     0,  1224,
       0,     0,  1426,     0,  2470,  2900, -1644,     0,     0,     0,
    1420,     0,     0,     0,     0,  1574,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1421,  1422,     0,     0,     0,     0,     0,     0,     0,  1217,
       0,     0,     0, -1644,     0,     0,     0,     0,  2628,     0,
       0,     0,     0,     0,  1588,     0,     0,     0,     0,     0,
       0,  1216,     0,   656,     0,  2394,     0, -1644,     0,     0,
       0,     0,     0,   656,     0,     0,     0,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1426,     0,  1467,     0,     0,  2660,     0,
       0,     0,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1415,     0,     0,  1416,   656,
       0,     0,     0,  1417,     0,     0,  1217,     0,  1418,  2679,
    1224,  2964,     0,     0,     0,     0,     0,  1222,     0,     0,
       0,   920,  2973,  2687,     0,     0,     0,     0,   656,   656,
       0,     0,     0,     0,     0,  1429,     0,     0, -1644,     0,
       0,     0,  1433,  1434,  1435,  1436,  1437,  1438,   968,     0,
       0,  1222,     0,  1439,     0,     0,     0,     0,   656,   656,
       0,     0,     0,   656,     0,  1222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   656,   656,   656,   656,     0,
       0,     0,     0,  1159,     0,     0,     0,   656,  1159,     0,
     656,     0,     0,   656,     0,     0,     0,     0,     0,     0,
       0,     0,   656,   656,     0,   656,     0,     0,  1216,     0,
       0,     0,     0,     0,     0,     0,     0,  1415,   656,     0,
     656,     0,  3033,  1419,   656,  1417,  1429,  1420,  2594,     0,
    1418,     0,  1080,  1433,  1434,  1435,  1436,  1437,  1438,     0,
       0,   656,  1216,     0,  1439,     0,     0,  1421,  1422,     0,
       0,   656,  2776,   656,   656,     0,  1216,     0,     0,     0,
    1423,     0,     0,     0,     0,     0,     0,     0,   656,     0,
       0,     0,     0,  1217,   656,     0,     0,     0,     0,     0,
       0,     0,     0,   656,   656,   656,     0,     0,     0,     0,
    2573,     0,     0,  1424,     0,  1222,  1425,     0,   656,  2582,
       0,     0,     0,     0,     0,     0,     0,  1217,     0,     0,
    1426,     0,  1427,  1222,     0,  2596,     0,     0,     0,  1224,
    1224,  1217,  1224,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1222,     0,     0,  1224,     0,  1224,     0,     0,
       0,     0,     0,     0,     0,  1419,  2845,     0,     0,  1420,
       0,     0,     0,     0,     0,  1222,     0,     0,     0,     0,
    2636,     0,  2637,     0,  1415,     0,     0,  2640,     0,  1421,
    1422,     0,  1417,     0,     0,  1428,  1354,  1418,  1224,     0,
       0,     0,  1423,     0,     0,     0,  1216,     0,     0,   820,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1222,     0,  1377,     0,  1216,     0,     0,  1219,     0,     0,
       0,  1222,     0,     0,     0,  1424,     0,     0,  1425,     0,
       0,     0,     0,  1216,     0,     0,     0,  1224,     0,     0,
       0,     0,  1426,     0,  1427,  1402,  1403,     0,  1406,     0,
       0,     0,     0,     0,     0,  2313,  1216,     0,     0,     0,
       0,  1217,  1224,     0,     0,  1444,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,  1430,  1431,  1432,  1217,
    1433,  1434,  1435,  1436,  1437,  1438,     0,     0,     0,  1159,
    1224,  1439,     0,     0,     0,     0,     0,     0,  1217,     0,
       0,  1216,  1419,     0,  1219,  1224,  1420,  1428,  2729,  2730,
       0,     0,  1216,     0,     0,     0,     0,     0,  1224,     0,
    1508,  1217,     0,  1515,  1517,     0,  1421,  1422,     0,  1224,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1423,
       0,     0,     0,   656,  2967,     0,     0,   656,     0,     0,
       0,     0,  3216,     0,     0,     0,     0,   656,     0,     0,
       0,     0,  1224,     0,     0,     0,  1217,     0,  1224,     0,
       0,     0,  1424,     0,     0,  1425,  1222,  1217,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1426,
       0,  1427,     0,     0,     0,  1429,     0,     0,  1430,  1431,
    1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,     0,   656,
       0,     0,  1224,  1439,     0,     0,     0,     0,   656,     0,
       0,     0,     0,     0,   656,     0,   656,     0,     0,     0,
       0,   656,     0,     0,   656,   656,   656,   656,   656,   656,
     656,   656,   656,  1224,   656,     0,     0,     0,   656,   656,
       0,     0,     0,     0,  1428,     0,     0,  1224,     0,  2822,
       0,     0,   656,     0,     0,     0,  1159,  1216,   656,     0,
       0,  1219,     0,     0,     0,  2843,     0,  1417,   656,     0,
       0,   656,  1418,   656,     0,  2847,  2579,     0,     0,     0,
       0,  1224,   656,   656,   656,     0,     0,     0,   656,     0,
       0,   656,     0,     0,  1222,  1219,     0,     0,  1222,  1222,
       0,   656,     0,     0,     0,     0,     0,     0,     0,  1219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1217,     0,     0,     0,     0,     0,     0,     0,
    1220,     0,  1429,     0,     0,  1430,  1431,  1432,     0,  1433,
    1434,  1435,  1436,  1437,  1438,     0,     0,     0,     0,  1889,
    1439,     0,     0,     0,  2945,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1224,     0,     0,     0,
       0,  1222,     0,     0,     0,  1216,     0, -1644,     0,  1216,
    1216,  1420,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1222,     0,     0,     0,     0,     0,     0,
       0,  1421,  1422,     0,     0,     0,     0,  1220,     0,     0,
       0,     0,     0,     0, -1644,     0,     0,     0,  2948,  2949,
    2950,  2951,     0,     0,     0,     0,     0,     0,     0,  1219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1217,     0,     0,     0,  1217,  1217,     0,  1219,     0,   656,
    1425,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1224,     0,  1216,     0,  1426,     0,  1219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1829,     0,     0,
       0,     0,     0,     0,  1216,     0,     0,     0,     0,  1219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1851,
       0,     0,  1853,     0,     0,  1864,   656,     0,     0,     0,
       0,   656,  1871,  1876,   656,     0,     0,  1881,     0,     0,
    1886,     0,     0,     0,  1222,     0,     0,  1217,     0, -1644,
       0,     0,  1588,     0,  1219,     0,  1895,     0,     0,     0,
    1901,     0,     0,     0,  1913,  1219,     0,     0,  1920,  1217,
     656,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,
       0,     0,  1932,     0,     0,     0,     0,   920,     0,     0,
       0,     0,     0,     0,  1220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   656,     0,     0,     0,
       0,     0,     0,   656,   656,     0,  1224,     0,     0,     0,
       0,   656,   656,     0,     0,     0,   656,  1224,  1220,     0,
       0,     0,   656,   656,     0,  1216,   656,  1429,     0,     0,
     968,     0,  1220,     0,  1433,  1434,  1435,  1436,  1437,  1438,
       0,   468,     0,     0,     0,  1439,     0,     0,     0,     0,
       0,     0,     0,   469,     0,     0,     0,     0,  1224,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   470,     0,     0,     0,     0,     0,  2003,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1217,     0,   471,     0,     0,  -501,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3110,
    1219,     0,   472,     0,     0,     0,     0,     0,   473,     0,
       0,     0,     0,     0,     0,  1221,     0,     0,     0,     0,
       0,   820,     0,   474,     0,     0,     0,     0,   656,     0,
       0,     0,     0,  1222,  1222,     0,  1222,     0,     0,     0,
       0,     0,  3146,     0,     0,     0,     0,     0,     0,  1222,
       0,  1222,  1220,     0,  -651,   475,     0,     0,     0,   476,
       0,     0,     0,     0,     0,     0,     0,  2122,   656,     0,
    1220,     0,     0,  -631,     0,     0,     0,     0,     0,     0,
    3158,   656,     0,     0,     0,   656,     0,     0,     0,  1220,
    1224,     0,  1222,     0,     0,  2152,  -407,     0,     0,     0,
       0,     0,  1221,     0,     0,     0,     0,   477,     0,     0,
     656,     0,  1220,     0,  1224,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1216,  1216,     0,  1216,  1219,     0,
       0,     0,  1219,  1219,   656,   656,     0,     0,   656,     0,
    1216,  1222,  1216,     0,     0,   656,   656,     0,     0,     0,
       0,     0,     0,   478,     0,   479,     0,  1220,   656,     0,
       0,     0,     0,     0,     0,     0,  1222,     0,  1220,     0,
       0,  2246,   656,     0,     0,     0,  -407,     0,     0,     0,
       0,     0,     0,  1216,     0,     0,     0,     0,     0,  1217,
    1217,     0,  1217,  1415,  1222,     0,  2299,   656,   480,     0,
    2263,  1417,  -651,     0,   481,  1217,  1418,  1217,     0,  1222,
       0,     0,     0,     0,     0,  1219,     0,   920,     0,     0,
       0,     0,  1222,     0,     0,     0,     0,     0,     0,     0,
       0,  1223,  1216,  1222,   656,   656,     0,  1219,   482,   483,
       0,   484,   485,     0,     0,     0,     0,  2295,  1217,     0,
     486,     0,     0,     0,   487,   488,     0,  1216,     0,   489,
     656,  1224,     0,   656,   490,   656,  1222,     0,     0,  1221,
       0,     0,  1222,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1224,     0,  1216,     0,  1224,  1224,     0,
       0,     0,     0,  1876,     0,  1876,  1876,  1217,     0,     0,
    1216,     0,     0,  1221,     0,  2356,     0,     0,  2359,     0,
       0,  2361,     0,  1216,     0,   656,  1222,  1221,  1223,     0,
       0,  1419,  1217,  1220,  1216,  1420,     0,     0,     0,     0,
       0,     0,     0,     0,   656,     0,  2382,     0,  2384,     0,
       0,     0,  2387,     0,     0,  1421,  1422,  1222,     0,     0,
    1217,     0,     0,     0,     0,     0,  1224,  1216,  1423,     0,
       0,  1222,     0,  1216,     0,  1217,     0,     0,  1219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1217,     0,
       0,     0,     0,     0,     0,     0,   968,     0,     0,  1217,
       0,  1424,  1508,     0,  1425,  1222,     0,   656,     0,     0,
       0,  1517,  1517,  1515,     0,     0,     0,  1216,  1426,     0,
    1427,     0,     0,     0,     0,     0,  2431,     0,     0,     0,
       0,     0,  1217,     0,     0,     0,     0,     0,  1217,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1216,     0,
       0,     0,     0,     0,     0,     0,     0,  1221,     0,     0,
       0,  1220,  1216,     0,     0,  1220,  1220,     0,     0,     0,
       0,     0,     0,     0,     0,  1221,     0,   656,     0,     0,
       0,     0,  1217,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1221,  1223,  1216,     0,     0,     0,
    1222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1217,     0,     0,     0,  1221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1217,     0,  1575,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1223,     0,     0,     0,     0,  1220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1217,  1221,     0,     0,     0,     0,     0,     0,     0,
    1220,  1429,     0,  1221,  1430,  1431,  1432,     0,  1433,  1434,
    1435,  1436,  1437,  1438,     0,     0,     0,  1219,  1219,  1439,
    1219,  1216,     0,     0,  1222,     0,     0,     0,     0,     0,
       0,     0,     0,  1219,     0,  1219,     0,  1415,     0,     0,
    2344,     0,     0,     0,     0,  1417,     0,     0,     0,     0,
    1418,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1217,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1223,     0,     0,     0,     0,     0,     0,
       0,  1415,     0,     0,     0,  1216,     0,     0,     0,  1417,
       0,  1223,     0,     0,  1418,  1219,     0,     0,     0,     0,
       0,  1220,     0,     0,     0,     0,     0,     0,     0,     0,
    1223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1219,     0,     0,     0,     0,     0,     0,  2658,  1221,     0,
    1222,     0,     0,  1223,     0,  1419,  2661,     0,     0,  1420,
       0,  1222,  2662,     0,  2663,     0,     0,     0,  1219,     0,
    1217,     0,     0,     0,     0,     0,     0,     0,     0,  1421,
    1422,     0,     0,  1219,     0,     0,  2681,  2682,     0,     0,
       0,     0,  1423,     0,     0,     0,  1219,     0,  1223,     0,
       0,     0,  1222,     0,     0,     0,  1881,  1219,     0,  1223,
       0,     0,     0,     0,     0,  2349,  2707,     0,     0,  2710,
       0,  2712,     0,     0,     0,  1424,     0,     0,  1425,  1419,
    2716,     0,     0,  1420,     0,     0,  2721,     0,     0,  2724,
    1219,  1216,  1426,     0,  1427,     0,  1219,     0,     0,  2731,
       0,     0,  1216,  1421,  1422,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1221,     0,     0,     0,
    1221,  1221,     0,     0,     0,     0,     0,     0,  1415,     0,
    1219,  2353,     0,  1216,     0,     0,  1417,     0,     0,  1424,
       0,  1418,  1425,     0,     0,     0,  1217,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,  1426,  1217,  1427,     0,
       0,  1219,     0,     0,     0,     0,     0,     0,     0,     0,
    1220,  1220,     0,  1220,     0,  1219,     0,     0,     0,     0,
       0,     0,     0,     0,  1222,     0,  1220,     0,  1220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1217,     0,
       0,     0,     0,  1221,  1223,     0,     0,     0,  1222,  1219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,  1221,     0,     0,     0,  1220,
       0,     0,     0,     0,     0,  1429,     0,     0,  1430,  1431,
    1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,     0,     0,
       0,     0,     0,  1439,     0,     0,  1419,     0,     0,     0,
    1420,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1216,     0,     0,  1220,     0,
    1421,  1422,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1423,     0,     0,     0,     0,     0,  1216,
       0,     0,     0,  1220,  1219,     0,     0,     0,     0,  1429,
       0,     0,  1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,
    1437,  1438,     0,     0,     0,     0,  1424,  1439,     0,  1425,
       0,  1220,  2014,     0,     0,     0,  1575,  2021,     0,     0,
    1217,     0,     0,  1426,     0,  1427,  1220,     0,  2913,     0,
       0,     0,     0,     0,     0,  1222,  1221,     0,     0,  1220,
       0,     0,     0,     0,  1217,     0,     0,     0,     0,     0,
    1220,     0,     0,     0,     0,     0,     0,  1222,     0,     0,
       0,  1222,  1222,     0,     0,     0,     0,     0,     0,  1441,
       0,  2929,  2931,     0,     0,     0,     0,     0,  1219,     0,
       0,     0,     0,  1220,  2938,     0,     0,     0,  1428,  1220,
    2943,  2944,     0,     0,  2946,     0,     0,     0,     0,  1223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1441,     0,  1415,
       0,  1223,     0,     0,     0,     0,  1216,  1417,     0,     0,
    1222,     0,  1418,  1220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1216,     0,
       0,     0,  1216,  1216,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,  1220,  1430,
    1431,  1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,     0,
       0,  1217,     0,     0,  1439,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3009,     0,     0,     0,
       0,     0,  1220,  1217,  1219,     0,     0,  1217,  1217,     0,
       0,  1216,     0,     0,     0,  1219,     0,     0,     0,  1441,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1221,  1221,  1419,  1221,     0,
       0,  1420,  1223,     0,     0,     0,     0,     0,     0,  3052,
       0,  1221,     0,  1221,     0,     0,  1219,     0,     0,     0,
       0,  1421,  1422,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1423,     0,  1217,     0,     0,   708,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1221,     0,     0,  1220,     0,     0,
       0,     0,     0,     0,     0,     0,  3082,  1424,     0,     0,
    1425,   709,     0,     0,  3084,     0,     0,     0,     0,     0,
       0,     0,     0,   710,  1426,     0,  1427,     0,     0,     0,
     711,     0,     0,   712,     0,     0,     0,     0,     0,     0,
    3097,     0,     0,  1221,     0,     0,     0,     0,     0,     0,
     713,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1221,     0,
       0,   714,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1428,
       0,  1220,     0,     0,     0,     0,  1221,     0,  1219,     0,
       0,     0,   715,  3139,     0,     0,     0,     0,     0,     0,
       0,  1221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   716,  1219,     0,  1221,     0,     0,     0,     0,     0,
       0,  1881,     0,     0,     0,  1221,     0,     0,     0,     0,
       0,  1441,     0,     0,     0,   717,     0,     0,     0,     0,
       0,  1575,  2021,     0,  2021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1223,  1221,  1223,
       0,     0,     0,     0,  1221,     0,     0,  1429,     0,     0,
    1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,
       0,     0,  2494,  1441,     0,  1439,     0,     0,     0,     0,
    1415,   718,     0,     0,     0,     0,     0,     0,  1417,     0,
    1223,     0,     0,  1418,     0,     0,  1441,     0,  1221,     0,
       0,  1860,     0,     0,   158,     0,     0,  1220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1220,     0,
       0,  1441,  1441,     0,     0,  1441,   719,     0,     0,  1221,
     720,     0,   721,     0,     1,     0,     0,     0,   722,  1223,
       0,     0,     0,  1221,     2,     0,     3,     4,     0,  1219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1220,
       5,     0,     0,  1441,  2021,   723,   724,     0,     0,     0,
     725,  1219,     0,     0,     0,  1219,  1219,  1221,   726,     6,
       0,     7,     8,   727,     0,     0,     9,    10,     0,     0,
       0,     0,  2021,     0,     0,     0,    11,     0,    12,     0,
       0,     0,     0,   728,     0,     0,     0,  1223,  1419,     0,
       0,     0,  1420,     0,    13,     0,     0,    14,     0,     0,
    1223,     0,     0,    15,     0,     0,     0,  1441,     0,    16,
       0,  2021,  1421,  1422,  1441,    17,  1441,     0,     0,     0,
       0,    18,     0,     0,  1219,  1423,     0,    19,     0,    20,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1223,     0,    22,     0,     0,     0,
    1223,     0,  1221,     0,     0,     0,     0,     0,  1424,     0,
       0,  1425,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    23,     0,     0,  1426,     0,  1427,     0,     0,
       0,  1220,     0,     0,     0,     0,     0,     0,     0,  1415,
       0,     0,  2703,     0,  1223,    24,    25,  1417,     0,     0,
       0,    26,  1418,     0,     0,  1220,     0,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1223,     0,     0,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1223,
    1428,     0,     0,     0,     0,     0,  1221,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    29,     0,     0,     0,     0,     0,  1415,     0,     0,
       0,    30,     0,  1223,    31,  1417,    32,     0,     0,     0,
    1418,    33,     0,     0,     0,     0,    34,     0,     0,    35,
       0,     0,     0,    36,     0,     0,     0,     0,     0,    37,
       0,     0,     0,     0,    38,     0,     0,    39,     0,     0,
       0,     0,     0,     0,    40,     0,     0,  1419,     0,     0,
       0,  1420,     0,     0,     0,     0,     0,     0,  1429,     0,
       0,  1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,  1437,
    1438,  1421,  1422,    41,     0,  2532,  1439,     0,     0,     0,
       0,    42,  1220,    43,  1423,     0,    44,     0,     0,     0,
      45,     0,     0,     0,     0,     0,     0,     0,  1223,     0,
       0,     0,     0,     0,  1220,     0,     0,     0,  1220,  1220,
       0,     0,  1221,     0,     0,     0,     0,  1424,     0,     0,
    1425,     0,     0,  1221,     0,  1419,     0,     0,     0,  1420,
       0,     0,     0,     0,  1426,     0,  1427,     0,     0,     0,
       0,     0,    46,     0,     0,     0,     0,     0,     0,  1421,
    1422,     0,     0,     0,     0,     0,     0,     0,  1441,     0,
       0,     0,  1423,     0,  1221,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1220,     0,     0,
    1441,     0,  1441,  1415,  1860,  1860,  2331,     0,     0,  1860,
       0,  1417,  1223,  1441,     0,  1424,  1418,     0,  1425,  1428,
    1441,     0,     0,     0,     0,  1441,     0,     0,     0,     0,
    1441,     0,  1426,     0,  1427,  1441,     0,     0,     0,     0,
       0,     0,     0,     0,  1441,     0,  1415,     0,  1860,  1860,
    1441,     0,     0,     0,  1417,     0,     0,     0,     0,  1418,
       0,     0,  1441,     0,     0,     0,     0,     0,     0,  1441,
       0,  1441,  1441,  1441,  1441,  1441,  1441,  1441,  1441,  1441,
       0,  1441,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,     0,
    1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,
       0,     0,  2657,     0,     0,  1439,  1221,     0,     0,     0,
       0,  1419,     0,     0,     0,  1420,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1223,     0,
    1221,     0,  1441,     0,     0,  1421,  1422,     0,     0,  1223,
       0,     0,     0,     0,     0,     0,     0,     0,  1423,     0,
       0,     0,     0,     0,  1419,     0,     0,     0,  1420,     0,
       0,     0,     0,     0,     0,  1429,     0,     0,  1430,  1431,
    1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,  1421,  1422,
    1223,  1424,     0,  1439,  1425,     0,     0,     0,     0,     0,
       0,  1423,     0,     0,     0,     0,     0,     0,  1426,     0,
    1427,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1415,     0,     0,  1424,     0,     0,  1425,     0,  1417,
       0,     0,     0,     0,  1418,     0,     0,     0,     0,     0,
       0,  1426,     0,  1427,     0,     0,     0,     0,     0,     0,
       0,  1441,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1415,     0,  1428,     0,     0,     0,     0,     0,  1417,
       0,     0,     0,     0,  1418,     0,     0,  1221,     0,     0,
       0,  1441,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1221,
       0,     0,     0,  1221,  1221,     0,  1428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1415,
       0,     0,     0,     0,     0,     0,  1223,  1417,     0,  1419,
       0,  1429,  1418,  1420,  1430,  1431,  1432,     0,  1433,  1434,
    1435,  1436,  1437,  1438,     0,     0,     0,     0,  2704,  1439,
    1415,     0,  1221,  1421,  1422,  1441,     0,     0,  1417,     0,
       0,     0,     0,  1418,     0,     0,  1423,     0,     0,  1419,
       0,     0,  1441,  1420,  1429,     0,     0,  1430,  1431,  1432,
       0,  1433,  1434,  1435,  1436,  1437,  1438,     0,     0,     0,
       0,  2744,  1439,  1421,  1422,     0,     0,     0,     0,  1424,
       0,     0,  1425,     0,  1441,     0,  1423,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1426,     0,  1427,     0,
       0,     0,     0,     0,     0,  2331,  2331,  1860,     0,     0,
    1860,  1860,  1860,  1860,  1860,  1860,  1860,  1860,  1860,  1424,
    1860,  2331,  1425,     0,     0,     0,     0,  1419,     0,     0,
       0,  1420,     0,     0,     0,     0,  1426,     0,  1427,     0,
       0,     0,     0,     0,     0,  1441,     0,     0,  1441,     0,
    1441,  1421,  1422,  1223,     0,  2331,  2331,     0,  1419,     0,
       0,  1428,  1420,     0,  1423,     0,     0,     0,     0,  1860,
    1860,  1441,     0,  1441,     0,  1223,  1441,     0,     0,  1223,
    1223,     0,  1421,  1422,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1423,  1415,  1424,     0,     0,
    1425,  1428,     0,     0,  1417,     0,     0,     0,     0,  1418,
       0,     0,     0,     0,  1426,     0,  1427,     0,     0,     0,
    1441,     0,     0,     0,     0,     0,     0,     0,  1424,     0,
       0,  1425,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1426,     0,  1427,  1223,  1429,
       0,     0,  1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,
    1437,  1438,     0,     0,     0,     0,  2915,  1439,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,  1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,
    1437,  1438,     0,     0,     0,     0,  2947,  1439,     0,     0,
    1428,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1415,     0,     0,  1419,     0,     0,     0,  1420,  1417,
       0,     0,     0,     0,  1418,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1860,     0,     0,  1421,  1422,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1423,     0,     0,     0,     0,     0,  1429,     0,     0,
    1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,  1437,  1438,
       0,     0,     0,     0,  3074,  1439,     0,     0,     0,     0,
       0,     0,     0,     0,  1424,     0,     0,  1425,  1429,     0,
       0,  1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,  1437,
    1438,  1426,     0,  1427,     0,  3112,  1439,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2036,     0,     0,     0,     0,  1441,     0,  1419,
    1441,  1441,  1441,  1420,  2331,     0,     0,     0,     0,  2331,
    2331,  2331,  2331,  2331,  2331,  2331,  2331,  2331,     0,  2331,
    1441,  1441,     0,  1421,  1422,     0,  1428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
       0,     0,     0,     0,  2037,     0,  1441,  1860,  1860,  1441,
       0,  1441,  2038,  2039,  2040,  1441,  2331,  2331,     0,     0,
    1441,     0,     0,  1441,     0,     0,     0,     0,     0,  1424,
    1441,     0,  1425,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1426,     0,  1427,     0,
       0,     0,     0,  2041,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1429,     0,     0,  1430,  1431,  1432,
       0,  1433,  1434,  1435,  1436,  1437,  1438,     0,     0,     0,
       0,  3191,  1439,  2042,     0,     0,     0,     0,  2043,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2044,  2331,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2045,  2046,  2047,  2048,  2049,     0,  2050,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2051,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,  1430,  1431,  1432,     0,  1433,  1434,  1435,  1436,
    1437,  1438,  1441,     0,     0,     0,  1860,  1439,     0,     0,
       0,  2052,     0,     0,     0,     0,     0,     0,  1441,     0,
    1441,     0,     0,     0,     0,  2331,  2331,  1441,     0,     0,
    1860,  1860,  1441,  1441,     0,  1441,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2053,     0,  2054,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2055,     0,     0,     0,     0,     0,     0,  2056,     0,     0,
    2057,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1441,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1441,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2331,  1860,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2331,
    2331,  1441,     0,  1441,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1441,     0,     0,   171,
     172,   173,   174,   175,   176,   177,   178,     0,   180,   181,
     182,     0,     0,     0,     0,     0,     0,     0,   183,   184,
       0,   185,     0,   186,   187,   188,     0,   189,     0,   190,
     191,     0,   192,   193,   194,   195,   196,     0,  1441,   197,
     198,   199,   200,     0,   201,   202,   203,   204,   205,     0,
    2331,   206,   207,   208,   209,   210,   211,     0,   212,   213,
     214,   215,   216,     0,   217,   218,   219,     0,   220,   221,
       0,     0,     0,     0,     0,   222,   223,   224,   225,   226,
     227,   228,   229,     0,   230,     0,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,     0,   256,   257,
     258,   259,     0,   260,     0,   261,     0,     0,     0,   262,
     263,     0,   264,   265,     0,   266,     0,   267,   268,   269,
     270,     0,   271,   272,   273,     0,   274,   275,   276,   277,
     278,   279,     0,     0,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,     0,     0,   289,     0,   290,
     291,   292,   293,   294,     0,   295,     0,   296,     0,     0,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,   320,   321,   322,
     323,     0,   324,   325,     0,   326,     0,   327,   328,   329,
     330,   331,     0,     0,   332,     0,     0,     0,   333,   334,
       0,     0,   335,     0,     0,   336,   337,   338,   339,   340,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,     0,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,     0,   383,
     384,   385,   386,     0,   387,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,     0,   403,   404,   405,   406,   407,     0,   408,
     409,     0,     0,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,     0,
    3142,   423,   424,   425,   426,   427,   428,   429,     0,   430,
     431,   432,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     0,     0,     0,     0,     0,   450,     0,     0,     0,
       0,     0,   171,   172,   173,   174,   175,   176,   177,   178,
    1950,   180,   181,   182,     0, -1396,     0,     0,   841,     0,
   -1396,   183,   184,     0,   185,   632,   186,   187,   188,   633,
     842,   634,   843,   844,     0,   192,   193,   194,   195,   196,
     845,   846,   197,   847,   848,   200,     0,   201,   202,   203,
     204,   849,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     635,   220,   221,   850,   851,   852,   853,   854,   222,   223,
     224,   225,   226,   855,   856,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,  1951,     0,
     239,   240,   857,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   858,   253,   254,   859,
     860,   256,   257,   258,   861,     0,   260,     0,   261,   636,
       0,   637,   262,   263,     0,   264,   862,     0,   266,     0,
     267,   268,   269,   270,   638,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,   639,   280,   281,   282,
     283,   284,   863,   864,     0,   865,     0,   288,   640,   641,
     289,   642,   290,   291,   292,   293,   294,     0,   866,   643,
     296,   644,     0,   297,   298,   299,   867,   868,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   869,   645,   870,   455,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   871,   324,   325,   646,   326,   872,
     873,   328,   874,   330,   331,     0,     0,   332,   456,     0,
       0,   875,   334,     0,     0,   335,   647,   648,   876,   337,
     338,   339,   340,   341,     0,   342,   877,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   878,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   649,   369,   370,   879,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,   880,   383,   384,   385,   386,   650,   387,   881,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     882,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   883,   884,     0,     0,   410,   885,   412,   886,
     887,   414,   415,   416,   417,   418,     0,   888,   419,   420,
     421,   422,   889,     0,   423,   424,   425,   426,   427,   890,
     429,   651,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   891,   892,   893,   894,   895,   896,
     897,   447,   448,   449,     0,     0,     0,     0,     0,   652,
     898,   557,   899,   900,   901,   902,   903,     0,     0,     0,
       0,   904,   905,  1952,     0,     0,     0,     0,     0,     0,
     907,  1953,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,   841,     0,
       0,   183,   184,     0,   185,   632,   186,   187,   188,   633,
     842,   634,   843,   844,     0,   192,   193,   194,   195,   196,
     845,   846,   197,   847,   848,   200,     0,   201,   202,   203,
     204,   849,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     635,   220,   221,   850,   851,   852,   853,   854,   222,   223,
     224,   225,   226,   855,   856,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   857,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   858,   253,   254,   859,
     860,   256,   257,   258,   861,     0,   260,     0,   261,   636,
       0,   637,   262,   263,     0,   264,   862,     0,   266,     0,
     267,   268,   269,   270,   638,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,   639,   280,   281,   282,
     283,   284,   863,   864,     0,   865,     0,   288,   640,   641,
     289,   642,   290,   291,   292,   293,   294,     0,   866,   643,
     296,   644,     0,   297,   298,   299,   867,   868,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   869,   645,   870,   455,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   871,   324,   325,   646,   326,   872,
     873,   328,   874,   330,   331,     0,     0,   332,   456,     0,
       0,   875,   334,     0,     0,   335,   647,   648,   876,   337,
     338,   339,   340,   341,     0,   342,   877,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   878,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   649,   369,   370,   879,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,   880,   383,   384,   385,   386,   650,   387,   881,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     882,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   883,   884,     0,     0,   410,   885,   412,   886,
     887,   414,   415,   416,   417,   418,     0,   888,   419,   420,
     421,   422,   889,     0,   423,   424,   425,   426,   427,   890,
     429,   651,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   891,   892,   893,   894,   895,   896,
     897,   447,   448,   449,     0,     0,     0,     0,     0,   652,
     898,   557,   899,   900,   901,   902,   903,     0,     0,     0,
       0,   904,   905,     0,     0,     0,     0,     0,     0,     0,
     907,  1862,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,  2227,
       0,   183,   184,     0,   185,     0,   186,   187,   188,     0,
     189,     0,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
   -1033,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,     0,
       0, -1033,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   270,     0,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0, -1033,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,     0,     0,
     289, -1033,   290,   291,   292,   293,   294,     0,   295, -1033,
     296,     0,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313, -1033,   314,     0,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,     0,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,     0,     0,
       0,   333,   334,     0,     0,   335,     0,     0,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368, -1033,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,   384,   385,   386,     0,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   408,   409,     0,     0,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   450,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,   971,   185,   632,   186,   187,   188,   633,  1190,   634,
    1191,  1192,     0,   192,   193,   194,   195,   196,     0,     0,
     197,  1193,  1194,   200,     0,   201,   202,   203,   204,     0,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   635,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,  1195,  1196,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     857,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,     0,   253,   254,     0,     0,   256,
     257,   258,  1197,     0,   260,     0,   261,   636,     0,   637,
     262,   263,     0,   264,     0,     0,   266,     0,   267,   268,
     269,   270,   638,   271,   272,   273,  1564,   274,   275,   276,
     277,   278,   279,     0,   639,  1565,   281,   282,   283,   284,
    1198,  1199,     0,  1200,     0,   288,   640,   641,   289,   642,
     290,   291,   292,   293,   294,     0,     0,   643,   296,   644,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,  1201,
     645,  1202,     0,   315,   316,   317,   318,   319,   320,   321,
       0,   323,     0,   324,   325,   646,   326,     0,     0,   328,
    1203,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,  1566,   647,   648,     0,   337,   338,   339,
     340,   341,     0,   342,     0,     0,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,  1204,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   649,   369,   370,     0,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,  1567,   385,   386,   650,   387,  1206,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
    1207,  1208,     0,     0,   410,     0,   412,     0,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,     0,  1209,   429,   651,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,     0,     0,     0,     0,     0,     0,     0,     0,   447,
     448,   449,     0,     0,     0,     0,     0,  1210,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,   841,     0,     0,   183,   184,  1568,
     185,   632,   186,   187,   188,   633,   842,   634,   843,   844,
    1872,   192,   193,   194,   195,   196,   845,   846,   197,   847,
     848,   200,     0,   201,   202,   203,   204,   849,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   635,   220,   221,   850,
     851,   852,   853,   854,   222,   223,   224,   225,   226,   855,
     856,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   857,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   858,   253,   254,   859,   860,   256,   257,   258,
     861,     0,   260,     0,   261,   636,  1873,   637,   262,   263,
       0,   264,   862,     0,   266,     0,   267,   268,   269,   270,
     638,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,   639,   280,   281,   282,   283,   284,   863,   864,
       0,   865,     0,   288,   640,   641,   289,   642,   290,   291,
     292,   293,   294,  1874,   866,   643,   296,   644,     0,   297,
     298,   299,   867,   868,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   869,   645,   870,
     455,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     871,   324,   325,   646,   326,   872,   873,   328,   874,   330,
     331,     0,     0,   332,   456,     0,     0,   875,   334,     0,
       0,   335,   647,   648,   876,   337,   338,   339,   340,   341,
       0,   342,   877,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   878,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   649,   369,   370,   879,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,   880,   383,   384,
     385,   386,   650,   387,   881,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   882,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   883,   884,
       0,  1875,   410,   885,   412,   886,   887,   414,   415,   416,
     417,   418,     0,   888,   419,   420,   421,   422,   889,     0,
     423,   424,   425,   426,   427,   890,   429,   651,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     891,   892,   893,   894,   895,   896,   897,   447,   448,   449,
       0,     0,     0,     0,     0,   652,   898,   557,   899,   900,
     901,   902,   903,     0,     0,     0,     0,   904,   905,     0,
       0,     0,     0,     0,     0,     0,   907,   171,   172,   173,
     174,   175,   176,   177,   178,     0,   180,   181,   182,     0,
       0,     0,     0,   841,     0,     0,   183,   184,     0,   185,
     632,   186,   187,   188,   633,   842,   634,   843,   844,     0,
     192,   193,   194,   195,   196,   845,   846,   197,   847,   848,
     200,     0,   201,   202,   203,   204,   849,     0,     0,   206,
     207,   208,   209,   210,   211,     0,   212,   213,   214,   215,
     216,     0,   217,   218,   219,   635,   220,   221,   850,   851,
     852,   853,   854,   222,   223,   224,   225,   226,   855,   856,
     229,     0,   230,     0,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,     0,   239,   240,   857,   242,   243,
       0,   244,   245,   246,     0,   247,   248,     0,   249,   250,
     251,   858,   253,   254,   859,   860,   256,   257,   258,   861,
       0,   260,     0,   261,   636,     0,   637,   262,   263,     0,
     264,   862,     0,   266,     0,   267,   268,   269,   270,   638,
     271,   272,   273,     0,   274,   275,   276,   277,   278,   279,
       0,   639,   280,   281,   282,   283,   284,   863,   864,     0,
     865,     0,   288,   640,   641,   289,   642,   290,   291,   292,
     293,   294,     0,   866,   643,   296,   644,     0,   297,   298,
     299,   867,   868,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   869,   645,   870,   455,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   871,
     324,   325,   646,   326,   872,   873,   328,   874,   330,   331,
       0,     0,   332,   456,     0,     0,   875,   334,     0,     0,
     335,   647,   648,   876,   337,   338,   339,   340,   341,     0,
     342,   877,   344,   345,   346,   347,     0,   348,   349,   350,
     351,   352,   353,   878,   355,   356,     0,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     649,   369,   370,   879,   372,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   880,   383,   384,   385,
     386,   650,   387,   881,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   882,   400,     0,   401,   402,
       0,   403,   404,   405,   406,   407,     0,   883,   884,     0,
       0,   410,   885,   412,   886,   887,   414,   415,   416,   417,
     418,     0,   888,   419,   420,   421,   422,   889,     0,   423,
     424,   425,   426,   427,   890,   429,   651,   430,   431,   432,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   891,
     892,   893,   894,   895,   896,   897,   447,   448,   449,     0,
       0,     0,     0,     0,   652,   898,   557,   899,   900,   901,
     902,   903,     0,     0,     0,     0,   904,   905,   906,     0,
       0,     0,     0,     0,     0,   907,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,   841,     0,     0,   183,   184,     0,   185,   632,
     186,   187,   188,   633,   842,   634,   843,   844,     0,   192,
     193,   194,   195,   196,   845,   846,   197,   847,   848,   200,
       0,   201,   202,   203,   204,   849,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   635,   220,   221,   850,   851,   852,
     853,   854,   222,   223,   224,   225,   226,   855,   856,   229,
     967,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   857,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     858,   253,   254,   859,   860,   256,   257,   258,   861,     0,
     260,     0,   261,   636,     0,   637,   262,   263,     0,   264,
     862,     0,   266,     0,   267,   268,   269,   270,   638,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
     639,   280,   281,   282,   283,   284,   863,   864,     0,   865,
       0,   288,   640,   641,   289,   642,   290,   291,   292,   293,
     294,     0,   866,   643,   296,   644,     0,   297,   298,   299,
     867,   868,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   869,   645,   870,   455,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   871,   324,
     325,   646,   326,   872,   873,   328,   874,   330,   331,     0,
       0,   332,   456,     0,     0,   875,   334,     0,     0,   335,
     647,   648,   876,   337,   338,   339,   340,   341,     0,   342,
     877,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   878,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   649,
     369,   370,   879,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,   880,   383,   384,   385,   386,
     650,   387,   881,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   882,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   883,   884,     0,     0,
     410,   885,   412,   886,   887,   414,   415,   416,   417,   418,
       0,   888,   419,   420,   421,   422,   889,     0,   423,   424,
     425,   426,   427,   890,   429,   651,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   891,   892,
     893,   894,   895,   896,   897,   447,   448,   449,     0,     0,
       0,     0,     0,   652,   898,   557,   899,   900,   901,   902,
     903,     0,     0,     0,     0,   904,   905,     0,     0,     0,
       0,     0,     0,     0,   907,   171,   172,   173,   174,   175,
     176,   177,   178,     0,   180,   181,   182,     0,     0,     0,
       0,   841,     0,     0,   183,   184,     0,   185,   632,   186,
     187,   188,   633,   842,   634,   843,   844,     0,   192,   193,
     194,   195,   196,   845,   846,   197,   847,   848,   200,     0,
     201,   202,   203,   204,   849,     0,     0,   206,   207,   208,
     209,   210,   211,     0,   212,   213,   214,   215,   216,     0,
     217,   218,   219,   635,   220,   221,   850,   851,   852,   853,
     854,   222,   223,   224,   225,   226,   855,   856,   229,     0,
     230,     0,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,     0,   239,   240,   857,   242,   243,     0,   244,
     245,   246,     0,   247,   248,     0,   249,   250,   251,   858,
     253,   254,   859,   860,   256,   257,   258,   861,     0,   260,
       0,   261,   636,     0,   637,   262,   263,     0,   264,   862,
       0,   266,     0,   267,   268,   269,   270,   638,   271,   272,
     273,     0,   274,   275,   276,   277,   278,   279,     0,   639,
     280,   281,   282,   283,   284,   863,   864,     0,   865,     0,
     288,   640,   641,   289,   642,   290,   291,   292,   293,   294,
       0,   866,   643,   296,   644,     0,   297,   298,   299,   867,
     868,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   869,   645,   870,   455,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   871,   324,   325,
     646,   326,   872,   873,   328,   874,   330,   331,     0,     0,
     332,   456,     0,     0,   875,   334,     0,     0,   335,   647,
     648,   876,   337,   338,   339,   340,   341,     0,   342,   877,
     344,   345,   346,   347,     0,   348,   349,   350,   351,   352,
     353,   878,   355,   356,     0,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   649,   369,
     370,   879,   372,   373,   374,   375,   376,   377,   378,   379,
      37,   380,   381,   382,   880,   383,   384,   385,   386,   650,
     387,   881,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   882,   400,     0,   401,   402,     0,   403,
     404,   405,   406,   407,     0,   883,   884,     0,     0,   410,
     885,   412,   886,   887,   414,   415,   416,   417,   418,     0,
     888,   419,   420,   421,   422,   889,     0,   423,   424,   425,
     426,  1404,   890,   429,   651,   430,   431,   432,     0,     0,
     433,   434,   435,   436,   437,   438,   439,   891,   892,   893,
     894,   895,   896,   897,   447,   448,   449,     0,     0,     0,
       0,     0,   652,   898,   557,   899,   900,   901,   902,   903,
       0,     0,     0,     0,   904,   905,     0,     0,     0,     0,
       0,     0,     0,   907,   171,   172,   173,   174,   175,   176,
     177,   178,  1513,   180,   181,   182,     0,     0,     0,     0,
     841,     0,     0,   183,   184,     0,   185,   632,   186,   187,
     188,   633,   842,   634,   843,   844,     0,   192,   193,   194,
     195,   196,   845,   846,   197,   847,   848,   200,     0,   201,
     202,   203,   204,   849,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   635,   220,   221,   850,   851,   852,   853,   854,
     222,   223,   224,   225,   226,   855,   856,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   857,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   858,   253,
     254,   859,   860,   256,   257,   258,   861,     0,   260,     0,
     261,   636,     0,   637,   262,   263,     0,   264,   862,     0,
     266,     0,   267,   268,   269,   270,   638,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,   639,   280,
     281,   282,   283,   284,   863,   864,     0,   865,     0,   288,
     640,   641,   289,   642,   290,   291,   292,   293,   294,     0,
     866,   643,   296,   644,     0,   297,   298,   299,   867,   868,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   869,   645,   870,   455,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   871,   324,   325,   646,
     326,   872,   873,   328,   874,   330,   331,     0,     0,   332,
     456,     0,     0,   875,   334,     0,     0,   335,   647,   648,
     876,   337,   338,   339,   340,   341,     0,   342,   877,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     878,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   649,   369,   370,
     879,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,   880,   383,   384,   385,   386,   650,   387,
     881,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   882,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   883,   884,     0,     0,   410,   885,
     412,   886,   887,   414,   415,   416,   417,   418,     0,   888,
     419,   420,   421,   422,   889,     0,   423,   424,   425,   426,
     427,   890,   429,   651,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   891,   892,   893,   894,
     895,   896,   897,   447,   448,   449,     0,     0,     0,     0,
       0,   652,   898,   557,   899,   900,   901,   902,   903,     0,
       0,     0,     0,   904,   905,     0,     0,     0,     0,     0,
       0,     0,   907,   171,   172,   173,   174,   175,   176,   177,
     178,     0,   180,   181,   182,     0,     0,     0,     0,   841,
       0,     0,   183,   184,     0,   185,   632,   186,   187,   188,
     633,   842,   634,   843,   844,     0,   192,   193,   194,   195,
     196,   845,   846,   197,   847,   848,   200,     0,   201,   202,
     203,   204,   849,     0,     0,   206,   207,   208,   209,   210,
     211,     0,   212,   213,   214,   215,   216,     0,   217,   218,
     219,   635,   220,   221,   850,   851,   852,   853,   854,   222,
     223,   224,   225,   226,   855,   856,   229,     0,   230,     0,
     231,   232,   233,   234,   235,     0,   236,   237,   238,     0,
       0,   239,   240,   857,   242,   243,     0,   244,   245,   246,
       0,   247,   248,     0,   249,   250,   251,   858,   253,   254,
     859,   860,   256,   257,   258,   861,     0,   260,     0,   261,
     636,     0,   637,   262,   263,     0,   264,   862,     0,   266,
       0,   267,   268,   269,   270,   638,   271,   272,   273,     0,
     274,   275,   276,   277,   278,   279,     0,   639,   280,   281,
     282,   283,   284,   863,   864,     0,   865,     0,   288,   640,
     641,   289,   642,   290,   291,   292,   293,   294,     0,   866,
     643,   296,   644,     0,   297,   298,   299,   867,   868,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   869,   645,   870,   455,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   871,   324,   325,   646,   326,
     872,   873,   328,   874,   330,   331,     0,     0,   332,   456,
       0,     0,   875,   334,     0,     0,   335,   647,   648,   876,
     337,   338,   339,   340,   341,     0,   342,   877,   344,   345,
     346,   347,     0,   348,   349,   350,   351,   352,   353,   878,
     355,   356,     0,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   649,   369,   370,   879,
     372,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   880,   383,   384,   385,   386,   650,   387,   881,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   882,   400,     0,   401,   402,     0,   403,   404,   405,
     406,   407,     0,   883,   884,     0,     0,   410,   885,   412,
     886,   887,   414,   415,   416,   417,   418,     0,   888,   419,
     420,   421,   422,   889,     0,   423,   424,   425,   426,   427,
     890,   429,   651,   430,   431,   432,     0,     0,   433,   434,
     435,   436,   437,   438,   439,   891,   892,   893,   894,   895,
     896,   897,   447,   448,   449,     0,     0,     0,     0,     0,
     652,   898,   557,   899,   900,   901,   902,   903,     0,     0,
       0,     0,   904,   905,     0,     0,     0,     0,     0,  1349,
       0,   907,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,   841,     0,
       0,   183,   184,     0,   185,   632,   186,   187,   188,   633,
     842,   634,   843,   844,     0,   192,   193,   194,   195,   196,
     845,   846,   197,   847,   848,   200,     0,   201,   202,   203,
     204,   849,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     635,   220,   221,   850,   851,   852,   853,   854,   222,   223,
     224,   225,   226,   855,   856,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   857,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   858,   253,   254,   859,
     860,   256,   257,   258,   861,     0,   260,     0,   261,   636,
    1873,   637,   262,   263,     0,   264,   862,     0,   266,     0,
     267,   268,   269,   270,   638,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,   639,   280,   281,   282,
     283,   284,   863,   864,     0,   865,     0,   288,   640,   641,
     289,   642,   290,   291,   292,   293,   294,     0,   866,   643,
     296,   644,     0,   297,   298,   299,   867,   868,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   869,   645,   870,   455,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   871,   324,   325,   646,   326,   872,
     873,   328,   874,   330,   331,     0,     0,   332,   456,     0,
       0,   875,   334,     0,     0,   335,   647,   648,   876,   337,
     338,   339,   340,   341,     0,   342,   877,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   878,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   649,   369,   370,   879,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,   880,   383,   384,   385,   386,   650,   387,   881,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     882,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   883,   884,     0,     0,   410,   885,   412,   886,
     887,   414,   415,   416,   417,   418,     0,   888,   419,   420,
     421,   422,   889,     0,   423,   424,   425,   426,   427,   890,
     429,   651,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   891,   892,   893,   894,   895,   896,
     897,   447,   448,   449,     0,     0,     0,     0,     0,   652,
     898,   557,   899,   900,   901,   902,   903,     0,     0,     0,
       0,   904,   905,     0,     0,     0,     0,     0,     0,     0,
     907,   171,   172,   173,   174,   175,   176,   177,   178,     0,
     180,   181,   182,     0,     0,     0,     0,   841,     0,     0,
     183,   184,     0,   185,   632,   186,   187,   188,   633,   842,
     634,   843,   844,     0,   192,   193,   194,   195,   196,   845,
     846,   197,   847,   848,   200,     0,   201,   202,   203,   204,
     849,     0,     0,   206,   207,   208,   209,   210,   211,     0,
     212,   213,   214,   215,   216,     0,   217,   218,   219,   635,
     220,   221,   850,   851,   852,   853,   854,   222,   223,   224,
     225,   226,   855,   856,   229,     0,   230,     0,   231,   232,
     233,   234,   235,     0,   236,   237,   238,     0,     0,   239,
     240,   857,   242,   243,     0,   244,   245,   246,     0,   247,
     248,     0,   249,   250,   251,   858,   253,   254,   859,   860,
     256,   257,   258,   861,     0,   260,     0,   261,   636,     0,
     637,   262,   263,     0,   264,   862,     0,   266,     0,   267,
     268,   269,   270,   638,   271,   272,   273,     0,   274,   275,
     276,   277,   278,   279,     0,   639,   280,   281,   282,   283,
     284,   863,   864,     0,   865,     0,   288,   640,   641,   289,
     642,   290,   291,   292,   293,   294,     0,   866,   643,   296,
     644,     0,   297,   298,   299,   867,   868,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     869,   645,   870,   455,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   871,   324,   325,   646,   326,   872,   873,
     328,   874,   330,   331,     0,     0,   332,   456,     0,     0,
     875,   334,     0,     0,   335,   647,   648,   876,   337,   338,
     339,   340,   341,     0,   342,   877,   344,   345,   346,   347,
       0,   348,   349,   350,   351,   352,   353,   878,   355,   356,
       0,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   649,   369,   370,   879,   372,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     880,   383,   384,   385,   386,   650,   387,   881,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   882,
     400,     0,   401,   402,     0,   403,   404,   405,   406,   407,
       0,   883,   884,     0,     0,   410,   885,   412,   886,   887,
     414,   415,   416,   417,   418,     0,   888,   419,   420,   421,
     422,   889,     0,   423,   424,   425,   426,   427,   890,   429,
     651,   430,   431,   432,     0,     0,   433,   434,   435,   436,
     437,   438,   439,   891,   892,   893,   894,   895,   896,   897,
     447,   448,   449,     0,     0,     0,     0,     0,   652,   898,
     557,   899,   900,   901,   902,   903,     0,     0,     0,     0,
     904,   905,     0,     0,     0,     0,     0,     0,     0,   907,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,   841,     0,     0,   183,
     184,     0,   185,   632,   186,   187,   188,   633,   842,   634,
     843,   844,     0,   192,   193,   194,   195,   196,   845,   846,
     197,   847,   848,   200,     0,   201,   202,   203,   204,   849,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   635,   220,
    2245,   850,   851,   852,   853,   854,   222,   223,   224,   225,
     226,   855,   856,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     857,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   858,   253,   254,   859,   860,   256,
     257,   258,   861,     0,   260,     0,   261,   636,     0,   637,
     262,   263,     0,   264,   862,     0,   266,     0,   267,   268,
     269,   270,   638,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,   639,   280,   281,   282,   283,   284,
     863,   864,     0,   865,     0,   288,   640,   641,   289,   642,
     290,   291,   292,   293,   294,     0,   866,   643,   296,   644,
       0,   297,   298,   299,   867,   868,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   869,
     645,   870,   455,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   871,   324,   325,   646,   326,   872,   873,   328,
     874,   330,   331,     0,     0,   332,   456,     0,     0,   875,
     334,     0,     0,   335,   647,   648,   876,   337,   338,   339,
     340,   341,     0,   342,   877,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,   878,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   649,   369,   370,   879,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   880,
     383,   384,   385,   386,   650,   387,   881,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   882,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     883,   884,     0,     0,   410,   885,   412,   886,   887,   414,
     415,   416,   417,   418,     0,   888,   419,   420,   421,   422,
     889,     0,   423,   424,   425,   426,   427,   890,   429,   651,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   891,   892,   893,   894,   895,   896,   897,   447,
     448,   449,     0,     0,     0,     0,     0,   652,   898,   557,
     899,   900,   901,   902,   903,     0,     0,     0,     0,   904,
     905,     0,     0,     0,     0,     0,     0,     0,   907,   171,
     172,   173,   174,   175,   176,   177,   178,     0,   180,   181,
     182,     0,     0,     0,     0,   841,     0,     0,   183,   184,
       0,   185,   632,   186,   187,   188,   633,   842,   634,   843,
     844,     0,   192,   193,   194,   195,   196,   845,   846,   197,
     847,   848,   200,     0,   201,   202,   203,   204,   849,     0,
       0,   206,   207,   208,   209,   210,   211,     0,   212,   213,
     214,   215,   216,     0,   217,   218,   219,   635,   220,   221,
     850,   851,   852,   853,   854,   222,   223,   224,   225,   226,
     855,   856,   229,     0,   230,     0,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,     0,   239,   240,   857,
     242,   243,     0,   244,   245,   246,     0,   247,   248,     0,
     249,   250,   251,   858,   253,   254,   859,   860,   256,   257,
     258,   861,     0,   260,     0,   261,   636,     0,   637,   262,
     263,     0,   264,   862,     0,   266,     0,   267,   268,   269,
     270,   638,   271,   272,   273,     0,   274,   275,   276,   277,
     278,   279,     0,   639,   280,   281,   282,   283,   284,   863,
     864,     0,   865,     0,   288,   640,   641,   289,   642,   290,
     291,   292,   293,   294,     0,   866,   643,   296,   644,     0,
     297,   298,   299,   867,   868,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   869,   645,
     870,   455,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   871,   324,   325,   646,   326,   872,   873,   328,   874,
     330,   331,     0,     0,   332,   456,     0,     0,   875,   334,
       0,     0,   335,   647,   648,   876,   337,   338,   339,   340,
     341,     0,   342,   877,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,   353,   878,   355,   356,     0,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   649,   369,   370,   879,   372,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   880,   383,
     384,   385,   386,   650,   387,   881,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   882,   400,     0,
     401,   402,     0,   403,   404,   405,   406,   407,     0,   883,
     884,     0,     0,   410,   885,   412,   886,   887,   414,   415,
     416,   417,   418,     0,   888,   419,   420,   421,   422,   889,
       0,   423,   424,   425,   426,   427,   890,   429,   651,   430,
     431,   432,     0,     0,   433,   434,   435,   436,   437,   438,
    2923,   891,   892,   893,   894,   895,   896,   897,   447,   448,
     449,     0,     0,     0,     0,     0,   652,   898,   557,   899,
     900,   901,   902,   903,     0,     0,     0,     0,   904,   905,
       0,     0,     0,     0,     0,     0,     0,   907,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,   841,     0,     0,   183,   184,     0,
     185,   632,   186,   187,   188,   633,   842,   634,   843,   844,
       0,   192,   193,   194,   195,   196,   845,   846,   197,   847,
     848,   200,     0,   201,   202,   203,   204,   849,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   635,   220,   221,   850,
     851,   852,   853,   854,   222,   223,   224,   225,   226,   855,
     856,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   857,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   858,   253,   254,   859,   860,   256,   257,   258,
     861,     0,   260,     0,   261,   636,     0,   637,   262,   263,
       0,   264,   862,     0,   266,     0,   267,   268,   269,   270,
     638,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,   639,   280,   281,   282,   283,   284,   863,   864,
       0,   865,     0,   288,   640,   641,   289,   642,   290,   291,
     292,   293,   294,     0,   866,   643,   296,   644,     0,   297,
     298,   299,   867,   868,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   869,   645,   870,
     455,   315,  2930,   317,   318,   319,   320,   321,   322,   323,
     871,   324,   325,   646,   326,   872,   873,   328,   874,   330,
     331,     0,     0,   332,   456,     0,     0,   875,   334,     0,
       0,   335,   647,   648,   876,   337,   338,   339,   340,   341,
       0,   342,   877,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   878,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   649,   369,   370,   879,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,   880,   383,   384,
     385,   386,   650,   387,   881,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   882,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   883,   884,
       0,     0,   410,   885,   412,   886,   887,   414,   415,   416,
     417,   418,     0,   888,   419,   420,   421,   422,   889,     0,
     423,   424,   425,   426,   427,   890,   429,   651,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     891,   892,   893,   894,   895,   896,   897,   447,   448,   449,
       0,     0,     0,     0,     0,   652,   898,   557,   899,   900,
     901,   902,   903,     0,     0,     0,     0,   904,   905,     0,
       0,     0,     0,     0,     0,     0,   907,   171,   172,   173,
     174,   175,   176,   177,   178,     0,   180,   181,   182,     0,
       0,     0,     0,   841,     0,     0,   183,   184,     0,   185,
     632,   186,   187,   188,   633,   842,   634,   843,   844,     0,
     192,   193,   194,   195,   196,   845,   846,   197,   847,   848,
     200,     0,   201,   202,   203,   204,   849,     0,     0,   206,
     207,   208,   209,   210,   211,     0,   212,   213,   214,   215,
     216,     0,   217,   218,   219,   635,   220,   221,   850,   851,
     852,   853,   854,   222,   223,   224,   225,   226,   855,   856,
     229,     0,   230,     0,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,     0,   239,   240,   857,   242,   243,
       0,   244,   245,   246,     0,   247,   248,     0,   249,   250,
     251,   858,   253,   254,   859,   860,   256,   257,   258,   861,
       0,   260,     0,   261,   636,     0,   637,   262,   263,     0,
     264,   862,     0,   266,     0,   267,   268,   269,   270,   638,
     271,   272,   273,     0,   274,   275,   276,   277,   278,   279,
       0,   639,   280,   281,   282,   283,   284,   863,   864,     0,
     865,     0,   288,   640,   641,   289,   642,   290,   291,   292,
     293,   294,     0,   866,   643,   296,   644,     0,   297,   298,
     299,   867,   868,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   869,   645,   870,   455,
     315,   316,   317,   318,   319,   320,   321,   322,   323,     0,
     324,   325,   646,   326,   872,   873,   328,   874,   330,   331,
       0,     0,   332,   456,     0,     0,   875,   334,     0,     0,
     335,   647,   648,   876,   337,   338,   339,   340,   341,     0,
     342,   877,   344,   345,   346,   347,     0,   348,   349,   350,
     351,   352,   353,   878,   355,   356,     0,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     649,   369,   370,   879,   372,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   880,   383,   384,   385,
     386,   650,   387,   881,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   882,   400,     0,   401,   402,
       0,   403,   404,   405,   406,   407,     0,   883,   884,     0,
       0,   410,   885,   412,   886,   887,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,   889,     0,   423,
     424,   425,   426,   427,   890,   429,   651,   430,   431,   432,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   891,
     892,   893,   894,   895,   896,   897,   447,   448,   449,     0,
       0,     0,     0,     0,   652,   898,   557,   899,   900,   901,
     902,   903,     0,     0,     0,     0,  1855,  1856,     0,     0,
       0,     0,     0,     0,     0,   907,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,   841,     0,     0,   183,   184,     0,   185,   632,
     186,   187,   188,     0,   842,   634,   843,   844,     0,   192,
     193,   194,   195,   196,   845,   846,   197,   847,   848,   200,
       0,   201,   202,   203,   204,   849,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   635,   220,   221,   850,   851,   852,
     853,   854,   222,   223,   224,   225,   226,   855,   856,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   857,   242,   243,     0,
     244,   245,   246,     0,   247,     0,     0,   249,   250,   251,
     858,   253,   254,   859,   860,   256,   257,   258,   861,     0,
     260,     0,   261,   636,     0,   637,   262,   263,     0,   264,
     862,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
     639,   280,   281,   282,   283,   284,   863,   864,     0,   865,
       0,   288,   640,   641,   289,   642,   290,   291,   292,   293,
     294,     0,   866,   643,   296,     0,     0,   297,   298,   299,
     867,   868,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   869,   645,   870,   455,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,   646,   326,   872,   873,   328,   874,   330,   331,     0,
       0,   332,   456,     0,     0,   875,   334,     0,     0,   335,
     647,   648,   876,   337,   338,   339,   340,   341,     0,   342,
     877,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   878,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   649,
     369,   370,   879,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,   880,   383,   384,   385,   386,
       0,   387,   881,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   882,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   883,   884,     0,     0,
     410,   885,   412,   886,   887,   414,   415,   416,   417,   418,
       0,   888,   419,   420,   421,   422,   889,     0,   423,   424,
     425,   426,   427,   890,   429,   651,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   891,   892,
     893,   894,   895,   896,   897,   447,   448,   449,     0,     0,
       0,     0,     0,   652,   898,   557,   899,   900,   901,   902,
     903,     0,     0,     0,     0,   904,   905,     0,     0,     0,
       0,     0,     0,     0,   907,   171,   172,   173,   174,   175,
     176,   177,   178,     0,   180,   181,   182,     0,     0,     0,
       0,   841,     0,     0,   183,   184,     0,   185,   632,   186,
     187,   188,     0,   842,   634,   843,   844,     0,   192,   193,
     194,   195,   196,   845,   846,   197,   847,   848,   200,     0,
     201,   202,   203,   204,   849,     0,     0,   206,   207,   208,
     209,   210,   211,     0,   212,   213,   214,   215,   216,     0,
     217,   218,   219,   635,   220,   221,   850,   851,   852,   853,
     854,   222,   223,   224,   225,   226,   855,   856,   229,     0,
     230,     0,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,     0,   239,   240,   857,   242,   243,     0,   244,
     245,   246,     0,   247,     0,     0,   249,   250,   251,   858,
     253,   254,   859,   860,   256,   257,   258,   861,     0,   260,
       0,   261,   636,     0,   637,   262,   263,     0,   264,   862,
       0,   266,     0,   267,   268,   269,   270,     0,   271,   272,
     273,     0,   274,   275,   276,   277,   278,   279,     0,   639,
     280,   281,   282,   283,   284,   863,   864,     0,   865,     0,
     288,   640,   641,   289,   642,   290,   291,   292,   293,   294,
       0,   866,   643,   296,     0,     0,   297,   298,   299,   867,
     868,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   869,   645,   870,   455,   315,   316,
     317,   318,   319,   320,   321,   322,   323,     0,   324,   325,
     646,   326,   872,   873,   328,   874,   330,   331,     0,     0,
     332,   456,     0,     0,   875,   334,     0,     0,   335,   647,
     648,   876,   337,   338,   339,   340,   341,     0,   342,   877,
     344,   345,   346,   347,     0,   348,   349,   350,   351,   352,
     353,   878,   355,   356,     0,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   649,   369,
     370,   879,   372,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   880,   383,   384,   385,   386,     0,
     387,   881,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   882,   400,     0,   401,   402,     0,   403,
     404,   405,   406,   407,     0,   883,   884,     0,     0,   410,
     885,   412,   886,   887,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   889,     0,   423,   424,   425,
     426,   427,   890,   429,   651,   430,   431,   432,     0,     0,
     433,   434,   435,   436,   437,   438,   439,   891,   892,   893,
     894,   895,   896,   897,   447,   448,   449,     0,     0,     0,
       0,     0,   652,   898,   557,   899,   900,   901,   902,   903,
       0,     0,     0,     0,  1855,  1856,     0,     0,     0,     0,
       0,     0,     0,   907,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,   632,   186,   187,
     188,   633,   189,   634,   190,   191,     0,   192,   193,   194,
     195,   196,     0,   846,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   849,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   635,   220,   221,   850,   851,   852,   853,   854,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   859,     0,   256,   257,   258,   259,     0,   260,     0,
     261,   636,     0,   637,   262,   263,     0,   264,   862,     0,
     266,     0,   267,   268,   269,   270,   638,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,   639,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     640,   641,   289,   642,   290,   291,   292,   293,   294,     0,
     866,   643,   296,   644,     0,   297,   298,   299,   867,   868,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   645,   314,   455,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,   646,
     326,     0,   873,   328,   329,   330,   331,     0,     0,   332,
     456,     0,   610,   333,   334,     0,     0,   335,   647,   648,
     876,   337,   338,   339,   340,   341,     0,   342,   877,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   649,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    37,
     380,   381,   382,   880,   383,   384,   385,   386,   650,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   882,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   885,
     412,   886,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   889,     0,   423,   424,   425,   426,
    1404,   428,   429,   651,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   891,   892,   893,   894,
     895,   896,   897,   447,   448,   449,     0,     0,     0,     0,
       0,   652,     0,     0,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,  1740,   183,   184,     0,   185,   632,   186,   187,
     188,   633,   189,   634,   190,   191,     0,   192,   193,   194,
     195,   196,     0,   846,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   849,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   635,   220,   221,   850,   851,   852,   853,   854,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   859,     0,   256,   257,   258,   259,     0,   260,     0,
     261,   636,     0,   637,   262,   263,     0,   264,   862,     0,
     266,     0,   267,   268,   269,   270,   638,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,   639,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     640,   641,   289,   642,   290,   291,   292,   293,   294,     0,
     866,   643,   296,   644,     0,   297,   298,   299,   867,   868,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   645,   314,   455,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,   646,
     326,     0,   873,   328,   329,   330,   331,     0,     0,   332,
     456,     0,   610,   333,   334,     0,     0,   335,   647,   648,
     876,   337,   338,   339,   340,   341,     0,   342,   877,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   649,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,   880,   383,   384,   385,   386,   650,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   882,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   885,
     412,   886,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   889,     0,   423,   424,   425,   426,
     427,   428,   429,   651,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   891,   892,   893,   894,
     895,   896,   897,   447,   448,   449,     0,     0,     0,     0,
       0,   652,     0,     0,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,  1740,   183,   184,     0,   185,   632,   186,   187,
     188,   633,   189,   634,   190,   191,     0,   192,   193,   194,
     195,   196,     0,   846,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   849,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   635,   220,   221,   850,   851,   852,   853,   854,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   859,     0,   256,   257,   258,   259,     0,   260,     0,
     261,   636,     0,   637,   262,   263,     0,   264,   862,     0,
     266,     0,   267,   268,   269,   270,   638,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,   639,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     640,   641,   289,   642,   290,   291,   292,   293,   294,     0,
     866,   643,   296,   644,     0,   297,   298,   299,   867,   868,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   645,   314,   455,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,   646,
     326,     0,   873,   328,   329,   330,   331,     0,     0,   332,
     456,     0,     0,   333,   334,     0,     0,   335,   647,   648,
     876,   337,   338,   339,   340,   341,     0,   342,   877,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   649,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,   880,   383,   384,   385,   386,   650,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   882,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   885,
     412,   886,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   889,     0,   423,   424,   425,   426,
     427,   428,   429,   651,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   891,   892,   893,   894,
     895,   896,   897,   447,   448,   449,     0,     0,     0,     0,
       0,   652,     0,     0,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,  3042,   183,   184,     0,   185,   632,   186,   187,
     188,   633,   189,   634,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   635,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,   636,     0,   637,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,   638,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,   639,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     640,   641,   289,   642,   290,   291,   292,   293,   294,     0,
     295,   643,   296,   644,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   645,   314,   455,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,   646,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
     456,     0,     0,   333,   334,     0,     0,   335,   647,   648,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   649,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,   650,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,   651,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   652,     0,     0,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,  3090,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,   455,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
     456,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,     0,     0,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,   959,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    37,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
    1404,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,     0,     0,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,    46,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,     0,     0,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,  1490,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2622,   171,   172,   173,   174,   175,   176,   177,
     178,  1081,   180,   181,   182,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,   183,   184,  1089,   185,   632,   186,   187,   188,
     633,  1190,   634,  1191,  1192,  1090,   192,   193,   194,   195,
     196,  1091,  1092,   197,  1193,  1194,   200,  1093,   201,   202,
     203,   204,     0,  1094,  1095,   206,   207,   208,   209,   210,
     211,  1096,   212,   213,   214,   215,   216,  1097,   217,   218,
     219,   635,   220,   221,  1098,  1099,  1100,  1101,  1102,   222,
     223,   224,   225,   226,  1195,  1196,   229,  1103,   230,  1104,
     231,   232,   233,   234,   235,  1105,   236,   237,   238,  1106,
    1107,   239,   240,   857,   242,   243,  1108,   244,   245,   246,
    1109,   247,   248,  1110,   249,   250,   251,     0,   253,   254,
       0,  1111,   256,   257,   258,  1197,  1112,   260,  1113,   261,
     636,  1114,   637,   262,   263,  1115,   264,     0,  1116,   266,
    1117,   267,   268,   269,   270,   638,   271,   272,   273,  1118,
     274,   275,   276,   277,   278,   279,  1119,   639,     0,   281,
     282,   283,   284,  1198,  1199,  1120,  1200,  1121,   288,   640,
     641,   289,   642,   290,   291,   292,   293,   294,  1122,     0,
     643,   296,   644,  1123,   297,   298,   299,  1124,  1125,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,  1201,   645,  1202,  1126,   315,   316,   317,   318,
     319,   320,   321,     0,   323,  1127,   324,   325,   646,   326,
    1128,     0,   328,  1203,   330,   331,  1129,  1130,   332,  1131,
    1132,  1133,  2522,   334,  1134,  1135,     0,   647,   648,     0,
     337,   338,   339,   340,   341,  1136,   342,     0,     0,   345,
     346,   347,  1137,   348,   349,   350,   351,   352,   353,  1204,
     355,   356,  1138,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,  1139,   367,   368,   649,   369,   370,     0,
     372,   373,   374,   375,   376,   377,   378,   379,  1140,   380,
     381,   382,  1141,   383,  1567,   385,   386,   650,   387,  1206,
    1142,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,   400,  1143,   401,   402,  1144,   403,   404,   405,
     406,   407,  1145,  1207,  1208,  1146,  1147,   410,     0,   412,
       0,  1148,   414,   415,   416,   417,   418,  1149,  1150,   419,
     420,   421,   422,  1151,  1152,   423,   424,   425,   426,     0,
    1209,   429,   651,   430,   431,   432,  1153,  1154,   433,   434,
     435,   436,   437,   438,     0,     0,     0,     0,     0,     0,
       0,     0,   447,   448,   449,     0,     0,     0,     0,     0,
    1210,  1461,   557,     0,     0,   670,   542,     0,   671,   672,
     673,     0,   674,  2523,   676,   677,   678,   679,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   668,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   669,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,     0,     0,     0,     0,
     670,     0,     0,   671,   672,   673,     0,   674,   675,   676,
     677,   678,   679,   171,   172,   173,   174,   175,   176,   177,
     178,     0,   180,   181,   182,     0,     0,     0,     0,     0,
       0,     0,   183,   184,     0,   185,     0,   186,   187,   188,
       0,   189,     0,   190,   191,     0,   192,   193,   194,   195,
     196,     0,     0,   197,   198,   199,   200,     0,   201,   745,
     203,   204,   205,     0,     0,   206,   207,   208,   209,   210,
     211,     0,   212,   213,   214,   215,   216,     0,   217,   218,
     219,     0,   220,   221,     0,     0,     0,     0,     0,   222,
     223,   224,   225,   226,   227,   228,   229,     0,   230,     0,
     231,   232,   233,   234,   235,     0,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,     0,   746,   257,   258,   259,     0,   260,     0,   261,
       0,     0,     0,   262,   263,     0,   264,   265,     0,   266,
       0,   267,   268,   269,   270,     0,   271,   272,   273,     0,
     274,   275,   276,   277,   278,   279,     0,     0,   280,   281,
     282,   283,   284,   285,   286,     0,   287,     0,   288,     0,
       0,   289,     0,   290,   291,   292,   293,   294,     0,   295,
       0,   296,     0,     0,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,   320,   321,   322,   323,     0,   324,   325,     0,   326,
       0,   327,   328,   329,   330,   331,     0,     0,   332,     0,
       0,     0,   333,   334,     0,     0,   335,     0,     0,   336,
     337,   338,   339,   340,   341,     0,   342,   343,   344,   345,
     346,   347,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,     0,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,     0,   383,   384,   385,   386,     0,   387,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,     0,   403,   404,   405,
     406,   407,     0,   408,   409,     0,     0,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,     0,     0,   419,
     420,   421,   422,     0,     0,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,   432,     0,     0,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     0,     0,     0,     0,     0,
     450,     0,     0,     0,     0,   670,     0,     0,   671,   672,
     673,     0,   674,   675,   676,   677,   678,   679,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   781,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   782,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   783,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,     0,     0,     0,     0,
     670,     0,     0,   671,   672,   673,     0,   674,   675,   676,
     677,   678,   679,   171,   172,   173,   174,   175,   176,   177,
     178,     0,   180,   181,   182,     0,     0,     0,     0,     0,
       0,     0,   183,   184,     0,   185,     0,   186,   187,   188,
       0,   189,     0,   190,   191,     0,   192,   193,   194,   195,
     196,     0,     0,   197,   198,   199,   200,     0,   201,  1172,
     203,   204,   205,     0,     0,   206,   207,   208,   209,   210,
     211,     0,   212,   213,   214,   215,   216,     0,   217,   218,
     219,     0,   220,   221,     0,     0,     0,     0,     0,   222,
     223,   224,   225,   226,   227,   228,   229,     0,   230,     0,
     231,   232,   233,   234,   235,     0,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,     0,  1173,   257,   258,   259,     0,   260,     0,   261,
       0,     0,     0,   262,   263,     0,   264,   265,     0,   266,
       0,   267,   268,   269,   270,     0,   271,   272,   273,     0,
     274,   275,   276,   277,   278,   279,     0,     0,   280,   281,
     282,   283,   284,   285,   286,     0,   287,     0,   288,     0,
       0,   289,     0,   290,   291,   292,   293,   294,     0,   295,
       0,   296,     0,     0,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,   320,   321,   322,   323,     0,   324,   325,     0,   326,
       0,   327,   328,   329,   330,   331,     0,     0,   332,     0,
       0,     0,   333,   334,     0,     0,   335,     0,     0,   336,
     337,   338,   339,   340,   341,     0,   342,   343,   344,   345,
     346,   347,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,     0,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,     0,   383,   384,   385,   386,     0,   387,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,     0,   403,   404,   405,
     406,   407,     0,   408,   409,     0,     0,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,     0,     0,   419,
     420,   421,   422,     0,     0,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,   432,     0,     0,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     0,     0,     0,     0,     0,
     450,     0,     0,     0,     0,   670,     0,     0,   671,   672,
     673,     0,   674,   675,   676,   677,   678,   679,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,     0,     0,     0,     0,
     670,     0,     0,   671,   672,   673,     0,   674,   675,   676,
     677,   678,   679,   171,   172,   173,   174,   175,   176,   177,
     178,  1081,   180,   181,   182,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,   183,   184,  1089,   185,   632,   186,   187,   188,
     633,   189,   634,   190,   191,  1090,   192,   193,   194,   195,
     196,  1091,  1092,   197,   198,   199,   200,  1093,   201,   202,
     203,   204,   205,  1094,  1095,   206,   207,   208,   209,   210,
     211,  1096,   212,   213,   214,   215,   216,  1097,   217,   218,
     219,   635,   220,   221,  1098,  1099,  1100,  1101,  1102,   222,
     223,   224,   225,   226,   227,   228,   229,  1103,   230,  1104,
     231,   232,   233,   234,   235,  1105,   236,   237,   238,  1106,
    1107,   239,   240,   241,   242,   243,  1108,   244,   245,   246,
    1109,   247,   248,  1110,   249,   250,   251,   252,   253,   254,
     255,  1111,   256,   257,   258,   259,  1112,   260,  1113,   261,
     636,  1114,   637,   262,   263,  1115,   264,   265,  1116,   266,
    1117,   267,   268,   269,   270,   638,   271,   272,   273,  1118,
     274,   275,   276,   277,   278,   279,  1119,   639,   280,   281,
     282,   283,   284,   285,   286,  1120,   287,  1121,   288,   640,
     641,   289,   642,   290,   291,   292,   293,   294,  1122,   295,
     643,   296,   644,  1123,   297,   298,   299,  1124,  1125,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   645,   314,  1126,   315,   316,   317,   318,
     319,   320,   321,   322,   323,  1127,   324,   325,   646,   326,
    1128,   327,   328,   329,   330,   331,  1129,  1130,   332,  1131,
    1132,  1133,   333,   334,  1134,  1135,   335,   647,   648,   336,
     337,   338,   339,   340,   341,  1136,   342,   343,   344,   345,
     346,   347,  1137,   348,   349,   350,   351,   352,   353,   354,
     355,   356,  1138,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,  1139,   367,   368,   649,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,  1140,   380,
     381,   382,  1141,   383,   384,   385,   386,   650,   387,   388,
    1142,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,  1143,   401,   402,  1144,   403,   404,   405,
     406,   407,  1145,   408,   409,  1146,  1147,   410,   411,   412,
     413,  1148,   414,   415,   416,   417,   418,  1149,  1150,   419,
     420,   421,   422,  1151,  1152,   423,   424,   425,   426,   427,
     428,   429,   651,   430,   431,   432,  1153,  1154,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     0,     0,     0,     0,     0,
    1155,   171,   172,   173,   174,   175,   176,   177,   178,     0,
     180,   181,   182,     0,  1156,     0,     0,     0,     0,     0,
     183,   184,     0,   185,     0,   186,   187,   188,     0,   189,
       0,   190,   191,     0,   192,   193,   194,   195,   196,     0,
       0,   197,   198,   199,   200,     0,   201,   202,   203,   204,
     205,     0,     0,   206,   207,   208,   209,   210,   211,     0,
     212,   213,   214,   215,   216,     0,   217,   218,   219,     0,
     220,   221,     0,     0,     0,     0,     0,   222,   223,   224,
     225,   226,   227,   228,   229,     0,   230,     0,   231,   232,
     233,   234,   235,     0,   236,   237,   238,     0,     0,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,     0,
     256,   257,   258,   259,     0,   260,     0,   261,     0,     0,
       0,   262,   263,     0,   264,   265,     0,   266,     0,   267,
     268,   269,   270,     0,   271,   272,   273,     0,   274,   275,
     276,   277,   278,   279,     0,     0,   280,   281,   282,   283,
     284,   285,   286,     0,   287,     0,   288,     0,     0,   289,
       0,   290,   291,   292,   293,   294,     0,   295,     0,   296,
       0,     0,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,   320,
     321,   322,   323,     0,   324,   325,     0,   326,     0,   327,
     328,   329,   330,   331,     0,     0,   332,     0,     0,     0,
     333,   334,     0,     0,   335,     0,     0,   336,   337,   338,
     339,   340,   341,     0,   342,   343,   344,   345,   346,   347,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,     0,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
       0,   383,   384,   385,   386,     0,   387,   388,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,     0,   403,   404,   405,   406,   407,
       0,   408,   409,     0,     0,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,     0,     0,   419,   420,   421,
     422,     0,     0,   423,   424,   425,   426,   427,   428,   429,
       0,   430,   431,   432,     0,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     0,     0,     0,     0,     0,   450,   171,
     172,   173,   174,   175,   176,   177,   178,     0,   180,   181,
     182,     0,   608,     0,     0,     0,     0,     0,   183,   184,
       0,   185,   632,   186,   187,   188,   633,  1190,   634,  1191,
    1192,     0,   192,   193,   194,   195,   196,     0,     0,   197,
    1193,  1194,   200,     0,   201,   202,   203,   204,     0,     0,
       0,   206,   207,   208,   209,   210,   211,     0,   212,   213,
     214,   215,   216,     0,   217,   218,   219,   635,   220,   221,
       0,     0,     0,     0,     0,   222,   223,   224,   225,   226,
    1195,  1196,   229,     0,   230,     0,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,     0,   239,   240,   857,
     242,   243,     0,   244,   245,   246,     0,   247,   248,     0,
     249,   250,   251,     0,   253,   254,     0,     0,   256,   257,
     258,  1197,     0,   260,     0,   261,   636,     0,   637,   262,
     263,     0,   264,     0,     0,   266,     0,   267,   268,   269,
     270,   638,   271,   272,   273,     0,   274,   275,   276,   277,
     278,   279,     0,   639,     0,   281,   282,   283,   284,  1198,
    1199,     0,  1200,     0,   288,   640,   641,   289,   642,   290,
     291,   292,   293,   294,     0,     0,   643,   296,   644,     0,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,  1201,   645,
    1202,     0,   315,   316,   317,   318,   319,   320,   321,     0,
     323,     0,   324,   325,   646,   326,     0,     0,   328,  1203,
     330,   331,     0,     0,   332,     0,     0,     0,   333,   334,
       0,     0,     0,   647,   648,     0,   337,   338,   339,   340,
     341,     0,   342,     0,     0,   345,   346,   347,     0,   348,
     349,   350,   351,   352,   353,  1204,   355,   356,     0,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   649,   369,   370,     0,   372,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,     0,   383,
    1205,   385,   386,   650,   387,  1206,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,   400,     0,
     401,   402,     0,   403,   404,   405,   406,   407,     0,  1207,
    1208,     0,     0,   410,     0,   412,     0,     0,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,     0,
       0,   423,   424,   425,   426,     0,  1209,   429,   651,   430,
     431,   432,     0,     0,   433,   434,   435,   436,   437,   438,
       0,     0,     0,     0,     0,     0,     0,     0,   447,   448,
     449,     0,     0,     0,     0,     0,  1210,   171,   172,   173,
     174,   175,   176,   177,   178,     0,   180,   181,   182,     0,
    1524,     0,     0,     0,     0,     0,   183,   184,     0,   185,
     632,   186,   187,   188,   633,  1190,   634,  1191,  1192,     0,
     192,   193,   194,   195,   196,     0,     0,   197,  1193,  1194,
     200,     0,   201,   202,   203,   204,     0,     0,     0,   206,
     207,   208,   209,   210,   211,     0,   212,   213,   214,   215,
     216,     0,   217,   218,   219,   635,   220,   221,     0,     0,
       0,     0,     0,   222,   223,   224,   225,   226,  1195,  1196,
     229,     0,   230,     0,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,     0,   239,   240,   857,   242,   243,
       0,   244,   245,   246,     0,   247,   248,     0,   249,   250,
     251,     0,   253,   254,     0,     0,   256,   257,   258,  1197,
       0,   260,     0,   261,   636,     0,   637,   262,   263,     0,
     264,     0,     0,   266,     0,   267,   268,   269,   270,   638,
     271,   272,   273,     0,   274,   275,   276,   277,   278,   279,
       0,   639,     0,   281,   282,   283,   284,  1198,  1199,     0,
    1200,     0,   288,   640,   641,   289,   642,   290,   291,   292,
     293,   294,     0,     0,   643,   296,   644,     0,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,  1201,   645,  1202,     0,
     315,   316,   317,   318,   319,   320,   321,     0,   323,     0,
     324,   325,   646,   326,     0,     0,   328,  1203,   330,   331,
       0,     0,   332,     0,     0,     0,   333,   334,     0,     0,
       0,   647,   648,     0,   337,   338,   339,   340,   341,     0,
     342,     0,     0,   345,   346,   347,     0,   348,   349,   350,
     351,   352,   353,  1204,   355,   356,     0,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     649,   369,   370,     0,   372,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,     0,   383,  1205,   385,
     386,   650,   387,  1206,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,   400,     0,   401,   402,
       0,   403,   404,   405,   406,   407,     0,  1207,  1208,     0,
       0,   410,     0,   412,     0,     0,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,     0,     0,   423,
     424,   425,   426,     0,  1209,   429,   651,   430,   431,   432,
       0,     0,   433,   434,   435,   436,   437,   438,     0,     0,
       0,     0,     0,     0,     0,     0,   447,   448,   449,     0,
       0,     0,     0,     0,  1670,   171,   172,   173,   174,   175,
     176,   177,   178,     0,   180,   181,   182,     0,  1524,     0,
       0,     0,     0,     0,   183,   184,     0,   185,     0,   186,
     187,   188,     0,   189,     0,   190,   191,     0,   192,   193,
     194,   195,   196,     0,     0,   197,   198,   199,   200,     0,
     201,   202,   203,   204,   205,     0,     0,   206,   207,   208,
     209,   210,   211,     0,   212,   213,   214,   215,   216,     0,
     217,   218,   219,     0,   220,   221,     0,     0,     0,     0,
       0,   222,   223,   224,   225,   226,   227,   228,   229,  1474,
     230,     0,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,     0,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,  1475,   256,   257,   258,   259,     0,   260,
       0,   261,     0,     0,     0,   262,   263,     0,   264,   265,
       0,   266,     0,   267,   268,   269,   270,     0,   271,   272,
     273,     0,   274,   275,   276,   277,   278,   279,     0,     0,
     280,   281,   282,   283,   284,   285,   286,     0,   287,     0,
     288,     0,     0,   289,     0,   290,   291,   292,   293,   294,
       0,   295,     0,   296,     0,     0,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,   320,   321,   322,   323,     0,   324,   325,
       0,   326,     0,   327,   328,   329,   330,   331,  1476,     0,
     332,     0,  1477,     0,   333,   334,     0,     0,   335,     0,
       0,   336,   337,   338,   339,   340,   341,     0,   342,   343,
     344,   345,   346,   347,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,     0,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,     0,   383,   384,   385,   386,     0,
     387,   388,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,     0,   403,
     404,   405,   406,   407,     0,   408,   409,     0,     0,   410,
     411,   412,   413,  1478,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,     0,     0,   423,   424,   425,
     426,   427,   428,   429,     0,   430,   431,   432,     0,     0,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     0,     0,     0,
       0,     0,   450,  1461,   942,     0,     0,     0,   542,     0,
       0,     0,     0,     0,     0,  1462,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,     0,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
    1484,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,  1475,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,  1476,
       0,   332,     0,  1477,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   408,   409,     0,     0,
     410,   411,   412,   413,  1478,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,  1461,   942,     0,     0,     0,   542,
       0,     0,     0,     0,     0,     0,  1462,   171,   172,   173,
     174,   175,   176,   177,   178,     0,   180,   181,   182,     0,
       0,     0,     0,     0,     0,     0,   183,   184,     0,   185,
       0,   186,   187,   188,     0,   189,     0,   190,   191,     0,
     192,   193,   194,   195,   196,     0,     0,   197,   198,   199,
     200,     0,   201,   202,   203,   204,   205,     0,     0,   206,
     207,   208,   209,   210,   211,     0,   212,   213,   214,   215,
     216,     0,   217,   218,   219,     0,   220,   221,     0,     0,
       0,     0,     0,   222,   223,   224,   225,   226,   227,   228,
     229,     0,   230,     0,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,     0,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,  1475,   256,   257,   258,   259,
       0,   260,     0,   261,     0,     0,     0,   262,   263,     0,
     264,   265,     0,   266,     0,   267,   268,   269,   270,     0,
     271,   272,   273,     0,   274,   275,   276,   277,   278,   279,
       0,     0,   280,   281,   282,   283,   284,   285,   286,     0,
     287,     0,   288,     0,     0,   289,     0,   290,   291,   292,
     293,   294,     0,   295,     0,   296,     0,     0,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,   320,   321,   322,   323,     0,
     324,   325,     0,   326,     0,   327,   328,   329,   330,   331,
    1476,     0,   332,     0,  1477,     0,   333,   334,     0,     0,
     335,     0,     0,   336,   337,   338,   339,   340,   341,     0,
     342,   343,   344,   345,   346,   347,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
       0,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,     0,   383,   384,   385,
     386,     0,   387,   388,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
       0,   403,   404,   405,   406,   407,     0,   408,   409,     0,
       0,   410,   411,   412,   413,  1478,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,     0,     0,   423,
     424,   425,   426,   427,   428,   429,     0,   430,   431,   432,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     0,
       0,     0,     0,     0,   450,  1461,   942,     0,     0,     0,
     542,     0,     0,     0,     0,     0,     0,  1462,   171,   533,
     173,   174,   175,   176,   177,   178,   534,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   535,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   536,
     259,     0,   260,     0,   537,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   538,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   539,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   540,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   541,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,     0,     0,     0,     0,
       0,   542,     0,     0,     0,     0,     0,     0,   543,   171,
     172,   173,   174,   175,   176,   177,   178,     0,   180,   181,
     182,     0,     0,     0,     0,     0,     0,     0,   183,   184,
       0,   185,     0,   186,   187,   188,     0,   189,     0,   190,
     191,     0,   192,   193,   194,   195,   196,     0,     0,   197,
     198,   199,   200,     0,   201,   202,   203,   204,   205,     0,
       0,   206,   207,   208,   209,   210,   211,     0,   212,   213,
     214,   215,   216,     0,   217,   218,   219,     0,   220,   221,
       0,     0,     0,     0,     0,   222,   223,   224,   225,   226,
     227,   228,   229,     0,   230,     0,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,     0,   256,   257,
     258,   259,     0,   260,     0,   261,     0,     0,     0,   262,
     263,     0,   264,   265,     0,   266,     0,   267,   268,   269,
     270,     0,   271,   272,   273,     0,   274,   275,   276,   277,
     278,   279,     0,     0,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,     0,     0,   289,     0,   290,
     291,   292,   293,   294,     0,   295,     0,   296,     0,     0,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,   320,   321,   322,
     323,     0,   324,   325,     0,   326,     0,   327,   328,   329,
     330,   331,     0,     0,   332,     0,     0,     0,   333,   334,
       0,     0,   335,     0,     0,   336,   337,   338,   339,   340,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,     0,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,     0,   383,
     384,   385,   386,     0,   387,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,     0,   403,   404,   405,   406,   407,     0,   408,
     409,     0,     0,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,     0,
       0,   423,   424,   425,   426,   427,   428,   429,     0,   430,
     431,   432,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     0,     0,     0,     0,     0,   450,     0,     0,     0,
       0,     0,     0,  2899,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,  3239,   557,  3240,  3241,     0,  3242,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,  1455,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,     0,   942,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,     0,   942,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,  1297,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,     0,   942,   171,   172,
     173,   174,   175,   176,   177,   178,  1081,   180,   181,   182,
    1082,  1083,  1084,  1085,  1086,  1087,  1088,   183,   184,  1089,
     185,   632,   186,   187,   188,   633,   189,   634,   190,   191,
    1090,   192,   193,   194,   195,   196,  1091,  1092,   197,   198,
     199,   200,  1093,   201,   202,   203,   204,   205,  1094,  1095,
     206,   207,   208,   209,   210,   211,  1096,   212,   213,   214,
     215,   216,  1097,   217,   218,   219,   635,   220,   221,  1098,
    1099,  1100,  1101,  1102,   222,   223,   224,   225,   226,   227,
     228,   229,  1103,   230,  1104,   231,   232,   233,   234,   235,
    1105,   236,   237,   238,  1106,  1107,   239,   240,   241,   242,
     243,  1108,   244,   245,   246,  1109,   247,   248,  1110,   249,
     250,   251,   252,   253,   254,   255,  1111,   256,   257,   258,
     259,  1112,   260,  1113,   261,   636,  1114,   637,   262,   263,
    1115,   264,   265,  1116,   266,  1117,   267,   268,   269,   270,
     638,   271,   272,   273,  1118,   274,   275,   276,   277,   278,
     279,  1119,   639,   280,   281,   282,   283,   284,   285,   286,
    1120,   287,  1121,   288,   640,   641,   289,   642,   290,   291,
     292,   293,   294,  1122,   295,   643,   296,   644,  1123,   297,
     298,   299,  1124,  1125,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   645,   314,
    1126,   315,   316,   317,   318,   319,   320,   321,   322,   323,
    1127,   324,   325,   646,   326,  1128,   327,   328,   329,   330,
     331,  1129,  1130,   332,  1131,  1132,  1133,   333,   334,  1134,
    1135,   335,   647,   648,   336,   337,   338,   339,   340,   341,
    1136,   342,   343,   344,   345,   346,   347,  1137,   348,   349,
     350,   351,   352,   353,   354,   355,   356,  1138,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,  1139,   367,
     368,   649,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,  1140,   380,   381,   382,  1141,   383,   384,
     385,   386,   650,   387,   388,  1142,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,  1143,   401,
     402,  1144,   403,   404,   405,   406,   407,  1145,   408,   409,
    1146,  1147,   410,   411,   412,   413,  1148,   414,   415,   416,
     417,   418,  1149,  1150,   419,   420,   421,   422,  1151,  1152,
     423,   424,   425,   426,   427,   428,   429,   651,   430,   431,
     432,  1153,  1154,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,  1155,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,   632,
     186,   187,   188,   633,   189,   634,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   635,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,   636,     0,   637,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,   638,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
     639,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,   640,   641,   289,   642,   290,   291,   292,   293,
     294,     0,   295,   643,   296,   644,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   645,   314,   455,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,   646,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,   456,     0,     0,   333,   334,     0,     0,   335,
     647,   648,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   649,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,     0,   383,   384,   385,   386,
     650,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   408,   409,     0,     0,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,   651,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   652,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,   632,   186,   187,
     188,   633,   189,   634,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   635,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,   636,     0,   637,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   769,   638,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,   639,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     640,   641,   289,   642,   290,   291,   292,   293,   294,     0,
     295,   643,   296,   644,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   645,   314,   455,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,   646,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
     456,     0,     0,   333,   334,     0,     0,   335,   647,   648,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   649,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,   650,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,   651,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   652,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,   632,   186,   187,   188,   633,
     189,   634,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     635,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,   636,
       0,   637,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   776,   638,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,   639,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,   640,   641,
     289,   642,   290,   291,   292,   293,   294,     0,   295,   643,
     296,   644,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   645,   314,   455,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,   646,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,   456,     0,
       0,   333,   334,     0,     0,   335,   647,   648,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   649,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,   384,   385,   386,   650,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   408,   409,     0,     0,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,   427,   428,
     429,   651,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   652,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,     0,   186,   187,   188,     0,   189,     0,
     190,   191,     0,   192,   193,   194,   195,   196,     0,     0,
     197,   198,   199,   200,  1537,   201,   202,   203,   204,   205,
       0,     0,   206,   207,   208,   209,   210,   211,  1538,   212,
     213,   214,   215,   216,     0,   217,   218,   219,     0,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,     0,   260,  1539,   261,     0,     0,     0,
     262,   263,     0,   264,   265,     0,   266,     0,   267,   268,
     269,   270,     0,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,     0,     0,   289,     0,
     290,   291,   292,   293,   294,     0,   295,     0,   296,  2196,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   320,   321,
     322,   323,     0,   324,   325,     0,   326,     0,   327,   328,
     329,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,   335,     0,     0,   336,   337,   338,   339,
     340,   341,     0,   342,   343,   344,   345,   346,   347,  1540,
     348,   349,   350,   351,   352,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,     0,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,   384,   385,   386,     0,   387,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     408,   409,     0,     0,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,     0,  1541,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,     0,   450,   171,   172,
     173,   174,   175,   581,   177,   178,   547,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,   548,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
     582,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   549,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   550,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,   171,   172,   173,   174,
     175,   176,   177,   178,   547,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,     0,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
     548,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   549,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   550,   380,   381,   382,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   408,   409,     0,     0,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     3,     4,     0,     0,
       0,     0,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,   455,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
     456,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,     0,   186,   187,   188,     0,
     189,     0,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
       0,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,     0,
       0,     0,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   270,     0,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,     0,     0,
     289,     0,   290,   291,   292,   293,   294,     0,   295,     0,
     296,     0,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,   314,   455,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,     0,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,   456,     0,
     610,   333,   334,     0,     0,   335,     0,     0,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,     0,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,   384,   385,   386,     0,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   408,   409,     0,     0,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   450,
     171,   172,   173,   174,   175,   176,   177,   178,   934,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,     0,   186,   187,   188,     0,   189,     0,
     190,   191,     0,   192,   193,   194,   195,   196,     0,     0,
     197,   198,   199,   200,     0,   201,   202,   203,   204,   205,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,     0,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,     0,   260,     0,   261,     0,     0,     0,
     262,   263,     0,   264,   265,     0,   266,     0,   267,   268,
     269,   270,     0,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,     0,     0,   289,     0,
     290,   291,   292,   293,   294,     0,   295,     0,   296,     0,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,   455,   315,   316,   317,   318,   319,   320,   321,
     322,   323,     0,   324,   325,     0,   326,     0,   327,   328,
     329,   330,   331,     0,     0,   332,   456,     0,     0,   333,
     334,     0,     0,   335,     0,     0,   336,   337,   338,   339,
     340,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,     0,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,   384,   385,   386,     0,   387,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     408,   409,     0,     0,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,     0,   450,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,  1313,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,  1314,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
    1315,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
     455,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,   456,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,  1316,   376,
     377,   378,   379,     0,  1317,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,  1318,  1319,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,     0,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
     548,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   549,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   550,   380,   381,   382,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   408,   409,     0,     0,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,  1940,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,  1941,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,   455,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
     456,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,  1942,   403,  1943,
     405,  1944,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,     0,   186,   187,   188,     0,
     189,     0,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
       0,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,     0,
       0,     0,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   270,     0,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,     0,     0,
     289,     0,   290,   291,   292,   293,   294,     0,   295,     0,
     296,     0,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,   314,   455,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,     0,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,   456,     0,
       0,   333,   334,     0,     0,   335,     0,     0,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,     0,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,   384,   385,   386,     0,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   408,   409,     0,     0,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   450,
     171,   172,   173,   174,   175,   176,   177,   178,  2079,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,     0,   186,   187,   188,     0,   189,     0,
     190,   191,     0,   192,   193,   194,   195,   196,     0,     0,
     197,   198,   199,   200,     0,   201,   202,   203,   204,   205,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,     0,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,     0,   260,     0,   261,     0,     0,     0,
     262,   263,     0,   264,   265,     0,   266,     0,   267,   268,
     269,   270,     0,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,     0,     0,   289,     0,
     290,   291,   292,   293,   294,     0,   295,     0,   296,     0,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   320,   321,
     322,   323,     0,   324,   325,     0,   326,     0,   327,   328,
     329,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,   335,     0,     0,   336,   337,   338,   339,
     340,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,     0,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,   384,   385,   386,     0,   387,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     408,   409,     0,     0,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
    2080,     0,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,     0,   450,   171,   172,
     173,   174,   175,   176,   177,   178,  2089,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,  2090,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,     0,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   408,   409,     0,     0,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,   171,   172,   173,   174,   175,   176,
     177,   178,   496,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   497,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,   171,   172,   173,   174,   175,   176,   177,   178,
     575,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,     0,   186,   187,   188,     0,
     189,     0,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
       0,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,     0,
       0,     0,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   270,     0,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,     0,     0,
     289,     0,   290,   291,   292,   293,   294,     0,   295,     0,
     296,     0,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,     0,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,     0,     0,
       0,   333,   334,     0,     0,   335,     0,     0,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,     0,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     576,     0,   383,   384,   385,   386,     0,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   577,   409,     0,     0,   578,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   450,
     171,   172,   173,   174,   175,   176,   177,   178,   601,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,     0,   186,   187,   188,     0,   189,     0,
     190,   191,     0,   192,   193,   194,   195,   196,     0,     0,
     197,   198,   199,   200,     0,   201,   202,   203,   204,   205,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,     0,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,     0,   260,     0,   261,     0,     0,     0,
     262,   263,     0,   264,   265,     0,   266,     0,   267,   268,
     269,   270,     0,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,     0,     0,   289,     0,
     290,   291,   292,   293,   294,     0,   295,     0,   296,     0,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   320,   321,
     322,   323,     0,   324,   325,     0,   326,     0,   327,   328,
     329,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,   335,     0,     0,   336,   337,   338,   339,
     340,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,     0,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   602,     0,
     383,   384,   385,   386,     0,   387,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     603,   409,     0,     0,   604,   411,   412,   413,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,     0,   450,   171,   172,
     173,   174,   175,   176,   177,   178,   765,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,   945,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   946,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   593,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     594,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   937,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   596,   409,     0,     0,
     597,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   598,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,  2227,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,  2240,
       0,   183,   184,     0,   185,     0,   186,   187,   188,     0,
     189,     0,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
       0,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,     0,
       0,     0,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   270,     0,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,     0,     0,
     289,     0,   290,   291,   292,   293,   294,     0,   295,     0,
     296,     0,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,     0,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,     0,     0,
       0,   333,   334,     0,     0,   335,     0,     0,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,     0,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,   384,   385,   386,     0,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   408,   409,     0,     0,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   450,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,     0,   186,   187,   188,     0,   189,     0,
     190,   191,     0,   192,   193,   194,   195,   196,     0,     0,
     197,   198,   199,   200,     0,   201,   202,   203,   204,   205,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,     0,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,     0,   260,     0,   261,     0,     0,     0,
     262,   263,     0,   264,   265,  2266,   266,     0,   267,   268,
     269,   270,     0,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,     0,     0,   289,     0,
     290,   291,   292,   293,   294,     0,   295,     0,   296,     0,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   320,   321,
     322,   323,     0,   324,   325,     0,   326,     0,   327,   328,
     329,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,   335,     0,     0,   336,   337,   338,   339,
     340,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,     0,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,   384,   385,   386,     0,   387,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     408,   409,     0,     0,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,     0,   450,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,  2829,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,     0,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
    2831,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   408,   409,     0,     0,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,  2833,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,     0,   186,   187,   188,     0,
     189,     0,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
       0,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,     0,
       0,     0,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   270,     0,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,     0,     0,
     289,     0,   290,   291,   292,   293,   294,     0,   295,     0,
     296,     0,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,     0,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,     0,     0,
       0,   333,   334,     0,     0,   335,     0,     0,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,     0,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,   384,   385,   386,     0,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   408,   409,     0,     0,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,  3142,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   450,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,     0,   186,   187,   188,     0,   189,     0,
     190,   191,     0,   192,   193,   194,   195,   196,     0,     0,
     197,   198,   199,   200,     0,   201,   202,   203,   204,   205,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,     0,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,     0,   260,     0,   261,     0,     0,     0,
     262,   263,     0,   264,   265,     0,   266,     0,   267,   268,
     269,   270,     0,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,     0,     0,   289,     0,
     290,   291,   292,   293,   294,     0,   295,     0,   296,     0,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   320,   321,
     322,   323,     0,   324,   325,     0,   326,     0,   327,   328,
     329,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,   335,     0,     0,   336,   337,   338,   339,
     340,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,     0,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,   384,   385,   386,     0,   387,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     408,   409,     0,     0,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,     0,   450,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   270,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   565,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,     0,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     369,   370,   371,   372,   373,   573,   375,   376,   377,   378,
     379,     0,   380,   381,   382,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   408,   409,     0,     0,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   591,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   592,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   593,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   594,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   595,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   596,   409,     0,     0,   597,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   598,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,     0,   186,   187,   188,     0,
     189,     0,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
       0,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,     0,
       0,     0,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   774,     0,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,     0,     0,
     289,     0,   290,   291,   292,   293,   294,     0,   295,     0,
     296,     0,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,     0,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,     0,     0,
       0,   333,   334,     0,     0,   335,     0,     0,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,     0,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,   384,   385,   386,     0,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   408,   409,     0,     0,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   450,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,     0,   186,   187,   188,     0,   189,     0,
     190,   191,     0,   192,   193,   194,   195,   196,     0,     0,
     197,   198,   199,   200,     0,   201,   202,   203,   204,   205,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,     0,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,     0,   260,     0,   261,     0,     0,     0,
     262,   263,     0,   264,   265,     0,   266,     0,   267,   268,
     269,   778,     0,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,     0,     0,   289,     0,
     290,   291,   292,   293,   294,     0,   295,     0,   296,     0,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   320,   321,
     322,   323,     0,   324,   325,     0,   326,     0,   327,   328,
     329,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,   335,     0,     0,   336,   337,   338,   339,
     340,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,     0,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,   384,   385,   386,     0,   387,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     408,   409,     0,     0,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,     0,   450,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   786,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,     0,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   788,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   408,   409,     0,     0,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   790,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,     0,   186,   187,   188,     0,
     189,     0,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
       0,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,     0,
       0,     0,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   793,     0,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,     0,     0,
     289,     0,   290,   291,   292,   293,   294,     0,   295,     0,
     296,     0,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,     0,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,     0,     0,
       0,   333,   334,     0,     0,   335,     0,     0,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,     0,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,   384,   385,   386,     0,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   408,   409,     0,     0,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   450,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,     0,   186,   187,   188,     0,   189,     0,
     190,   191,     0,   192,   193,   194,   195,   196,     0,     0,
     197,   198,   199,   200,     0,   201,   202,   203,   204,   205,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,     0,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,     0,   260,     0,   261,     0,     0,     0,
     262,   263,     0,   264,   265,     0,   266,     0,   267,   268,
     269,   795,     0,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,     0,     0,   289,     0,
     290,   291,   292,   293,   294,     0,   295,     0,   296,     0,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   320,   321,
     322,   323,     0,   324,   325,     0,   326,     0,   327,   328,
     329,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,   335,     0,     0,   336,   337,   338,   339,
     340,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,     0,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,   384,   385,   386,     0,   387,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     408,   409,     0,     0,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,     0,   450,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,   798,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,     0,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   593,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     594,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   937,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   596,   409,     0,     0,
     597,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   598,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,   961,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,     0,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   408,   409,     0,     0,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,     0,   186,   187,   188,     0,
     189,     0,   190,   191,     0,   192,   193,   194,   195,   196,
       0,     0,   197,   198,   199,   200,     0,   201,   202,   203,
     204,   205,     0,     0,   206,   207,   208,  1256,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
       0,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,     0,   260,     0,   261,     0,
       0,     0,   262,   263,     0,   264,   265,     0,   266,     0,
     267,   268,   269,   270,     0,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,     0,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,     0,     0,
     289,     0,   290,   291,   292,   293,   294,     0,   295,     0,
     296,     0,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
     320,   321,   322,   323,     0,   324,   325,     0,   326,     0,
     327,   328,   329,   330,   331,     0,     0,   332,     0,     0,
       0,   333,   334,     0,     0,   335,     0,     0,   336,   337,
     338,   339,   340,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,     0,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,   384,   385,   386,     0,   387,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,   408,   409,     0,     0,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,   450,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,     0,   186,   187,   188,     0,   189,     0,
     190,   191,     0,   192,   193,   194,   195,   196,     0,     0,
     197,   198,   199,   200,     0,   201,   202,   203,   204,   205,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,     0,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,     0,   260,     0,   261,     0,     0,     0,
     262,   263,     0,   264,   265,     0,   266,     0,   267,   268,
     269,  1279,     0,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,     0,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,     0,     0,   289,     0,
     290,   291,   292,   293,   294,     0,   295,     0,   296,     0,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   320,   321,
     322,   323,     0,   324,   325,     0,   326,     0,   327,   328,
     329,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,   335,     0,     0,   336,   337,   338,   339,
     340,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,     0,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,   384,   385,   386,     0,   387,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
     408,   409,     0,     0,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,     0,   450,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,     0,   186,   187,   188,     0,   189,     0,   190,   191,
       0,   192,   193,   194,   195,   196,     0,     0,   197,   198,
     199,   200,     0,   201,   202,   203,   204,   205,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,     0,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,     0,   260,     0,   261,     0,     0,     0,   262,   263,
       0,   264,   265,     0,   266,     0,   267,   268,   269,  1281,
       0,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,     0,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,     0,     0,   289,     0,   290,   291,
     292,   293,   294,     0,   295,     0,   296,     0,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   320,   321,   322,   323,
       0,   324,   325,     0,   326,     0,   327,   328,   329,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,   335,     0,     0,   336,   337,   338,   339,   340,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,     0,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,   384,
     385,   386,     0,   387,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,   408,   409,
       0,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,   450,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,     0,
     186,   187,   188,     0,   189,     0,   190,   191,     0,   192,
     193,   194,   195,   196,     0,     0,   197,   198,   199,   200,
       0,   201,   202,   203,   204,   205,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,     0,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,     0,
     260,     0,   261,     0,     0,     0,   262,   263,     0,   264,
     265,     0,   266,     0,   267,   268,   269,   270,     0,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,     0,     0,   289,     0,   290,   291,   292,   293,
     294,     0,   295,     0,   296,     0,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   320,   321,   322,   323,     0,   324,
     325,     0,   326,     0,   327,   328,   329,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,   335,
       0,     0,   336,   337,   338,   339,   340,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,     0,
     369,   370,   371,   372,   373,  1346,   375,   376,   377,   378,
     379,     0,   380,   381,   382,     0,   383,   384,   385,   386,
       0,   387,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,   408,   409,     0,     0,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,     0,   450,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,     0,   186,   187,
     188,     0,   189,     0,   190,   191,     0,   192,   193,   194,
     195,   196,     0,     0,   197,   198,   199,   200,     0,   201,
     202,   203,   204,   205,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,     0,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,     0,   260,     0,
     261,     0,     0,     0,   262,   263,     0,   264,   265,     0,
     266,     0,   267,   268,   269,   270,     0,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,     0,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
       0,     0,   289,     0,   290,   291,   292,   293,   294,     0,
     295,     0,   296,     0,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   593,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   320,   321,   322,   323,     0,   324,   325,     0,
     326,     0,   327,   328,   329,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,   335,     0,     0,
     336,   337,   338,   339,   340,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,     0,   594,   370,
     371,   372,   373,   374,  1560,   376,   377,   378,   379,     0,
     380,   381,   937,     0,   383,   384,   385,   386,     0,   387,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,   596,   409,     0,     0,   597,   411,
     412,   413,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   598,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   450,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,   632,   186,   187,   188,   633,
    1190,   634,  1191,  1192,     0,   192,   193,   194,   195,   196,
       0,     0,   197,  1193,  1194,   200,     0,   201,   202,   203,
     204,     0,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     635,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,  1195,  1196,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   857,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,     0,   253,   254,     0,
       0,   256,   257,   258,  1197,     0,   260,     0,   261,   636,
       0,   637,   262,   263,     0,   264,     0,     0,   266,     0,
     267,   268,   269,   270,   638,   271,   272,   273,  1564,   274,
     275,   276,   277,   278,   279,     0,   639,  1565,   281,   282,
     283,   284,  1198,  1199,     0,  1200,     0,   288,   640,   641,
     289,   642,   290,   291,   292,   293,   294,     0,     0,   643,
     296,   644,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,  1201,   645,  1202,     0,   315,   316,   317,   318,   319,
     320,   321,     0,   323,     0,   324,   325,   646,   326,     0,
       0,   328,  1203,   330,   331,     0,     0,   332,     0,     0,
       0,   333,   334,     0,     0,  1566,   647,   648,     0,   337,
     338,   339,   340,   341,     0,   342,     0,     0,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,  1204,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   649,   369,   370,     0,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,  1567,   385,   386,   650,   387,  1206,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,  1207,  1208,     0,     0,   410,     0,   412,     0,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,     0,  1209,
     429,   651,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,     0,     0,     0,     0,     0,     0,     0,
       0,   447,   448,   449,     0,     0,     0,     0,     0,  1210,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,   632,   186,   187,   188,   633,  1190,   634,
    1191,  1192,     0,   192,   193,   194,   195,   196,     0,     0,
     197,  1193,  1194,   200,     0,   201,   202,   203,   204,     0,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   635,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,  1195,  1196,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     857,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,     0,   253,   254,     0,     0,   256,
     257,   258,  1197,     0,   260,     0,   261,   636,     0,   637,
     262,   263,     0,   264,     0,     0,   266,     0,   267,   268,
     269,   270,   638,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,   639,     0,   281,   282,   283,   284,
    1198,  1199,     0,  1200,     0,   288,   640,   641,   289,   642,
     290,   291,   292,   293,   294,     0,     0,   643,   296,   644,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,  1201,
     645,  1202,     0,   315,   316,   317,   318,   319,   320,   321,
    1586,   323,     0,   324,   325,   646,   326,     0,     0,   328,
    1203,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,     0,   647,   648,     0,   337,   338,   339,
     340,   341,     0,   342,     0,     0,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,  1204,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   649,   369,   370,     0,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,  1205,   385,   386,   650,   387,  1206,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
    1207,  1208,     0,     0,   410,     0,   412,     0,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,     0,  1209,   429,   651,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,     0,     0,     0,     0,     0,     0,     0,     0,   447,
     448,   449,     0,     0,     0,     0,     0,  1210,   171,   172,
     173,   174,   175,   176,   177,   178,     0,   180,   181,   182,
       0,     0,     0,     0,     0,     0,     0,   183,   184,     0,
     185,   632,   186,   187,   188,   633,  1190,   634,  1191,  1192,
       0,   192,   193,   194,   195,   196,     0,     0,   197,  1193,
    1194,   200,     0,   201,   202,   203,   204,     0,     0,     0,
     206,   207,   208,   209,   210,   211,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   635,   220,   221,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,  1195,
    1196,   229,     0,   230,     0,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,     0,   239,   240,   857,   242,
     243,     0,   244,   245,   246,     0,   247,   248,     0,   249,
     250,   251,     0,   253,   254,     0,     0,   256,   257,   258,
    1197,     0,   260,     0,   261,   636,     0,   637,   262,   263,
       0,   264,     0,     0,   266,     0,   267,   268,   269,   270,
     638,   271,   272,   273,     0,   274,   275,   276,   277,   278,
     279,     0,   639,     0,   281,   282,   283,   284,  1198,  1199,
       0,  1200,     0,   288,   640,   641,   289,   642,   290,   291,
     292,   293,   294,     0,     0,   643,   296,   644,     0,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,  1201,   645,  1202,
       0,   315,   316,   317,   318,   319,   320,   321,  2452,   323,
       0,   324,   325,   646,   326,     0,     0,   328,  1203,   330,
     331,     0,     0,   332,     0,     0,     0,   333,   334,     0,
       0,     0,   647,   648,     0,   337,   338,   339,   340,   341,
       0,   342,     0,     0,   345,   346,   347,     0,   348,   349,
     350,   351,   352,   353,  1204,   355,   356,     0,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   649,   369,   370,     0,   372,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,     0,   383,  1205,
     385,   386,   650,   387,  1206,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,   400,     0,   401,
     402,     0,   403,   404,   405,   406,   407,     0,  1207,  1208,
       0,     0,   410,     0,   412,     0,     0,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,     0,     0,
     423,   424,   425,   426,     0,  1209,   429,   651,   430,   431,
     432,     0,     0,   433,   434,   435,   436,   437,   438,     0,
       0,     0,     0,     0,     0,     0,     0,   447,   448,   449,
       0,     0,     0,     0,     0,  1210,   171,   172,   173,   174,
     175,   176,   177,   178,     0,   180,   181,   182,     0,     0,
       0,     0,     0,     0,     0,   183,   184,     0,   185,   632,
     186,   187,   188,   633,  1190,   634,  1191,  1192,     0,   192,
     193,   194,   195,   196,     0,     0,   197,  1193,  1194,   200,
       0,   201,   202,   203,   204,     0,     0,     0,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   635,   220,   221,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,  1195,  1196,   229,
       0,   230,     0,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,     0,   239,   240,   857,   242,   243,     0,
     244,   245,   246,     0,   247,   248,     0,   249,   250,   251,
       0,   253,   254,     0,     0,   256,   257,   258,  1197,     0,
     260,     0,   261,   636,     0,   637,   262,   263,     0,   264,
       0,     0,   266,     0,   267,   268,   269,   270,   638,   271,
     272,   273,     0,   274,   275,   276,   277,   278,   279,     0,
     639,     0,   281,   282,   283,   284,  1198,  1199,     0,  1200,
       0,   288,   640,   641,   289,   642,   290,   291,   292,   293,
     294,     0,     0,   643,   296,   644,     0,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,  1201,   645,  1202,     0,   315,
     316,   317,   318,   319,   320,   321,     0,   323,     0,   324,
     325,   646,   326,  1556,     0,   328,  1203,   330,   331,     0,
       0,   332,     0,     0,     0,   333,   334,     0,     0,     0,
     647,   648,     0,   337,   338,   339,   340,   341,     0,   342,
       0,     0,   345,   346,   347,     0,   348,   349,   350,   351,
     352,   353,  1204,   355,   356,     0,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   649,
     369,   370,     0,   372,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,     0,   383,  1567,   385,   386,
     650,   387,  1206,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,   400,     0,   401,   402,     0,
     403,   404,   405,   406,   407,     0,  1207,  1208,     0,     0,
     410,     0,   412,     0,     0,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,     0,     0,   423,   424,
     425,   426,     0,  1209,   429,   651,   430,   431,   432,     0,
       0,   433,   434,   435,   436,   437,   438,     0,     0,     0,
       0,     0,     0,     0,     0,   447,   448,   449,     0,     0,
       0,     0,     0,  1210,   171,   172,   173,   174,   175,   176,
     177,   178,     0,   180,   181,   182,     0,     0,     0,     0,
       0,     0,     0,   183,   184,     0,   185,   632,   186,   187,
     188,   633,  1190,   634,  1191,  1192,     0,   192,   193,   194,
     195,   196,     0,     0,   197,  1193,  1194,   200,     0,   201,
     202,   203,   204,     0,     0,     0,   206,   207,   208,   209,
     210,   211,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   635,   220,   221,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,  1195,  1196,   229,     0,   230,
       0,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,     0,   239,   240,   857,   242,   243,     0,   244,   245,
     246,     0,   247,   248,     0,   249,   250,   251,     0,   253,
     254,     0,     0,   256,   257,   258,  1197,     0,   260,     0,
     261,   636,     0,   637,   262,   263,     0,   264,     0,     0,
     266,     0,   267,   268,   269,   270,   638,   271,   272,   273,
       0,   274,   275,   276,   277,   278,   279,     0,   639,     0,
     281,   282,   283,   284,  1198,  1199,     0,  1200,     0,   288,
     640,   641,   289,   642,   290,   291,   292,   293,   294,     0,
       0,   643,   296,   644,     0,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,  1201,   645,  1202,     0,   315,   316,   317,
     318,   319,   320,   321,     0,   323,     0,   324,   325,   646,
     326,     0,     0,   328,  1203,   330,   331,     0,     0,   332,
       0,     0,     0,   333,   334,     0,     0,     0,   647,   648,
       0,   337,   338,   339,   340,   341,     0,   342,     0,     0,
     345,   346,   347,     0,   348,   349,   350,   351,   352,   353,
    1204,   355,   356,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   649,   369,   370,
       0,   372,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,     0,   383,  1205,   385,   386,   650,   387,
    1206,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,   400,     0,   401,   402,     0,   403,   404,
     405,   406,   407,     0,  1207,  1208,     0,     0,   410,     0,
     412,     0,     0,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,     0,     0,   423,   424,   425,   426,
       0,  1209,   429,   651,   430,   431,   432,     0,     0,   433,
     434,   435,   436,   437,   438,     0,     0,     0,     0,     0,
       0,     0,     0,   447,   448,   449,     0,     0,     0,     0,
       0,  1210,   171,   172,   173,   174,   175,   176,   177,   178,
       0,   180,   181,   182,     0,     0,     0,     0,     0,     0,
       0,   183,   184,     0,   185,   632,   186,   187,   188,   633,
    1190,   634,  1191,  1192,     0,   192,   193,   194,   195,   196,
       0,     0,   197,  1193,  1194,   200,     0,   201,   202,   203,
     204,     0,     0,     0,   206,   207,   208,   209,   210,   211,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     635,   220,   221,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,  1195,  1196,   229,     0,   230,     0,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,     0,
     239,   240,   857,   242,   243,     0,   244,   245,   246,     0,
     247,   248,     0,   249,   250,   251,     0,   253,   254,     0,
       0,   256,   257,   258,  1197,     0,   260,     0,   261,   636,
       0,   637,   262,   263,     0,   264,     0,     0,   266,     0,
     267,   268,   269,   270,   638,   271,   272,   273,     0,   274,
     275,   276,   277,   278,   279,     0,   639,     0,   281,   282,
     283,   284,  1198,  1199,     0,  1200,     0,   288,   640,   641,
     289,   642,   290,   291,   292,   293,   294,     0,     0,   643,
     296,   644,     0,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,  1201,   645,  1202,     0,   315,   316,   317,   318,   319,
     320,   321,     0,   323,     0,   324,   325,   646,   326,     0,
       0,   328,  1203,   330,   331,     0,     0,   332,     0,     0,
       0,   333,   334,     0,     0,     0,   647,   648,     0,   337,
     338,   339,   340,   341,     0,   342,     0,     0,   345,   346,
     347,     0,   348,   349,   350,   351,   352,   353,  1204,   355,
     356,     0,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   649,   369,   370,     0,   372,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,     0,   383,  1567,   385,   386,   650,   387,  1206,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,   400,     0,   401,   402,     0,   403,   404,   405,   406,
     407,     0,  1207,  1208,     0,     0,   410,     0,   412,     0,
       0,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,     0,     0,   423,   424,   425,   426,     0,  1209,
     429,   651,   430,   431,   432,     0,     0,   433,   434,   435,
     436,   437,   438,     0,     0,     0,     0,     0,     0,     0,
       0,   447,   448,   449,     0,     0,     0,     0,     0,  1210,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   180,
     181,   182,     0,     0,     0,     0,     0,     0,     0,   183,
     184,     0,   185,   632,   186,   187,   188,   633,  1190,   634,
    1191,  1192,     0,   192,   193,   194,   195,   196,     0,     0,
     197,  1193,  1194,   200,     0,   201,   202,   203,   204,     0,
       0,     0,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   635,   220,
     221,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,  1195,  1196,   229,     0,   230,     0,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,     0,   239,   240,
     857,   242,   243,     0,   244,   245,   246,     0,   247,   248,
       0,   249,   250,   251,     0,   253,   254,     0,     0,   256,
     257,   258,  1197,     0,   260,     0,   261,   636,     0,   637,
     262,   263,     0,   264,     0,     0,   266,     0,   267,   268,
     269,   270,   638,   271,   272,   273,     0,   274,   275,   276,
     277,   278,   279,     0,   639,     0,   281,   282,   283,   284,
    1198,  1199,     0,  1200,     0,   288,   640,   641,   289,   642,
     290,   291,   292,   293,   294,     0,     0,   643,   296,   644,
       0,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,  1201,
     645,  1202,     0,   315,   316,   317,   318,   319,   320,   321,
       0,   323,     0,   324,   325,   646,   326,     0,     0,   328,
    1203,   330,   331,     0,     0,   332,     0,     0,     0,   333,
     334,     0,     0,     0,   647,   648,     0,   337,   338,   339,
     340,   341,     0,   342,     0,     0,   345,   346,   347,     0,
     348,   349,   350,   351,   352,   353,  1204,   355,   356,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   649,   369,   370,     0,   372,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,     0,
     383,     0,   385,   386,   650,   387,  1206,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,   400,
       0,   401,   402,     0,   403,   404,   405,   406,   407,     0,
    1207,  1208,     0,     0,   410,     0,   412,     0,     0,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
       0,     0,   423,   424,   425,   426,     0,  1209,   429,   651,
     430,   431,   432,     0,     0,   433,   434,   435,   436,   437,
     438,     0,     0,     0,     0,     0,     0,     0,     0,   447,
     448,   449,     0,     0,     0,     0,     0,  1210
};

static const yytype_int16 yycheck[] =
{
       0,    46,   157,   561,     0,  1253,    41,   777,   478,   631,
    1284,    11,   659,    21,   699,  1299,  1205,   747,   702,    27,
     155,   823,   855,   856,   159,   755,    12,   597,  1314,   884,
     702,   836,   167,   591,   801,   594,     0,     0,    22,   684,
       0,   874,    34,   150,   514,   948,    46,   154,   693,   607,
      34,  1817,    43,  1585,   734,  1414,  1349,     7,     8,  1740,
    1232,  1999,   457,    13,    14,  1791,  1237,  1237,  1237,    19,
    1265,    21,    22,  1237,    24,  1237,   472,    27,    28,    29,
     704,  1237,    32,    33,    34,  2188,    36,  1490,    38,    39,
     770,   667,    42,   738,  2217,  2417,  1751,   742,  1745,  1746,
    2563,     0,     0,    38,   749,   994,  1009,   532,  1360,  1361,
      17,   756,  1015,   509,  1499,   705,  1368,  1496,     0,    20,
    1372,  1373,  1571,  1572,   847,   848,   663,    39,    45,    11,
      32,    39,     0,   736,    39,  1387,    25,  1389,     0,     0,
     907,     0,    25,    87,    87,  2337,   111,   870,    39,     0,
       5,    14,    47,    87,    87,    24,   131,    11,    24,  1411,
      11,  1413,  1694,   116,    18,   156,    11,    11,     7,    47,
     161,   162,   762,    82,    18,   131,    54,   168,  2167,  2168,
    2169,  2170,    54,    61,   131,    11,  1663,    67,   131,   167,
      57,  3007,    18,    39,    47,   113,   115,   133,   228,    87,
     131,   151,   152,   153,    19,   155,    86,   157,    61,   159,
     160,   136,    92,   163,    51,   165,   166,   167,     7,   134,
     823,     7,    25,  2858,     7,   149,    82,    13,    92,  1761,
    2622,  1763,  2624,   128,   143,   225,   116,   241,   797,  3046,
      92,   106,    59,  3029,  1416,    12,   225,   165,   718,    89,
     128,    45,   261,    45,   231,    87,   251,    87,   653,   133,
     115,    17,   266,    23,   949,   104,   207,   317,  1171,   325,
      91,   186,   220,   306,   307,   128,    67,   279,    89,    96,
     351,   161,    21,   281,  2747,  2961,   195,   143,   325,   198,
     138,   359,    90,    25,   279,    63,   232,   161,   281,   183,
     327,    94,  1032,   241,   241,   359,    26,   131,   400,   230,
     994,   382,  1382,   115,   406,   104,   156,   235,   104,   304,
      25,   104,   994,   478,   133,   149,    46,   215,   266,   266,
     401,   329,   327,   101,   361,   288,  3012,  3123,   406,   195,
     342,   476,   198,   227,   135,   480,   329,   168,   146,   382,
     406,   401,   406,  1208,   288,   490,    95,   252,   131,   514,
     272,   468,  1195,  1196,   272,   989,   361,   272,    25,   406,
    1203,   401,   308,  1443,   252,   215,   295,   286,  1567,  2842,
    1654,   272,   325,   215,  3191,   362,   945,   990,   148,  3024,
     220,   228,   401,  1078,   325,   162,   349,   401,   505,   252,
    1170,   246,   241,   318,   511,   320,   269,   281,   288,   220,
     220,   401,  3088,   169,  2877,   349,  1795,   305,   281,   337,
     308,  1024,   401,   232,   279,   242,   272,   227,   406,   277,
     286,   406,   373,  1685,   382,  1038,   401,  3253,   382,   382,
     295,  2430,   386,   338,   313,   388,   300,   313,   401,   382,
     406,   283,    59,   325,   293,   241,   300,  1187,   241,   406,
     338,   404,   342,   372,   169,   170,   329,   401,   335,   349,
    1193,  1194,  2664,   318,   300,   320,   232,   266,   342,  1202,
     266,   406,   406,   266,   401,   338,  1023,  1167,  1258,    96,
     342,   356,   401,   295,   406,  2433,  2434,  2960,   406,   401,
     401,   406,   319,  2895,   386,   394,   395,   396,   397,   500,
    1889,   393,   169,   218,   403,   406,   372,    39,   131,   469,
     403,   401,   472,   405,   474,   533,   476,   535,   478,   537,
     480,   481,   482,   541,   929,   386,   486,   405,   488,  1184,
     490,   966,   393,   405,   405,  1740,   405,   497,  1232,  2230,
     279,   344,   325,  2234,   405,   462,   506,   351,  2547,   509,
    1232,   126,   512,   718,   514,  1168,   516,   517,  2017,  1039,
    2019,   521,   382,   523,    17,   525,  1223,   195,   528,    87,
    1965,  1348,  1349,  1186,   399,   492,   401,   402,   382,   404,
     382,   406,  1359,   104,   397,  1362,  2128,  2129,   132,  1958,
     403,   708,  1205,  1370,  1371,    92,   406,   401,   715,   401,
      30,   167,   169,  1382,  1071,   388,  1383,  1384,   568,   382,
     570,   266,   622,   573,    32,  1228,   622,  1394,    11,   385,
     171,   404,   388,   389,   390,   242,   392,   393,   394,   395,
     396,   397,   592,  1532,   594,   595,  2123,   403,   293,  2126,
    2127,  1374,  1375,    99,    61,   101,   763,   592,   622,   622,
     595,   611,   622,  2140,    92,    89,  1256,    59,   286,    59,
    1273,    79,   401,   230,   161,   121,   104,  3140,    81,   316,
      87,  1284,  1449,   295,    99,   207,   101,   392,   393,   394,
     395,   396,   397,  1596,   169,  1254,  1599,  1600,   403,    99,
    2149,   101,   240,   268,    96,  1957,    96,   215,  1880,   243,
     171,    91,   319,  1885,   132,    60,    99,   258,   668,   669,
     386,   121,   327,   622,   622,   145,   169,  3190,  2177,   149,
     342,   463,  1416,    47,   400,   392,   393,   394,   395,   396,
     397,  3144,  3145,   401,  1416,   695,   403,  2850,    92,   152,
     272,  2314,   160,  1948,  2877,   705,  2411,   143,   132,  1317,
    1318,   711,   182,   108,   298,   268,   266,  2216,   718,   215,
     720,   293,  1229,    87,   220,  2338,   726,  1401,  1235,   225,
     730,    90,   293,   157,  1408,  1855,  1856,   737,   168,   232,
    1860,   215,  1249,   293,   405,   745,   746,   258,   172,   207,
      38,   288,  2054,   803,   359,   134,   180,   803,   215,   195,
     225,   761,   762,  1283,   764,   283,   241,   161,   818,  3222,
     220,   249,   818,   334,  1448,   225,     0,    80,    66,  1899,
    1900,   781,   782,   565,   126,   785,  1439,   146,   352,   803,
     803,   841,    92,   803,   189,    92,    11,   797,  1532,   317,
     242,   406,   242,   585,  1687,   342,   359,   186,   858,    90,
    1532,   593,   907,   813,    17,   406,   816,   817,   293,  2807,
     406,   821,   241,  3195,  3196,   825,   284,   297,  1274,   285,
     251,   119,    62,   833,  1039,   331,  3146,   837,   888,   839,
     175,   183,   360,   339,   394,   169,   241,   266,   126,  1629,
     286,   215,   276,   406,  2156,  2157,   220,   907,    88,   147,
    1380,   161,   315,   316,   161,   146,   325,   392,   393,   394,
     395,   396,   397,   113,   293,  2651,  3248,   319,   403,   319,
    2178,   331,  2613,   401,    99,   227,   126,  2618,   252,   339,
    2621,   194,   385,   196,   288,   388,   389,   390,   262,   392,
     393,   394,   395,   396,   397,   183,   327,   344,  1603,  1604,
     403,   288,  2609,  3223,  1567,   230,   216,   217,  1571,  1572,
     217,   241,   317,   153,   319,   165,   317,   977,   978,  2265,
     980,  2255,  1712,  1713,  1714,  1715,  1756,  3247,   230,   318,
     361,   320,   241,   183,   126,   945,   266,   401,   342,   227,
    2293,   733,   952,   953,  2176,   349,  2409,  1583,  2179,  2179,
    2179,   961,   144,   963,   329,  2179,   169,  2179,   241,   360,
    2497,   270,   349,  2179,   338,   354,  2503,  2504,  2505,  2506,
    2507,  2508,   270,   281,   272,  2230,   274,   227,   288,  2234,
     215,   288,   280,   266,   293,   235,   268,   270,   998,   287,
     266,  1654,  1003,   241,   270,   293,  2994,   401,  1825,    99,
     401,   101,    87,   301,    62,  2597,   258,  1017,   114,   289,
     293,   309,  1752,  1676,   401,   382,  1067,   293,   266,   232,
     266,   329,   257,   289,   270,   255,  1855,  1856,  3131,  1039,
      88,  1860,   342,   382,   401,   342,   316,  1048,  2630,   349,
    2632,  1236,   349,   295,   150,    82,  1873,   293,   401,  2149,
     316,   404,   401,  1063,  1064,  1065,  1066,   355,   392,   393,
     394,   395,   396,   397,   285,   359,   360,   241,  1283,   403,
    1899,  1900,   359,   360,   354,  1902,   359,  2177,  1534,   660,
     241,   166,    64,   359,  3187,     9,  2912,   337,   354,  3192,
     342,   401,   266,   397,   401,   153,   270,   152,  1265,   403,
    1267,   186,  2065,   684,    28,   266,   143,   401,  1275,  2072,
    2073,  1938,   693,   359,   401,   215,     7,   909,  3221,   293,
     144,  2353,    13,  1950,  1951,   225,  2545,   919,   400,  2022,
     977,   978,    36,   980,   406,   151,  1880,   153,   930,    71,
     382,  1885,   402,   285,  1807,   382,   406,  1314,  1880,   399,
     166,  2892,   402,  1885,   404,  1774,   948,   401,   195,   401,
      51,   198,  1172,  1173,   401,  1380,   359,   360,  1178,    37,
    1180,  1872,   385,  1874,  1875,   388,   389,   390,   258,   392,
     393,   394,   395,   396,   397,   175,  2149,   267,  2318,   382,
     403,  2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,
     132,  2331,   399,   382,     5,  1265,    97,   404,   401,    10,
     290,   402,    80,   104,  2177,   406,   107,    18,   359,   360,
    1325,  2533,   401,   382,   382,   157,  1236,   254,  1238,   386,
    1240,  1241,  1242,  1243,    35,   382,   393,  2549,    15,    16,
     172,   382,   401,   401,  1254,     8,  1256,   386,   180,   286,
    2380,  2381,    47,   382,   401,  2792,  2793,  2794,  1304,   318,
     401,   320,    54,   154,  1274,  1325,    61,  1277,  1278,    61,
     399,   203,   401,  1283,  1334,   404,  1286,  1287,  1334,  1289,
      43,   402,  1966,   151,  1294,   406,  1296,  2706,   230,  1299,
    1300,  1343,    87,  1748,    89,   380,   381,   382,  1342,   381,
     399,   386,   401,  1313,   386,  1315,  1316,  2014,   393,  1319,
    1334,  1334,   401,   396,  1334,  1325,   207,   381,   401,    25,
    1049,   404,   386,  1052,    30,  1955,   194,  1056,   196,   393,
      26,    33,  1342,  1343,  1529,   372,  1346,    39,  1533,   207,
     318,   374,   320,   380,   276,   382,   394,   395,   396,   397,
     241,    36,  1547,  2016,  2017,   403,  2019,   396,  2613,  1554,
    1420,   156,   401,  2618,   402,   404,  2621,   171,   406,  2032,
    1380,  2034,   240,   404,   402,   266,  2514,  2515,   406,   270,
    2518,  1576,  2520,  1578,   402,    44,    45,   150,   406,  1919,
     402,   154,   402,   156,   406,  1590,   406,  1592,   161,   162,
     402,   233,   293,   271,   406,   168,   112,   402,   399,   233,
     401,   406,  2075,   404,   402,   402,  2206,  2244,   406,   406,
     215,  2286,   375,   376,  3016,   220,  2556,  2342,  2343,   402,
     402,  1626,  2176,   406,   406,   303,   827,   828,  1633,   145,
    1635,  2753,  2754,   149,  2176,    17,  2758,  2759,   402,  2986,
     402,   402,   406,   405,  2703,   406,   402,   252,   474,   230,
     406,  2124,   402,   169,   170,   402,   406,   262,   318,   406,
     320,   402,   488,   402,   402,   406,   182,   406,   406,   402,
    1490,    61,   401,   406,   402,   404,  2149,   402,   406,  2318,
    1500,   406,  2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,
    2329,   402,  2331,   402,   402,   406,   402,   406,   406,   402,
     406,   325,   218,   406,  2177,   402,  2378,   402,   405,  1529,
    1530,   406,  2349,  1533,  1534,   230,   232,   402,  1538,  2192,
    1397,   406,   374,  1400,  1544,  2843,  2955,  1547,   977,   978,
    1550,   980,  2205,   338,  1554,  1555,  2439,   377,   378,   379,
    1560,  2380,  2381,  2216,   134,   233,   402,   402,   402,  2243,
     406,   406,   406,   318,    26,   320,  1576,  1577,  1578,  1579,
     171,  1581,   152,  1740,  1584,  1585,   374,   402,  2708,  2709,
    1590,   406,  1592,  1593,  1594,  1595,  2249,  1978,  1979,   402,
    2274,   297,  2255,   406,   359,   360,  2215,   169,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,   394,   186,  1617,  1618,  2353,
     293,  1621,  1622,  1623,   402,   402,  1626,  1627,   406,   406,
    2875,  2353,   130,  1633,  1634,  1635,     7,  1637,   402,   402,
     402,    36,    13,   406,   406,  1740,  2299,  2892,   402,  1649,
     402,   402,   406,   402,   406,   406,  1656,  1657,  1658,  1659,
    1660,  1661,   668,   669,   234,  1701,   359,   360,  3004,  2404,
     232,    25,   359,   360,   402,  1725,    30,  2330,   406,  1725,
      51,   359,   360,   402,   402,  1467,  2360,   406,   406,   385,
    1740,  2344,   401,   626,  1694,   628,   392,   393,   394,   395,
     396,   397,  1702,   404,   402,   402,   230,   403,   406,   406,
    1980,  1981,   402,   466,  1919,   468,   406,   402,  2235,   402,
    2237,   406,  1722,   406,   730,  2378,    97,  1727,   402,   266,
     402,   402,   406,   104,   406,   406,   107,  2556,   401,   745,
     746,  1741,   169,   401,   404,  1745,  1746,   500,   318,   181,
     320,   401,   505,   224,   285,   761,   175,   401,   511,   329,
    1760,  1761,  1762,  1763,  3098,   401,  3100,    47,   338,  1974,
     359,    20,   149,   401,  1774,   781,   782,   241,    26,    26,
     344,   175,    25,   154,   117,   117,   401,    30,   117,  1789,
     117,  1948,   169,   117,   406,   149,  3041,  2917,   117,   401,
    1985,   117,   555,   117,   230,   232,   117,  1902,   561,   117,
     230,   117,   117,  1813,    20,   169,   170,  1817,   127,   572,
    2473,  2941,  2942,   385,  2604,   181,   388,   389,   390,   126,
     392,   393,   394,   395,   396,   397,   207,   126,   591,  3163,
     401,   403,   382,   382,   401,   401,   401,   401,   799,   248,
     401,   401,  1902,   401,   607,   232,   382,   610,  1943,  1944,
    3158,   382,  2714,   401,   218,   401,  1916,   401,   401,   112,
     241,   624,   401,  1655,   401,   382,  2693,   382,   232,   401,
     238,  1663,   401,   401,    32,   401,  1936,   401,   401,  2708,
    2709,  1891,   401,   401,   406,   401,  3141,  2594,  1948,   270,
     401,   401,   145,    20,   401,    73,   149,   181,   401,   126,
     126,   325,   325,   404,  2567,   325,   325,   325,   230,  1919,
     287,   325,   293,   325,    72,   220,   169,   170,   325,  1711,
     406,   343,  2117,   325,   325,   325,    71,   344,   344,   182,
     325,   325,   325,   283,  2149,    93,    54,  3067,   230,  1731,
     154,   406,   325,   325,   707,   708,   325,   283,   385,  1959,
     325,   325,   715,  1963,   112,   392,   393,   394,   395,   396,
     397,   169,  2177,   230,   230,   218,   403,  1977,   401,   127,
     169,   359,    20,   401,   401,  1985,  1986,  1987,   351,   232,
     401,    19,     9,   141,    87,   344,   189,   132,    20,  1999,
     126,   354,   230,   284,   757,   758,   759,   958,   385,    20,
     763,   388,   389,   390,   357,   392,   393,   394,   395,   396,
     397,   117,   157,   344,   344,   117,   403,   117,   273,   325,
     131,   385,   349,   219,   232,   401,  2036,   172,   392,   393,
     394,   395,   396,   397,   386,   180,   356,   323,     0,   403,
    2703,   323,  2052,   200,   297,   200,  2056,  1063,  1064,  1065,
    1066,  2714,   815,   293,   403,   406,  2738,   401,   203,  2921,
     323,  2071,   220,  2230,   325,   512,   401,  2234,   131,   516,
     228,  2266,   165,   836,  2084,  2085,  2086,  2087,   525,   327,
     388,   406,   231,   406,   225,   230,   183,    17,  2917,   402,
     402,    20,  2755,  2288,   325,    25,   325,  2802,  2265,   257,
      30,   283,    60,   401,   173,    67,   173,  2117,  2118,    38,
     220,   220,  2941,  2942,   401,   220,     7,   230,  2128,  2129,
     236,   406,    13,    14,   402,  2952,   406,    36,    19,    36,
      21,   276,   385,  2143,   266,   266,    27,    66,    29,   392,
     393,   394,   395,   396,   397,   266,   325,   169,   325,  2209,
     403,   113,    20,  2209,   258,   169,  1172,  1173,   169,   344,
     344,   169,  1178,  2223,   126,   388,   228,  2223,    19,   131,
    2230,   399,   325,   135,  2234,   399,   138,   385,   140,   113,
     388,   389,   390,  2193,   392,   393,   394,   395,   396,   397,
     119,   325,   126,   126,   388,   403,   959,   325,   234,   344,
    2210,   325,   230,   165,   401,  2215,  3068,    20,   139,   126,
     230,  2741,  2272,   406,  2224,   145,  2272,  2227,   147,   149,
     142,   183,   142,    20,  1240,  1241,  1242,  1243,  3090,   401,
    2240,   165,  3094,  3095,  2897,   401,   230,   402,  3067,   169,
     170,   230,   316,   406,     8,  3072,   175,   136,   197,   183,
     230,    36,   182,   131,   406,   402,  2266,   374,  2921,  2051,
     402,  3091,   402,  2273,   402,   227,   374,   169,   131,   160,
     325,   406,   163,   235,   165,  2285,   402,   402,  2288,   402,
     402,   357,   402,  2388,  1300,   215,   374,   402,   218,   401,
    2485,  1054,  2487,   227,   401,  2390,  2391,  2392,  2393,   183,
     401,   235,   232,   402,  1067,   159,   402,  1268,   402,   220,
     402,   273,   402,   402,   401,  1276,   241,   183,   244,   325,
     244,   192,   341,   192,  1285,   192,   325,   325,  2388,   325,
     232,  2123,   325,   325,  2126,  2127,   169,  1298,   785,   113,
     325,   270,   325,   402,   169,   274,   169,   169,  2140,   169,
     169,   280,   126,   232,   316,  2147,   380,  2149,   287,   169,
     399,   402,   198,   286,   293,   402,   230,   297,   183,   816,
     388,   334,   301,   268,   230,   337,   401,   406,   825,   402,
     309,   228,   325,   344,   230,  2177,   402,  2455,   401,   172,
     837,   165,   237,   172,   401,   357,   225,  2189,  3228,  2409,
     344,   233,   344,   337,   406,  3068,   115,   115,   399,   183,
    3028,   110,   131,   403,   126,   377,   378,   379,   402,    45,
     402,   402,  2214,  2433,  2434,   353,   355,  3090,   131,   401,
     359,  3094,  3095,   402,   138,   402,  2966,   399,   388,   159,
     402,   401,   404,   405,   334,   325,  2613,  2457,  2458,   325,
     325,  2618,   325,   227,  2621,   385,   126,   402,   388,   389,
     390,   235,   392,   393,   394,   395,   396,   397,   325,   169,
      20,  2481,   169,   403,   169,  2485,  2486,  2487,  2488,  2489,
    2490,  2491,   400,   385,   400,   173,   401,   389,   390,   359,
     392,   393,   394,   395,   396,   397,   126,   234,   155,    56,
    3163,   403,  1265,   317,  1267,   347,   385,   401,   406,   388,
     389,   390,  1275,   392,   393,   394,   395,   396,   397,   401,
     172,   402,    20,   135,   401,  1288,  2741,   131,   402,   401,
     131,   358,  1295,    36,   358,   140,   334,   402,   220,   401,
     220,  2551,  2552,  2553,   402,  2555,   406,   402,   344,   117,
     169,  1314,    94,  2613,  1317,  1318,  2751,   406,  2618,   220,
      89,  2621,   406,   337,   156,   400,  1329,  2762,  2578,  2764,
     133,  2581,  2364,   133,  2584,   131,  2586,   344,   469,   344,
     105,   116,    47,    47,   402,   401,   233,  2597,   174,   401,
     131,   482,   325,   401,   116,   486,   233,   131,   401,  2609,
     401,  2611,   348,   402,   302,   359,   497,   402,   402,   262,
     401,  2403,  2622,   401,  2624,   506,  2626,   126,    20,   406,
    2630,   220,  2632,   193,   152,   256,   517,   233,   230,   280,
     521,   280,   523,  1649,  2644,   233,   126,   122,   317,   105,
    1656,  1657,  1658,  1659,  1660,  1661,   348,    17,   406,   359,
     230,    20,   230,    20,   401,    25,   100,   402,   279,    92,
      30,   342,   116,     6,  2456,   261,   256,   401,   622,    38,
    1700,  2463,   953,  2465,  1959,  2743,  1625,   568,  2076,   570,
    2990,  2584,  1445,  2581,  2470,  1855,  1856,  1608,  2147,  2836,
    1860,    17,  2143,  1996,  3203,  3227,  3182,    66,  3181,    25,
    3211,  2586,  2264,  2774,    30,  2497,  2869,  3284,  2875,  1689,
    1250,  2503,  2504,  2505,  2506,  2507,  2508,  3261,  2176,  2815,
    2814,  2177,  3218,  2151,  2968,  2892,  1230,  3229,  2971,  1899,
    1900,  2741,    27,   817,  1497,  2644,   562,  2596,  3041,  3141,
    1571,  2751,  2752,  2016,  1760,  1572,  1762,  2602,  3107,  3252,
     119,  2966,  2762,  2763,  2764,  2823,   126,  2549,  2550,  3283,
    3017,   131,  1497,   606,    20,  2775,  2580,  1963,  2778,  2779,
    2780,  2781,   803,  2273,   985,   145,  1971,   803,   147,   149,
    1982,   986,   984,  1948,  1740,  1512,  2846,  1491,  2236,  2893,
    2846,  1964,  1675,   500,  2578,  3070,  2363,  2807,  2965,   169,
     170,  2355,  1974,  2595,   695,  1916,   175,  1827,  1769,  1914,
    1796,  1772,   182,  1446,    -1,  1776,    -1,    -1,    -1,   145,
     711,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,   720,
    1277,    -1,  2892,    -1,    -1,   726,    -1,  3004,    -1,  1286,
      -1,    -1,    -1,   169,   170,   215,   737,    -1,   218,  1296,
      -1,    -1,    -1,  2863,    -1,    -1,   182,  1620,  1819,  2869,
      -1,     8,   232,    -1,   234,  2875,  1313,    -1,  1315,  1316,
      -1,    -1,  1319,   764,  3041,  2885,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2895,    -1,    -1,    -1,   215,
      -1,    -1,   218,    -1,    -1,    -1,    -1,    -1,  2908,    -1,
      -1,   270,  2912,    -1,    -1,   274,   232,    -1,   234,    -1,
      -1,   280,    -1,    -1,    -1,    -1,    -1,    -1,   287,    -1,
      -1,    -1,   813,    -1,   293,    -1,    -1,   297,    -1,    -1,
     821,    -1,   301,    -1,    -1,  1698,    -1,    -1,    -1,    -1,
     309,    -1,    -1,    -1,    -1,  2737,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3122,  2966,    -1,    -1,    -1,
      -1,    -1,    -1,  1726,    -1,    -1,    -1,    -1,    -1,    -1,
    1733,   297,    -1,    -1,  3141,    -1,    -1,  1740,    -1,    -1,
      -1,    -1,    -1,    -1,  2994,    -1,   355,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,
    2792,  2793,  2794,    -1,    -1,    -1,  3016,    -1,  3018,    -1,
      -1,    -1,  2804,  2805,   161,   385,  2808,  2809,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,    -1,    -1,
    3040,  3041,    -1,   403,    -1,  3045,  3046,  3204,    -1,  2000,
      -1,    -1,    -1,  3053,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,  1500,    -1,  2071,    30,    -1,    -1,   385,
    2852,    -1,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,    -1,    -1,   400,    -1,    -1,   403,    -1,    -1,
      -1,   407,    -1,    -1,  2876,    -1,    -1,    -1,  3098,  3099,
    3100,  3101,  3102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     0,    -1,    -1,    -1,    -1,    -1,  3274,    -1,    -1,
     145,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,
      -1,  2082,  2083,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1577,  3141,  3142,    -1,   169,   170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   182,  2318,    -1,
      -1,  2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,
    3265,  2331,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,   145,    -1,  3183,  3184,   149,    -1,    -1,    -1,  1942,
     215,  3191,    -1,   218,    -1,  1948,    -1,    -1,    -1,    -1,
      -1,    -1,  3252,    -1,  2986,   169,   170,   232,  3208,  2991,
      -1,    -1,    -1,   150,    -1,  3265,    -1,   154,   182,  3219,
    2380,  2381,    -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3283,    -1,    -1,    -1,   126,    -1,    -1,
      -1,    -1,   131,    -1,    -1,    -1,   135,    -1,    -1,   138,
      -1,   140,    -1,    -1,   218,    -1,  3038,    25,    -1,    -1,
      -1,  3261,    30,    -1,    -1,    -1,    -1,    -1,   232,    -1,
      -1,    -1,   297,    -1,    -1,   736,   165,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3284,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   183,    -1,    -1,  2248,    -1,  2250,
      -1,  2252,    -1,  2254,    -1,  2256,    -1,    -1,    -1,    -1,
    2261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,
      -1,    -1,    -1,   297,    -1,    -1,  2287,    -1,   227,    -1,
      -1,    -1,    -1,    -1,   112,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1238,    -1,    -1,
     385,    -1,    -1,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,    -1,    -1,    -1,    -1,   145,   403,    -1,
      -1,   149,    -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2556,  1278,    -1,    -1,
      -1,   169,   170,    -1,    -1,    -1,  1287,    -1,  1289,    -1,
      -1,    -1,    -1,  1294,   182,    10,    -1,    -1,   555,    -1,
      -1,   385,    -1,    -1,   561,   389,   390,   316,   392,   393,
     394,   395,   396,   397,  2187,   572,    -1,  3219,    -1,   403,
      -1,    -1,    -1,  2196,    -1,    -1,    -1,    -1,   337,    -1,
     218,    -1,    -1,    -1,   591,    -1,    -1,    -1,    -1,  2212,
      -1,    -1,    -1,    -1,   232,    -1,    -1,    -1,   357,    64,
     607,    -1,    -1,   610,    -1,    -1,    -1,  2230,    -1,  3261,
      -1,  2234,    -1,    -1,    -1,    -1,    81,   624,   377,   378,
     379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3284,    -1,  2257,    -1,  2259,   102,    -1,    -1,
     399,  2264,  2265,   402,    -1,   404,   405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,
      -1,   468,    -1,  2286,    -1,    -1,    -1,    -1,   133,    -1,
    1977,    -1,    -1,   138,    -1,    -1,    -1,    -1,  2708,  2709,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,
      -1,    -1,    -1,  1024,    -1,    -1,    -1,    -1,   505,    -1,
     707,    -1,    -1,    -1,   511,    -1,    -1,  1038,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2036,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2052,    -1,   385,    -1,  2056,
     757,   758,   759,    17,   392,   393,   394,   395,   396,   397,
      -1,    25,    -1,    -1,    -1,   403,    30,   232,    -1,    -1,
      -1,    -1,  2395,  2396,    -1,    -1,    -1,    -1,    -1,  1530,
      -1,    -1,    -1,   590,    -1,    -1,    -1,  1538,    -1,    -1,
     255,    -1,    -1,  1544,    -1,    -1,    -1,    -1,    -1,  1550,
      -1,    -1,    -1,    20,  1555,    -1,    -1,    -1,   815,  1560,
     617,    -1,   277,    -1,    -1,  2636,  2637,    -1,   283,    -1,
      -1,    38,    -1,    -1,   289,    -1,    -1,    17,  1579,   836,
    1581,    -1,    -1,    -1,    -1,    25,    -1,  1168,    -1,    -1,
      30,    -1,  1593,  1594,  1595,    -1,    -1,    -1,    -1,    66,
      -1,   316,   317,    -1,    -1,    -1,   321,    -1,    -1,  1610,
    1611,  1612,  1613,    -1,   329,    -1,  1617,  1618,    -1,   334,
    1621,  1622,  1623,    -1,    -1,    -1,  1627,    -1,   343,    -1,
      -1,   145,    -1,  1634,    -1,   149,  1637,  2917,    -1,   354,
      -1,    -1,    -1,    -1,   701,   702,    -1,  1228,    -1,    -1,
      -1,   708,   119,    -1,  2780,   169,   170,    -1,   715,    -1,
      -1,  2941,  2942,    10,    -1,    -1,    -1,    -1,   182,    -1,
      -1,    -1,    -1,  2546,    -1,    22,    -1,    -1,    -1,   736,
     147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2562,
      -1,    -1,  1273,    -1,    -1,    42,    -1,    -1,    -1,  2572,
      -1,   215,   959,  1284,   218,   145,   763,    -1,   175,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,   232,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2285,   169,
     170,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,
    2613,    -1,   182,    -1,   801,  2618,    -1,    -1,  2621,    -1,
      -1,    -1,    -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   823,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   215,    -1,    -1,   218,    -1,
      -1,    -1,    -1,   297,    -1,    -1,   133,  3067,   845,    -1,
      -1,   138,   232,    -1,   234,    -1,    -1,  1054,    -1,    -1,
      -1,    -1,    -1,   270,    -1,   152,    -1,   274,    -1,    -1,
      -1,    -1,  1813,   280,   871,    -1,    -1,    -1,    -1,    -1,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,    -1,    -1,
    2901,  2902,  2903,  2904,   301,    -1,    -1,    -1,    -1,    -1,
    2911,    -1,   309,    -1,    -1,    -1,    -1,   904,   905,    -1,
     907,    -1,  2725,  2726,  2727,  2728,    -1,   297,  1439,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   924,    -1,    -1,
      -1,   385,    -1,    -1,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,    -1,   232,    -1,    -1,   355,   403,
      38,    -1,   406,   240,    -1,    -1,    -1,    -1,    17,    -1,
    2457,  2458,    21,    -1,    -1,    -1,    25,    -1,   255,    -1,
      -1,    30,    -1,    -1,  3040,    -1,    -1,    -1,    66,  3045,
    3046,    -1,   979,    -1,    -1,   982,   983,    -1,    -1,    -1,
     277,    -1,    -1,   990,   281,    -1,   283,   994,    -1,    -1,
      -1,    -1,   289,    -1,    -1,   385,    -1,    -1,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,    -1,    -1,
      -1,    -1,    -1,   403,    -1,    -1,   406,  1024,    -1,   316,
     317,   119,    -1,  3099,   321,  3101,    95,    -1,    -1,    -1,
      -1,  1038,   329,    -1,    -1,  1986,  1987,   334,    -1,    -1,
    1571,  1572,    -1,    -1,  3065,    -1,   343,    -1,    -1,   147,
      -1,    -1,  2875,    -1,    -1,    -1,    -1,   354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3142,    -1,    -1,  2892,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
     149,  1288,    -1,    -1,    -1,    -1,    -1,    -1,  1295,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,
     169,   170,    -1,    -1,    -1,    -1,    -1,    -1,  3184,    -1,
    1317,  1318,    -1,   182,    -1,  3191,    -1,    -1,    -1,    -1,
      -1,    -1,  1329,  1654,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3208,  2084,  2085,  2086,  2087,    -1,    -1,    -1,
      -1,    -1,  2965,   241,    -1,  1676,   215,    -1,    -1,   218,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1168,    -1,   232,    -1,   234,    -1,  2118,   266,    -1,
      -1,    -1,   270,    -1,    -1,    -1,   274,    -1,    -1,  1186,
      -1,  3004,   280,  3006,    -1,    -1,    -1,    -1,    -1,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,    -1,  1205,    -1,
      -1,    -1,    -1,   301,    17,  3028,    -1,    -1,    -1,   145,
      -1,   309,    25,   149,    -1,    -1,    -1,    30,  3041,    -1,
      -1,  1228,    -1,    -1,    -1,  1232,  3049,    -1,   297,    -1,
      -1,    -1,    -1,   169,   170,    -1,    -1,    -1,  1445,    -1,
      -1,    -1,  2193,    -1,    -1,    -1,   182,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,  1265,  2210,
    1267,    -1,    -1,    -1,  3087,    -1,  1273,    -1,  1275,    -1,
      -1,  2778,  2779,    -1,  2781,   344,  1807,  1284,    -1,    -1,
      -1,    -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1497,    -1,    -1,    -1,    -1,    -1,   232,    -1,    -1,  3122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1314,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   385,    -1,  3141,   388,
     389,   390,    -1,   392,   393,   394,   395,   396,   397,    -1,
      -1,    -1,   145,    -1,   403,    -1,   149,    -1,    -1,    -1,
      -1,  1348,  1349,    -1,    -1,    -1,    -1,    -1,    -1,  1356,
      -1,    -1,  1359,    -1,    -1,  1362,   169,   170,    -1,    -1,
      -1,   297,    -1,  1370,  1371,    -1,    -1,    -1,    -1,   182,
      -1,  1378,    -1,    -1,  1381,  1382,  1383,  1384,  2885,    -1,
      -1,  3204,    -1,    -1,  1391,  1392,    -1,  1394,  2895,  1396,
      -1,    -1,  1399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   215,    -1,    -1,   218,    -1,    -1,  1415,  1416,
      -1,    -1,  1419,  1620,    -1,    -1,  1423,    -1,    -1,   232,
    1427,   234,    -1,  1430,  1431,  1432,  1433,  1434,  1435,  1436,
    1437,  1438,  1439,    -1,  1441,    -1,   249,    -1,    -1,  1446,
      -1,    -1,  1449,    -1,    -1,    -1,    -1,    -1,    -1,   385,
      -1,  3274,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,    -1,    -1,    -1,    25,    -1,   403,    -1,    -1,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   297,  2016,  2017,    -1,  2019,    -1,
      -1,  1698,  1499,    -1,    -1,    -1,    -1,   310,    -1,    -1,
      -1,  2032,    -1,  2034,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1726,
      -1,    -1,    -1,    -1,    -1,  1532,  1733,    -1,    -1,    -1,
    2481,    -1,    -1,    -1,    -1,  2486,    -1,  2488,  2489,  2490,
    2491,  1548,    -1,    -1,  2075,    -1,  3053,    -1,    -1,    -1,
      -1,    -1,   112,   736,    -1,    -1,    25,    -1,    -1,    -1,
    1567,    30,    -1,    -1,  1571,  1572,    -1,    -1,    -1,    -1,
      -1,    -1,   385,    -1,    -1,   388,   389,   390,    -1,   392,
     393,   394,   395,   396,   397,   145,    -1,    -1,    -1,   149,
     403,    -1,    -1,  2124,    -1,  3102,    -1,    -1,    -1,    -1,
    2551,  2552,  2553,    -1,  2555,    -1,    -1,    -1,    -1,   169,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2149,    -1,
      -1,    -1,   182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1646,
     823,    -1,    -1,   112,   736,    -1,  2177,  1654,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,    -1,
      -1,  2192,    -1,    -1,    -1,    -1,    -1,  1674,    -1,  1676,
      -1,    -1,   232,    -1,  2205,  2626,   145,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,  2216,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   736,
      -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,  2249,    -1,
      -1,    -1,    -1,    -1,  2255,    -1,    -1,    -1,    -1,    -1,
      -1,   823,    -1,  1740,    -1,  1942,    -1,   297,    -1,    -1,
      -1,    -1,    -1,  1750,    -1,    -1,    -1,    -1,    -1,   218,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   232,    -1,   948,    -1,    -1,  2299,    -1,
      -1,    -1,  1779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    -1,    -1,    20,  1796,
      -1,    -1,    -1,    25,    -1,    -1,   823,    -1,    30,  2330,
    1807,  2752,    -1,    -1,    -1,    -1,    -1,   990,    -1,    -1,
      -1,   590,  2763,  2344,    -1,    -1,    -1,    -1,  1825,  1826,
      -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,   297,    -1,
      -1,    -1,   392,   393,   394,   395,   396,   397,   617,    -1,
      -1,  1024,    -1,   403,    -1,    -1,    -1,    -1,  1855,  1856,
      -1,    -1,    -1,  1860,    -1,  1038,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1872,  1873,  1874,  1875,    -1,
      -1,    -1,    -1,  1880,    -1,    -1,    -1,  1884,  1885,    -1,
    1887,    -1,    -1,  1890,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1899,  1900,    -1,  1902,    -1,    -1,   990,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,  1915,    -1,
    1917,    -1,  2863,   145,  1921,    25,   385,   149,  2869,    -1,
      30,    -1,   701,   392,   393,   394,   395,   396,   397,    -1,
      -1,  1938,  1024,    -1,   403,    -1,    -1,   169,   170,    -1,
      -1,  1948,  2473,  1950,  1951,    -1,  1038,    -1,    -1,    -1,
     182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1965,    -1,
      -1,    -1,    -1,   990,  1971,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1980,  1981,  1982,    -1,    -1,    -1,    -1,
    2187,    -1,    -1,   215,    -1,  1168,   218,    -1,  1995,  2196,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1024,    -1,    -1,
     232,    -1,   234,  1186,    -1,  2212,    -1,    -1,    -1,  2016,
    2017,  1038,  2019,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1205,    -1,    -1,  2032,    -1,  2034,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   145,  2567,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,  1228,    -1,    -1,    -1,    -1,
    2257,    -1,  2259,    -1,    17,    -1,    -1,  2264,    -1,   169,
     170,    -1,    25,    -1,    -1,   297,   845,    30,  2075,    -1,
      -1,    -1,   182,    -1,    -1,    -1,  1168,    -1,    -1,  2286,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1273,    -1,   871,    -1,  1186,    -1,    -1,   736,    -1,    -1,
      -1,  1284,    -1,    -1,    -1,   215,    -1,    -1,   218,    -1,
      -1,    -1,    -1,  1205,    -1,    -1,    -1,  2124,    -1,    -1,
      -1,    -1,   232,    -1,   234,   904,   905,    -1,   907,    -1,
      -1,    -1,    -1,    -1,    -1,   245,  1228,    -1,    -1,    -1,
      -1,  1168,  2149,    -1,    -1,   924,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   385,    -1,    -1,   388,   389,   390,  1186,
     392,   393,   394,   395,   396,   397,    -1,    -1,    -1,  2176,
    2177,   403,    -1,    -1,    -1,    -1,    -1,    -1,  1205,    -1,
      -1,  1273,   145,    -1,   823,  2192,   149,   297,  2395,  2396,
      -1,    -1,  1284,    -1,    -1,    -1,    -1,    -1,  2205,    -1,
     979,  1228,    -1,   982,   983,    -1,   169,   170,    -1,  2216,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,  2230,  2755,    -1,    -1,  2234,    -1,    -1,
      -1,    -1,  3183,    -1,    -1,    -1,    -1,  2244,    -1,    -1,
      -1,    -1,  2249,    -1,    -1,    -1,  1273,    -1,  2255,    -1,
      -1,    -1,   215,    -1,    -1,   218,  1439,  1284,  2265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   232,
      -1,   234,    -1,    -1,    -1,   385,    -1,    -1,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,    -1,  2296,
      -1,    -1,  2299,   403,    -1,    -1,    -1,    -1,  2305,    -1,
      -1,    -1,    -1,    -1,  2311,    -1,  2313,    -1,    -1,    -1,
      -1,  2318,    -1,    -1,  2321,  2322,  2323,  2324,  2325,  2326,
    2327,  2328,  2329,  2330,  2331,    -1,    -1,    -1,  2335,  2336,
      -1,    -1,    -1,    -1,   297,    -1,    -1,  2344,    -1,  2546,
      -1,    -1,  2349,    -1,    -1,    -1,  2353,  1439,  2355,    -1,
      -1,   990,    -1,    -1,    -1,  2562,    -1,    25,  2365,    -1,
      -1,  2368,    30,  2370,    -1,  2572,  2897,    -1,    -1,    -1,
      -1,  2378,  2379,  2380,  2381,    -1,    -1,    -1,  2385,    -1,
      -1,  2388,    -1,    -1,  1567,  1024,    -1,    -1,  1571,  1572,
      -1,  2398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1038,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     736,    -1,   385,    -1,    -1,   388,   389,   390,    -1,   392,
     393,   394,   395,   396,   397,    -1,    -1,    -1,    -1,   402,
     403,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2473,    -1,    -1,    -1,
      -1,  1654,    -1,    -1,    -1,  1567,    -1,   145,    -1,  1571,
    1572,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1676,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   169,   170,    -1,    -1,    -1,    -1,   823,    -1,    -1,
      -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,  2725,  2726,
    2727,  2728,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1168,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1567,    -1,    -1,    -1,  1571,  1572,    -1,  1186,    -1,  2556,
     218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2567,    -1,  1654,    -1,   232,    -1,  1205,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1356,    -1,    -1,
      -1,    -1,    -1,    -1,  1676,    -1,    -1,    -1,    -1,  1228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1378,
      -1,    -1,  1381,    -1,    -1,  1384,  2613,    -1,    -1,    -1,
      -1,  2618,  1391,  1392,  2621,    -1,    -1,  1396,    -1,    -1,
    1399,    -1,    -1,    -1,  1807,    -1,    -1,  1654,    -1,   297,
      -1,    -1,  3163,    -1,  1273,    -1,  1415,    -1,    -1,    -1,
    1419,    -1,    -1,    -1,  1423,  1284,    -1,    -1,  1427,  1676,
    2657,  1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,  1438,
      -1,    -1,  1441,    -1,    -1,    -1,    -1,  1446,    -1,    -1,
      -1,    -1,    -1,    -1,   990,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2693,    -1,    -1,    -1,
      -1,    -1,    -1,  2700,  2701,    -1,  2703,    -1,    -1,    -1,
      -1,  2708,  2709,    -1,    -1,    -1,  2713,  2714,  1024,    -1,
      -1,    -1,  2719,  2720,    -1,  1807,  2723,   385,    -1,    -1,
    1499,    -1,  1038,    -1,   392,   393,   394,   395,   396,   397,
      -1,    10,    -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,  2755,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,  1548,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1807,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3006,
    1439,    -1,    81,    -1,    -1,    -1,    -1,    -1,    87,    -1,
      -1,    -1,    -1,    -1,    -1,   736,    -1,    -1,    -1,    -1,
      -1,  3028,    -1,   102,    -1,    -1,    -1,    -1,  2835,    -1,
      -1,    -1,    -1,  2016,  2017,    -1,  2019,    -1,    -1,    -1,
      -1,    -1,  3049,    -1,    -1,    -1,    -1,    -1,    -1,  2032,
      -1,  2034,  1168,    -1,   133,   134,    -1,    -1,    -1,   138,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1646,  2875,    -1,
    1186,    -1,    -1,   152,    -1,    -1,    -1,    -1,    -1,    -1,
    3087,  2888,    -1,    -1,    -1,  2892,    -1,    -1,    -1,  1205,
    2897,    -1,  2075,    -1,    -1,  1674,   175,    -1,    -1,    -1,
      -1,    -1,   823,    -1,    -1,    -1,    -1,   186,    -1,    -1,
    2917,    -1,  1228,    -1,  2921,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2016,  2017,    -1,  2019,  1567,    -1,
      -1,    -1,  1571,  1572,  2941,  2942,    -1,    -1,  2945,    -1,
    2032,  2124,  2034,    -1,    -1,  2952,  2953,    -1,    -1,    -1,
      -1,    -1,    -1,   232,    -1,   234,    -1,  1273,  2965,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2149,    -1,  1284,    -1,
      -1,  1750,  2979,    -1,    -1,    -1,   255,    -1,    -1,    -1,
      -1,    -1,    -1,  2075,    -1,    -1,    -1,    -1,    -1,  2016,
    2017,    -1,  2019,    17,  2177,    -1,    20,  3004,   277,    -1,
    1779,    25,   281,    -1,   283,  2032,    30,  2034,    -1,  2192,
      -1,    -1,    -1,    -1,    -1,  1654,    -1,  1796,    -1,    -1,
      -1,    -1,  2205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   736,  2124,  2216,  3041,  3042,    -1,  1676,   317,   318,
      -1,   320,   321,    -1,    -1,    -1,    -1,  1826,  2075,    -1,
     329,    -1,    -1,    -1,   333,   334,    -1,  2149,    -1,   338,
    3067,  3068,    -1,  3070,   343,  3072,  2249,    -1,    -1,   990,
      -1,    -1,  2255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3090,    -1,  2177,    -1,  3094,  3095,    -1,
      -1,    -1,    -1,  1872,    -1,  1874,  1875,  2124,    -1,    -1,
    2192,    -1,    -1,  1024,    -1,  1884,    -1,    -1,  1887,    -1,
      -1,  1890,    -1,  2205,    -1,  3122,  2299,  1038,   823,    -1,
      -1,   145,  2149,  1439,  2216,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3141,    -1,  1915,    -1,  1917,    -1,
      -1,    -1,  1921,    -1,    -1,   169,   170,  2330,    -1,    -1,
    2177,    -1,    -1,    -1,    -1,    -1,  3163,  2249,   182,    -1,
      -1,  2344,    -1,  2255,    -1,  2192,    -1,    -1,  1807,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2205,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1965,    -1,    -1,  2216,
      -1,   215,  1971,    -1,   218,  2378,    -1,  3204,    -1,    -1,
      -1,  1980,  1981,  1982,    -1,    -1,    -1,  2299,   232,    -1,
     234,    -1,    -1,    -1,    -1,    -1,  1995,    -1,    -1,    -1,
      -1,    -1,  2249,    -1,    -1,    -1,    -1,    -1,  2255,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2330,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1168,    -1,    -1,
      -1,  1567,  2344,    -1,    -1,  1571,  1572,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1186,    -1,  3274,    -1,    -1,
      -1,    -1,  2299,   297,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1205,   990,  2378,    -1,    -1,    -1,
    2473,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2330,    -1,    -1,    -1,  1228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2344,    -1,  1024,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1038,    -1,    -1,    -1,    -1,  1654,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2378,  1273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1676,   385,    -1,  1284,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,    -1,    -1,    -1,  2016,  2017,   403,
    2019,  2473,    -1,    -1,  2567,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2032,    -1,  2034,    -1,    17,    -1,    -1,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2075,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2473,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    -1,    -1,    -1,  2567,    -1,    -1,    -1,    25,
      -1,  1186,    -1,    -1,    30,  2124,    -1,    -1,    -1,    -1,
      -1,  1807,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2149,    -1,    -1,    -1,    -1,    -1,    -1,  2296,  1439,    -1,
    2703,    -1,    -1,  1228,    -1,   145,  2305,    -1,    -1,   149,
      -1,  2714,  2311,    -1,  2313,    -1,    -1,    -1,  2177,    -1,
    2567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,
     170,    -1,    -1,  2192,    -1,    -1,  2335,  2336,    -1,    -1,
      -1,    -1,   182,    -1,    -1,    -1,  2205,    -1,  1273,    -1,
      -1,    -1,  2755,    -1,    -1,    -1,  2355,  2216,    -1,  1284,
      -1,    -1,    -1,    -1,    -1,   131,  2365,    -1,    -1,  2368,
      -1,  2370,    -1,    -1,    -1,   215,    -1,    -1,   218,   145,
    2379,    -1,    -1,   149,    -1,    -1,  2385,    -1,    -1,  2388,
    2249,  2703,   232,    -1,   234,    -1,  2255,    -1,    -1,  2398,
      -1,    -1,  2714,   169,   170,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1567,    -1,    -1,    -1,
    1571,  1572,    -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,
    2299,    20,    -1,  2755,    -1,    -1,    25,    -1,    -1,   215,
      -1,    30,   218,    -1,    -1,    -1,  2703,   297,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   232,  2714,   234,    -1,
      -1,  2330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2016,  2017,    -1,  2019,    -1,  2344,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2897,    -1,  2032,    -1,  2034,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2755,    -1,
      -1,    -1,    -1,  1654,  1439,    -1,    -1,    -1,  2921,  2378,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    -1,    -1,  1676,    -1,    -1,    -1,  2075,
      -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,    -1,    -1,
      -1,    -1,    -1,   403,    -1,    -1,   145,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2897,    -1,    -1,  2124,    -1,
     169,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,    -1,  2921,
      -1,    -1,    -1,  2149,  2473,    -1,    -1,    -1,    -1,   385,
      -1,    -1,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,    -1,    -1,    -1,    -1,   215,   403,    -1,   218,
      -1,  2177,  1567,    -1,    -1,    -1,  1571,  1572,    -1,    -1,
    2897,    -1,    -1,   232,    -1,   234,  2192,    -1,  2657,    -1,
      -1,    -1,    -1,    -1,    -1,  3068,  1807,    -1,    -1,  2205,
      -1,    -1,    -1,    -1,  2921,    -1,    -1,    -1,    -1,    -1,
    2216,    -1,    -1,    -1,    -1,    -1,    -1,  3090,    -1,    -1,
      -1,  3094,  3095,    -1,    -1,    -1,    -1,    -1,    -1,   920,
      -1,  2700,  2701,    -1,    -1,    -1,    -1,    -1,  2567,    -1,
      -1,    -1,    -1,  2249,  2713,    -1,    -1,    -1,   297,  2255,
    2719,  2720,    -1,    -1,  2723,    -1,    -1,    -1,    -1,  1654,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   968,    -1,    17,
      -1,  1676,    -1,    -1,    -1,    -1,  3068,    25,    -1,    -1,
    3163,    -1,    30,  2299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3090,    -1,
      -1,    -1,  3094,  3095,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2330,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   385,    -1,  2344,   388,
     389,   390,    -1,   392,   393,   394,   395,   396,   397,    -1,
      -1,  3068,    -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2835,    -1,    -1,    -1,
      -1,    -1,  2378,  3090,  2703,    -1,    -1,  3094,  3095,    -1,
      -1,  3163,    -1,    -1,    -1,  2714,    -1,    -1,    -1,  1080,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2016,  2017,   145,  2019,    -1,
      -1,   149,  1807,    -1,    -1,    -1,    -1,    -1,    -1,  2888,
      -1,  2032,    -1,  2034,    -1,    -1,  2755,    -1,    -1,    -1,
      -1,   169,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   182,    -1,  3163,    -1,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2075,    -1,    -1,  2473,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2945,   215,    -1,    -1,
     218,    42,    -1,    -1,  2953,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,   232,    -1,   234,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
    2979,    -1,    -1,  2124,    -1,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2149,    -1,
      -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,
      -1,  2567,    -1,    -1,    -1,    -1,  2177,    -1,  2897,    -1,
      -1,    -1,   133,  3042,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   152,  2921,    -1,  2205,    -1,    -1,    -1,    -1,    -1,
      -1,  3070,    -1,    -1,    -1,  2216,    -1,    -1,    -1,    -1,
      -1,  1302,    -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,
      -1,  2016,  2017,    -1,  2019,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2032,  2249,  2034,
      -1,    -1,    -1,    -1,  2255,    -1,    -1,   385,    -1,    -1,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
      -1,    -1,   400,  1354,    -1,   403,    -1,    -1,    -1,    -1,
      17,   232,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,
    2075,    -1,    -1,    30,    -1,    -1,  1377,    -1,  2299,    -1,
      -1,  1382,    -1,    -1,   255,    -1,    -1,  2703,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2714,    -1,
      -1,  1402,  1403,    -1,    -1,  1406,   277,    -1,    -1,  2330,
     281,    -1,   283,    -1,     3,    -1,    -1,    -1,   289,  2124,
      -1,    -1,    -1,  2344,    13,    -1,    15,    16,    -1,  3068,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2755,
      29,    -1,    -1,  1444,  2149,   316,   317,    -1,    -1,    -1,
     321,  3090,    -1,    -1,    -1,  3094,  3095,  2378,   329,    48,
      -1,    50,    51,   334,    -1,    -1,    55,    56,    -1,    -1,
      -1,    -1,  2177,    -1,    -1,    -1,    65,    -1,    67,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,  2192,   145,    -1,
      -1,    -1,   149,    -1,    83,    -1,    -1,    86,    -1,    -1,
    2205,    -1,    -1,    92,    -1,    -1,    -1,  1508,    -1,    98,
      -1,  2216,   169,   170,  1515,   104,  1517,    -1,    -1,    -1,
      -1,   110,    -1,    -1,  3163,   182,    -1,   116,    -1,   118,
      -1,    -1,    -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2249,    -1,   135,    -1,    -1,    -1,
    2255,    -1,  2473,    -1,    -1,    -1,    -1,    -1,   215,    -1,
      -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   161,    -1,    -1,   232,    -1,   234,    -1,    -1,
      -1,  2897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      -1,    -1,    20,    -1,  2299,   184,   185,    25,    -1,    -1,
      -1,   190,    30,    -1,    -1,  2921,    -1,    -1,    -1,    -1,
     199,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2330,    -1,    -1,   217,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2344,
     297,    -1,    -1,    -1,    -1,    -1,  2567,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   250,    -1,    -1,    -1,    -1,    -1,    17,    -1,    -1,
      -1,   260,    -1,  2378,   263,    25,   265,    -1,    -1,    -1,
      30,   270,    -1,    -1,    -1,    -1,   275,    -1,    -1,   278,
      -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,    -1,   293,    -1,    -1,   296,    -1,    -1,
      -1,    -1,    -1,    -1,   303,    -1,    -1,   145,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,    -1,    -1,   385,    -1,
      -1,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   169,   170,   332,    -1,   402,   403,    -1,    -1,    -1,
      -1,   340,  3068,   342,   182,    -1,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2473,    -1,
      -1,    -1,    -1,    -1,  3090,    -1,    -1,    -1,  3094,  3095,
      -1,    -1,  2703,    -1,    -1,    -1,    -1,   215,    -1,    -1,
     218,    -1,    -1,  2714,    -1,   145,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   232,    -1,   234,    -1,    -1,    -1,
      -1,    -1,   401,    -1,    -1,    -1,    -1,    -1,    -1,   169,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1829,    -1,
      -1,    -1,   182,    -1,  2755,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3163,    -1,    -1,
    1851,    -1,  1853,    17,  1855,  1856,  1857,    -1,    -1,  1860,
      -1,    25,  2567,  1864,    -1,   215,    30,    -1,   218,   297,
    1871,    -1,    -1,    -1,    -1,  1876,    -1,    -1,    -1,    -1,
    1881,    -1,   232,    -1,   234,  1886,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1895,    -1,    17,    -1,  1899,  1900,
    1901,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,  1913,    -1,    -1,    -1,    -1,    -1,    -1,  1920,
      -1,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,
      -1,  1932,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
      -1,    -1,   322,    -1,    -1,   403,  2897,    -1,    -1,    -1,
      -1,   145,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2703,    -1,
    2921,    -1,  2003,    -1,    -1,   169,   170,    -1,    -1,  2714,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,
      -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,   169,   170,
    2755,   215,    -1,   403,   218,    -1,    -1,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,    -1,    -1,    -1,   232,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    -1,    -1,   215,    -1,    -1,   218,    -1,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      -1,   232,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    -1,   297,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,  3068,    -1,    -1,
      -1,  2152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3090,
      -1,    -1,    -1,  3094,  3095,    -1,   297,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      -1,    -1,    -1,    -1,    -1,    -1,  2921,    25,    -1,   145,
      -1,   385,    30,   149,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,    -1,    -1,    -1,    -1,   402,   403,
      17,    -1,  3163,   169,   170,  2246,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,   182,    -1,    -1,   145,
      -1,    -1,  2263,   149,   385,    -1,    -1,   388,   389,   390,
      -1,   392,   393,   394,   395,   396,   397,    -1,    -1,    -1,
      -1,   402,   403,   169,   170,    -1,    -1,    -1,    -1,   215,
      -1,    -1,   218,    -1,  2295,    -1,   182,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   232,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,  2316,  2317,  2318,    -1,    -1,
    2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,   215,
    2331,  2332,   218,    -1,    -1,    -1,    -1,   145,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   232,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,  2356,    -1,    -1,  2359,    -1,
    2361,   169,   170,  3068,    -1,  2366,  2367,    -1,   145,    -1,
      -1,   297,   149,    -1,   182,    -1,    -1,    -1,    -1,  2380,
    2381,  2382,    -1,  2384,    -1,  3090,  2387,    -1,    -1,  3094,
    3095,    -1,   169,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   182,    17,   215,    -1,    -1,
     218,   297,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    -1,   232,    -1,   234,    -1,    -1,    -1,
    2431,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,    -1,
      -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   232,    -1,   234,  3163,   385,
      -1,    -1,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,    -1,    -1,    -1,    -1,   402,   403,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   385,
      -1,    -1,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,    -1,    -1,    -1,    -1,   402,   403,    -1,    -1,
     297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    -1,    -1,   145,    -1,    -1,    -1,   149,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2556,    -1,    -1,   169,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
      -1,    -1,    -1,    -1,   402,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   215,    -1,    -1,   218,   385,    -1,
      -1,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   232,    -1,   234,    -1,   402,   403,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    -1,    -1,  2658,    -1,   145,
    2661,  2662,  2663,   149,  2665,    -1,    -1,    -1,    -1,  2670,
    2671,  2672,  2673,  2674,  2675,  2676,  2677,  2678,    -1,  2680,
    2681,  2682,    -1,   169,   170,    -1,   297,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    -1,  2707,  2708,  2709,  2710,
      -1,  2712,    68,    69,    70,  2716,  2717,  2718,    -1,    -1,
    2721,    -1,    -1,  2724,    -1,    -1,    -1,    -1,    -1,   215,
    2731,    -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   232,    -1,   234,    -1,
      -1,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   385,    -1,    -1,   388,   389,   390,
      -1,   392,   393,   394,   395,   396,   397,    -1,    -1,    -1,
      -1,   402,   403,   149,    -1,    -1,    -1,    -1,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   191,  2837,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   208,   209,   210,   211,   212,    -1,   214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   385,
      -1,    -1,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,  2913,    -1,    -1,    -1,  2917,   403,    -1,    -1,
      -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,  2929,    -1,
    2931,    -1,    -1,    -1,    -1,  2936,  2937,  2938,    -1,    -1,
    2941,  2942,  2943,  2944,    -1,  2946,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,   314,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     336,    -1,    -1,    -1,    -1,    -1,    -1,   343,    -1,    -1,
     346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3009,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3052,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3066,  3067,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3080,
    3081,  3082,    -1,  3084,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3097,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,  3139,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
    3151,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    69,    70,    -1,    72,    73,
      -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,
      84,    85,    86,    -1,    88,    -1,    90,    91,    92,    93,
      94,    -1,    96,    97,    98,    -1,    -1,   101,   102,   103,
     104,   105,    -1,   107,   108,   109,    -1,   111,   112,    -1,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,
     134,    -1,   136,   137,    -1,   139,    -1,   141,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,    -1,    -1,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,
     184,   185,   186,    -1,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,    -1,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,   216,   217,    -1,   219,    -1,   221,   222,   223,
     224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,
      -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,    -1,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,    -1,    -1,   339,   340,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,   399,    -1,    -1,    19,    -1,
     404,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    99,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,    -1,   127,    -1,   129,   130,
      -1,   132,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,    -1,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,    -1,   228,   229,    -1,
      -1,   232,   233,    -1,    -1,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,    -1,
      -1,   392,   393,   394,    -1,    -1,    -1,    -1,    -1,    -1,
     401,   402,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,    -1,   127,    -1,   129,   130,
      -1,   132,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,    -1,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,    -1,   228,   229,    -1,
      -1,   232,   233,    -1,    -1,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,    -1,
      -1,   392,   393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     401,   402,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    20,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,    -1,
      -1,   132,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,
     171,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,
      -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,   402,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    -1,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,    -1,   118,   119,    -1,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,   130,    -1,   132,
     133,   134,    -1,   136,    -1,    -1,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,    -1,    -1,   180,   181,   182,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,    -1,    -1,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,   236,   237,   238,    -1,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,    -1,   329,    -1,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,   402,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,    -1,   127,    -1,   129,   130,   131,   132,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,    -1,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,    -1,   228,   229,    -1,    -1,   232,   233,    -1,
      -1,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,    -1,    -1,   392,   393,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    88,    -1,    90,    91,    92,    93,    94,    -1,
      96,    97,    98,    -1,    -1,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,    -1,   111,   112,    -1,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,    -1,   132,   133,   134,    -1,
     136,   137,    -1,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,    -1,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,    -1,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,    -1,   228,   229,    -1,    -1,   232,   233,    -1,    -1,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,    -1,
      -1,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
      -1,    -1,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,    -1,    -1,   392,   393,   394,    -1,
      -1,    -1,    -1,    -1,    -1,   401,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
     127,    -1,   129,   130,    -1,   132,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
      -1,   228,   229,    -1,    -1,   232,   233,    -1,    -1,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,    -1,    -1,   392,   393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   401,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    19,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      88,    -1,    90,    91,    92,    93,    94,    -1,    96,    97,
      98,    -1,    -1,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,    -1,   111,   112,    -1,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,    -1,   132,   133,   134,    -1,   136,   137,
      -1,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,    -1,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,    -1,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,    -1,
     228,   229,    -1,    -1,   232,   233,    -1,    -1,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,    -1,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,    -1,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,    -1,    -1,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,    -1,    -1,   392,   393,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   401,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,    -1,   127,    -1,
     129,   130,    -1,   132,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,    -1,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,    -1,    -1,   232,   233,    -1,    -1,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,    -1,    -1,   392,   393,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   401,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    19,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    -1,    88,    -1,
      90,    91,    92,    93,    94,    -1,    96,    97,    98,    -1,
      -1,   101,   102,   103,   104,   105,    -1,   107,   108,   109,
      -1,   111,   112,    -1,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,    -1,   132,   133,   134,    -1,   136,   137,    -1,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,    -1,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,    -1,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,    -1,   228,   229,
      -1,    -1,   232,   233,    -1,    -1,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,    -1,    -1,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,    -1,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
      -1,    -1,   392,   393,    -1,    -1,    -1,    -1,    -1,   399,
      -1,   401,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,    -1,   127,    -1,   129,   130,
     131,   132,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,    -1,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,    -1,   228,   229,    -1,
      -1,   232,   233,    -1,    -1,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,    -1,
      -1,   392,   393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     401,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    -1,    88,    -1,    90,    91,
      92,    93,    94,    -1,    96,    97,    98,    -1,    -1,   101,
     102,   103,   104,   105,    -1,   107,   108,   109,    -1,   111,
     112,    -1,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,    -1,
     132,   133,   134,    -1,   136,   137,    -1,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,    -1,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,    -1,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,    -1,   228,   229,    -1,    -1,
     232,   233,    -1,    -1,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,    -1,    -1,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,    -1,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,    -1,    -1,
     392,   393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,    -1,   127,    -1,   129,   130,    -1,   132,
     133,   134,    -1,   136,   137,    -1,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
      -1,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,    -1,   228,   229,    -1,    -1,   232,
     233,    -1,    -1,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,    -1,    -1,   392,
     393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    -1,    88,    -1,    90,    91,    92,    93,
      94,    -1,    96,    97,    98,    -1,    -1,   101,   102,   103,
     104,   105,    -1,   107,   108,   109,    -1,   111,   112,    -1,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,    -1,   132,   133,
     134,    -1,   136,   137,    -1,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,    -1,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,    -1,   228,   229,    -1,    -1,   232,   233,
      -1,    -1,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,    -1,    -1,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,    -1,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,    -1,    -1,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,    -1,    -1,   392,   393,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,    -1,   127,    -1,   129,   130,    -1,   132,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,    -1,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,    -1,   228,   229,    -1,    -1,   232,   233,    -1,
      -1,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,    -1,    -1,   392,   393,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    88,    -1,    90,    91,    92,    93,    94,    -1,
      96,    97,    98,    -1,    -1,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,    -1,   111,   112,    -1,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,    -1,   132,   133,   134,    -1,
     136,   137,    -1,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,    -1,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,    -1,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,    -1,   228,   229,    -1,    -1,   232,   233,    -1,    -1,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,    -1,
      -1,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
      -1,    -1,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,    -1,    -1,   392,   393,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   401,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,    -1,    -1,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
     127,    -1,   129,   130,    -1,   132,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,    -1,    -1,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
      -1,   228,   229,    -1,    -1,   232,   233,    -1,    -1,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,    -1,    -1,   392,   393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   401,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    19,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      88,    -1,    90,    91,    92,    93,    94,    -1,    96,    97,
      98,    -1,    -1,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,    -1,   111,    -1,    -1,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,    -1,   132,   133,   134,    -1,   136,   137,
      -1,   139,    -1,   141,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,    -1,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,    -1,    -1,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,    -1,
     228,   229,    -1,    -1,   232,   233,    -1,    -1,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,    -1,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,    -1,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,    -1,    -1,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,    -1,    -1,   392,   393,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   401,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,   130,    -1,   132,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,    -1,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,   218,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,    -1,   231,   232,   233,    -1,    -1,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   401,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,   130,    -1,   132,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,    -1,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,   218,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,    -1,   231,   232,   233,    -1,    -1,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   401,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,   130,    -1,   132,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,    -1,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,   218,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,    -1,    -1,   232,   233,    -1,    -1,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   401,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,   130,    -1,   132,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,   218,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,    -1,    -1,   232,   233,    -1,    -1,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   401,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   401,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   401,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   401,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   401,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,    -1,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,   238,    -1,
     240,   241,   242,   243,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,
     380,   381,   382,    -1,    -1,   385,   386,    -1,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,    -1,    -1,
     385,    -1,    -1,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    69,
      70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,
      80,    81,    82,    83,    84,    85,    86,    -1,    88,    -1,
      90,    91,    92,    93,    94,    -1,    96,    97,    98,    -1,
      -1,   101,   102,   103,   104,   105,    -1,   107,   108,   109,
      -1,   111,   112,    -1,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,    -1,   127,    -1,   129,
      -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,
      -1,   141,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,    -1,    -1,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,    -1,   168,    -1,
      -1,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,    -1,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,   216,   217,    -1,   219,
      -1,   221,   222,   223,   224,   225,    -1,    -1,   228,    -1,
      -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,    -1,   293,   294,   295,   296,    -1,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,    -1,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,    -1,    -1,   339,
     340,   341,   342,    -1,    -1,   345,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,
     380,    -1,    -1,    -1,    -1,   385,    -1,    -1,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,    -1,    -1,
     385,    -1,    -1,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    69,
      70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,
      80,    81,    82,    83,    84,    85,    86,    -1,    88,    -1,
      90,    91,    92,    93,    94,    -1,    96,    97,    98,    -1,
      -1,   101,   102,   103,   104,   105,    -1,   107,   108,   109,
      -1,   111,   112,    -1,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,    -1,   127,    -1,   129,
      -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,
      -1,   141,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,    -1,    -1,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,    -1,   168,    -1,
      -1,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,    -1,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,   216,   217,    -1,   219,
      -1,   221,   222,   223,   224,   225,    -1,    -1,   228,    -1,
      -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,    -1,   293,   294,   295,   296,    -1,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,    -1,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,    -1,    -1,   339,
     340,   341,   342,    -1,    -1,   345,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,   355,    -1,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,
     380,    -1,    -1,    -1,    -1,   385,    -1,    -1,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,    -1,    -1,
     385,    -1,    -1,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,
     380,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,   394,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    69,    70,    -1,
      72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,
      82,    83,    84,    85,    86,    -1,    88,    -1,    90,    91,
      92,    93,    94,    -1,    96,    97,    98,    -1,    -1,   101,
     102,   103,   104,   105,    -1,   107,   108,   109,    -1,   111,
     112,    -1,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,    -1,   127,    -1,   129,    -1,    -1,
      -1,   133,   134,    -1,   136,   137,    -1,   139,    -1,   141,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,    -1,    -1,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
      -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,    -1,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,   216,   217,    -1,   219,    -1,   221,
     222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,
     232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,    -1,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,    -1,    -1,   339,   340,   341,
     342,    -1,    -1,   345,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,   394,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    -1,    -1,
      -1,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,
      84,    85,    86,    -1,    88,    -1,    90,    91,    92,    93,
      94,    -1,    96,    97,    98,    -1,    -1,   101,   102,   103,
     104,   105,    -1,   107,   108,   109,    -1,   111,   112,    -1,
     114,   115,   116,    -1,   118,   119,    -1,    -1,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,    -1,   132,   133,
     134,    -1,   136,    -1,    -1,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,    -1,   157,    -1,   159,   160,   161,   162,   163,
     164,    -1,   166,    -1,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,    -1,    -1,   180,   181,   182,    -1,
     184,   185,   186,    -1,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,    -1,   216,   217,   218,   219,    -1,    -1,   222,   223,
     224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,
      -1,    -1,    -1,   237,   238,    -1,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,    -1,    -1,   327,    -1,   329,    -1,    -1,   332,   333,
     334,   335,   336,    -1,    -1,   339,   340,   341,   342,    -1,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,   373,
     374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
     394,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    -1,    -1,    -1,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    -1,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    88,    -1,    90,    91,    92,    93,    94,    -1,
      96,    97,    98,    -1,    -1,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,    -1,   111,   112,    -1,   114,   115,
     116,    -1,   118,   119,    -1,    -1,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,    -1,   132,   133,   134,    -1,
     136,    -1,    -1,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
      -1,   157,    -1,   159,   160,   161,   162,   163,   164,    -1,
     166,    -1,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,    -1,    -1,   180,   181,   182,    -1,   184,   185,
     186,    -1,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,    -1,
     216,   217,   218,   219,    -1,    -1,   222,   223,   224,   225,
      -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,
      -1,   237,   238,    -1,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,    -1,
      -1,   327,    -1,   329,    -1,    -1,   332,   333,   334,   335,
     336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   372,   373,   374,    -1,
      -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,   394,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,
      -1,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    90,    91,    92,    93,    94,    -1,    96,    97,
      98,    -1,    -1,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,    -1,   111,   112,    -1,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,
      -1,   139,    -1,   141,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,    -1,    -1,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,    -1,
     168,    -1,    -1,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,    -1,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,   216,   217,
      -1,   219,    -1,   221,   222,   223,   224,   225,   226,    -1,
     228,    -1,   230,    -1,   232,   233,    -1,    -1,   236,    -1,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,    -1,   293,   294,   295,   296,    -1,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,    -1,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,    -1,
      -1,   339,   340,   341,   342,    -1,    -1,   345,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,   355,    -1,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,    -1,    -1,
      -1,    -1,   380,   381,   382,    -1,    -1,    -1,   386,    -1,
      -1,    -1,    -1,    -1,    -1,   393,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,   226,
      -1,   228,    -1,   230,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,   381,   382,    -1,    -1,    -1,   386,
      -1,    -1,    -1,    -1,    -1,    -1,   393,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    69,    70,    -1,    72,    73,    -1,    -1,
      -1,    -1,    -1,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    88,    -1,    90,    91,    92,    93,    94,    -1,
      96,    97,    98,    -1,    -1,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,    -1,   111,   112,    -1,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,
     136,   137,    -1,   139,    -1,   141,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
      -1,    -1,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,
     186,    -1,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,    -1,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
     216,   217,    -1,   219,    -1,   221,   222,   223,   224,   225,
     226,    -1,   228,    -1,   230,    -1,   232,   233,    -1,    -1,
     236,    -1,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,    -1,   293,   294,   295,
     296,    -1,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,    -1,
      -1,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,   355,
      -1,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
      -1,    -1,    -1,    -1,   380,   381,   382,    -1,    -1,    -1,
     386,    -1,    -1,    -1,    -1,    -1,    -1,   393,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,    -1,    -1,
      -1,   386,    -1,    -1,    -1,    -1,    -1,    -1,   393,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    69,    70,    -1,    72,    73,
      -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,
      84,    85,    86,    -1,    88,    -1,    90,    91,    92,    93,
      94,    -1,    96,    97,    98,    -1,    -1,   101,   102,   103,
     104,   105,    -1,   107,   108,   109,    -1,   111,   112,    -1,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,
     134,    -1,   136,   137,    -1,   139,    -1,   141,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,    -1,    -1,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,
     184,   185,   186,    -1,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,    -1,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,   216,   217,    -1,   219,    -1,   221,   222,   223,
     224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,
      -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,    -1,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,    -1,    -1,   339,   340,   341,   342,    -1,
      -1,   345,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,    -1,
      -1,    -1,    -1,   387,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,   381,   382,   383,   384,    -1,   386,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,    -1,   382,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,    -1,   382,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,    -1,   382,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,   130,    -1,   132,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,   218,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,   229,    -1,    -1,   232,   233,    -1,    -1,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,   130,    -1,   132,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,   218,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,    -1,    -1,   232,   233,    -1,    -1,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,   130,
      -1,   132,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,   218,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,   229,    -1,
      -1,   232,   233,    -1,    -1,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,    -1,   127,   128,   129,    -1,    -1,    -1,
     133,   134,    -1,   136,   137,    -1,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,   219,    -1,   221,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,    -1,   338,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
     135,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,    -1,
      -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,   229,    -1,
     231,   232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,
     133,   134,    -1,   136,   137,    -1,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,    -1,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,   219,    -1,   221,   222,
     223,   224,   225,    -1,    -1,   228,   229,    -1,    -1,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,   229,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,    -1,
      -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,   229,    -1,
      -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,
     133,   134,    -1,   136,   137,    -1,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,    -1,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,   219,    -1,   221,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,    -1,
      -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,    -1,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,
      -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,
     133,   134,    -1,   136,   137,    -1,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,    -1,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,   219,    -1,   221,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    20,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    20,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,    -1,
      -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,    -1,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,
      -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,
     133,   134,    -1,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,    -1,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,   219,    -1,   221,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,    -1,
      -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,    -1,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,
      -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,
     133,   134,    -1,   136,   137,    -1,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,    -1,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,   219,    -1,   221,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,    -1,
      -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,    -1,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,
      -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,
     133,   134,    -1,   136,   137,    -1,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,    -1,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,   219,    -1,   221,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,    -1,
      -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,    -1,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,
      -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,
     133,   134,    -1,   136,   137,    -1,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,    -1,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,   219,    -1,   221,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    20,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,    -1,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,    -1,
      -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,    -1,    -1,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,    -1,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,    -1,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,   219,    -1,
     221,   222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,
      -1,   232,   233,    -1,    -1,   236,    -1,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,    -1,    -1,    -1,
     133,   134,    -1,   136,   137,    -1,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,    -1,    -1,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,    -1,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,   219,    -1,   221,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,   236,    -1,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,    -1,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,    -1,    -1,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,    -1,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,   219,    -1,   221,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,   236,    -1,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,    -1,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,    -1,    -1,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,    -1,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,   219,    -1,   221,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,   236,
      -1,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,    -1,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
      -1,    -1,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,    -1,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
     219,    -1,   221,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,   236,    -1,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    -1,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,    -1,   118,   119,    -1,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,   130,
      -1,   132,   133,   134,    -1,   136,    -1,    -1,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,    -1,    -1,   180,
     181,   182,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
     211,   212,    -1,   214,    -1,   216,   217,   218,   219,    -1,
      -1,   222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,
      -1,   232,   233,    -1,    -1,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,    -1,   246,    -1,    -1,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,    -1,   329,    -1,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    -1,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,    -1,   118,   119,    -1,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,   130,    -1,   132,
     133,   134,    -1,   136,    -1,    -1,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,   157,    -1,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,    -1,    -1,   180,   181,   182,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,   218,   219,    -1,    -1,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,    -1,   237,   238,    -1,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,    -1,   329,    -1,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    -1,    -1,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,    -1,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,    -1,   111,   112,    -1,   114,
     115,   116,    -1,   118,   119,    -1,    -1,   122,   123,   124,
     125,    -1,   127,    -1,   129,   130,    -1,   132,   133,   134,
      -1,   136,    -1,    -1,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,    -1,   157,    -1,   159,   160,   161,   162,   163,   164,
      -1,   166,    -1,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,    -1,   180,   181,   182,    -1,   184,
     185,   186,    -1,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,   216,   217,   218,   219,    -1,    -1,   222,   223,   224,
     225,    -1,    -1,   228,    -1,    -1,    -1,   232,   233,    -1,
      -1,    -1,   237,   238,    -1,   240,   241,   242,   243,   244,
      -1,   246,    -1,    -1,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,    -1,   329,    -1,    -1,   332,   333,   334,
     335,   336,    -1,    -1,   339,   340,   341,   342,    -1,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,   373,   374,
      -1,    -1,    -1,    -1,    -1,   380,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    -1,    -1,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    88,    -1,    90,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,    -1,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,    -1,   111,   112,    -1,   114,   115,   116,
      -1,   118,   119,    -1,    -1,   122,   123,   124,   125,    -1,
     127,    -1,   129,   130,    -1,   132,   133,   134,    -1,   136,
      -1,    -1,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,    -1,
     157,    -1,   159,   160,   161,   162,   163,   164,    -1,   166,
      -1,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,    -1,    -1,   180,   181,   182,    -1,   184,   185,   186,
      -1,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,   211,   212,    -1,   214,    -1,   216,
     217,   218,   219,   220,    -1,   222,   223,   224,   225,    -1,
      -1,   228,    -1,    -1,    -1,   232,   233,    -1,    -1,    -1,
     237,   238,    -1,   240,   241,   242,   243,   244,    -1,   246,
      -1,    -1,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,    -1,   329,    -1,    -1,   332,   333,   334,   335,   336,
      -1,    -1,   339,   340,   341,   342,    -1,    -1,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   372,   373,   374,    -1,    -1,
      -1,    -1,    -1,   380,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    -1,    -1,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,    -1,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,    -1,   111,   112,    -1,   114,   115,   116,    -1,   118,
     119,    -1,    -1,   122,   123,   124,   125,    -1,   127,    -1,
     129,   130,    -1,   132,   133,   134,    -1,   136,    -1,    -1,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,    -1,   157,    -1,
     159,   160,   161,   162,   163,   164,    -1,   166,    -1,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
      -1,   180,   181,   182,    -1,   184,   185,   186,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
     209,   210,   211,   212,    -1,   214,    -1,   216,   217,   218,
     219,    -1,    -1,   222,   223,   224,   225,    -1,    -1,   228,
      -1,    -1,    -1,   232,   233,    -1,    -1,    -1,   237,   238,
      -1,   240,   241,   242,   243,   244,    -1,   246,    -1,    -1,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,    -1,
     329,    -1,    -1,   332,   333,   334,   335,   336,    -1,    -1,
     339,   340,   341,   342,    -1,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   372,   373,   374,    -1,    -1,    -1,    -1,
      -1,   380,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    -1,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,    -1,
     111,   112,    -1,   114,   115,   116,    -1,   118,   119,    -1,
      -1,   122,   123,   124,   125,    -1,   127,    -1,   129,   130,
      -1,   132,   133,   134,    -1,   136,    -1,    -1,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,    -1,   157,    -1,   159,   160,
     161,   162,   163,   164,    -1,   166,    -1,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,    -1,    -1,   180,
     181,   182,    -1,   184,   185,   186,    -1,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,   209,   210,
     211,   212,    -1,   214,    -1,   216,   217,   218,   219,    -1,
      -1,   222,   223,   224,   225,    -1,    -1,   228,    -1,    -1,
      -1,   232,   233,    -1,    -1,    -1,   237,   238,    -1,   240,
     241,   242,   243,   244,    -1,   246,    -1,    -1,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,    -1,   329,    -1,
      -1,   332,   333,   334,   335,   336,    -1,    -1,   339,   340,
     341,   342,    -1,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   372,   373,   374,    -1,    -1,    -1,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    -1,
      -1,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,    -1,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,    -1,   111,   112,
      -1,   114,   115,   116,    -1,   118,   119,    -1,    -1,   122,
     123,   124,   125,    -1,   127,    -1,   129,   130,    -1,   132,
     133,   134,    -1,   136,    -1,    -1,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,    -1,   157,    -1,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,    -1,    -1,   180,   181,   182,
      -1,   184,   185,   186,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,    -1,    -1,   222,
     223,   224,   225,    -1,    -1,   228,    -1,    -1,    -1,   232,
     233,    -1,    -1,    -1,   237,   238,    -1,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,    -1,
     293,    -1,   295,   296,   297,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,    -1,   329,    -1,    -1,   332,
     333,   334,   335,   336,    -1,    -1,   339,   340,   341,   342,
      -1,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,
     373,   374,    -1,    -1,    -1,    -1,    -1,   380
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     3,    13,    15,    16,    29,    48,    50,    51,    55,
      56,    65,    67,    83,    86,    92,    98,   104,   110,   116,
     118,   123,   135,   161,   184,   185,   190,   199,   217,   250,
     260,   263,   265,   270,   275,   278,   282,   288,   293,   296,
     303,   332,   340,   342,   345,   349,   401,   409,   410,   411,
     412,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     426,   427,   431,   441,   443,   444,   447,   448,   449,   457,
     458,   467,   495,   500,   501,   508,   513,   515,   517,   518,
     531,   532,   533,   534,   544,   550,   551,   554,   555,   556,
     557,   558,   563,   564,   567,   570,   571,   581,   582,   585,
     593,   607,   610,   611,   612,   615,   617,   619,   622,   624,
     625,   626,   634,   635,   636,   637,   638,   643,   645,   646,
     650,   651,   654,   655,   656,   658,   659,   660,   661,   663,
     664,   665,   670,   673,   676,   678,   679,   684,   686,   690,
     697,   700,   701,   702,   703,   704,   725,   327,   361,   639,
      10,    64,    81,   102,   133,   138,   152,   232,   255,   277,
     283,   289,   316,   317,   321,   329,   334,   343,   354,   514,
     639,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    22,    23,    25,    27,    28,    29,    31,
      33,    34,    36,    37,    38,    39,    40,    43,    44,    45,
      46,    48,    49,    50,    51,    52,    55,    56,    57,    58,
      59,    60,    62,    63,    64,    65,    66,    68,    69,    70,
      72,    73,    79,    80,    81,    82,    83,    84,    85,    86,
      88,    90,    91,    92,    93,    94,    96,    97,    98,   101,
     102,   103,   104,   105,   107,   108,   109,   111,   112,   114,
     115,   116,   117,   118,   119,   120,   122,   123,   124,   125,
     127,   129,   133,   134,   136,   137,   139,   141,   142,   143,
     144,   146,   147,   148,   150,   151,   152,   153,   154,   155,
     158,   159,   160,   161,   162,   163,   164,   166,   168,   171,
     173,   174,   175,   176,   177,   179,   181,   184,   185,   186,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   204,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   216,   217,   219,   221,   222,   223,
     224,   225,   228,   232,   233,   236,   239,   240,   241,   242,
     243,   244,   246,   247,   248,   249,   250,   251,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   274,   275,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     289,   290,   291,   293,   294,   295,   296,   298,   299,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   314,   315,   317,   318,   319,   320,   321,   323,   324,
     327,   328,   329,   330,   332,   333,   334,   335,   336,   339,
     340,   341,   342,   345,   346,   347,   348,   349,   350,   351,
     353,   354,   355,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     380,   815,   827,   830,   831,   205,   229,   811,   813,   819,
     827,   834,   230,   251,   639,    32,   463,   701,    10,    22,
      42,    61,    81,    87,   102,   134,   138,   186,   232,   234,
     277,   283,   317,   318,   320,   321,   329,   333,   334,   338,
     343,   468,   509,   547,   586,   594,    11,   250,   815,   815,
     131,    11,   246,   318,   320,    10,    22,    42,    64,    81,
     102,   133,   138,   152,   232,   240,   277,   281,   283,   289,
     316,   317,   321,   329,   334,   343,   354,   514,   559,   639,
     815,   665,   672,     4,    11,    27,   124,   129,   177,   206,
     253,   264,   386,   393,   568,   815,   826,    11,    67,   262,
     288,   572,   573,   574,   827,   167,   827,   382,   820,   824,
     316,   707,   568,   815,   827,   327,   815,   240,    81,   152,
     315,   316,   620,   282,   827,    11,   291,   323,   327,   433,
     827,     8,   135,   572,   573,   251,   639,   827,    11,    99,
     709,    62,   186,   201,   277,   291,   323,   327,   363,   432,
     433,    11,   291,   323,   327,   433,   327,   707,   394,   827,
     231,   734,   735,   813,   827,   132,   667,   401,   808,   701,
     702,     0,   405,   352,   666,   113,   165,   235,   337,   710,
     711,   406,    26,    30,    32,    71,   130,   132,   145,   157,
     169,   170,   172,   180,   182,   203,   218,   237,   238,   276,
     297,   352,   380,   811,   821,   828,   830,   832,   561,   827,
     816,   827,   561,   580,   821,   825,   827,   734,    49,   122,
     385,   388,   389,   390,   392,   393,   394,   395,   396,   397,
     614,   777,   778,   827,   825,   815,   734,   813,   734,   815,
     285,   815,   561,   825,   734,   175,   171,   258,   640,   641,
     642,   399,   404,   802,   803,   344,   662,   230,    10,    42,
      54,    61,    64,    81,   102,   133,   152,   176,   232,   277,
     281,   283,   289,   316,   317,   321,   329,   334,   354,   514,
     565,   824,   813,   325,   821,   815,   401,   329,   816,   561,
     318,   320,   825,   318,   320,    49,   122,   614,   268,   825,
     428,   827,   815,   285,   815,   561,   825,   289,   316,   354,
     514,    64,   152,   133,   281,    11,   815,   698,   735,   144,
     821,   815,   144,   618,   144,   816,   144,   821,   144,   814,
     815,    49,   122,   144,   614,    36,   144,   814,   144,   815,
     144,   815,   285,   144,   815,   144,   814,   175,   144,   560,
     561,   401,   677,   666,   826,    11,   826,    11,   826,   826,
     386,   131,   149,   569,   254,   230,   325,   406,   813,   812,
     813,   569,   824,   401,   674,    36,   815,   815,   813,   827,
      26,   374,   171,   404,   233,   233,   230,   131,   824,   325,
     230,    19,    31,    33,    34,    41,    42,    44,    45,    52,
      74,    75,    76,    77,    78,    84,    85,   103,   117,   120,
     121,   125,   137,   163,   164,   166,   179,   187,   188,   202,
     204,   215,   220,   221,   223,   232,   239,   247,   259,   279,
     292,   299,   311,   323,   324,   328,   330,   331,   338,   343,
     350,   365,   366,   367,   368,   369,   370,   371,   381,   383,
     384,   385,   386,   387,   392,   393,   394,   401,   701,   744,
     747,   750,   751,   752,   754,   755,   756,   757,   760,   761,
     764,   766,   767,   775,   779,   796,   801,   809,   810,   811,
     821,   822,   823,   824,    11,   445,   812,   291,   432,    87,
     439,   824,   382,   440,   827,    26,    46,   432,   374,   641,
     233,   131,   325,   388,    26,   374,   171,   642,   812,   401,
     813,    20,   827,   293,   394,   130,   668,    87,   764,   806,
     807,   402,   402,   411,   813,    11,    99,   708,   708,    36,
     708,   126,   183,   227,   714,   720,   722,   723,   808,   803,
     401,   539,   241,   266,   404,   562,   241,   266,   293,   359,
     413,   441,   442,     7,   104,   241,   293,   454,    38,    66,
     119,   147,   241,   266,   274,   280,   287,   293,   301,   309,
     355,   442,   603,   608,   401,   595,     7,   104,   266,   425,
     241,   266,   270,   293,   452,   453,   561,   561,   401,   404,
     266,   413,   442,   241,   266,   266,   293,   502,     7,    13,
      51,    97,   104,   107,   154,   207,   266,   293,   450,   451,
     453,   241,   266,    59,    96,   242,   319,   230,   241,   293,
     266,   413,   442,   266,   815,   181,   231,   362,   406,   640,
     764,    11,    15,    16,    17,    18,    19,    20,    21,    24,
      35,    41,    42,    47,    53,    54,    61,    67,    74,    75,
      76,    77,    78,    87,    89,    95,    99,   100,   106,   110,
     113,   121,   126,   128,   131,   135,   138,   140,   149,   156,
     165,   167,   178,   183,   187,   188,   205,   215,   220,   226,
     227,   229,   230,   231,   234,   235,   245,   252,   262,   273,
     288,   292,   300,   313,   316,   322,   325,   326,   331,   337,
     338,   343,   344,   356,   357,   380,   394,   818,   829,   830,
     831,   832,   833,   802,   819,   827,   813,   821,   401,   815,
     821,   224,    49,   122,   614,   815,   285,   815,   175,   561,
     401,   482,   306,   307,   460,   824,   401,   539,   540,    47,
      31,    33,    34,    44,    45,    84,    85,   125,   163,   164,
     166,   202,   204,   223,   259,   294,   299,   323,   324,   350,
     380,   741,   743,   745,   747,   749,   751,   752,   753,   755,
     756,   760,   761,   828,   830,   815,   413,    20,   657,   413,
     561,   561,   401,   535,   468,   413,    26,   429,   241,   516,
      59,    96,   242,   319,     9,    28,   519,    20,   535,   413,
     813,   496,   813,   813,   175,   561,    58,   819,   821,   815,
      32,    79,   160,   207,   284,   344,   685,   117,   539,    39,
     272,   455,   117,   401,   117,   117,   595,   117,   406,   144,
     561,   144,   561,   117,   401,   814,   117,   117,   230,   117,
      59,    96,   242,   319,   117,   230,   117,   144,   440,   117,
     406,   455,   764,   782,    67,   671,   676,   679,   684,   690,
     697,   700,   815,    81,   133,   175,   283,   289,   316,   317,
     575,   812,   814,   574,    87,   401,   680,   700,   149,   406,
     687,   815,   741,   784,    20,   814,   127,   621,   621,   621,
     181,   827,   126,   126,   575,   814,   282,   827,   401,   399,
     701,   786,   351,   758,   764,   800,   401,   758,   758,   401,
     401,   401,   401,   746,   746,   248,   701,   401,   401,   748,
     401,   401,   401,   401,    44,    45,   758,   764,   401,   746,
     401,   401,   401,   401,   401,   359,   360,   401,   762,   401,
     762,   401,   401,   701,   401,   401,   401,   401,   401,   401,
     401,   804,   764,   764,   349,   701,   764,   782,   803,   824,
      45,   401,   759,   401,   824,    17,    20,    25,    30,   145,
     149,   169,   170,   182,   215,   218,   232,   234,   297,   385,
     388,   389,   390,   392,   393,   394,   395,   396,   397,   403,
     777,   779,   781,   238,   764,   167,   406,   705,   803,   401,
     824,    90,   146,   446,    46,    87,   440,    20,    87,   186,
     380,   381,   393,   438,   505,   506,   507,   761,   824,   826,
      63,   101,   773,    73,    87,   121,   226,   230,   331,   434,
     435,   437,   440,   505,    87,   434,   181,   455,   813,   827,
     401,   691,   692,   693,   694,   695,   827,   666,   402,   406,
     401,   669,   701,   703,   704,   703,   712,   713,   764,   703,
     258,   295,   342,    11,   716,   764,   717,   764,   720,   721,
     714,   715,   126,   723,   394,   784,   241,   266,   293,   325,
     325,   818,   404,   325,   325,   432,   652,    47,    61,   128,
     252,   338,   480,   481,    61,    87,   215,   325,    87,   215,
     283,   230,   505,   287,   325,   325,   220,   505,    91,   168,
     283,   272,   603,   609,   149,   158,   236,   294,   402,   596,
     597,   598,   599,   601,   741,   828,   325,   343,   325,   325,
     535,   317,   535,   406,   344,   344,   213,   613,   741,   614,
     325,   414,   325,   325,   325,   283,    37,    80,   151,   194,
     196,   207,   240,   271,   303,   503,    54,   480,   623,   623,
     230,   281,   329,    61,   623,    14,   269,   281,   329,   813,
     154,   325,   623,   283,   360,   406,   325,   325,   561,   561,
     561,   561,   734,   325,   283,   325,   414,   325,   241,   266,
     258,   267,   290,   436,   640,   400,   407,   539,   741,   230,
     595,   505,   561,   561,   401,   169,   230,    59,    96,   242,
     319,   230,   561,   169,   483,   484,   827,   359,   464,   413,
     380,   541,   542,   535,   401,   743,    20,    19,   742,    82,
     143,   195,   198,   286,   372,   401,   763,   562,   746,     9,
     647,   741,   414,   547,   344,   536,   537,   829,   354,   414,
     825,    67,   135,   430,   467,   500,   518,   570,   585,   643,
     815,   189,   561,   561,   561,   561,    92,   161,   342,   520,
     521,   111,   401,   414,   502,    20,   225,   401,   497,   482,
     440,   126,   819,   230,   595,    20,   359,   360,   699,   284,
     401,   701,   727,   728,   729,   734,   736,   767,   811,   821,
     357,   738,   821,   455,   741,   816,   821,   455,   814,   815,
     117,   344,   117,   344,   614,   613,   455,   814,   815,   813,
     815,   815,   813,   814,   117,   455,   560,   561,   402,   406,
     468,   814,   579,   580,   814,   814,   812,   812,   814,   325,
     359,   583,   349,   681,   682,   827,   273,   683,     5,   115,
     279,   295,   688,   813,   219,   689,   402,   406,   675,   679,
     684,   690,   700,   325,   573,   572,   573,   131,   136,   584,
     827,   782,   782,   785,   786,   401,   356,   797,   798,   764,
     782,   823,   823,   782,    82,   143,   195,   198,   286,   372,
     380,   382,   783,   787,   823,   782,   782,   823,   823,   758,
     758,   764,   614,   764,   788,   392,   393,   765,   766,   775,
     779,   790,   402,   782,   764,   782,   791,   323,   323,   823,
     823,   764,    35,   131,   178,   326,   764,   782,   794,   782,
     200,   764,   771,   772,   773,   200,   764,   773,   802,   402,
     406,   293,   823,   823,   763,   764,   829,   323,    24,   313,
     805,   764,   401,   701,   795,    99,   101,   121,   215,   220,
     225,   331,   339,   764,    30,   145,   149,   182,   297,   401,
     764,   325,   764,   764,   764,   764,   764,   764,   764,   764,
     764,   741,   764,    11,    18,   300,   776,   279,   401,   775,
     134,   186,   316,   318,   320,   706,   813,   810,   131,   726,
      11,    99,   394,   402,   782,   327,   381,   401,   824,   406,
     402,   695,   696,   406,   726,   388,   804,   664,   813,   806,
     814,   406,    21,    95,   344,   591,   231,   225,   724,   724,
     227,   406,   183,   402,   402,   325,   325,   283,   825,   815,
     818,   825,   816,    60,   653,   401,   815,   173,   173,   401,
     815,   220,   825,   764,   220,   815,   220,    91,   168,   825,
     815,   230,   815,   236,   828,   402,   406,   599,   601,   598,
     601,   828,   562,   825,   814,   825,   815,   815,   453,   817,
     827,   817,   406,   402,   406,   825,     8,    60,    68,    69,
      70,   109,   149,   154,   191,   208,   209,   210,   211,   212,
     214,   244,   277,   312,   314,   336,   343,   346,   415,   825,
     815,   815,   815,   505,    36,   504,   505,   505,    80,   194,
     196,    36,   413,   413,   472,   827,   827,   815,   815,    11,
     343,   815,   815,   827,   281,   329,   281,   329,   815,    11,
     343,   815,   813,   815,   815,   815,    51,   228,   293,   451,
     825,   815,     7,    13,   104,   241,   266,   241,   266,   535,
     266,   266,   266,   825,   815,   825,   815,   325,   325,    57,
     335,   258,   764,   169,    20,   561,   169,   169,   344,   344,
     613,   220,   566,   824,   561,   561,   561,   561,   561,   561,
     169,   566,   402,   406,   228,   131,   325,   459,   461,   388,
     402,   406,   764,    19,   742,   741,   399,   399,   325,   325,
     325,   325,   823,   746,   520,    60,   108,   189,   241,   317,
     319,   648,   473,   126,   817,   402,   406,   388,   813,   429,
     234,   468,   824,   535,   535,   535,   535,   230,   234,   401,
     739,   740,   827,   116,   700,   813,   182,   469,   470,   471,
     472,   477,   480,   498,   499,   827,   359,   360,   491,    20,
     139,   824,   230,   813,    20,   175,   274,   602,   603,   604,
     627,   142,   142,   126,   701,   728,   729,    20,   730,   827,
     406,    71,   132,   157,   172,   180,   203,   276,   731,   730,
      20,   730,   827,   803,   401,    73,   764,   683,   539,    20,
     595,   561,   817,   561,   817,   401,   402,   230,   455,   230,
     455,   440,   455,   764,   316,   406,   138,   576,   577,   825,
       8,   584,   402,   406,   804,   809,   115,   295,   115,   295,
     279,   342,   197,   741,   815,   131,   230,   576,    36,   455,
     402,   400,   400,   406,   782,   764,   106,   798,   799,    20,
     402,   402,   402,   402,   402,   131,   402,   402,   402,   402,
     402,   406,   402,   245,   789,   402,   765,   765,   149,   169,
     232,   388,   389,   390,   392,   393,   394,   395,   396,   397,
     403,   779,   765,   402,   402,   126,   131,   792,   793,   402,
     374,   374,   402,   402,    20,   794,   782,   794,   794,   131,
     402,   402,   829,    20,   402,   406,   764,   829,   406,   764,
     804,   764,   827,   402,   402,   374,   765,   765,   112,   782,
     131,    99,   101,   121,   220,   225,   331,   339,   401,   112,
     313,   805,   764,   795,   764,   325,   614,   764,   401,   701,
     318,   320,   318,   320,   813,   707,   707,   727,   357,   737,
     782,   782,   402,   402,   641,   823,   763,   435,   402,   406,
     692,   738,   806,   402,   713,   232,   777,   780,   375,   376,
     592,   814,   689,   689,   717,   717,   716,   825,   815,   815,
     183,   764,   481,   401,   401,   483,   455,   159,   220,   562,
     597,   601,   601,   396,   241,   266,     7,   104,   241,   266,
     741,   241,   213,   741,   814,   183,   244,   138,   277,   220,
     824,   814,   823,   244,   814,   341,   505,   561,   505,   505,
     741,   104,   293,   334,   454,   455,   455,   815,   815,   815,
     815,   325,   192,   192,   192,   325,   325,   325,   325,   325,
     325,   325,   825,   815,   400,   566,   741,   169,   566,   566,
     817,   817,   402,   169,   169,   169,   169,   169,   169,   566,
     484,   460,    32,    72,    93,   112,   127,   141,   220,   228,
     257,   462,   232,   393,   505,   538,   601,   780,   824,   833,
     380,   542,   402,   399,   402,   823,   400,   823,   143,   195,
     286,   195,   286,   286,   198,   402,   230,   183,   388,   649,
     649,   649,   649,   649,    47,    61,    87,    89,   156,   215,
     220,   252,   262,   338,   474,   475,   476,   334,   537,   538,
     482,   268,   316,   813,   521,   543,   824,   402,   406,   741,
     815,   401,   813,   402,   406,   402,   406,   228,   535,   228,
     230,   492,   700,   510,   815,   325,   813,   344,   587,   605,
     824,   440,   600,   601,   359,   604,   606,   230,   700,   402,
     827,   401,   728,   172,   237,   732,   728,   732,   172,   731,
     732,   172,   401,   827,   401,   782,   225,   455,   741,   455,
     344,   455,   344,   455,   613,   455,   813,   813,   455,   496,
     813,   580,   825,   359,   406,   578,   233,   700,   682,   115,
     115,   814,   575,   455,   825,   786,   402,   322,   764,   110,
     741,   764,   764,   764,   792,   765,    99,   101,   215,   225,
     765,   765,   765,   765,   765,   765,   765,   765,   765,   741,
     765,   764,   764,   793,   792,   762,   762,   741,   402,   402,
     402,   782,   402,   406,   829,   772,   249,   310,   774,   402,
     406,   353,   768,    20,   402,   759,   824,   764,    17,    17,
     764,   402,   764,   131,   401,   784,   764,   765,   765,   112,
     112,   764,   402,   112,   764,   707,   707,   707,   707,   813,
     813,   764,   138,   718,   402,   402,   824,   402,   388,   695,
     683,   401,   592,   649,   402,   483,   483,   402,   159,   396,
     334,   325,   325,   133,   232,   308,   545,   546,   133,   232,
     552,   553,   325,   325,   325,   826,   824,   814,   814,   824,
     824,   473,   215,   215,   305,   308,   741,   815,   126,   126,
     268,   126,   144,   825,   815,   825,   815,   815,   815,   815,
     402,   566,   169,   169,   169,   566,   566,   566,   566,   566,
     566,   344,   465,   466,   657,   657,   215,   257,   657,   657,
      89,   156,   215,   528,   529,   530,   823,   359,   360,   400,
     400,   763,   813,   649,    87,   823,   824,    87,   824,    87,
     815,    87,   815,    87,   815,   401,   815,   765,    90,   146,
      89,   220,   173,   813,   606,   741,    20,   813,   126,   522,
     234,   402,   406,   740,   677,   469,   478,   155,   490,   471,
     499,   827,    56,   317,   493,   377,   378,   379,   644,   347,
     511,   562,   824,   587,   817,   401,   406,   602,   535,    92,
     161,   288,   342,   632,   730,   401,   814,   728,   230,   344,
     733,   728,   172,   728,   739,   401,   739,   827,   402,   387,
     815,   402,   817,   817,   402,   455,   455,    20,   401,   135,
     577,   584,   131,   764,   402,   402,   793,   131,    99,   101,
     225,   401,   402,   364,   770,   782,   358,   358,   402,   764,
     207,   764,   406,   769,   743,   763,   765,   765,   764,   784,
     402,    17,    17,   764,   764,   112,   764,   402,   813,   813,
     813,   813,    36,   140,   719,   824,   808,   614,   826,   402,
     402,   606,   334,   825,   815,   823,   823,   741,   406,   823,
     823,   406,   825,   815,   825,   220,   220,   507,   827,   344,
     456,   814,   814,   561,   814,   117,   169,   566,   566,   566,
     413,    94,   824,   824,   220,   483,   824,   824,    90,   146,
      89,   530,   529,   400,   133,   133,   131,   527,   826,   764,
     215,   475,   606,   482,   344,   494,   344,   700,   401,   105,
     523,   116,   521,   824,   402,   114,   150,   479,   401,   491,
      92,   104,   249,   815,    47,    47,   233,   510,   174,   512,
     131,   401,   401,   588,   589,   767,   827,   824,   606,   325,
     814,   402,   764,   401,   728,   733,   402,   739,   402,   455,
     455,   455,   455,   233,   455,   576,   765,   131,   401,   784,
     401,   402,   406,   402,   402,   348,   302,   402,   402,   402,
     765,   765,   764,   782,   764,   763,   402,   262,   606,   494,
     401,   821,   614,   546,   401,   401,   553,   764,   359,   268,
     359,   359,   126,   566,   461,   824,   483,   580,    20,   616,
     813,   528,   402,   494,   193,   485,   152,   817,   644,   279,
     304,   524,   256,   491,    62,    88,   153,    62,    88,   153,
     812,   492,   280,   280,   233,   233,   824,   561,   588,   764,
     402,   406,   344,   561,   590,   590,   813,   402,   814,   402,
     455,   765,   784,   402,   771,   782,   207,   373,   813,   494,
     784,   595,   261,   401,   549,   784,   784,   560,   561,   560,
     561,   814,   616,    23,   148,   126,   132,   243,   298,   230,
     486,   487,   488,   317,   122,   548,   821,   492,   402,   493,
     402,   402,   606,   589,   561,   591,   591,   737,   402,   402,
     402,   402,   348,   482,   402,   613,   402,   402,   359,   105,
      92,   342,   230,   488,   230,   487,   815,   561,    20,   401,
     493,   606,   590,   493,   592,   592,   100,   485,   821,   402,
     561,   279,    39,   207,   272,   293,   489,   489,   545,   381,
     383,   384,   386,   525,   526,   824,   827,   493,   591,   737,
      12,   162,   633,   486,   595,   549,   116,     6,    87,   220,
     402,   406,   737,   592,   216,   401,   628,   630,   635,   679,
     684,   690,   700,   528,   256,   526,   629,   630,   631,   701,
     702,   821,   402,   405,   401,   631,   525,   402
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 511 "gram.y"
    { parsetree = (yyvsp[(1) - (1)].list); }
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 516 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 522 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					  else
						(yyval.list) = NIL;
					}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 622 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 633 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 643 "gram.y"
    {}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 644 "gram.y"
    {}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 653 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 654 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 659 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 664 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 668 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 673 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 678 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 682 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 686 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 690 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
				}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 694 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
				}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 698 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
				}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 702 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
				}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 706 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
				}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 710 "gram.y"
    {
					/* For backwards compatibility, synonym for SUPERUSER */
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 715 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 719 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
				}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 723 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
				}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 727 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 731 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 736 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 741 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 745 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 749 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 753 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 757 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 771 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 789 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 800 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 817 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 829 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 849 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 856 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 875 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 882 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 899 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 917 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 927 "gram.y"
    { (yyval.ival) = +1; }
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 928 "gram.y"
    { (yyval.ival) = -1; }
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 941 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 948 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 965 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 977 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 988 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 989 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 993 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 994 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1022 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1028 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1034 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1043 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1051 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1059 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1066 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1073 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1081 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1092 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1100 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1108 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), NULL));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1119 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), NULL));
					(yyval.vsetstmt) = n;
				}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1127 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), NULL));
					(yyval.vsetstmt) = n;
				}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1135 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1142 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", NULL));
					(yyval.vsetstmt) = n;
				}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1151 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1153 "gram.y"
    {
					(yyval.str) = palloc(strlen((yyvsp[(1) - (3)].str)) + strlen((yyvsp[(3) - (3)].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str));
				}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1159 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1160 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1164 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), NULL); }
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1166 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), NULL); }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1168 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value)); }
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1171 "gram.y"
    { (yyval.str) = "read uncommitted"; }
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1172 "gram.y"
    { (yyval.str) = "read committed"; }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1173 "gram.y"
    { (yyval.str) = "repeatable read"; }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1174 "gram.y"
    { (yyval.str) = "serializable"; }
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1178 "gram.y"
    { (yyval.str) = "true"; }
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1179 "gram.y"
    { (yyval.str) = "false"; }
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1180 "gram.y"
    { (yyval.str) = "on"; }
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1181 "gram.y"
    { (yyval.str) = "off"; }
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1194 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1198 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1202 "gram.y"
    {
					A_Const *n = (A_Const *) makeStringConst((yyvsp[(2) - (3)].str), (yyvsp[(1) - (3)].typnam));
					if ((yyvsp[(3) - (3)].ival) != INTERVAL_FULL_RANGE)
					{
						if (((yyvsp[(3) - (3)].ival) & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE")));
						n->typename->typmods = list_make1(makeIntConst((yyvsp[(3) - (3)].ival)));
					}
					(yyval.node) = (Node *)n;
				}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1215 "gram.y"
    {
					A_Const *n = (A_Const *) makeStringConst((yyvsp[(5) - (6)].str), (yyvsp[(1) - (6)].typnam));
					if (((yyvsp[(6) - (6)].ival) != INTERVAL_FULL_RANGE)
						&& (((yyvsp[(6) - (6)].ival) & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("time zone interval must be HOUR or HOUR TO MINUTE")));
					n->typename->typmods = list_make2(makeIntConst((yyvsp[(6) - (6)].ival)),
													  makeIntConst((yyvsp[(3) - (6)].ival)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1226 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value)); }
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1227 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1228 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1232 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1233 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1234 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1238 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1239 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1244 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1251 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1258 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1265 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1272 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1281 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1282 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1288 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1294 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1300 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1306 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1312 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1322 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred    = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1331 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1332 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1336 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1337 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1346 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1361 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1367 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1373 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1379 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1395 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1403 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					(yyval.node) = (Node *)n;
				}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1413 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1414 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1421 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1429 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1438 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1446 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1454 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) (yyvsp[(6) - (6)].value);
					(yyval.node) = (Node *)n;
				}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1463 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1472 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1484 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) (yyvsp[(5) - (6)].typnam);
					n->transform = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1494 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1502 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1511 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1518 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1526 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1534 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1542 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1550 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1558 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1565 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1572 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1580 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1587 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1594 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1602 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1610 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1618 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1626 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1634 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1641 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1647 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1648 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1655 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1663 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1671 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1679 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1688 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); }
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1689 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1693 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; }
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1694 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; }
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1695 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1699 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1700 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1714 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1720 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1744 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (10)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (10)].list);
					n->is_from = (yyvsp[(6) - (10)].boolean);
					n->filename = (yyvsp[(7) - (10)].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (10)].defelt));
					if ((yyvsp[(5) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (10)].defelt));
					if ((yyvsp[(8) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(8) - (10)].defelt));
					if ((yyvsp[(10) - (10)].list))
						n->options = list_concat(n->options, (yyvsp[(10) - (10)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1766 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (6)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[(4) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1779 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1780 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1789 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1790 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1791 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1797 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1798 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1804 "gram.y"
    {
					(yyval.defelt) = makeDefElem("binary", (Node *)makeInteger(TRUE));
				}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1808 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1812 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1816 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1820 "gram.y"
    {
					(yyval.defelt) = makeDefElem("csv", (Node *)makeInteger(TRUE));
				}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1824 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1828 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1832 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1836 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1840 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_notnull", (Node *)(yyvsp[(4) - (4)].list));
				}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1849 "gram.y"
    {
					(yyval.defelt) = makeDefElem("binary", (Node *)makeInteger(TRUE));
				}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1852 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1857 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1860 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1866 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1869 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1873 "gram.y"
    {}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1874 "gram.y"
    {}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1887 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->istemp = (yyvsp[(2) - (11)].boolean);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1901 "gram.y"
    {
					/* SQL99 CREATE TABLE OF <UDT> (cols) seems to be satisfied
					 * by our inheritance capabilities. Let's try it...
					 */
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (12)].range)->istemp = (yyvsp[(2) - (12)].boolean);
					n->relation = (yyvsp[(4) - (12)].range);
					n->tableElts = (yyvsp[(8) - (12)].list);
					n->inhRelations = list_make1((yyvsp[(6) - (12)].range));
					n->constraints = NIL;
					n->options = (yyvsp[(10) - (12)].list);
					n->oncommit = (yyvsp[(11) - (12)].oncommit);
					n->tablespacename = (yyvsp[(12) - (12)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1925 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1926 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1927 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1928 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1929 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1930 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1931 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1935 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1936 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1941 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1945 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1951 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1952 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1953 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1957 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typename = (yyvsp[(2) - (3)].typnam);
					n->constraints = (yyvsp[(3) - (3)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1968 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1969 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1974 "gram.y"
    {
					switch (nodeTag((yyvsp[(3) - (3)].node)))
					{
						case T_Constraint:
							{
								Constraint *n = (Constraint *)(yyvsp[(3) - (3)].node);
								n->name = (yyvsp[(2) - (3)].str);
							}
							break;
						case T_FkConstraint:
							{
								FkConstraint *n = (FkConstraint *)(yyvsp[(3) - (3)].node);
								n->constr_name = (yyvsp[(2) - (3)].str);
							}
							break;
						default:
							break;
					}
					(yyval.node) = (yyvsp[(3) - (3)].node);
				}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1994 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1995 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2015 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2026 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2037 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2049 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2061 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->name = NULL;
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2072 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->name = NULL;
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2083 "gram.y"
    {
					FkConstraint *n = makeNode(FkConstraint);
					n->constr_name		= NULL;
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->deferrable		= FALSE;
					n->initdeferred		= FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2112 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2118 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2124 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					(yyval.node) = (Node *)n;
				}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2130 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2148 "gram.y"
    {
					InhRelation *n = makeNode(InhRelation);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2157 "gram.y"
    { (yyval.list) = lappend_int((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].ival)); }
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2158 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2162 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_DEFAULTS; }
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2163 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_DEFAULTS; }
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2164 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_CONSTRAINTS; }
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2165 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_CONSTRAINTS; }
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2166 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_INDEXES; }
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2167 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_INDEXES; }
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2177 "gram.y"
    {
					switch (nodeTag((yyvsp[(3) - (3)].node)))
					{
						case T_Constraint:
							{
								Constraint *n = (Constraint *)(yyvsp[(3) - (3)].node);
								n->name = (yyvsp[(2) - (3)].str);
							}
							break;
						case T_FkConstraint:
							{
								FkConstraint *n = (FkConstraint *)(yyvsp[(3) - (3)].node);
								n->constr_name = (yyvsp[(2) - (3)].str);
							}
							break;
						default:
							break;
					}
					(yyval.node) = (yyvsp[(3) - (3)].node);
				}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2197 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2202 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->name = NULL;
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2212 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = (yyvsp[(3) - (6)].list);
					n->options = (yyvsp[(5) - (6)].list);
					n->indexspace = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2224 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = (yyvsp[(4) - (7)].list);
					n->options = (yyvsp[(6) - (7)].list);
					n->indexspace = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2237 "gram.y"
    {
					FkConstraint *n = makeNode(FkConstraint);
					n->constr_name		= NULL;
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					n->deferrable		= ((yyvsp[(11) - (11)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(11) - (11)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2253 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2254 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2258 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2259 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2263 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2269 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2273 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented")));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2280 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2284 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2297 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2299 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); }
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2301 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); }
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2303 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); }
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2305 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2308 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2311 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2315 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2316 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2317 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2318 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2319 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2322 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2323 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2328 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2329 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); }
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2330 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); }
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2331 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2334 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; }
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2335 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2336 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2337 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2340 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2341 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2344 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); }
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2345 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2356 "gram.y"
    {
					/*
					 * When the SelectStmt is a set-operation tree, we must
					 * stuff the INTO information into the leftmost component
					 * Select, because that's where analyze.c will expect
					 * to find it.	Similarly, the output column names must
					 * be attached to that Select's target list.
					 */
					SelectStmt *n = findLeftmostSelect((SelectStmt *) (yyvsp[(6) - (6)].node));
					if (n->intoClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE AS cannot specify INTO")));
					(yyvsp[(4) - (6)].into)->rel->istemp = (yyvsp[(2) - (6)].boolean);
					n->intoClause = (yyvsp[(4) - (6)].into);
					(yyval.node) = (yyvsp[(6) - (6)].node);
				}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2377 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
				}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 2388 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 2389 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 2393 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 2394 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 2399 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (1)].str);
					n->typename = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 2424 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->istemp = (yyvsp[(2) - (5)].boolean);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 2435 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2443 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2444 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2448 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2452 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2456 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2460 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2464 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2468 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2472 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2476 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2480 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2484 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2488 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2493 "gram.y"
    {}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2494 "gram.y"
    {}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2498 "gram.y"
    { (yyval.value) = (yyvsp[(1) - (1)].value); }
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2499 "gram.y"
    { (yyval.value) = (yyvsp[(1) - (1)].value); }
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2502 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); }
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2504 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2510 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); }
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2523 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->plname = (yyvsp[(5) - (5)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2534 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->plname = (yyvsp[(5) - (9)].str);
				n->plhandler = (yyvsp[(7) - (9)].list);
				n->plvalidator = (yyvsp[(8) - (9)].list);
				n->pltrusted = (yyvsp[(2) - (9)].boolean);
				/* LANCOMPILER is now ignored entirely */
				(yyval.node) = (Node *)n;
			}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2546 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 2547 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2555 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2556 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2560 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2561 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2565 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2566 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2571 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(4) - (5)].str);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2579 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2589 "gram.y"
    {}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2590 "gram.y"
    {}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2601 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2610 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2611 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2625 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2632 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2652 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->funcname = (yyvsp[(11) - (14)].list);
					n->args = (yyvsp[(13) - (14)].list);
					n->before = (yyvsp[(4) - (14)].boolean);
					n->row = (yyvsp[(8) - (14)].boolean);
					memcpy(n->actions, (yyvsp[(5) - (14)].str), 4);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2672 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (19)].str);
					n->relation = (yyvsp[(8) - (19)].range);
					n->funcname = (yyvsp[(16) - (19)].list);
					n->args = (yyvsp[(18) - (19)].list);
					n->before = FALSE;
					n->row = TRUE;
					memcpy(n->actions, (yyvsp[(6) - (19)].str), 4);
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(10) - (19)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(10) - (19)].ival) & 2) != 0;

					n->constrrel = (yyvsp[(9) - (19)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2691 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2692 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2697 "gram.y"
    {
					char *e = palloc(4);
					e[0] = (yyvsp[(1) - (1)].chr); e[1] = '\0';
					(yyval.str) = e;
				}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2703 "gram.y"
    {
					char *e = palloc(4);
					e[0] = (yyvsp[(1) - (3)].chr); e[1] = (yyvsp[(3) - (3)].chr); e[2] = '\0';
					(yyval.str) = e;
				}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2709 "gram.y"
    {
					char *e = palloc(4);
					e[0] = (yyvsp[(1) - (5)].chr); e[1] = (yyvsp[(3) - (5)].chr); e[2] = (yyvsp[(5) - (5)].chr); e[3] = '\0';
					(yyval.str) = e;
				}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2717 "gram.y"
    { (yyval.chr) = 'i'; }
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2718 "gram.y"
    { (yyval.chr) = 'd'; }
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2719 "gram.y"
    { (yyval.chr) = 'u'; }
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2724 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2728 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2738 "gram.y"
    {}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2739 "gram.y"
    {}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2743 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2744 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 2748 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 2749 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2750 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2755 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2760 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2761 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2762 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2763 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2764 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2768 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); }
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 2769 "gram.y"
    { (yyval.range) = NULL; }
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2774 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2776 "gram.y"
    {
					if ((yyvsp[(1) - (2)].ival) == 0 && (yyvsp[(2) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE")));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2784 "gram.y"
    {
					if ((yyvsp[(1) - (1)].ival) != 0)
						(yyval.ival) = 3;
					else
						(yyval.ival) = 0;
				}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2791 "gram.y"
    {
					if ((yyvsp[(2) - (2)].ival) == 0 && (yyvsp[(1) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE")));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2799 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2803 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2804 "gram.y"
    { (yyval.ival) = 1; }
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2808 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2809 "gram.y"
    { (yyval.ival) = 2; }
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2815 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2825 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2848 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2866 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = NULL;
					n->property = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2889 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2899 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2910 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2920 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2930 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2941 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);
					RangeVar *r = makeNode(RangeVar);

					/* can't use qualified_name, sigh */
					switch (list_length((yyvsp[(3) - (7)].list)))
					{
						case 1:
							r->catalogname = NULL;
							r->schemaname = NULL;
							r->relname = strVal(linitial((yyvsp[(3) - (7)].list)));
							break;
						case 2:
							r->catalogname = NULL;
							r->schemaname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							break;
						case 3:
							r->catalogname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->schemaname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lthird((yyvsp[(3) - (7)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString((yyvsp[(3) - (7)].list)))));
							break;
					}
					n->typevar = r;
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2975 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typename = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 2982 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 2991 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 3000 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 3009 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 3019 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 3022 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 3023 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 3027 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 3031 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 3037 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); }
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 3038 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); }
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 3039 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); }
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 3040 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); }
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 3041 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 3044 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 3045 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 3048 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 3051 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 3052 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3056 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3062 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3064 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3082 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3095 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3096 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3101 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (4)].ival);
					n->recheck = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3111 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (7)].list);
					n->args = (yyvsp[(5) - (7)].list);
					n->number = (yyvsp[(2) - (7)].ival);
					n->recheck = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3121 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3130 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3140 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3148 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3149 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3152 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3153 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3156 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3157 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3163 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3173 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3182 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3193 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3194 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3199 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3207 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3219 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3228 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3240 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3249 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3270 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3280 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3298 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3307 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3318 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3319 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3320 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3321 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3322 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3323 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; }
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3324 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3325 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3326 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3327 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3328 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3329 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3333 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3334 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3337 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3338 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3342 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); }
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3344 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3357 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3388 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3397 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3406 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3416 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (9)].list);
					n->objargs = (yyvsp[(6) - (9)].list);
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3425 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3434 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3443 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3453 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3462 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3471 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3480 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3489 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 3498 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 3507 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 3515 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 3523 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 3531 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 3541 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 3542 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 3543 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 3544 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 3545 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 3546 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 3547 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 3548 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 3549 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 3550 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 3551 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 3552 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 3556 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 3557 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 3568 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (4)].node);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 3575 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					n->portalname = (yyvsp[(2) - (2)].str);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 3584 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (4)].node);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 3591 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					n->portalname = (yyvsp[(2) - (2)].str);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 3603 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 3610 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 3617 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 3624 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 3631 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 3638 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 3645 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 3652 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (1)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 3659 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 3666 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 3673 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 3680 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 3687 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 3694 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 3701 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 3709 "gram.y"
    {}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 3710 "gram.y"
    {}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 3722 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 3737 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 3750 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 3775 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 3777 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 3779 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 3783 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 3785 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 3788 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 3789 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 3790 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 3791 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 3800 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 3807 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 3814 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 3821 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 3828 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 3835 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 3842 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 3849 "gram.y"
    {
					PrivTarget *n = makeNode(PrivTarget);
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 3859 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 3860 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 3864 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 3874 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 3887 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 3888 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 3892 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); }
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 3894 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); }
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 3899 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 3915 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 3928 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 3938 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 3949 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 3950 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 3953 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 3954 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 3972 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (13)].boolean);
					n->concurrent = false;
					n->idxname = (yyvsp[(4) - (13)].str);
					n->relation = (yyvsp[(6) - (13)].range);
					n->accessMethod = (yyvsp[(7) - (13)].str);
					n->indexParams = (yyvsp[(9) - (13)].list);
					n->options = (yyvsp[(11) - (13)].list);
					n->tableSpace = (yyvsp[(12) - (13)].str);
					n->whereClause = (yyvsp[(13) - (13)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 3988 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = true;
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 4004 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 4005 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 4009 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 4010 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 4013 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); }
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 4014 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); }
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 4023 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (4)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 4032 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (4)].node);
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 4041 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (6)].node);
					(yyval.ielem)->opclass = (yyvsp[(4) - (6)].list);
					(yyval.ielem)->ordering = (yyvsp[(5) - (6)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(6) - (6)].ival);
				}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 4051 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 4052 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 4053 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 4056 "gram.y"
    { (yyval.ival) = SORTBY_ASC; }
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 4057 "gram.y"
    { (yyval.ival) = SORTBY_DESC; }
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 4058 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; }
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 4061 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4062 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; }
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4063 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4081 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4093 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4106 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4107 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4110 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4111 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4115 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4116 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4131 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					(yyval.fun_param) = n;
				}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4139 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					(yyval.fun_param) = n;
				}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4147 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					(yyval.fun_param) = n;
				}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4155 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					(yyval.fun_param) = n;
				}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4163 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					(yyval.fun_param) = n;
				}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4173 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4174 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4175 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4176 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4187 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4201 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4203 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 4209 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4220 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 4221 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4229 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4233 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4237 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4241 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 4245 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 4249 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 4253 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 4257 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4261 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4265 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4269 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4273 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4277 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4285 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4289 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4293 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4298 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4300 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4306 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4307 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4320 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4330 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4331 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 4353 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = extractArgTypes((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 4363 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = extractArgTypes((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 4376 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 4386 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 4399 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(3) - (7)].list);
					n->args = (yyvsp[(5) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 4409 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(5) - (9)].list);
					n->args = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 4422 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator.")));
				}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 4429 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (3)].typnam), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 4431 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(3) - (3)].typnam)); }
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 4433 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (3)].typnam), NULL); }
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 4438 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 4440 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); }
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 4452 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 4462 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 4472 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; }
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 4473 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; }
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 4474 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; }
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 4479 "gram.y"
    {
					DropCastStmt *n = makeNode(DropCastStmt);
					n->sourcetype = (yyvsp[(5) - (9)].typnam);
					n->targettype = (yyvsp[(7) - (9)].typnam);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 4489 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 4490 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 4505 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 4513 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 4523 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 4535 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 4536 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 4539 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 4540 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 4551 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 4560 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 4568 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 4576 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 4585 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 4593 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[(4) - (7)].str);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 4601 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 4610 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 4619 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 4627 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 4636 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 4645 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 4654 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 4663 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 4672 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 4681 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 4689 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 4697 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 4705 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 4713 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 4721 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 4729 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 4738 "gram.y"
    { (yyval.ival) = COLUMN; }
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 4739 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 4750 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 4759 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 4767 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 4776 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 4784 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 4792 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 4808 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 4817 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 4825 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 4833 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 4841 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 4850 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 4858 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (9)].list);
					n->objarg = (yyvsp[(5) - (9)].list);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 4867 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 4876 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 4885 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 4893 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 4901 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 4909 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 4917 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 4934 "gram.y"
    { QueryIsRule=TRUE; }
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 4937 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (14)].boolean);
					n->relation = (yyvsp[(10) - (14)].range);
					n->rulename = (yyvsp[(4) - (14)].str);
					n->whereClause = (yyvsp[(11) - (14)].node);
					n->event = (yyvsp[(8) - (14)].ival);
					n->instead = (yyvsp[(13) - (14)].boolean);
					n->actions = (yyvsp[(14) - (14)].list);
					(yyval.node) = (Node *)n;
					QueryIsRule=FALSE;
				}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 4952 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 4953 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 4954 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 4960 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 4966 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 4982 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 4983 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 4986 "gram.y"
    { (yyval.ival) = CMD_SELECT; }
    break;

  case 783:

/* Line 1455 of yacc.c  */
#line 4987 "gram.y"
    { (yyval.ival) = CMD_UPDATE; }
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 4988 "gram.y"
    { (yyval.ival) = CMD_DELETE; }
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 4989 "gram.y"
    { (yyval.ival) = CMD_INSERT; }
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 4993 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 4994 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 4995 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 5001 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 5011 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 5032 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->relation = makeNode(RangeVar);
					n->relation->relname = (yyvsp[(2) - (2)].str);
					n->relation->schemaname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 5042 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->relation = makeNode(RangeVar);
					n->relation->relname = (yyvsp[(2) - (2)].str);
					n->relation->schemaname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 5053 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->relation = makeNode(RangeVar);
					n->relation->relname = (yyvsp[(2) - (2)].str);
					n->relation->schemaname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 5061 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->relation = makeNode(RangeVar);
					n->relation->relname = "*";
					n->relation->schemaname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 5082 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 5089 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 5096 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 5103 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 5110 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 5117 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 5124 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 5132 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 5140 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 5148 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 5156 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 5164 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 5171 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 5178 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 5186 "gram.y"
    {}
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 5187 "gram.y"
    {}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 5188 "gram.y"
    {}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 5193 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), NULL)); }
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 5196 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE)); }
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 5199 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE)); }
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 5206 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 5208 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 5210 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 819:

/* Line 1455 of yacc.c  */
#line 5216 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 5230 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (8)].range);
					n->view->istemp = (yyvsp[(2) - (8)].boolean);
					n->aliases = (yyvsp[(5) - (8)].list);
					n->query = (yyvsp[(7) - (8)].node);
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 5241 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (10)].range);
					n->view->istemp = (yyvsp[(4) - (10)].boolean);
					n->aliases = (yyvsp[(7) - (10)].list);
					n->query = (yyvsp[(9) - (10)].node);
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 5258 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 5264 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 5270 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 5275 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 5286 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 5302 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 5311 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 5312 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 5317 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 5321 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 5325 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 5329 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 5333 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 5337 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 5341 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 5345 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 5349 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 5353 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 5357 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 5361 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 5370 "gram.y"
    {}
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 5371 "gram.y"
    {}
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 5383 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 5393 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 5403 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 847:

/* Line 1455 of yacc.c  */
#line 5404 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 848:

/* Line 1455 of yacc.c  */
#line 5409 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 5423 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 5430 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 5447 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typename = (yyvsp[(5) - (6)].typnam);
					n->constraints = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 5459 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typename = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 5468 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typename = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 5476 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typename = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 5484 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typename = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 5493 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typename = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 5503 "gram.y"
    {}
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 5504 "gram.y"
    {}
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 5516 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 5526 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 5536 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 5546 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 5556 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 5566 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 5574 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 5596 "gram.y"
    {
			  CreateConversionStmt *n = makeNode(CreateConversionStmt);
			  n->conversion_name = (yyvsp[(4) - (10)].list);
			  n->for_encoding_name = (yyvsp[(6) - (10)].str);
			  n->to_encoding_name = (yyvsp[(8) - (10)].str);
			  n->func_name = (yyvsp[(10) - (10)].list);
			  n->def = (yyvsp[(2) - (10)].boolean);
			  (yyval.node) = (Node *)n;
			}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 5618 "gram.y"
    {
			       ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(2) - (3)].range);
				   n->indexname = (yyvsp[(3) - (3)].str);
				   (yyval.node) = (Node*)n;
				}
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 5625 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = NULL;
				   n->indexname = NULL;
				   (yyval.node) = (Node*)n;
				}
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 5633 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(4) - (4)].range);
				   n->indexname = (yyvsp[(2) - (4)].str);
				   (yyval.node) = (Node*)n;
				}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 5642 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 5643 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 5656 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = true;
					n->analyze = false;
					n->full = (yyvsp[(2) - (4)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->verbose = (yyvsp[(4) - (4)].boolean);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 5668 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = true;
					n->analyze = false;
					n->full = (yyvsp[(2) - (5)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->verbose = (yyvsp[(4) - (5)].boolean);
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 5680 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->vacuum = true;
					n->full = (yyvsp[(2) - (5)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->verbose |= (yyvsp[(4) - (5)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 5692 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = false;
					n->analyze = true;
					n->full = false;
					n->freeze_min_age = -1;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 5704 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = false;
					n->analyze = true;
					n->full = false;
					n->freeze_min_age = -1;
					n->verbose = (yyvsp[(2) - (4)].boolean);
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 5718 "gram.y"
    {}
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 5719 "gram.y"
    {}
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 5723 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 880:

/* Line 1455 of yacc.c  */
#line 5724 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 5727 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 882:

/* Line 1455 of yacc.c  */
#line 5728 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 883:

/* Line 1455 of yacc.c  */
#line 5731 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 5732 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 5736 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 5737 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 5749 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->analyze = (yyvsp[(2) - (4)].boolean);
					n->verbose = (yyvsp[(3) - (4)].boolean);
					n->query = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 5768 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 895:

/* Line 1455 of yacc.c  */
#line 5769 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 5780 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 897:

/* Line 1455 of yacc.c  */
#line 5789 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 898:

/* Line 1455 of yacc.c  */
#line 5790 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 5808 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					n->into = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 904:

/* Line 1455 of yacc.c  */
#line 5817 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (8)].str);
					n->params = (yyvsp[(8) - (8)].list);
					(yyvsp[(4) - (8)].into)->rel->istemp = (yyvsp[(2) - (8)].boolean);
					n->into = (yyvsp[(4) - (8)].into);
					if ((yyvsp[(4) - (8)].into)->colNames)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("column name list not allowed in CREATE TABLE / AS EXECUTE")));
					/* ... because it's not implemented, but it could be */
					(yyval.node) = (Node *) n;
				}
    break;

  case 905:

/* Line 1455 of yacc.c  */
#line 5832 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 5833 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 5844 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 5850 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 5856 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 5862 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 911:

/* Line 1455 of yacc.c  */
#line 5878 "gram.y"
    {
					(yyvsp[(4) - (5)].istmt)->relation = (yyvsp[(3) - (5)].range);
					(yyvsp[(4) - (5)].istmt)->returningList = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) (yyvsp[(4) - (5)].istmt);
				}
    break;

  case 912:

/* Line 1455 of yacc.c  */
#line 5887 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				}
    break;

  case 913:

/* Line 1455 of yacc.c  */
#line 5893 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				}
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 5899 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 5908 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 5910 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 5915 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = (yyvsp[(2) - (2)].list);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 5925 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 5926 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 5939 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(3) - (6)].range);
					n->usingClause = (yyvsp[(4) - (6)].list);
					n->whereClause = (yyvsp[(5) - (6)].node);
					n->returningList = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 921:

/* Line 1455 of yacc.c  */
#line 5950 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 5951 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 923:

/* Line 1455 of yacc.c  */
#line 5955 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 5965 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); }
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 5966 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 5969 "gram.y"
    { (yyval.ival) = AccessShareLock; }
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 5970 "gram.y"
    { (yyval.ival) = RowShareLock; }
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 5971 "gram.y"
    { (yyval.ival) = RowExclusiveLock; }
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 5972 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; }
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 5973 "gram.y"
    { (yyval.ival) = ShareLock; }
    break;

  case 931:

/* Line 1455 of yacc.c  */
#line 5974 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; }
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 5975 "gram.y"
    { (yyval.ival) = ExclusiveLock; }
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 5976 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 5979 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 5980 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 5996 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(2) - (7)].range);
					n->targetList = (yyvsp[(4) - (7)].list);
					n->fromClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 6008 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 6009 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); }
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 6013 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 6014 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 941:

/* Line 1455 of yacc.c  */
#line 6019 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				}
    break;

  case 942:

/* Line 1455 of yacc.c  */
#line 6027 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values")));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				}
    break;

  case 943:

/* Line 1455 of yacc.c  */
#line 6054 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = (yyvsp[(2) - (2)].list);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 944:

/* Line 1455 of yacc.c  */
#line 6064 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 945:

/* Line 1455 of yacc.c  */
#line 6065 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); }
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 6076 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 6086 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 6087 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; }
    break;

  case 949:

/* Line 1455 of yacc.c  */
#line 6088 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; }
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 6089 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; }
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 6090 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; }
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 6093 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 6094 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; }
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 6095 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 6148 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 6149 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 6159 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 6161 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 6167 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1));
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 962:

/* Line 1455 of yacc.c  */
#line 6173 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1));
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 963:

/* Line 1455 of yacc.c  */
#line 6181 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 964:

/* Line 1455 of yacc.c  */
#line 6182 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 965:

/* Line 1455 of yacc.c  */
#line 6212 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (8)].list);
					n->targetList = (yyvsp[(3) - (8)].list);
					n->intoClause = (yyvsp[(4) - (8)].into);
					n->fromClause = (yyvsp[(5) - (8)].list);
					n->whereClause = (yyvsp[(6) - (8)].node);
					n->groupClause = (yyvsp[(7) - (8)].list);
					n->havingClause = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 6223 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 967:

/* Line 1455 of yacc.c  */
#line 6225 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 6229 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 6233 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 970:

/* Line 1455 of yacc.c  */
#line 6240 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
				}
    break;

  case 971:

/* Line 1455 of yacc.c  */
#line 6249 "gram.y"
    { (yyval.into) = NULL; }
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 6258 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				}
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 6263 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				}
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 6268 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				}
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 6273 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				}
    break;

  case 976:

/* Line 1455 of yacc.c  */
#line 6278 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				}
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 6283 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				}
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 6288 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->istemp = false;
				}
    break;

  case 979:

/* Line 1455 of yacc.c  */
#line 6293 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->istemp = false;
				}
    break;

  case 980:

/* Line 1455 of yacc.c  */
#line 6299 "gram.y"
    {}
    break;

  case 981:

/* Line 1455 of yacc.c  */
#line 6300 "gram.y"
    {}
    break;

  case 982:

/* Line 1455 of yacc.c  */
#line 6303 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 983:

/* Line 1455 of yacc.c  */
#line 6304 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 6305 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 6312 "gram.y"
    { (yyval.list) = list_make1(NIL); }
    break;

  case 986:

/* Line 1455 of yacc.c  */
#line 6313 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 6314 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 6315 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 989:

/* Line 1455 of yacc.c  */
#line 6319 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 6320 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 991:

/* Line 1455 of yacc.c  */
#line 6324 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 6328 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); }
    break;

  case 993:

/* Line 1455 of yacc.c  */
#line 6329 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); }
    break;

  case 994:

/* Line 1455 of yacc.c  */
#line 6333 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
				}
    break;

  case 995:

/* Line 1455 of yacc.c  */
#line 6341 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
				}
    break;

  case 996:

/* Line 1455 of yacc.c  */
#line 6353 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(4) - (4)].node), (yyvsp[(2) - (4)].node)); }
    break;

  case 997:

/* Line 1455 of yacc.c  */
#line 6355 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (4)].node), (yyvsp[(4) - (4)].node)); }
    break;

  case 998:

/* Line 1455 of yacc.c  */
#line 6357 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(2) - (2)].node)); }
    break;

  case 999:

/* Line 1455 of yacc.c  */
#line 6359 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), NULL); }
    break;

  case 1000:

/* Line 1455 of yacc.c  */
#line 6361 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses.")));
				}
    break;

  case 1001:

/* Line 1455 of yacc.c  */
#line 6371 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1002:

/* Line 1455 of yacc.c  */
#line 6373 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); }
    break;

  case 1003:

/* Line 1455 of yacc.c  */
#line 6377 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 6379 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Null;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1005:

/* Line 1455 of yacc.c  */
#line 6388 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1006:

/* Line 1455 of yacc.c  */
#line 6392 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1007:

/* Line 1455 of yacc.c  */
#line 6393 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1008:

/* Line 1455 of yacc.c  */
#line 6397 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1009:

/* Line 1455 of yacc.c  */
#line 6398 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1010:

/* Line 1455 of yacc.c  */
#line 6402 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1011:

/* Line 1455 of yacc.c  */
#line 6403 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1012:

/* Line 1455 of yacc.c  */
#line 6407 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1013:

/* Line 1455 of yacc.c  */
#line 6408 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1014:

/* Line 1455 of yacc.c  */
#line 6412 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1015:

/* Line 1455 of yacc.c  */
#line 6413 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1016:

/* Line 1455 of yacc.c  */
#line 6418 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1017:

/* Line 1455 of yacc.c  */
#line 6426 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1018:

/* Line 1455 of yacc.c  */
#line 6436 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1019:

/* Line 1455 of yacc.c  */
#line 6437 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1020:

/* Line 1455 of yacc.c  */
#line 6443 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1021:

/* Line 1455 of yacc.c  */
#line 6449 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1022:

/* Line 1455 of yacc.c  */
#line 6466 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1023:

/* Line 1455 of yacc.c  */
#line 6467 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1024:

/* Line 1455 of yacc.c  */
#line 6471 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1025:

/* Line 1455 of yacc.c  */
#line 6472 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1026:

/* Line 1455 of yacc.c  */
#line 6483 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].range);
				}
    break;

  case 1027:

/* Line 1455 of yacc.c  */
#line 6487 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				}
    break;

  case 1028:

/* Line 1455 of yacc.c  */
#line 6492 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (1)].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1029:

/* Line 1455 of yacc.c  */
#line 6499 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1030:

/* Line 1455 of yacc.c  */
#line 6507 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1031:

/* Line 1455 of yacc.c  */
#line 6514 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (6)].node);
					a->aliasname = (yyvsp[(3) - (6)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1032:

/* Line 1455 of yacc.c  */
#line 6524 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					a->aliasname = (yyvsp[(2) - (5)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1033:

/* Line 1455 of yacc.c  */
#line 6534 "gram.y"
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[(1) - (1)].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[(1) - (1)].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo.")));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo.")));
					(yyval.node) = NULL;
				}
    break;

  case 1034:

/* Line 1455 of yacc.c  */
#line 6560 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1035:

/* Line 1455 of yacc.c  */
#line 6567 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				}
    break;

  case 1036:

/* Line 1455 of yacc.c  */
#line 6571 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				}
    break;

  case 1037:

/* Line 1455 of yacc.c  */
#line 6597 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				}
    break;

  case 1038:

/* Line 1455 of yacc.c  */
#line 6601 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->using = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
    break;

  case 1039:

/* Line 1455 of yacc.c  */
#line 6613 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->using = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1040:

/* Line 1455 of yacc.c  */
#line 6626 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->using = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1041:

/* Line 1455 of yacc.c  */
#line 6640 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->using = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1042:

/* Line 1455 of yacc.c  */
#line 6651 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->using = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1043:

/* Line 1455 of yacc.c  */
#line 6666 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				}
    break;

  case 1044:

/* Line 1455 of yacc.c  */
#line 6672 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				}
    break;

  case 1045:

/* Line 1455 of yacc.c  */
#line 6677 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				}
    break;

  case 1046:

/* Line 1455 of yacc.c  */
#line 6683 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				}
    break;

  case 1047:

/* Line 1455 of yacc.c  */
#line 6689 "gram.y"
    { (yyval.jtype) = JOIN_FULL; }
    break;

  case 1048:

/* Line 1455 of yacc.c  */
#line 6690 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; }
    break;

  case 1049:

/* Line 1455 of yacc.c  */
#line 6691 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; }
    break;

  case 1050:

/* Line 1455 of yacc.c  */
#line 6692 "gram.y"
    { (yyval.jtype) = JOIN_INNER; }
    break;

  case 1051:

/* Line 1455 of yacc.c  */
#line 6696 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1052:

/* Line 1455 of yacc.c  */
#line 6697 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1053:

/* Line 1455 of yacc.c  */
#line 6709 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); }
    break;

  case 1054:

/* Line 1455 of yacc.c  */
#line 6710 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1055:

/* Line 1455 of yacc.c  */
#line 6716 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1056:

/* Line 1455 of yacc.c  */
#line 6723 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1057:

/* Line 1455 of yacc.c  */
#line 6730 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1058:

/* Line 1455 of yacc.c  */
#line 6737 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1059:

/* Line 1455 of yacc.c  */
#line 6756 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				}
    break;

  case 1060:

/* Line 1455 of yacc.c  */
#line 6760 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				}
    break;

  case 1061:

/* Line 1455 of yacc.c  */
#line 6767 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				}
    break;

  case 1062:

/* Line 1455 of yacc.c  */
#line 6776 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1063:

/* Line 1455 of yacc.c  */
#line 6781 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1064:

/* Line 1455 of yacc.c  */
#line 6782 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1065:

/* Line 1455 of yacc.c  */
#line 6787 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1066:

/* Line 1455 of yacc.c  */
#line 6789 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1067:

/* Line 1455 of yacc.c  */
#line 6797 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = NULL;
					n->cursor_param = (yyvsp[(4) - (4)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1068:

/* Line 1455 of yacc.c  */
#line 6804 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1069:

/* Line 1455 of yacc.c  */
#line 6810 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1070:

/* Line 1455 of yacc.c  */
#line 6814 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1071:

/* Line 1455 of yacc.c  */
#line 6820 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (2)].str);
					n->typename = (yyvsp[(2) - (2)].typnam);
					n->constraints = NIL;
					n->is_local = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1072:

/* Line 1455 of yacc.c  */
#line 6841 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1073:

/* Line 1455 of yacc.c  */
#line 6846 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1074:

/* Line 1455 of yacc.c  */
#line 6852 "gram.y"
    {
					/* SQL99's redundant syntax */
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				}
    break;

  case 1075:

/* Line 1455 of yacc.c  */
#line 6858 "gram.y"
    {
					/* SQL99's redundant syntax */
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1076:

/* Line 1455 of yacc.c  */
#line 6868 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); }
    break;

  case 1077:

/* Line 1455 of yacc.c  */
#line 6870 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); }
    break;

  case 1078:

/* Line 1455 of yacc.c  */
#line 6872 "gram.y"
    {  (yyval.list) = NIL; }
    break;

  case 1079:

/* Line 1455 of yacc.c  */
#line 6876 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1080:

/* Line 1455 of yacc.c  */
#line 6877 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1081:

/* Line 1455 of yacc.c  */
#line 6878 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1082:

/* Line 1455 of yacc.c  */
#line 6879 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1083:

/* Line 1455 of yacc.c  */
#line 6880 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1084:

/* Line 1455 of yacc.c  */
#line 6882 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					if ((yyvsp[(2) - (2)].ival) != INTERVAL_FULL_RANGE)
						(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(2) - (2)].ival)));
				}
    break;

  case 1085:

/* Line 1455 of yacc.c  */
#line 6888 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst((yyvsp[(5) - (5)].ival)),
											 makeIntConst((yyvsp[(3) - (5)].ival)));
				}
    break;

  case 1086:

/* Line 1455 of yacc.c  */
#line 6907 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1087:

/* Line 1455 of yacc.c  */
#line 6908 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1088:

/* Line 1455 of yacc.c  */
#line 6909 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1089:

/* Line 1455 of yacc.c  */
#line 6910 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1090:

/* Line 1455 of yacc.c  */
#line 6922 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1091:

/* Line 1455 of yacc.c  */
#line 6928 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1092:

/* Line 1455 of yacc.c  */
#line 6935 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1093:

/* Line 1455 of yacc.c  */
#line 6936 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1094:

/* Line 1455 of yacc.c  */
#line 6943 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1095:

/* Line 1455 of yacc.c  */
#line 6948 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1096:

/* Line 1455 of yacc.c  */
#line 6953 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1097:

/* Line 1455 of yacc.c  */
#line 6958 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1098:

/* Line 1455 of yacc.c  */
#line 6963 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1099:

/* Line 1455 of yacc.c  */
#line 6968 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1100:

/* Line 1455 of yacc.c  */
#line 6973 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1101:

/* Line 1455 of yacc.c  */
#line 6978 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1102:

/* Line 1455 of yacc.c  */
#line 6984 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1103:

/* Line 1455 of yacc.c  */
#line 6990 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1104:

/* Line 1455 of yacc.c  */
#line 6996 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1105:

/* Line 1455 of yacc.c  */
#line 7003 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit")));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits")));
				}
    break;

  case 1106:

/* Line 1455 of yacc.c  */
#line 7022 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
    break;

  case 1107:

/* Line 1455 of yacc.c  */
#line 7032 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1108:

/* Line 1455 of yacc.c  */
#line 7036 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1109:

/* Line 1455 of yacc.c  */
#line 7044 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1110:

/* Line 1455 of yacc.c  */
#line 7048 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1111:

/* Line 1455 of yacc.c  */
#line 7056 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1112:

/* Line 1455 of yacc.c  */
#line 7068 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1113:

/* Line 1455 of yacc.c  */
#line 7089 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1114:

/* Line 1455 of yacc.c  */
#line 7093 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1115:

/* Line 1455 of yacc.c  */
#line 7099 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1116:

/* Line 1455 of yacc.c  */
#line 7103 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1117:

/* Line 1455 of yacc.c  */
#line 7116 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival)));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1118:

/* Line 1455 of yacc.c  */
#line 7135 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1119:

/* Line 1455 of yacc.c  */
#line 7158 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1120:

/* Line 1455 of yacc.c  */
#line 7160 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1121:

/* Line 1455 of yacc.c  */
#line 7162 "gram.y"
    { (yyval.str) = "varchar"; }
    break;

  case 1122:

/* Line 1455 of yacc.c  */
#line 7164 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1123:

/* Line 1455 of yacc.c  */
#line 7166 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1124:

/* Line 1455 of yacc.c  */
#line 7168 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1125:

/* Line 1455 of yacc.c  */
#line 7172 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1126:

/* Line 1455 of yacc.c  */
#line 7173 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1127:

/* Line 1455 of yacc.c  */
#line 7177 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 1128:

/* Line 1455 of yacc.c  */
#line 7178 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1129:

/* Line 1455 of yacc.c  */
#line 7186 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					/* XXX the timezone field seems to be unused
					 * - thomas 2001-09-06
					 */
					(yyval.typnam)->timezone = (yyvsp[(5) - (5)].boolean);
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival)));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1130:

/* Line 1455 of yacc.c  */
#line 7199 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					/* XXX the timezone field seems to be unused
					 * - thomas 2001-09-06
					 */
					(yyval.typnam)->timezone = (yyvsp[(2) - (2)].boolean);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1131:

/* Line 1455 of yacc.c  */
#line 7211 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival)));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1132:

/* Line 1455 of yacc.c  */
#line 7220 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1133:

/* Line 1455 of yacc.c  */
#line 7231 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1134:

/* Line 1455 of yacc.c  */
#line 7238 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1135:

/* Line 1455 of yacc.c  */
#line 7239 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1136:

/* Line 1455 of yacc.c  */
#line 7240 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1137:

/* Line 1455 of yacc.c  */
#line 7244 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(YEAR); }
    break;

  case 1138:

/* Line 1455 of yacc.c  */
#line 7245 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(MONTH); }
    break;

  case 1139:

/* Line 1455 of yacc.c  */
#line 7246 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(DAY); }
    break;

  case 1140:

/* Line 1455 of yacc.c  */
#line 7247 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(HOUR); }
    break;

  case 1141:

/* Line 1455 of yacc.c  */
#line 7248 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(MINUTE); }
    break;

  case 1142:

/* Line 1455 of yacc.c  */
#line 7249 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(SECOND); }
    break;

  case 1143:

/* Line 1455 of yacc.c  */
#line 7251 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(YEAR) | INTERVAL_MASK(MONTH); }
    break;

  case 1144:

/* Line 1455 of yacc.c  */
#line 7253 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(DAY) | INTERVAL_MASK(HOUR); }
    break;

  case 1145:

/* Line 1455 of yacc.c  */
#line 7255 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(DAY) | INTERVAL_MASK(HOUR)
						| INTERVAL_MASK(MINUTE); }
    break;

  case 1146:

/* Line 1455 of yacc.c  */
#line 7258 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(DAY) | INTERVAL_MASK(HOUR)
						| INTERVAL_MASK(MINUTE) | INTERVAL_MASK(SECOND); }
    break;

  case 1147:

/* Line 1455 of yacc.c  */
#line 7261 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE); }
    break;

  case 1148:

/* Line 1455 of yacc.c  */
#line 7263 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE)
						| INTERVAL_MASK(SECOND); }
    break;

  case 1149:

/* Line 1455 of yacc.c  */
#line 7266 "gram.y"
    { (yyval.ival) = INTERVAL_MASK(MINUTE) | INTERVAL_MASK(SECOND); }
    break;

  case 1150:

/* Line 1455 of yacc.c  */
#line 7267 "gram.y"
    { (yyval.ival) = INTERVAL_FULL_RANGE; }
    break;

  case 1151:

/* Line 1455 of yacc.c  */
#line 7293 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1152:

/* Line 1455 of yacc.c  */
#line 7295 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 1153:

/* Line 1455 of yacc.c  */
#line 7297 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1154:

/* Line 1455 of yacc.c  */
#line 7316 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1155:

/* Line 1455 of yacc.c  */
#line 7318 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1156:

/* Line 1455 of yacc.c  */
#line 7320 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1157:

/* Line 1455 of yacc.c  */
#line 7322 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1158:

/* Line 1455 of yacc.c  */
#line 7324 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1159:

/* Line 1455 of yacc.c  */
#line 7326 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1160:

/* Line 1455 of yacc.c  */
#line 7328 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1161:

/* Line 1455 of yacc.c  */
#line 7330 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1162:

/* Line 1455 of yacc.c  */
#line 7332 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1163:

/* Line 1455 of yacc.c  */
#line 7334 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1164:

/* Line 1455 of yacc.c  */
#line 7336 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1165:

/* Line 1455 of yacc.c  */
#line 7339 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1166:

/* Line 1455 of yacc.c  */
#line 7341 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1167:

/* Line 1455 of yacc.c  */
#line 7343 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1168:

/* Line 1455 of yacc.c  */
#line 7346 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1169:

/* Line 1455 of yacc.c  */
#line 7348 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1170:

/* Line 1455 of yacc.c  */
#line 7350 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1171:

/* Line 1455 of yacc.c  */
#line 7353 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1172:

/* Line 1455 of yacc.c  */
#line 7355 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(4) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1173:

/* Line 1455 of yacc.c  */
#line 7365 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1174:

/* Line 1455 of yacc.c  */
#line 7367 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1175:

/* Line 1455 of yacc.c  */
#line 7377 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1176:

/* Line 1455 of yacc.c  */
#line 7379 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(4) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1177:

/* Line 1455 of yacc.c  */
#line 7389 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1178:

/* Line 1455 of yacc.c  */
#line 7391 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1179:

/* Line 1455 of yacc.c  */
#line 7402 "gram.y"
    {
					A_Const *c = makeNode(A_Const);
					FuncCall *n = makeNode(FuncCall);
					c->val.type = T_Null;
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (4)].node), (Node *) c);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				}
    break;

  case 1180:

/* Line 1455 of yacc.c  */
#line 7414 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1181:

/* Line 1455 of yacc.c  */
#line 7424 "gram.y"
    {
					A_Const *c = makeNode(A_Const);
					FuncCall *n = makeNode(FuncCall);
					c->val.type = T_Null;
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (5)].node), (Node *) c);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(5) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1182:

/* Line 1455 of yacc.c  */
#line 7436 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(6) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				}
    break;

  case 1183:

/* Line 1455 of yacc.c  */
#line 7456 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1184:

/* Line 1455 of yacc.c  */
#line 7463 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1185:

/* Line 1455 of yacc.c  */
#line 7470 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1186:

/* Line 1455 of yacc.c  */
#line 7477 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1187:

/* Line 1455 of yacc.c  */
#line 7484 "gram.y"
    {
					(yyval.node) = (Node *)makeOverlaps((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list), (yylsp[(2) - (3)]));
				}
    break;

  case 1188:

/* Line 1455 of yacc.c  */
#line 7488 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1189:

/* Line 1455 of yacc.c  */
#line 7495 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1190:

/* Line 1455 of yacc.c  */
#line 7502 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1191:

/* Line 1455 of yacc.c  */
#line 7509 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1192:

/* Line 1455 of yacc.c  */
#line 7516 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1193:

/* Line 1455 of yacc.c  */
#line 7523 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1194:

/* Line 1455 of yacc.c  */
#line 7530 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1195:

/* Line 1455 of yacc.c  */
#line 7534 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				}
    break;

  case 1196:

/* Line 1455 of yacc.c  */
#line 7542 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1197:

/* Line 1455 of yacc.c  */
#line 7546 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1198:

/* Line 1455 of yacc.c  */
#line 7550 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1199:

/* Line 1455 of yacc.c  */
#line 7557 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1200:

/* Line 1455 of yacc.c  */
#line 7564 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1201:

/* Line 1455 of yacc.c  */
#line 7577 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1202:

/* Line 1455 of yacc.c  */
#line 7590 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				}
    break;

  case 1203:

/* Line 1455 of yacc.c  */
#line 7608 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				}
    break;

  case 1204:

/* Line 1455 of yacc.c  */
#line 7628 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1205:

/* Line 1455 of yacc.c  */
#line 7637 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				}
    break;

  case 1206:

/* Line 1455 of yacc.c  */
#line 7644 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented")));
				}
    break;

  case 1207:

/* Line 1455 of yacc.c  */
#line 7659 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL, list_make1((yyvsp[(1) - (3)].node)));
				}
    break;

  case 1208:

/* Line 1455 of yacc.c  */
#line 7663 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL, list_make1((yyvsp[(1) - (4)].node))),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1209:

/* Line 1455 of yacc.c  */
#line 7680 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1210:

/* Line 1455 of yacc.c  */
#line 7682 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 1211:

/* Line 1455 of yacc.c  */
#line 7684 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1212:

/* Line 1455 of yacc.c  */
#line 7686 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1213:

/* Line 1455 of yacc.c  */
#line 7688 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1214:

/* Line 1455 of yacc.c  */
#line 7690 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1215:

/* Line 1455 of yacc.c  */
#line 7692 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1216:

/* Line 1455 of yacc.c  */
#line 7694 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1217:

/* Line 1455 of yacc.c  */
#line 7696 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1218:

/* Line 1455 of yacc.c  */
#line 7698 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1219:

/* Line 1455 of yacc.c  */
#line 7700 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1220:

/* Line 1455 of yacc.c  */
#line 7702 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1221:

/* Line 1455 of yacc.c  */
#line 7704 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1222:

/* Line 1455 of yacc.c  */
#line 7706 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1223:

/* Line 1455 of yacc.c  */
#line 7708 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1224:

/* Line 1455 of yacc.c  */
#line 7710 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1225:

/* Line 1455 of yacc.c  */
#line 7712 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1226:

/* Line 1455 of yacc.c  */
#line 7716 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				}
    break;

  case 1227:

/* Line 1455 of yacc.c  */
#line 7721 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1228:

/* Line 1455 of yacc.c  */
#line 7725 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1229:

/* Line 1455 of yacc.c  */
#line 7729 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL, list_make1((yyvsp[(1) - (3)].node)));
				}
    break;

  case 1230:

/* Line 1455 of yacc.c  */
#line 7733 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL, list_make1((yyvsp[(1) - (4)].node))),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1231:

/* Line 1455 of yacc.c  */
#line 7748 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1232:

/* Line 1455 of yacc.c  */
#line 7749 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1233:

/* Line 1455 of yacc.c  */
#line 7751 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = (yyvsp[(2) - (2)].list);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
    break;

  case 1234:

/* Line 1455 of yacc.c  */
#line 7765 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = (yyvsp[(4) - (4)].list);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1235:

/* Line 1455 of yacc.c  */
#line 7777 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1236:

/* Line 1455 of yacc.c  */
#line 7779 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1237:

/* Line 1455 of yacc.c  */
#line 7781 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1238:

/* Line 1455 of yacc.c  */
#line 7790 "gram.y"
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (2)].node);
					a->arg = (Node *)n;
					a->indirection = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)a;
				}
    break;

  case 1239:

/* Line 1455 of yacc.c  */
#line 7812 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1240:

/* Line 1455 of yacc.c  */
#line 7821 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1241:

/* Line 1455 of yacc.c  */
#line 7830 "gram.y"
    {	(yyval.node) = (yyvsp[(2) - (2)].node);	}
    break;

  case 1242:

/* Line 1455 of yacc.c  */
#line 7832 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					(yyval.node) = (Node *)r;
				}
    break;

  case 1243:

/* Line 1455 of yacc.c  */
#line 7849 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (3)].list);
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1244:

/* Line 1455 of yacc.c  */
#line 7859 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1245:

/* Line 1455 of yacc.c  */
#line 7869 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1246:

/* Line 1455 of yacc.c  */
#line 7883 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1247:

/* Line 1455 of yacc.c  */
#line 7893 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1248:

/* Line 1455 of yacc.c  */
#line 7913 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("date");

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				}
    break;

  case 1249:

/* Line 1455 of yacc.c  */
#line 7941 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("timetz");

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				}
    break;

  case 1250:

/* Line 1455 of yacc.c  */
#line 7958 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival)));

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				}
    break;

  case 1251:

/* Line 1455 of yacc.c  */
#line 7975 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1252:

/* Line 1455 of yacc.c  */
#line 7989 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival)));

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				}
    break;

  case 1253:

/* Line 1455 of yacc.c  */
#line 8007 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("time");

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				}
    break;

  case 1254:

/* Line 1455 of yacc.c  */
#line 8024 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival)));

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				}
    break;

  case 1255:

/* Line 1455 of yacc.c  */
#line 8041 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("timestamp");

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				}
    break;

  case 1256:

/* Line 1455 of yacc.c  */
#line 8058 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					A_Const *s = makeNode(A_Const);
					TypeName *d;

					s->val.type = T_String;
					s->val.val.str = "now";
					s->typename = SystemTypeName("text");

					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival)));

					(yyval.node) = (Node *)makeTypeCast((Node *)s, d);
				}
    break;

  case 1257:

/* Line 1455 of yacc.c  */
#line 8076 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1258:

/* Line 1455 of yacc.c  */
#line 8086 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1259:

/* Line 1455 of yacc.c  */
#line 8096 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1260:

/* Line 1455 of yacc.c  */
#line 8106 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1261:

/* Line 1455 of yacc.c  */
#line 8116 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam)); }
    break;

  case 1262:

/* Line 1455 of yacc.c  */
#line 8118 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1263:

/* Line 1455 of yacc.c  */
#line 8128 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * substring(A, 1, C-1) || B || substring(A, C+1, C+D)
					 * overlay(A PLACING B FROM C) is converted to
					 * substring(A, 1, C-1) || B || substring(A, C+1, C+char_length(B))
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1264:

/* Line 1455 of yacc.c  */
#line 8143 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1265:

/* Line 1455 of yacc.c  */
#line 8154 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1266:

/* Line 1455 of yacc.c  */
#line 8167 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1267:

/* Line 1455 of yacc.c  */
#line 8186 "gram.y"
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1268:

/* Line 1455 of yacc.c  */
#line 8199 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1269:

/* Line 1455 of yacc.c  */
#line 8209 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1270:

/* Line 1455 of yacc.c  */
#line 8219 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1271:

/* Line 1455 of yacc.c  */
#line 8229 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				}
    break;

  case 1272:

/* Line 1455 of yacc.c  */
#line 8233 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1273:

/* Line 1455 of yacc.c  */
#line 8239 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					(yyval.node) = (Node *)v;
				}
    break;

  case 1274:

/* Line 1455 of yacc.c  */
#line 8246 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					(yyval.node) = (Node *)v;
				}
    break;

  case 1275:

/* Line 1455 of yacc.c  */
#line 8253 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1276:

/* Line 1455 of yacc.c  */
#line 8257 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL);
				}
    break;

  case 1277:

/* Line 1455 of yacc.c  */
#line 8261 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL);
				}
    break;

  case 1278:

/* Line 1455 of yacc.c  */
#line 8265 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list));
				}
    break;

  case 1279:

/* Line 1455 of yacc.c  */
#line 8269 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list));
				}
    break;

  case 1280:

/* Line 1455 of yacc.c  */
#line 8273 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL);
				}
    break;

  case 1281:

/* Line 1455 of yacc.c  */
#line 8277 "gram.y"
    {
					XmlExpr *x = (XmlExpr *) makeXmlExpr(IS_XMLPARSE, NULL, NIL,
														 list_make2((yyvsp[(4) - (6)].node),
																	makeBoolAConst((yyvsp[(5) - (6)].boolean))));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				}
    break;

  case 1282:

/* Line 1455 of yacc.c  */
#line 8285 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL);
				}
    break;

  case 1283:

/* Line 1455 of yacc.c  */
#line 8289 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)));
				}
    break;

  case 1284:

/* Line 1455 of yacc.c  */
#line 8293 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)));
				}
    break;

  case 1285:

/* Line 1455 of yacc.c  */
#line 8298 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typename = (yyvsp[(6) - (7)].typnam);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1286:

/* Line 1455 of yacc.c  */
#line 8311 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1287:

/* Line 1455 of yacc.c  */
#line 8313 "gram.y"
    {
					A_Const *val = makeNode(A_Const);
					val->val.type = T_Null;
					(yyval.node) = (Node *) val;
				}
    break;

  case 1288:

/* Line 1455 of yacc.c  */
#line 8321 "gram.y"
    { (yyval.node) = (Node *) makeIntConst(XML_STANDALONE_YES); }
    break;

  case 1289:

/* Line 1455 of yacc.c  */
#line 8323 "gram.y"
    { (yyval.node) = (Node *) makeIntConst(XML_STANDALONE_NO); }
    break;

  case 1290:

/* Line 1455 of yacc.c  */
#line 8325 "gram.y"
    { (yyval.node) = (Node *) makeIntConst(XML_STANDALONE_NO_VALUE); }
    break;

  case 1291:

/* Line 1455 of yacc.c  */
#line 8327 "gram.y"
    { (yyval.node) = (Node *) makeIntConst(XML_STANDALONE_OMITTED); }
    break;

  case 1292:

/* Line 1455 of yacc.c  */
#line 8330 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1293:

/* Line 1455 of yacc.c  */
#line 8333 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1294:

/* Line 1455 of yacc.c  */
#line 8334 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1295:

/* Line 1455 of yacc.c  */
#line 8338 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NULL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1296:

/* Line 1455 of yacc.c  */
#line 8346 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NULL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1297:

/* Line 1455 of yacc.c  */
#line 8355 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
    break;

  case 1298:

/* Line 1455 of yacc.c  */
#line 8356 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; }
    break;

  case 1299:

/* Line 1455 of yacc.c  */
#line 8359 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1300:

/* Line 1455 of yacc.c  */
#line 8360 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1301:

/* Line 1455 of yacc.c  */
#line 8361 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1302:

/* Line 1455 of yacc.c  */
#line 8374 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1303:

/* Line 1455 of yacc.c  */
#line 8375 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1304:

/* Line 1455 of yacc.c  */
#line 8376 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); }
    break;

  case 1305:

/* Line 1455 of yacc.c  */
#line 8379 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1306:

/* Line 1455 of yacc.c  */
#line 8380 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1307:

/* Line 1455 of yacc.c  */
#line 8381 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; }
    break;

  case 1308:

/* Line 1455 of yacc.c  */
#line 8384 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1309:

/* Line 1455 of yacc.c  */
#line 8385 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1310:

/* Line 1455 of yacc.c  */
#line 8388 "gram.y"
    { (yyval.str) = "+"; }
    break;

  case 1311:

/* Line 1455 of yacc.c  */
#line 8389 "gram.y"
    { (yyval.str) = "-"; }
    break;

  case 1312:

/* Line 1455 of yacc.c  */
#line 8390 "gram.y"
    { (yyval.str) = "*"; }
    break;

  case 1313:

/* Line 1455 of yacc.c  */
#line 8391 "gram.y"
    { (yyval.str) = "/"; }
    break;

  case 1314:

/* Line 1455 of yacc.c  */
#line 8392 "gram.y"
    { (yyval.str) = "%"; }
    break;

  case 1315:

/* Line 1455 of yacc.c  */
#line 8393 "gram.y"
    { (yyval.str) = "^"; }
    break;

  case 1316:

/* Line 1455 of yacc.c  */
#line 8394 "gram.y"
    { (yyval.str) = "<"; }
    break;

  case 1317:

/* Line 1455 of yacc.c  */
#line 8395 "gram.y"
    { (yyval.str) = ">"; }
    break;

  case 1318:

/* Line 1455 of yacc.c  */
#line 8396 "gram.y"
    { (yyval.str) = "="; }
    break;

  case 1319:

/* Line 1455 of yacc.c  */
#line 8400 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1320:

/* Line 1455 of yacc.c  */
#line 8402 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1321:

/* Line 1455 of yacc.c  */
#line 8407 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1322:

/* Line 1455 of yacc.c  */
#line 8409 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1323:

/* Line 1455 of yacc.c  */
#line 8414 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1324:

/* Line 1455 of yacc.c  */
#line 8416 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1325:

/* Line 1455 of yacc.c  */
#line 8418 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); }
    break;

  case 1326:

/* Line 1455 of yacc.c  */
#line 8420 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); }
    break;

  case 1327:

/* Line 1455 of yacc.c  */
#line 8422 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); }
    break;

  case 1328:

/* Line 1455 of yacc.c  */
#line 8424 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); }
    break;

  case 1329:

/* Line 1455 of yacc.c  */
#line 8436 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1330:

/* Line 1455 of yacc.c  */
#line 8440 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1331:

/* Line 1455 of yacc.c  */
#line 8447 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(1) - (3)].str);
					(yyval.list) = list_make2((Node *) n, (yyvsp[(3) - (3)].node));
				}
    break;

  case 1332:

/* Line 1455 of yacc.c  */
#line 8453 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1333:

/* Line 1455 of yacc.c  */
#line 8456 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); }
    break;

  case 1334:

/* Line 1455 of yacc.c  */
#line 8457 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 1335:

/* Line 1455 of yacc.c  */
#line 8461 "gram.y"
    {	(yyval.list) = list_make1((yyvsp[(1) - (1)].node));		}
    break;

  case 1336:

/* Line 1455 of yacc.c  */
#line 8463 "gram.y"
    {	(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));	}
    break;

  case 1337:

/* Line 1455 of yacc.c  */
#line 8467 "gram.y"
    {
					ArrayExpr *n = makeNode(ArrayExpr);
					n->elements = (yyvsp[(2) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1338:

/* Line 1455 of yacc.c  */
#line 8473 "gram.y"
    {
					ArrayExpr *n = makeNode(ArrayExpr);
					n->elements = (yyvsp[(2) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1339:

/* Line 1455 of yacc.c  */
#line 8485 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1340:

/* Line 1455 of yacc.c  */
#line 8486 "gram.y"
    { (yyval.str) = "year"; }
    break;

  case 1341:

/* Line 1455 of yacc.c  */
#line 8487 "gram.y"
    { (yyval.str) = "month"; }
    break;

  case 1342:

/* Line 1455 of yacc.c  */
#line 8488 "gram.y"
    { (yyval.str) = "day"; }
    break;

  case 1343:

/* Line 1455 of yacc.c  */
#line 8489 "gram.y"
    { (yyval.str) = "hour"; }
    break;

  case 1344:

/* Line 1455 of yacc.c  */
#line 8490 "gram.y"
    { (yyval.str) = "minute"; }
    break;

  case 1345:

/* Line 1455 of yacc.c  */
#line 8491 "gram.y"
    { (yyval.str) = "second"; }
    break;

  case 1346:

/* Line 1455 of yacc.c  */
#line 8492 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1347:

/* Line 1455 of yacc.c  */
#line 8502 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1348:

/* Line 1455 of yacc.c  */
#line 8506 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1349:

/* Line 1455 of yacc.c  */
#line 8513 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1350:

/* Line 1455 of yacc.c  */
#line 8519 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); }
    break;

  case 1351:

/* Line 1455 of yacc.c  */
#line 8520 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1352:

/* Line 1455 of yacc.c  */
#line 8537 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1353:

/* Line 1455 of yacc.c  */
#line 8541 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				}
    break;

  case 1354:

/* Line 1455 of yacc.c  */
#line 8546 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1355:

/* Line 1455 of yacc.c  */
#line 8550 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Integer;
					n->val.val.ival = 1;
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), (Node *) n,
									makeTypeCast((yyvsp[(2) - (2)].node), SystemTypeName("int4")));
				}
    break;

  case 1356:

/* Line 1455 of yacc.c  */
#line 8567 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				}
    break;

  case 1357:

/* Line 1455 of yacc.c  */
#line 8571 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1358:

/* Line 1455 of yacc.c  */
#line 8575 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1359:

/* Line 1455 of yacc.c  */
#line 8578 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1360:

/* Line 1455 of yacc.c  */
#line 8581 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); }
    break;

  case 1361:

/* Line 1455 of yacc.c  */
#line 8582 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1362:

/* Line 1455 of yacc.c  */
#line 8583 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1363:

/* Line 1455 of yacc.c  */
#line 8587 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1364:

/* Line 1455 of yacc.c  */
#line 8593 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); }
    break;

  case 1365:

/* Line 1455 of yacc.c  */
#line 8604 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1366:

/* Line 1455 of yacc.c  */
#line 8616 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1367:

/* Line 1455 of yacc.c  */
#line 8617 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1368:

/* Line 1455 of yacc.c  */
#line 8622 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)w;
				}
    break;

  case 1369:

/* Line 1455 of yacc.c  */
#line 8631 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1370:

/* Line 1455 of yacc.c  */
#line 8632 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1371:

/* Line 1455 of yacc.c  */
#line 8635 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1372:

/* Line 1455 of yacc.c  */
#line 8636 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1373:

/* Line 1455 of yacc.c  */
#line 8645 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1374:

/* Line 1455 of yacc.c  */
#line 8649 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]));
				}
    break;

  case 1375:

/* Line 1455 of yacc.c  */
#line 8656 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				}
    break;

  case 1376:

/* Line 1455 of yacc.c  */
#line 8660 "gram.y"
    {
					(yyval.node) = (Node *) makeString("*");
				}
    break;

  case 1377:

/* Line 1455 of yacc.c  */
#line 8664 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1378:

/* Line 1455 of yacc.c  */
#line 8671 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1379:

/* Line 1455 of yacc.c  */
#line 8680 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1380:

/* Line 1455 of yacc.c  */
#line 8681 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1381:

/* Line 1455 of yacc.c  */
#line 8685 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1382:

/* Line 1455 of yacc.c  */
#line 8686 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1385:

/* Line 1455 of yacc.c  */
#line 8701 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); }
    break;

  case 1386:

/* Line 1455 of yacc.c  */
#line 8702 "gram.y"
    { (yyval.node) = (Node *) makeNode(SetToDefault); }
    break;

  case 1387:

/* Line 1455 of yacc.c  */
#line 8706 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1388:

/* Line 1455 of yacc.c  */
#line 8707 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1389:

/* Line 1455 of yacc.c  */
#line 8715 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1390:

/* Line 1455 of yacc.c  */
#line 8726 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1391:

/* Line 1455 of yacc.c  */
#line 8727 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1392:

/* Line 1455 of yacc.c  */
#line 8732 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1393:

/* Line 1455 of yacc.c  */
#line 8740 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1394:

/* Line 1455 of yacc.c  */
#line 8748 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeString("*"));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1395:

/* Line 1455 of yacc.c  */
#line 8769 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1396:

/* Line 1455 of yacc.c  */
#line 8770 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1397:

/* Line 1455 of yacc.c  */
#line 8774 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1398:

/* Line 1455 of yacc.c  */
#line 8775 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1399:

/* Line 1455 of yacc.c  */
#line 8787 "gram.y"
    {
					(yyval.range) = makeNode(RangeVar);
					(yyval.range)->catalogname = NULL;
					(yyval.range)->schemaname = NULL;
					(yyval.range)->relname = (yyvsp[(1) - (1)].str);
				}
    break;

  case 1400:

/* Line 1455 of yacc.c  */
#line 8794 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list));
					(yyval.range) = makeNode(RangeVar);
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list))))));
							break;
					}
				}
    break;

  case 1401:

/* Line 1455 of yacc.c  */
#line 8820 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1402:

/* Line 1455 of yacc.c  */
#line 8822 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 1403:

/* Line 1455 of yacc.c  */
#line 8826 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1404:

/* Line 1455 of yacc.c  */
#line 8829 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1405:

/* Line 1455 of yacc.c  */
#line 8832 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1406:

/* Line 1455 of yacc.c  */
#line 8834 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1407:

/* Line 1455 of yacc.c  */
#line 8836 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1408:

/* Line 1455 of yacc.c  */
#line 8838 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1409:

/* Line 1455 of yacc.c  */
#line 8849 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1410:

/* Line 1455 of yacc.c  */
#line 8851 "gram.y"
    { (yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list))); }
    break;

  case 1411:

/* Line 1455 of yacc.c  */
#line 8859 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Integer;
					n->val.val.ival = (yyvsp[(1) - (1)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1412:

/* Line 1455 of yacc.c  */
#line 8866 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Float;
					n->val.val.str = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1413:

/* Line 1455 of yacc.c  */
#line 8873 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1414:

/* Line 1455 of yacc.c  */
#line 8880 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_BitString;
					n->val.val.str = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1415:

/* Line 1455 of yacc.c  */
#line 8887 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					A_Const *n = makeNode(A_Const);
					n->val.type = T_BitString;
					n->val.val.str = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1416:

/* Line 1455 of yacc.c  */
#line 8899 "gram.y"
    {
					/* generic type 'literal' syntax */
					A_Const *n = makeNode(A_Const);
					n->typename = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					n->typename->location = (yylsp[(1) - (2)]);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1417:

/* Line 1455 of yacc.c  */
#line 8909 "gram.y"
    {
					/* generic syntax with a type modifier */
					A_Const *n = makeNode(A_Const);
					n->typename = makeTypeNameFromNameList((yyvsp[(1) - (5)].list));
					n->typename->typmods = (yyvsp[(3) - (5)].list);
					n->typename->location = (yylsp[(1) - (5)]);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(5) - (5)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1418:

/* Line 1455 of yacc.c  */
#line 8920 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->typename = (yyvsp[(1) - (2)].typnam);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1419:

/* Line 1455 of yacc.c  */
#line 8928 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->typename = (yyvsp[(1) - (3)].typnam);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(2) - (3)].str);
					/* precision is not specified, but fields may be... */
					if ((yyvsp[(3) - (3)].ival) != INTERVAL_FULL_RANGE)
						n->typename->typmods = list_make1(makeIntConst((yyvsp[(3) - (3)].ival)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1420:

/* Line 1455 of yacc.c  */
#line 8939 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->typename = (yyvsp[(1) - (6)].typnam);
					n->val.type = T_String;
					n->val.val.str = (yyvsp[(5) - (6)].str);
					n->typename->typmods = list_make2(makeIntConst((yyvsp[(6) - (6)].ival)),
													  makeIntConst((yyvsp[(3) - (6)].ival)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1421:

/* Line 1455 of yacc.c  */
#line 8949 "gram.y"
    {
					(yyval.node) = (Node *)makeBoolAConst(TRUE);
				}
    break;

  case 1422:

/* Line 1455 of yacc.c  */
#line 8953 "gram.y"
    {
					(yyval.node) = (Node *)makeBoolAConst(FALSE);
				}
    break;

  case 1423:

/* Line 1455 of yacc.c  */
#line 8957 "gram.y"
    {
					A_Const *n = makeNode(A_Const);
					n->val.type = T_Null;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1424:

/* Line 1455 of yacc.c  */
#line 8964 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1425:

/* Line 1455 of yacc.c  */
#line 8965 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1426:

/* Line 1455 of yacc.c  */
#line 8966 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1427:

/* Line 1455 of yacc.c  */
#line 8968 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1428:

/* Line 1455 of yacc.c  */
#line 8969 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); }
    break;

  case 1429:

/* Line 1455 of yacc.c  */
#line 8985 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1430:

/* Line 1455 of yacc.c  */
#line 8986 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1431:

/* Line 1455 of yacc.c  */
#line 8987 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1432:

/* Line 1455 of yacc.c  */
#line 8992 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1433:

/* Line 1455 of yacc.c  */
#line 8993 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1434:

/* Line 1455 of yacc.c  */
#line 8994 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1435:

/* Line 1455 of yacc.c  */
#line 9000 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1436:

/* Line 1455 of yacc.c  */
#line 9001 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1437:

/* Line 1455 of yacc.c  */
#line 9002 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1438:

/* Line 1455 of yacc.c  */
#line 9003 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1439:

/* Line 1455 of yacc.c  */
#line 9004 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1812:

/* Line 1455 of yacc.c  */
#line 9436 "gram.y"
    {
					if (QueryIsRule)
						(yyval.str) = "*OLD*";
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("OLD used in query that is not in a rule")));
				}
    break;

  case 1813:

/* Line 1455 of yacc.c  */
#line 9445 "gram.y"
    {
					if (QueryIsRule)
						(yyval.str) = "*NEW*";
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("NEW used in query that is not in a rule")));
				}
    break;



/* Line 1455 of yacc.c  */
#line 27781 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 9455 "gram.y"


static Node *
makeColumnRef(char *relname, List *indirection, int location)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(relname));
				i->indirection = indirection;
			}
			else
			{
				/* got to split the list in two */
				i->indirection = list_copy_tail(indirection, nfields);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(relname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(relname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename)
{
	/*
	 * Simply generate a TypeCast node.
	 *
	 * Earlier we would determine whether an A_Const would
	 * be acceptable, however Domains require coerce_type()
	 * to process them -- applying constraints as required.
	 */
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typename = typename;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, TypeName *typename)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->typename = typename;

	return (Node *)n;
}

static Node *
makeIntConst(int val)
{
	A_Const *n = makeNode(A_Const);
	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->typename = SystemTypeName("int4");

	return (Node *)n;
}

static Node *
makeFloatConst(char *str)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->typename = SystemTypeName("float8");

	return (Node *)n;
}

static Node *
makeAConst(Value *v)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, NULL);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const node and initialize to a boolean constant.
 */
static A_Const *
makeBoolAConst(bool state)
{
	A_Const *n = makeNode(A_Const);
	n->val.type = T_String;
	n->val.val.str = (state? "t": "f");
	n->typename = SystemTypeName("bool");
	return n;
}

/* makeOverlaps()
 * Create and populate a FuncCall node to support the OVERLAPS operator.
 */
static FuncCall *
makeOverlaps(List *largs, List *rargs, int location)
{
	FuncCall *n = makeNode(FuncCall);

	n->funcname = SystemFuncName("overlaps");
	if (list_length(largs) == 1)
		largs = lappend(largs, largs);
	else if (list_length(largs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on left side of OVERLAPS expression")));
	if (list_length(rargs) == 1)
		rargs = lappend(rargs, rargs);
	else if (list_length(rargs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on right side of OVERLAPS expression")));
	n->args = list_concat(largs, rargs);
	n->agg_star = FALSE;
	n->agg_distinct = FALSE;
	n->location = location;
	return n;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			yyerror("syntax error");
		else if (strcmp(strVal(lfirst(i)), "*") == 0)
			yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			yyerror("syntax error");
		else if (strcmp(strVal(lfirst(i)), "*") == 0)
			yyerror("syntax error");
	}
	return names;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT)			/* keep if IN or INOUT */
			result = lappend(result, p->argType);
	}
	return result;
}

/* findLeftmostSelect()
 * Find the leftmost component SelectStmt in a set-operation parsetree.
 */
static SelectStmt *
findLeftmostSelect(SelectStmt *node)
{
	while (node && node->op != SETOP_NONE)
		node = node->larg;
	Assert(node && IsA(node, SelectStmt) && node->larg == NULL);
	return node;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount)
{
	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed")));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed")));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed")));
		stmt->limitCount = limitCount;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(void)
{
	QueryIsRule = FALSE;
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args)
{
	XmlExpr    *x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	return (Node *) x;
}

/*
 * Must undefine base_yylex before including scan.c, since we want it
 * to create the function base_yylex not filtered_base_yylex.
 */
#undef base_yylex

#include "scan.c"

